/**
 * Generated by Apache Royale Compiler from mx/binding/BindabilityInfo.as
 * mx.binding.BindabilityInfo
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.binding.BindabilityInfo');

goog.require('org.apache.royale.events.ValueChangeEvent');
goog.require('org.apache.royale.reflection.DefinitionWithMetaData');
goog.require('org.apache.royale.reflection.MetaDataArgDefinition');
goog.require('org.apache.royale.reflection.MetaDataDefinition');
goog.require('org.apache.royale.reflection.TypeDefinition');
goog.require('org.apache.royale.reflection.describeType');
goog.require('org.apache.royale.reflection.utils.filterForMetaTags');
goog.require('org.apache.royale.reflection.utils.getMembersWithNameMatch');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @param {org.apache.royale.reflection.TypeDefinition} typeDefinition
 * @param {boolean=} cache
 */
mx.binding.BindabilityInfo = function(typeDefinition, cache) {
  cache = typeof cache !== 'undefined' ? cache : false;
  
  this.mx_binding_BindabilityInfo_childChangeEvents = {};
  ;
  this.mx_binding_BindabilityInfo_typeDefinition = typeDefinition;
  if (cache) {
    mx.binding.BindabilityInfo.storeInCache(this);
  }
};


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.binding.BindabilityInfo.BINDABLE = "Bindable";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.binding.BindabilityInfo.ACCESSOR = "accessor";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.binding.BindabilityInfo.METHOD = "method";


/**
 * @private
 * @const
 * @type {Map}
 */
mx.binding.BindabilityInfo.cache = new Map();


/**
 * @nocollapse
 * @param {Object} forTarget
 * @return {mx.binding.BindabilityInfo}
 */
mx.binding.BindabilityInfo.getCachedInfo = function(forTarget) {
  var /** @type {org.apache.royale.reflection.TypeDefinition} */ typeDef = org.apache.royale.reflection.describeType(forTarget);
  var /** @type {mx.binding.BindabilityInfo} */ info = mx.binding.BindabilityInfo.getFromCache(typeDef);
  if (!info) {
    info = new mx.binding.BindabilityInfo(typeDef, true);
  }
  return info;
};


/**
 * @private
 * @param {org.apache.royale.reflection.TypeDefinition} typeDef
 * @return {mx.binding.BindabilityInfo}
 */
mx.binding.BindabilityInfo.getFromCache = function(typeDef) {
  var /** @type {mx.binding.BindabilityInfo} */ info;
  
  info = mx.binding.BindabilityInfo.cache.get(typeDef.getClass());
  return info;
};


/**
 * @private
 * @param {mx.binding.BindabilityInfo} info
 */
mx.binding.BindabilityInfo.storeInCache = function(info) {
  var /** @type {org.apache.royale.reflection.TypeDefinition} */ typeDef = info.mx_binding_BindabilityInfo_typeDefinition;
  
  mx.binding.BindabilityInfo.cache.set(typeDef.getClass(), info);
};


/**
 * @private
 * @type {org.apache.royale.reflection.TypeDefinition}
 */
mx.binding.BindabilityInfo.prototype.mx_binding_BindabilityInfo_typeDefinition;


/**
 * @private
 * @type {Object}
 */
mx.binding.BindabilityInfo.prototype.mx_binding_BindabilityInfo_classChangeEvents;


/**
 * @private
 * @type {Object}
 */
mx.binding.BindabilityInfo.prototype.mx_binding_BindabilityInfo_childChangeEvents;


/**
 *  Object containing { eventName: true } for each change event
 *  (class- or child-level) that applies to the specified child.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {string} childName
 * @return {Object}
 */
mx.binding.BindabilityInfo.prototype.getChangeEvents = function(childName) {
  var /** @type {Object} */ changeEvents = this.mx_binding_BindabilityInfo_childChangeEvents[childName];
  if (!changeEvents) {
    changeEvents = this.mx_binding_BindabilityInfo_copyProps(this.mx_binding_BindabilityInfo_getClassChangeEvents(), {});
    var /** @type {Array} */ accessorsAndMethods = [];
    org.apache.royale.reflection.utils.getMembersWithNameMatch(this.mx_binding_BindabilityInfo_typeDefinition.accessors, childName, accessorsAndMethods);
    org.apache.royale.reflection.utils.getMembersWithNameMatch(this.mx_binding_BindabilityInfo_typeDefinition.methods, childName, accessorsAndMethods);
    var /** @type {number} */ numChildren = (accessorsAndMethods.length) >> 0;
    if (numChildren == 0) {
      org.apache.royale.utils.Language.trace("warning: no describeType entry for '" + childName + "' on non-dynamic type '" + this.mx_binding_BindabilityInfo_typeDefinition.name + "'");
    } else {
      if (numChildren > 1) {
        org.apache.royale.utils.Language.trace("warning: multiple describeType entries for '" + childName + "' on type '" + this.mx_binding_BindabilityInfo_typeDefinition.name + "':\n" + accessorsAndMethods);
      }
      this.mx_binding_BindabilityInfo_addBindabilityEvents(accessorsAndMethods, changeEvents);
    }
    this.mx_binding_BindabilityInfo_childChangeEvents[childName] = changeEvents;
  }
  return changeEvents;
};


/**
 *  @asprivate
 *  Build or return cached class change events object.
 * @private
 * @return {Object}
 */
mx.binding.BindabilityInfo.prototype.mx_binding_BindabilityInfo_getClassChangeEvents = function() {
  if (!this.mx_binding_BindabilityInfo_classChangeEvents) {
    this.mx_binding_BindabilityInfo_classChangeEvents = {};
    if (this.mx_binding_BindabilityInfo_typeDefinition.retrieveMetaDataByName('Bindable').length) {
      this.mx_binding_BindabilityInfo_classChangeEvents[org.apache.royale.events.ValueChangeEvent.VALUE_CHANGE] = true;
    }
    if (this.mx_binding_BindabilityInfo_typeDefinition.retrieveMetaDataByName('Managed').length) {
      this.mx_binding_BindabilityInfo_classChangeEvents[org.apache.royale.events.ValueChangeEvent.VALUE_CHANGE] = true;
    }
  }
  return this.mx_binding_BindabilityInfo_classChangeEvents;
};


/**
 *  @asprivate
 * @private
 * @param {Array} members
 * @param {Object} eventListObj
 */
mx.binding.BindabilityInfo.prototype.mx_binding_BindabilityInfo_addBindabilityEvents = function(members, eventListObj) {
  var /** @type {Array} */ metaNames = [mx.binding.BindabilityInfo.BINDABLE];
  var /** @type {Array} */ changeEvents = org.apache.royale.reflection.utils.filterForMetaTags(members, metaNames);
  this.mx_binding_BindabilityInfo_addChangeEvents(changeEvents, eventListObj);
};


/**
 *  @asprivate
 *  Transfer change events from a list of change-event-carrying metadata
 *  to an event list object.
 *  Note: metadata's first arg value is assumed to be change event name.
 * @private
 * @param {Array} members
 * @param {Object} eventListObj
 */
mx.binding.BindabilityInfo.prototype.mx_binding_BindabilityInfo_addChangeEvents = function(members, eventListObj) {
  var foreachiter0_target = members;
  for (var foreachiter0 in foreachiter0_target) 
  {
  var md = foreachiter0_target[foreachiter0];
  {
    var /** @type {Array} */ metaNames = [mx.binding.BindabilityInfo.BINDABLE];
    var foreachiter1_target = metaNames;
    for (var foreachiter1 in foreachiter1_target) 
    {
    var meta = foreachiter1_target[foreachiter1];
    {
      var /** @type {Array} */ metaItems = md.retrieveMetaDataByName(meta);
      if (metaItems.length) {
        var foreachiter2_target = metaItems;
        for (var foreachiter2 in foreachiter2_target) 
        {
        var metaItem = foreachiter2_target[foreachiter2];
        {
          if (metaItem.args.length) {
            var /** @type {Array} */ eventTypeArgs = metaItem.getArgsByKey('');
            if (!eventTypeArgs.length) {
              eventTypeArgs = metaItem.getArgsByKey('event');
            }
            if (eventTypeArgs.length) {
              eventListObj[org.apache.royale.utils.Language.as(eventTypeArgs[0], org.apache.royale.reflection.MetaDataArgDefinition, true).value] = true;
            }
          } else {
            if (meta == mx.binding.BindabilityInfo.BINDABLE) {
              eventListObj[org.apache.royale.events.ValueChangeEvent.VALUE_CHANGE] = true;
            } else {
              org.apache.royale.utils.Language.trace("warning: unconverted change events metadata in class '" + this.mx_binding_BindabilityInfo_typeDefinition.name + "'", metaItem);
            }
          }
        }}
        
      }
    }}
    
  }}
  
};


/**
 *  @asprivate
 *  Copy properties from one object to another.
 * @private
 * @param {Object} from
 * @param {Object} to
 * @return {Object}
 */
mx.binding.BindabilityInfo.prototype.mx_binding_BindabilityInfo_copyProps = function(from, to) {
  for (var /** @type {string} */ propName in from) {
    to[propName] = from[propName];
  }
  return to;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.binding.BindabilityInfo.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'BindabilityInfo', qName: 'mx.binding.BindabilityInfo', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.binding.BindabilityInfo.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        '|getCachedInfo': { type: 'mx.binding.BindabilityInfo', declaredBy: 'mx.binding.BindabilityInfo', parameters: function () { return [ 'Object', false ]; }},
        'BindabilityInfo': { type: '', declaredBy: 'mx.binding.BindabilityInfo', parameters: function () { return [ 'org.apache.royale.reflection.TypeDefinition', false ,'Boolean', true ]; }},
        'getChangeEvents': { type: 'Object', declaredBy: 'mx.binding.BindabilityInfo', parameters: function () { return [ 'String', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.binding.BindabilityInfo.prototype.ROYALE_COMPILE_FLAGS = 10;