/**
 * Generated by Apache Royale Compiler from mx/binding/Binding.as
 * mx.binding.Binding
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.binding.Binding');
/* Royale Static Dependency List: mx.core.mx_internal,org.apache.royale.utils.Language*/

goog.require('XML');
goog.require('XMLList');
goog.require('mx.binding.BindingManager');
goog.require('mx.collections.errors.ItemPendingError');
goog.require('mx.core.mx_internal');
goog.require('org.apache.royale.utils.Language');



/**
 *  Create a Binding object
 *
 *  @asparam document The document that is the target of all of this work.
 *
 *  @asparam srcFunc The function that returns us the value
 *  to use in this Binding.
 *
 *  @asparam destFunc The function that will take a value
 *  and assign it to the destination.
 *
 *  @asparam destString The destination represented as a String.
 *  We can then tell the ValidationManager to validate this field.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @param {Object} document
 * @param {Function} srcFunc
 * @param {Function} destFunc
 * @param {string} destString
 * @param {string=} srcString
 */
mx.binding.Binding = function(document, srcFunc, destFunc, destString, srcString) {
  srcString = typeof srcString !== 'undefined' ? srcString : null;
  ;
  this.http_$$www_adobe_com$2006$flex$mx$internal__document = document;
  this.http_$$www_adobe_com$2006$flex$mx$internal__srcFunc = srcFunc;
  this.http_$$www_adobe_com$2006$flex$mx$internal__destFunc = destFunc;
  this.http_$$www_adobe_com$2006$flex$mx$internal__destString = destString;
  this.http_$$www_adobe_com$2006$flex$mx$internal__srcString = srcString;
  this.http_$$www_adobe_com$2006$flex$mx$internal__destFuncFailed = false;
  if (this.http_$$www_adobe_com$2006$flex$mx$internal__srcFunc == null) {
    this.http_$$www_adobe_com$2006$flex$mx$internal__srcFunc = org.apache.royale.utils.Language.closure(this.mx_binding_Binding_defaultSrcFunc, this, 'mx_binding_Binding_defaultSrcFunc');
  }
  if (this.http_$$www_adobe_com$2006$flex$mx$internal__destFunc == null) {
    this.http_$$www_adobe_com$2006$flex$mx$internal__destFunc = org.apache.royale.utils.Language.closure(this.mx_binding_Binding_defaultDestFunc, this, 'mx_binding_Binding_defaultDestFunc');
  }
  this.http_$$www_adobe_com$2006$flex$mx$internal___isEnabled = true;
  this.http_$$www_adobe_com$2006$flex$mx$internal__isExecuting = false;
  this.http_$$www_adobe_com$2006$flex$mx$internal__isHandlingEvent = false;
  this.mx_binding_Binding_hasHadValue = false;
  this.uiComponentWatcher = -1;
  mx.binding.BindingManager.addBinding(document, destString, this);
};


/**
 * @type {Object}
 */
mx.binding.Binding.http_$$www_adobe_com$2006$flex$mx$internal__allowedErrors;


/**
 * @nocollapse
 * @return {Object}
 */
mx.binding.Binding.http_$$www_adobe_com$2006$flex$mx$internal__generateAllowedErrors = function() {
  var /** @type {Object} */ o = {};
  o[1507] = 1;
  o[2005] = 1;
  return o;
};


/**
 * @type {boolean}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal___isEnabled;


/**
 * @type {boolean}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__isExecuting;


/**
 * @type {boolean}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__isHandlingEvent;


/**
 * @type {Object}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests;


/**
 * @private
 * @type {boolean}
 */
mx.binding.Binding.prototype.mx_binding_Binding_hasHadValue;


/**
 * @type {number}
 */
mx.binding.Binding.prototype.uiComponentWatcher = 0;


/**
 * @type {mx.binding.Binding}
 */
mx.binding.Binding.prototype.twoWayCounterpart;


/**
 * @type {boolean}
 */
mx.binding.Binding.prototype.isTwoWayPrimary;


/**
 * @private
 * @type {boolean}
 */
mx.binding.Binding.prototype.mx_binding_Binding_wrappedFunctionSuccessful;


/**
 * @type {Object}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__document;


/**
 * @type {Function}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__srcFunc;


/**
 * @type {Function}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__destFunc;


/**
 * @type {boolean}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__destFuncFailed;


/**
 * @type {string}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__destString;


/**
 * @type {string}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__srcString;


/**
 * @private
 * @type {Object}
 */
mx.binding.Binding.prototype.mx_binding_Binding_lastValue;


/**
 * @private
 * @param {Object} value
 */
mx.binding.Binding.prototype.mx_binding_Binding_defaultDestFunc = function(value) {
  var /** @type {Array} */ chain = this.http_$$www_adobe_com$2006$flex$mx$internal__destString.split(".");
  var /** @type {Object} */ element = this.http_$$www_adobe_com$2006$flex$mx$internal__document;
  var /** @type {number} */ i = 0;
  if (chain[0] == "this") {
    i++;
  }
  while (i < (chain.length - 1)) {
    element = element[chain[i++]];
    if (element == null) {
      this.http_$$www_adobe_com$2006$flex$mx$internal__destFuncFailed = true;
      if (mx.binding.BindingManager.debugDestinationStrings[this.http_$$www_adobe_com$2006$flex$mx$internal__destString]) {
        org.apache.royale.utils.Language.trace("Binding: destString = " + this.http_$$www_adobe_com$2006$flex$mx$internal__destString + ", error = 1009");
      }
      return;
    }
  }
  element[chain[i]] = value;
};


/**
 * @private
 * @return {Object}
 */
mx.binding.Binding.prototype.mx_binding_Binding_defaultSrcFunc = function() {
  return this.http_$$www_adobe_com$2006$flex$mx$internal__document[this.http_$$www_adobe_com$2006$flex$mx$internal__srcString];
};


/**
 *  Execute the binding.
 *  Call the source function and get the value we'll use.
 *  Then call the destination function passing the value as an argument.
 *  Finally try to validate the destination.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object=} o
 */
mx.binding.Binding.prototype.execute = function(o) {
  o = typeof o !== 'undefined' ? o : null;
  if (!this.http_$$www_adobe_com$2006$flex$mx$internal__isEnabled) {
    if (o != null) {
      this.mx_binding_Binding_registerDisabledExecute(o);
    }
    return;
  }
  if (this.twoWayCounterpart && !this.twoWayCounterpart.mx_binding_Binding_hasHadValue && this.twoWayCounterpart.isTwoWayPrimary) {
    this.twoWayCounterpart.execute();
    this.mx_binding_Binding_hasHadValue = true;
    return;
  }
  if (this.http_$$www_adobe_com$2006$flex$mx$internal__isExecuting || (this.twoWayCounterpart && this.twoWayCounterpart.http_$$www_adobe_com$2006$flex$mx$internal__isExecuting)) {
    this.mx_binding_Binding_hasHadValue = true;
    return;
  }
  try {
    this.http_$$www_adobe_com$2006$flex$mx$internal__isExecuting = true;
    this.wrapFunctionCall(this, org.apache.royale.utils.Language.closure(this.mx_binding_Binding_innerExecute, this, 'mx_binding_Binding_innerExecute'), o);
  } catch (error) {
  } finally {
    this.http_$$www_adobe_com$2006$flex$mx$internal__isExecuting = false;
  }
};


/**
 * @asprivate 
 * Take note of any execute request that occur when we are disabled. 
 * @private
 * @param {Object} o
 */
mx.binding.Binding.prototype.mx_binding_Binding_registerDisabledExecute = function(o) {
  if (o != null) {
    this.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests = (this.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests != null) ? this.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests : new Object();
    this.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests[o] = true;
  }
};


/**
 * @asprivate 
 * Resynch with any watchers that may have updated while we were disabled.
 * @private
 */
mx.binding.Binding.prototype.mx_binding_Binding_processDisabledRequests = function() {
  if (this.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests != null) {
    for (var /** @type {Object} */ key in this.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests) {
      this.execute(key);
    }
    this.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests = null;
  }
};


/**
 *  @asprivate
 *  Note: use of this wrapper needs to be reexamined. Currently there's at least one situation where a
 *	wrapped function invokes another wrapped function, which is unnecessary (i.e., only the inner function
 *  will throw), and also risks future errors due to the 'wrappedFunctionSuccessful' member variable
 *  being stepped on. Leaving alone for now to minimize pre-GMC volatility, but should be revisited for
 *  an early dot release.
 *  Also note that the set of suppressed error codes below is repeated verbatim in Watcher.wrapUpdate.
 *  These need to be consolidated and the motivations for each need to be documented.
 * @protected
 * @param {Object} thisArg
 * @param {Function} wrappedFunction
 * @param {Object=} object
 * @param {...} args
 * @return {Object}
 */
mx.binding.Binding.prototype.wrapFunctionCall = function(thisArg, wrappedFunction, object, args) {
  args = Array.prototype.slice.call(arguments, 3);
  object = typeof object !== 'undefined' ? object : null;
  this.mx_binding_Binding_wrappedFunctionSuccessful = false;
  try {
    var /** @type {Object} */ result = wrappedFunction.apply(thisArg, args);
    if (this.http_$$www_adobe_com$2006$flex$mx$internal__destFuncFailed == true) {
      this.http_$$www_adobe_com$2006$flex$mx$internal__destFuncFailed = false;
      return null;
    }
    this.mx_binding_Binding_wrappedFunctionSuccessful = true;
    return result;
  } catch (error) {
    if (org.apache.royale.utils.Language.is(error, mx.collections.errors.ItemPendingError)) {
      if (mx.binding.BindingManager.debugDestinationStrings[this.http_$$www_adobe_com$2006$flex$mx$internal__destString]) {
        org.apache.royale.utils.Language.trace("Binding: destString = " + this.http_$$www_adobe_com$2006$flex$mx$internal__destString + ", error = " + error);
      }
    } else if (org.apache.royale.utils.Language.is(error, RangeError)) {
      if (mx.binding.BindingManager.debugDestinationStrings[this.http_$$www_adobe_com$2006$flex$mx$internal__destString]) {
        org.apache.royale.utils.Language.trace("Binding: destString = " + this.http_$$www_adobe_com$2006$flex$mx$internal__destString + ", error = " + error);
      }
    } else {
      if (error) {
      } else {
        if (mx.binding.BindingManager.debugDestinationStrings[this.http_$$www_adobe_com$2006$flex$mx$internal__destString]) {
          org.apache.royale.utils.Language.trace("Binding: destString = " + this.http_$$www_adobe_com$2006$flex$mx$internal__destString + ", error = " + error);
        }
      }
    }
  }
  return null;
};


/**
 *	@asprivate
 *  true if XMLLists x and y contain the same node sequence.
 * @private
 * @param {XMLList} x
 * @param {XMLList} y
 * @return {boolean}
 */
mx.binding.Binding.nodeSeqEqual = function(x, y) {
  var /** @type {number} */ n = (x.length()) >>> 0;
  if (n == y.length()) {
    for (var /** @type {number} */ i = 0; i < n && x[i] === y[i]; i++) {
    }
    return i == n;
  } else {
    return false;
  }
};


/**
 *  @asprivate
 * @private
 */
mx.binding.Binding.prototype.mx_binding_Binding_innerExecute = function() {
  this.http_$$www_adobe_com$2006$flex$mx$internal__destFuncFailed = false;
  var /** @type {Object} */ value = this.wrapFunctionCall(this.http_$$www_adobe_com$2006$flex$mx$internal__document, this.http_$$www_adobe_com$2006$flex$mx$internal__srcFunc);
  if (mx.binding.BindingManager.debugDestinationStrings[this.http_$$www_adobe_com$2006$flex$mx$internal__destString]) {
    org.apache.royale.utils.Language.trace("Binding: destString = " + this.http_$$www_adobe_com$2006$flex$mx$internal__destString + ", srcFunc result = " + value);
  }
  if (this.mx_binding_Binding_hasHadValue || this.mx_binding_Binding_wrappedFunctionSuccessful) {
    if (!(org.apache.royale.utils.Language.is(this.mx_binding_Binding_lastValue, XML) && this.mx_binding_Binding_lastValue.hasComplexContent() && this.mx_binding_Binding_lastValue === value) && !(org.apache.royale.utils.Language.is(this.mx_binding_Binding_lastValue, XMLList) && this.mx_binding_Binding_lastValue.hasComplexContent() && org.apache.royale.utils.Language.is(value, XMLList) && mx.binding.Binding.nodeSeqEqual(org.apache.royale.utils.Language.as(this.mx_binding_Binding_lastValue, XMLList), org.apache.royale.utils.Language.as(value, XMLList)))) {
      this.http_$$www_adobe_com$2006$flex$mx$internal__destFunc.call(this.http_$$www_adobe_com$2006$flex$mx$internal__document, value);
      if (this.http_$$www_adobe_com$2006$flex$mx$internal__destFuncFailed == false) {
        this.mx_binding_Binding_lastValue = value;
        this.mx_binding_Binding_hasHadValue = true;
      }
    }
  }
};


/**
 *  This function is called when one of this binding's watchers
 *  detects a property change.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {boolean} commitEvent
 * @param {number} cloneIndex
 */
mx.binding.Binding.prototype.watcherFired = function(commitEvent, cloneIndex) {
  if (this.http_$$www_adobe_com$2006$flex$mx$internal__isHandlingEvent)
    return;
  try {
    this.http_$$www_adobe_com$2006$flex$mx$internal__isHandlingEvent = true;
    this.execute(cloneIndex);
  } finally {
    this.http_$$www_adobe_com$2006$flex$mx$internal__isHandlingEvent = false;
  }
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__isEnabled;


mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__get__isEnabled = function() {
  return this.http_$$www_adobe_com$2006$flex$mx$internal___isEnabled;
};


mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__set__isEnabled = function(value) {
  this.http_$$www_adobe_com$2006$flex$mx$internal___isEnabled = value;
  if (value) {
    this.mx_binding_Binding_processDisabledRequests();
  }
};


Object.defineProperties(mx.binding.Binding.prototype, /** @lends {mx.binding.Binding.prototype} */ {
/**
 * @type {boolean}
 */
http_$$www_adobe_com$2006$flex$mx$internal__isEnabled: {
get: mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__get__isEnabled,
set: mx.binding.Binding.prototype.http_$$www_adobe_com$2006$flex$mx$internal__set__isEnabled}}
);

mx.binding.Binding.http_$$www_adobe_com$2006$flex$mx$internal__allowedErrors = mx.binding.Binding.http_$$www_adobe_com$2006$flex$mx$internal__generateAllowedErrors();




/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.binding.Binding.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Binding', qName: 'mx.binding.Binding', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.binding.Binding.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        '|http://www.adobe.com/2006/flex/mx/internal::allowedErrors': { type: 'Object', get_set: function (/** * */ v) {return v !== undefined ? mx.binding.Binding.http_$$www_adobe_com$2006$flex$mx$internal__allowedErrors = v : mx.binding.Binding.http_$$www_adobe_com$2006$flex$mx$internal__allowedErrors;}},
        'http://www.adobe.com/2006/flex/mx/internal::_isEnabled': { type: 'Boolean', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal___isEnabled = v : inst.http_$$www_adobe_com$2006$flex$mx$internal___isEnabled;}},
        'http://www.adobe.com/2006/flex/mx/internal::isExecuting': { type: 'Boolean', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__isExecuting = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__isExecuting;}},
        'http://www.adobe.com/2006/flex/mx/internal::isHandlingEvent': { type: 'Boolean', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__isHandlingEvent = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__isHandlingEvent;}},
        'http://www.adobe.com/2006/flex/mx/internal::disabledRequests': { type: 'Object', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__disabledRequests;}},
        'uiComponentWatcher': { type: 'int', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.uiComponentWatcher = v : inst.uiComponentWatcher;}},
        'twoWayCounterpart': { type: 'mx.binding.Binding', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.twoWayCounterpart = v : inst.twoWayCounterpart;}},
        'isTwoWayPrimary': { type: 'Boolean', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.isTwoWayPrimary = v : inst.isTwoWayPrimary;}},
        'http://www.adobe.com/2006/flex/mx/internal::document': { type: 'Object', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__document = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__document;}},
        'http://www.adobe.com/2006/flex/mx/internal::srcFunc': { type: 'Function', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__srcFunc = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__srcFunc;}},
        'http://www.adobe.com/2006/flex/mx/internal::destFunc': { type: 'Function', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__destFunc = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__destFunc;}},
        'http://www.adobe.com/2006/flex/mx/internal::destFuncFailed': { type: 'Boolean', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__destFuncFailed = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__destFuncFailed;}},
        'http://www.adobe.com/2006/flex/mx/internal::destString': { type: 'String', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__destString = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__destString;}},
        'http://www.adobe.com/2006/flex/mx/internal::srcString': { type: 'String', get_set: function (/** mx.binding.Binding */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__srcString = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__srcString;}}
      };
    },
    accessors: function () {
      return {
        'http://www.adobe.com/2006/flex/mx/internal::isEnabled': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.binding.Binding'}
      };
    },
    methods: function () {
      return {
        '|http://www.adobe.com/2006/flex/mx/internal::generateAllowedErrors': { type: 'Object', declaredBy: 'mx.binding.Binding'},
        'Binding': { type: '', declaredBy: 'mx.binding.Binding', parameters: function () { return [ 'Object', false ,'Function', false ,'Function', false ,'String', false ,'String', true ]; }},
        'execute': { type: 'void', declaredBy: 'mx.binding.Binding', parameters: function () { return [ 'Object', true ]; }},
        'watcherFired': { type: 'void', declaredBy: 'mx.binding.Binding', parameters: function () { return [ 'Boolean', false ,'int', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.binding.Binding.prototype.ROYALE_COMPILE_FLAGS = 10;