/**
 * Generated by Apache Royale Compiler from mx/collections/AsyncListView.as
 * mx.collections.AsyncListView
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.AsyncListView');
goog.provide('mx.collections.AsyncListView.ListItemResponder');

goog.require('mx.collections.IList');
goog.require('mx.collections.errors.ItemPendingError');
goog.require('mx.core.mx_internal');
goog.require('mx.events.CollectionEvent');
goog.require('mx.events.CollectionEventKind');
goog.require('mx.events.PropertyChangeEvent');
goog.require('mx.events.PropertyChangeEventKind');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.reflection.getQualifiedClassName');
goog.require('mx.rpc.IResponder');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *
 *  @asparam list Initial value of the list property, the IList we're delegating to.
 * 
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {mx.collections.IList}
 * @param {mx.collections.IList=} list
 */
mx.collections.AsyncListView = function(list) {
  list = typeof list !== 'undefined' ? list : null;
  
  this.mx_collections_AsyncListView__createPendingItemFunction = org.apache.royale.utils.Language.closure(this.mx_collections_AsyncListView_defaultCreatePendingItemFunction, this, 'mx_collections_AsyncListView_defaultCreatePendingItemFunction');
  this.mx_collections_AsyncListView__createFailedItemFunction = org.apache.royale.utils.Language.closure(this.mx_collections_AsyncListView_defaultCreateFailedItemFunction, this, 'mx_collections_AsyncListView_defaultCreateFailedItemFunction');
  this.mx_collections_AsyncListView_pendingResponders = [];
  this.mx_collections_AsyncListView_failedItems = [];
  mx.collections.AsyncListView.base(this, 'constructor');
  this.list = list;
};
goog.inherits(mx.collections.AsyncListView, org.apache.royale.events.EventDispatcher);


/**
 * @private
 * @type {mx.collections.IList}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView__list;


/**
 *  @asprivate
 * @private
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_deleteAllPendingResponders = function() {
  var foreachiter0_target = this.mx_collections_AsyncListView_pendingResponders;
  for (var foreachiter0 in foreachiter0_target) 
  {
  var responder = foreachiter0_target[foreachiter0];
  {
    if (responder)
      responder.index = -1;
  }}
  
  this.mx_collections_AsyncListView_pendingResponders.length = 0;
  this.mx_collections_AsyncListView_failedItems.length = 0;
};


/**
 * @private
 * @type {number}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_oldLength = -1;


/**
 *  This method checks the validity of incoming CollectionEvents. 
 *  In some cases, a CollectionEvent from the underlying list may have already
 *  been received once, or have been erroneously dispatched (See SDK-30594).
 *  Thus, we check the incoming event's location against the last known length'
 *  of the list (oldLength).
 * 
 *  <p>Returns false if the index is less than 0 or greater than the previous
 *  length of the list.
 *  This only applies to ADD, REMOVE, REPLACE, and MOVE CollectionEvents.
 *  It also updates oldLength to be the current length of the list, so it
 *  should not be called twice.</p>
 * @private
 * @param {mx.events.CollectionEvent} ce
 * @return {boolean}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_isValidCollectionEvent = function(ce) {
  if (this.mx_collections_AsyncListView_oldLength < 0)
    return true;
  
/**
 * @const
 * @type {number}
 */
var location = ce.location;
  switch (ce.kind) {
    case mx.events.CollectionEventKind.ADD:
      if (location < 0 || location > this.mx_collections_AsyncListView_oldLength)
        return false;
      break;
    case mx.events.CollectionEventKind.REMOVE:
    
    case mx.events.CollectionEventKind.REPLACE:
    
    case mx.events.CollectionEventKind.MOVE:
      if (location < 0 || location >= this.mx_collections_AsyncListView_oldLength)
        return false;
      break;
  }
  this.mx_collections_AsyncListView_oldLength = this.length;
  return true;
};


/**
 *  @asprivate
 *  Fixup the pendingResponders and failedItems arrays after a change to the list.  
 *  Generally speaking, if a list[index] item changes, the pending responder for 
 *  that index is no longer needed.
 *  
 *  All "collectionChange" events are redispatched to the AsyncListView listeners.
 * @private
 * @param {mx.events.CollectionEvent} ce
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_handleCollectionChangeEvent = function(ce) {
  if (!this.mx_collections_AsyncListView_isValidCollectionEvent(ce))
    return;
  switch (ce.kind) {
    case mx.events.CollectionEventKind.REPLACE:
    
    case mx.events.CollectionEventKind.UPDATE:
      this.mx_collections_AsyncListView_deletePendingResponders(ce);
      break;
    case mx.events.CollectionEventKind.MOVE:
      this.mx_collections_AsyncListView_movePendingResponders(ce);
      break;
    case mx.events.CollectionEventKind.ADD:
      this.mx_collections_AsyncListView_shiftPendingRespondersRight(ce);
      break;
    case mx.events.CollectionEventKind.REMOVE:
      this.mx_collections_AsyncListView_shiftPendingRespondersLeft(ce);
      break;
    case mx.events.CollectionEventKind.RESET:
    
    case mx.events.CollectionEventKind.REFRESH:
      this.mx_collections_AsyncListView_deleteAllPendingResponders();
      break;
  }
  this.dispatchEvent(ce);
};


/**
 *  @asprivate
 *  Delete the ListItemResponder at the specified index, if any.
 *  If a pending responder exists, return its item.
 *   
 *  This method assumes that the responder hasn't run yet, it sets
 *  the ListItemResponder index to -1 to prevent it from updating
 *  this AsyncListView later.
 * @private
 * @param {number} index
 * @return {Object}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_deletePendingResponder = function(index) {
  if ((index < 0) || (index >= this.mx_collections_AsyncListView_pendingResponders.length))
    return null;
  
/**
 * @const
 * @type {mx.collections.AsyncListView.ListItemResponder}
 */
var pendingResponder = this.mx_collections_AsyncListView_pendingResponders[index];
  if (pendingResponder) {
    delete this.mx_collections_AsyncListView_pendingResponders[index];
    org.apache.royale.utils.Language.as(pendingResponder, mx.collections.AsyncListView.ListItemResponder, true).index = -1;
    return pendingResponder.item;
  }
  return null;
};


/**
 *  @asprivate
 *  Handler for a CollectionEventKind.UPDATE or REPLACE event. In either
 *  case a contiguous block of items (ce.items) beginning with index=ce.location
 *  has been changed.  If there are any pending requests for these indices, we
 *  assume they're no longer valid, i.e. we assume that getItemAt() should no longer
 *  return the pending item.  Likewise for failed items.
 * @private
 * @param {mx.events.CollectionEvent} ce
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_deletePendingResponders = function(ce) {
  var /** @type {number} */ index = ce.location;
  var foreachiter1_target = ce.items;
  for (var foreachiter1 in foreachiter1_target) 
  {
  var item = foreachiter1_target[foreachiter1];
  {
    this.mx_collections_AsyncListView_deletePendingResponder(index);
    delete this.mx_collections_AsyncListView_failedItems[index];
    index += 1;
  }}
  
};


/**
 *  @asprivate
 *  Handler for a CollectionEventKind.MOVE event.  The event indicates that a 
 *  contiguous block of items (ce.items), beginning with index=ce.oldLocation,
 *  has been moved to ce.location.  If pendingRequests already exist at ce.location,
 *  they're deleted first.
 * @private
 * @param {mx.events.CollectionEvent} ce
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_movePendingResponders = function(ce) {
  var /** @type {number} */ fromIndex = ce.oldLocation;
  var /** @type {number} */ toIndex = ce.location;
  var foreachiter2_target = ce.items;
  for (var foreachiter2 in foreachiter2_target) 
  {
  var item = foreachiter2_target[foreachiter2];
  {
    var /** @type {mx.collections.AsyncListView.ListItemResponder} */ pendingResponder = this.mx_collections_AsyncListView_pendingResponders[fromIndex];
    if (pendingResponder) {
      delete this.mx_collections_AsyncListView_pendingResponders[fromIndex];
      org.apache.royale.utils.Language.as(pendingResponder, mx.collections.AsyncListView.ListItemResponder, true).index = toIndex;
      this.mx_collections_AsyncListView_deletePendingResponder(toIndex);
      this.mx_collections_AsyncListView_pendingResponders[toIndex] = pendingResponder;
    }
    var /** @type {*} */ failedItem = this.mx_collections_AsyncListView_failedItems[fromIndex];
    if (failedItem !== undefined) {
      delete this.mx_collections_AsyncListView_failedItems[fromIndex];
      this.mx_collections_AsyncListView_failedItems[toIndex] = failedItem;
    }
    fromIndex += 1;
    toIndex += 1;
  }}
  
};


/**
 *  @asprivate
 *  Handler for a CollectionEventKind.ADD.  The event indicates 
 *  that a block of ce.items.length items starting at ce.location was inserted,
 *  which implies that all of the pendingResponders whose index is greater than or
 *  equal to ce.location, must be shifted right by ce.items.length.  The failedItems
 *  array is handled similarly.
 * @private
 * @param {mx.events.CollectionEvent} ce
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_shiftPendingRespondersRight = function(ce) {
  
/**
 * @const
 * @type {number}
 */
var delta = (ce.items.length) >> 0;
  
/**
 * @const
 * @type {number}
 */
var startIndex = ce.location;
  
/**
 * @const
 * @type {Array}
 */
var pendingRespondersCopy = this.mx_collections_AsyncListView_sparseCopy(this.mx_collections_AsyncListView_pendingResponders);
  this.mx_collections_AsyncListView_pendingResponders.length = 0;
  var foreachiter3_target = pendingRespondersCopy;
  for (var foreachiter3 in foreachiter3_target) 
  {
  var responder = foreachiter3_target[foreachiter3];
  {
    if (responder.index >= startIndex)
      responder.index += delta;
    this.mx_collections_AsyncListView_pendingResponders[responder.index] = responder;
  }}
  
  for (var /** @type {number} */ index = (this.mx_collections_AsyncListView_failedItems.length - 1) >> 0; index >= startIndex; index--) {
    var /** @type {*} */ failedItem = this.mx_collections_AsyncListView_failedItems[index];
    if (failedItem !== undefined) {
      delete this.mx_collections_AsyncListView_failedItems[index];
      this.mx_collections_AsyncListView_failedItems[index + delta] = failedItem;
    }
  }
};


/**
 *  @asprivate
 *  Handler for a CollectionEventKind.REMOVE.  The event indicates 
 *  that a block of ce.items.length items starting at ce.location was removed,
 *  which implies that all of the pendingResponders whose index is greater than or
 *  equal to ce.location, must be shifted left by ce.items.length.  The failedItems
 *  array is handled similarly.
 * @private
 * @param {mx.events.CollectionEvent} ce
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_shiftPendingRespondersLeft = function(ce) {
  
/**
 * @const
 * @type {number}
 */
var delta = (ce.items.length) >> 0;
  
/**
 * @const
 * @type {number}
 */
var startIndex = (ce.location + delta) >> 0;
  
/**
 * @const
 * @type {Array}
 */
var pendingRespondersCopy = this.mx_collections_AsyncListView_sparseCopy(this.mx_collections_AsyncListView_pendingResponders);
  this.mx_collections_AsyncListView_pendingResponders.length = 0;
  var foreachiter4_target = pendingRespondersCopy;
  for (var foreachiter4 in foreachiter4_target) 
  {
  var responder = foreachiter4_target[foreachiter4];
  {
    if (responder.index >= startIndex)
      responder.index -= delta;
    this.mx_collections_AsyncListView_pendingResponders[responder.index] = responder;
  }}
  
  
/**
 * @const
 * @type {number}
 */
var failedItemsLength = (this.mx_collections_AsyncListView_failedItems.length) >> 0;
  for (var /** @type {number} */ index = startIndex; index < failedItemsLength; index++) {
    var /** @type {*} */ failedItem = this.mx_collections_AsyncListView_failedItems[index];
    if (failedItem !== undefined) {
      delete this.mx_collections_AsyncListView_failedItems[index];
      this.mx_collections_AsyncListView_failedItems[index - delta] = failedItem;
    }
  }
};


/**
 *  Applying concat() to a sparse array produces a new array that's
 *  not sparse, nulls replace items that were undefined.  Although the 
 *  result of this method is not sparse, it only includes items that 
 *  were in the original array.
 * @private
 * @param {Array} a
 * @return {Array}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_sparseCopy = function(a) {
  
/**
 * @const
 * @type {Array}
 */
var r = [];
  var /** @type {number} */ index = 0;
  var foreachiter5_target = a;
  for (var foreachiter5 in foreachiter5_target) 
  {
  var item = foreachiter5_target[foreachiter5];
  {
    if (item !== undefined)
      r[index++] = item;
  }}
  
  return r;
};


/**
 * @private
 * @type {Function}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView__createPendingItemFunction;


/**
 *  @asprivate
 * @private
 * @param {number} index
 * @param {mx.collections.errors.ItemPendingError} ipe
 * @return {Object}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_defaultCreatePendingItemFunction = function(index, ipe) {
  return null;
};


/**
 * @private
 * @type {Function}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView__createFailedItemFunction;


/**
 *  @asprivate
 * @private
 * @param {number} index
 * @param {Object} info
 * @return {Object}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_defaultCreateFailedItemFunction = function(index, info) {
  return null;
};


/**
 * @private
 * @const
 * @type {Array}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_pendingResponders;


/**
 * @private
 * @const
 * @type {Array}
 */
mx.collections.AsyncListView.prototype.mx_collections_AsyncListView_failedItems;


/**
 *  @asprivate
 *  Called by the ListItemProvider/result() method when a pending request
 *  completes successfully.
 * 
 *  @asparam index The item's index.
 *  @asparam info The informational object passed to IResponder/result().
 *  @see mx.rpc.IResponder#result
 * @param {number} index
 * @param {Object} info
 */
mx.collections.AsyncListView.prototype.http_$$www_adobe_com$2006$flex$mx$internal__pendingRequestSucceeded = function(index, info) {
  delete this.mx_collections_AsyncListView_pendingResponders[index];
};


/**
 *  @asprivate
 *  Called by the ListItemProvider/fault() method when a pending request
 *  fails.
 * 
 *  @asparam index The item's index.
 *  @asparam info The informational object passed to IResponder/fault().
 *  @see mx.rpc.IResponder#fault
 * @param {number} index
 * @param {Object} info
 */
mx.collections.AsyncListView.prototype.http_$$www_adobe_com$2006$flex$mx$internal__pendingRequestFailed = function(index, info) {
  delete this.mx_collections_AsyncListView_pendingResponders[index];
  if (this.createFailedItemFunction === null)
    return;
  
/**
 * @const
 * @type {Object}
 */
var item = this.createFailedItemFunction(index, info);
  this.mx_collections_AsyncListView_failedItems[index] = item;
  
/**
 * @const
 * @type {boolean}
 */
var hasCollectionListener = this.hasEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE);
  
/**
 * @const
 * @type {boolean}
 */
var hasPropertyListener = this.hasEventListener(mx.events.PropertyChangeEvent.PROPERTY_CHANGE);
  var /** @type {mx.events.PropertyChangeEvent} */ pce;
  if (hasCollectionListener || hasPropertyListener) {
    pce = new mx.events.PropertyChangeEvent(mx.events.PropertyChangeEvent.PROPERTY_CHANGE);
    pce.kind = mx.events.PropertyChangeEventKind.UPDATE;
    pce.oldValue = null;
    pce.newValue = item;
    pce.property = index;
  }
  if (hasCollectionListener) {
    var /** @type {mx.events.CollectionEvent} */ ce = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE);
    ce.kind = mx.events.CollectionEventKind.REPLACE;
    ce.location = index;
    ce.items.push(pce);
    this.dispatchEvent(ce);
  }
  if (hasPropertyListener)
    this.dispatchEvent(pce);
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} item
 */
mx.collections.AsyncListView.prototype.addItem = function(item) {
  if (this.list) {
    try {
      this.list.addItem(item);
    } catch (ignore) {
    }
  }
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} item
 * @param {number} index
 */
mx.collections.AsyncListView.prototype.addItemAt = function(item, index) {
  if (this.list) {
    try {
      this.list.addItemAt(item, index);
    } catch (ignore) {
    }
  }
};


/**
 *  Returns the value of <code>list.getItemAt(index)</code>.
 * 
 *  <p>This method catches ItemPendingErrors (IPEs) generated as a consequence of 
 *  calling <code>getItemAt()</code>.  If an IPE is thrown, an <code>IResponder</code> is added to
 *  the IPE and a provisional "pending" item, created with the 
 *  <code>createPendingItemFunction</code> is returned.   If the underlying request
 *  eventually succeeds, the pending item is replaced with the real item.  If it fails,
 *  the pending item is replaced with a value produced by calling
 *  <code>createFailedItemFunction</code>.</p>
 * 
 *  @asparam index The list index from which to retrieve the item.
 *
 *  @asparam prefetch An <code>int</code> indicating both the direction
 *    and number of items to fetch during the request if the item is not local.
 * 
 *  @throws RangeError if <code>index &lt; 0</code> or <code>index >= length</code>.
 * 
 *  @asreturn The list item at the specified index.
 * 
 *  @see #createPendingItemFunction
 *  @see #createFailedItemFunction
 *  @see mx.collections.errors.ItemPendingError
 *  @see mx.rpc.IResponder 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {number} index
 * @param {number=} prefetch
 * @return {Object}
 */
mx.collections.AsyncListView.prototype.getItemAt = function(index, prefetch) {
  prefetch = typeof prefetch !== 'undefined' ? prefetch : 0;
  if (!this.list)
    return null;
  
/**
 * @const
 * @type {*}
 */
var failedItem = this.mx_collections_AsyncListView_failedItems[index];
  if (failedItem !== undefined)
    return failedItem;
  
/**
 * @const
 * @type {mx.collections.AsyncListView.ListItemResponder}
 */
var pendingResponder = this.mx_collections_AsyncListView_pendingResponders[index];
  if (pendingResponder)
    return pendingResponder.item;
  var /** @type {Object} */ item = null;
  try {
    return this.list.getItemAt(index, prefetch);
  } catch (ipe) {
    
/**
 * @const
 * @type {Function}
 */
var createPendingItem = this.createPendingItemFunction;
    if (createPendingItem !== null)
      item = createPendingItem(index, ipe);
    var /** @type {mx.collections.AsyncListView.ListItemResponder} */ responder = new mx.collections.AsyncListView.ListItemResponder(this, index, item);
    this.mx_collections_AsyncListView_pendingResponders[index] = responder;
    ipe.addResponder(responder);
  }
  return item;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} item
 * @return {number}
 */
mx.collections.AsyncListView.prototype.getItemIndex = function(item) {
  
/**
 * @const
 * @type {number}
 */
var failedItemIndex = (this.mx_collections_AsyncListView_failedItems.indexOf(item)) >> 0;
  if (failedItemIndex != -1)
    return failedItemIndex;
  var foreachiter6_target = this.mx_collections_AsyncListView_pendingResponders;
  for (var foreachiter6 in foreachiter6_target) 
  {
  var responder = foreachiter6_target[foreachiter6];
  
    if (responder && responder.item === item)
      return responder.index;}
  
  return (this.list ? this.list.getItemIndex(item) : -1) >> 0;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} item
 * @param {Object=} property
 * @param {Object=} oldValue
 * @param {Object=} newValue
 */
mx.collections.AsyncListView.prototype.itemUpdated = function(item, property, oldValue, newValue) {
  property = typeof property !== 'undefined' ? property : null;
  oldValue = typeof oldValue !== 'undefined' ? oldValue : null;
  newValue = typeof newValue !== 'undefined' ? newValue : null;
  if (this.list)
    this.list.itemUpdated(item, property, oldValue, newValue);
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 */
mx.collections.AsyncListView.prototype.removeAll = function() {
  if (this.list)
    this.list.removeAll();
};


/**
 *  Removes the specified item from this list, should it exist.
 *  Relies on ArrayList implementation
 *
 *  @asparam  item Object reference to the item that should be removed.
 *  @asreturn Boolean indicating if the item was removed.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Apache Flex 4.10
 * @param {Object} item
 * @return {boolean}
 */
mx.collections.AsyncListView.prototype.removeItem = function(item) {
  var /** @type {Object} */ _item = this.removeItemAt(this.getItemIndex(item));
  return _item != null;
};


/**
 *  Removes the actual or pending item at the specified index and returns it.
 *  All items whose index is greater than the specified index  
 *  have their index reduced by 1.
 * 
 *  <p>If there is no actual or pending item at the specified index, for
 *  example because a call to <code>getItemAt(index)</code> hasn't caused the data to be 
 *  paged in, then the underlying <code>list</code> may throw an ItemPendingError.  
 *  The  implementation ignores the ItemPendingError and returns null.</p>
 *
 *  @asparam index The list index from which to retrieve the item.
 *
 *  @throws RangeError if <code>index &lt; 0</code> or <code>index >= length</code>.
 *
 *  @asreturn The item that was removed or null.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {number} index
 * @return {Object}
 */
mx.collections.AsyncListView.prototype.removeItemAt = function(index) {
  if (!this.list)
    return null;
  
/**
 * @const
 * @type {*}
 */
var failedItem = this.mx_collections_AsyncListView_failedItems[index];
  delete this.mx_collections_AsyncListView_failedItems[index];
  
/**
 * @const
 * @type {Object}
 */
var pendingItem = this.mx_collections_AsyncListView_deletePendingResponder(index);
  try {
    
/**
 * @const
 * @type {Object}
 */
var actualItem = this.list.removeItemAt(index);
    if (failedItem !== undefined)
      return failedItem;
    return pendingItem ? pendingItem : actualItem;
  } catch (ipe) {
  }
  return (failedItem !== undefined) ? failedItem : pendingItem;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} item
 * @param {number} index
 * @return {Object}
 */
mx.collections.AsyncListView.prototype.setItemAt = function(item, index) {
  if (!this.list)
    return null;
  
/**
 * @const
 * @type {*}
 */
var failedItem = this.mx_collections_AsyncListView_failedItems[index];
  
/**
 * @const
 * @type {mx.collections.AsyncListView.ListItemResponder}
 */
var pendingResponder = this.mx_collections_AsyncListView_pendingResponders[index];
  var /** @type {Object} */ setItemValue = null;
  try {
    setItemValue = this.list.setItemAt(item, index);
  } catch (ignore) {
  }
  if (failedItem !== undefined)
    return failedItem;
  else
    return pendingResponder ? pendingResponder.item : setItemValue;
};


/**
 *  Returns an array with the same elements as this AsyncListView.  The array is initialized
 *  by retrieving each item with <code>getItemAt()</code>, so pending items are substituted where actual
 *  values aren't available yet.   The array will not be updated when the AsyncListView replaces
 *  the pending items with actual (or failed) values.
 *  
 *  @asreturn an array with the same elements as this AsyncListView.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @return {Array}
 */
mx.collections.AsyncListView.prototype.toArray = function() {
  if (!this.list)
    return [];
  
/**
 * @const
 * @type {Array}
 */
var a = new Array(this.list.length);
  for (var /** @type {number} */ i = 0; i < a.length; i++)
    a[i] = this.getItemAt(i);
  return a;
};


/**
 *  Returns a string that contains the list's length and the number of pending item requests.  
 *  It does not trigger pending requests.
 * 
 *  @asreturn A brief description of the list.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @return {string}
 */
mx.collections.AsyncListView.prototype.toString = function() {
  var /** @type {string} */ s = org.apache.royale.reflection.getQualifiedClassName(this);
  if (this.list) {
    var /** @type {number} */ nRequests = 0;
    var foreachiter7_target = this.mx_collections_AsyncListView_pendingResponders;
    for (var foreachiter7 in foreachiter7_target) 
    {
    var responder = foreachiter7_target[foreachiter7];
    {
      if (responder)
        nRequests += 1;
    }}
    
    s += " length=" + this.length + ", " + nRequests + " pending requests";
  }
  else
    s += " no list";
  return s;
};


/**
 * @nocollapse
 * @export
 * @type {mx.collections.IList}
 */
mx.collections.AsyncListView.prototype.list;


mx.collections.AsyncListView.prototype.get__list = function() {
  return this.mx_collections_AsyncListView__list;
};


mx.collections.AsyncListView.prototype.set__list = function(value) {
  if (this.mx_collections_AsyncListView__list == value)
    return;
  this.mx_collections_AsyncListView_deleteAllPendingResponders();
  this.mx_collections_AsyncListView_oldLength = -1;
  if (this.mx_collections_AsyncListView__list)
    this.mx_collections_AsyncListView__list.removeEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.mx_collections_AsyncListView_handleCollectionChangeEvent, this, 'mx_collections_AsyncListView_handleCollectionChangeEvent'));
  this.mx_collections_AsyncListView__list = value;
  if (this.mx_collections_AsyncListView__list) {
    this.mx_collections_AsyncListView__list.addEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.mx_collections_AsyncListView_handleCollectionChangeEvent, this, 'mx_collections_AsyncListView_handleCollectionChangeEvent'));
    this.mx_collections_AsyncListView_oldLength = this.mx_collections_AsyncListView__list.length;
  }
  this.dispatchEvent(new org.apache.royale.events.Event("listChanged"));
  this.dispatchEvent(new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE, false, false, mx.events.CollectionEventKind.RESET));
};


/**
 * @nocollapse
 * @export
 * @type {Function}
 */
mx.collections.AsyncListView.prototype.createPendingItemFunction;


mx.collections.AsyncListView.prototype.get__createPendingItemFunction = function() {
  return this.mx_collections_AsyncListView__createPendingItemFunction;
};


mx.collections.AsyncListView.prototype.set__createPendingItemFunction = function(value) {
  this.mx_collections_AsyncListView__createPendingItemFunction = value;
};


/**
 * @nocollapse
 * @export
 * @type {Function}
 */
mx.collections.AsyncListView.prototype.createFailedItemFunction;


mx.collections.AsyncListView.prototype.get__createFailedItemFunction = function() {
  return this.mx_collections_AsyncListView__createFailedItemFunction;
};


mx.collections.AsyncListView.prototype.set__createFailedItemFunction = function(value) {
  this.mx_collections_AsyncListView__createFailedItemFunction = value;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.collections.AsyncListView.prototype.length;


mx.collections.AsyncListView.prototype.get__length = function() {
  try {
    return (this.list ? this.list.length : 0) >> 0;
  } catch (ignore) {
  }
  return 0;
};


Object.defineProperties(mx.collections.AsyncListView.prototype, /** @lends {mx.collections.AsyncListView.prototype} */ {
/**
 * @type {mx.collections.IList}
 */
list: {
get: mx.collections.AsyncListView.prototype.get__list,
set: mx.collections.AsyncListView.prototype.set__list},
/**
 * @type {Function}
 */
createPendingItemFunction: {
get: mx.collections.AsyncListView.prototype.get__createPendingItemFunction,
set: mx.collections.AsyncListView.prototype.set__createPendingItemFunction},
/**
 * @type {Function}
 */
createFailedItemFunction: {
get: mx.collections.AsyncListView.prototype.get__createFailedItemFunction,
set: mx.collections.AsyncListView.prototype.set__createFailedItemFunction},
/**
 * @type {number}
 */
length: {
get: mx.collections.AsyncListView.prototype.get__length}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.AsyncListView.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AsyncListView', qName: 'mx.collections.AsyncListView', kind: 'class' }], interfaces: [mx.collections.IList] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.AsyncListView.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'list': { type: 'mx.collections.IList', access: 'readwrite', declaredBy: 'mx.collections.AsyncListView', metadata: function () { return [ { name: 'Bindable', args: [ { key: '', value: 'listChanged' } ] } ]; }},
        'createPendingItemFunction': { type: 'Function', access: 'readwrite', declaredBy: 'mx.collections.AsyncListView'},
        'createFailedItemFunction': { type: 'Function', access: 'readwrite', declaredBy: 'mx.collections.AsyncListView'},
        'length': { type: 'int', access: 'readonly', declaredBy: 'mx.collections.AsyncListView', metadata: function () { return [ { name: 'Bindable', args: [ { key: '', value: 'collectionChange' } ] } ]; }}
      };
    },
    methods: function () {
      return {
        'AsyncListView': { type: '', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'mx.collections.IList', true ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::pendingRequestSucceeded': { type: 'void', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'int', false ,'Object', false ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::pendingRequestFailed': { type: 'void', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'int', false ,'Object', false ]; }},
        'addItem': { type: 'void', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'Object', false ]; }},
        'addItemAt': { type: 'void', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'Object', false ,'int', false ]; }},
        'getItemAt': { type: 'Object', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'int', false ,'int', true ]; }},
        'getItemIndex': { type: 'int', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'Object', false ]; }},
        'itemUpdated': { type: 'void', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'Object', false ,'Object', true ,'Object', true ,'Object', true ]; }},
        'removeAll': { type: 'void', declaredBy: 'mx.collections.AsyncListView'},
        'removeItem': { type: 'Boolean', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'Object', false ]; }},
        'removeItemAt': { type: 'Object', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'int', false ]; }},
        'setItemAt': { type: 'Object', declaredBy: 'mx.collections.AsyncListView', parameters: function () { return [ 'Object', false ,'int', false ]; }},
        'toArray': { type: 'Array', declaredBy: 'mx.collections.AsyncListView'},
        'toString': { type: 'String', declaredBy: 'mx.collections.AsyncListView'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.AsyncListView.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @constructor
 * @implements {mx.rpc.IResponder}
 * @param {mx.collections.AsyncListView} asyncListView
 * @param {number} index
 * @param {Object} item
 */
mx.collections.AsyncListView.ListItemResponder = function(asyncListView, index, item) {
  ;
  this.ListItemResponder_asyncListView = asyncListView;
  this.index = index;
  this.item = item;
};


/**
 * @private
 * @type {mx.collections.AsyncListView}
 */
mx.collections.AsyncListView.ListItemResponder.prototype.ListItemResponder_asyncListView;


/**
 * @type {number}
 */
mx.collections.AsyncListView.ListItemResponder.prototype.index = -1;


/**
 * @type {Object}
 */
mx.collections.AsyncListView.ListItemResponder.prototype.item = null;


/**
 * @param {Object} info
 */
mx.collections.AsyncListView.ListItemResponder.prototype.result = function(info) {
  if (this.index != -1)
    this.ListItemResponder_asyncListView.http_$$www_adobe_com$2006$flex$mx$internal__pendingRequestSucceeded(this.index, info);
};


/**
 * @param {Object} info
 */
mx.collections.AsyncListView.ListItemResponder.prototype.fault = function(info) {
  if (this.index != -1)
    this.ListItemResponder_asyncListView.http_$$www_adobe_com$2006$flex$mx$internal__pendingRequestFailed(this.index, info);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.AsyncListView.ListItemResponder.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ListItemResponder', qName: 'mx.collections.AsyncListView.ListItemResponder', kind: 'class' }], interfaces: [mx.rpc.IResponder] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.AsyncListView.ListItemResponder.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'index': { type: 'int', get_set: function (/** mx.collections.AsyncListView.ListItemResponder */ inst, /** * */ v) {return v !== undefined ? inst.index = v : inst.index;}},
        'item': { type: 'Object', get_set: function (/** mx.collections.AsyncListView.ListItemResponder */ inst, /** * */ v) {return v !== undefined ? inst.item = v : inst.item;}}
      };
    },
    methods: function () {
      return {
        'ListItemResponder': { type: '', declaredBy: 'mx.collections.AsyncListView.ListItemResponder', parameters: function () { return [ 'mx.collections.AsyncListView', false ,'int', false ,'Object', false ]; }},
        'result': { type: 'void', declaredBy: 'mx.collections.AsyncListView.ListItemResponder', parameters: function () { return [ 'Object', false ]; }},
        'fault': { type: 'void', declaredBy: 'mx.collections.AsyncListView.ListItemResponder', parameters: function () { return [ 'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.AsyncListView.ListItemResponder.prototype.ROYALE_COMPILE_FLAGS = 10;