/**
 * Generated by Apache Royale Compiler from mx/collections/ComplexFieldChangeWatcher.as
 * mx.collections.ComplexFieldChangeWatcher
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.ComplexFieldChangeWatcher');
goog.provide('mx.collections.ComplexFieldChangeWatcher.Closure');

goog.require('mx.binding.utils.ChangeWatcher');
goog.require('mx.collections.ICollectionView');
goog.require('mx.collections.IComplexSortField');
goog.require('mx.collections.IList');
goog.require('mx.core.mx_internal');
goog.require('mx.events.CollectionEvent');
goog.require('mx.events.CollectionEventKind');
goog.require('mx.events.PropertyChangeEvent');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 */
mx.collections.ComplexFieldChangeWatcher = function() {
  mx.collections.ComplexFieldChangeWatcher.base(this, 'constructor');
};
goog.inherits(mx.collections.ComplexFieldChangeWatcher, org.apache.royale.events.EventDispatcher);


/**
 * @private
 * @type {mx.collections.IList}
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher__list;


/**
 * @private
 * @type {mx.collections.ICollectionView}
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher__listCollection;


/**
 */
mx.collections.ComplexFieldChangeWatcher.prototype.stopWatchingForComplexFieldChanges = function() {
  this.mx_collections_ComplexFieldChangeWatcher_unwatchListForChanges();
  this.mx_collections_ComplexFieldChangeWatcher_unwatchAllItems();
};


/**
 * @private
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_unwatchAllItems = function() {
};


/**
 * @private
 * @param {Array} items
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_unwatchArrayOfItems = function(items) {
  for (var /** @type {number} */ i = 0; i < items.length; i++) {
    this.mx_collections_ComplexFieldChangeWatcher_unwatchItem(items[i]);
  }
};


/**
 * @private
 * @param {Object} item
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_unwatchItem = function(item) {
};


/**
 */
mx.collections.ComplexFieldChangeWatcher.prototype.startWatchingForComplexFieldChanges = function() {
  this.mx_collections_ComplexFieldChangeWatcher_watchListForChanges();
  this.mx_collections_ComplexFieldChangeWatcher_watchAllItems();
};


/**
 * @private
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_watchAllItems = function() {
  this.mx_collections_ComplexFieldChangeWatcher_watchItems(this.list);
};


/**
 * @private
 * @param {mx.collections.IList} items
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_watchItems = function(items) {
  if (this.mx_collections_ComplexFieldChangeWatcher_sortFields) {
    for (var /** @type {number} */ i = 0; i < items.length; i++) {
      this.mx_collections_ComplexFieldChangeWatcher_watchItem(items.getItemAt(i), this.mx_collections_ComplexFieldChangeWatcher_sortFields);
    }
  }
};


/**
 * @private
 * @param {Array} items
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_watchArrayOfItems = function(items) {
  if (this.mx_collections_ComplexFieldChangeWatcher_sortFields) {
    for (var /** @type {number} */ i = 0; i < items.length; i++) {
      this.mx_collections_ComplexFieldChangeWatcher_watchItem(items[i], this.mx_collections_ComplexFieldChangeWatcher_sortFields);
    }
  }
};


/**
 * @private
 * @param {Object} item
 * @param {Array} fieldsToWatch
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_watchItem = function(item, fieldsToWatch) {
  if (item) {
    for (var /** @type {number} */ i = 0; i < fieldsToWatch.length; i++) {
      var /** @type {mx.collections.IComplexSortField} */ sortField = org.apache.royale.utils.Language.as(fieldsToWatch[i], mx.collections.IComplexSortField);
      if (sortField && sortField.nameParts) {
        this.mx_collections_ComplexFieldChangeWatcher_watchItemForField(item, sortField.nameParts);
      }
    }
  }
};


/**
 * @private
 * @param {Object} item
 * @param {Array} chain
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_watchItemForField = function(item, chain) {
};


/**
 * @private
 * @param {mx.binding.utils.ChangeWatcher} watcher
 * @param {Object} forItem
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_addWatcher = function(watcher, forItem) {
};


/**
 * @private
 * @param {Object} item
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_onComplexValueChanged = function(item) {
  this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(item, null, null, null));
};


/**
 * @private
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_watchListForChanges = function() {
};


/**
 * @private
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_unwatchListForChanges = function() {
  if (this.list)
    this.list.removeEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.mx_collections_ComplexFieldChangeWatcher_onCollectionChanged, this, 'mx_collections_ComplexFieldChangeWatcher_onCollectionChanged'));
};


/**
 * @private
 * @param {mx.events.CollectionEvent} event
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_onCollectionChanged = function(event) {
  switch (event.kind) {
    case mx.events.CollectionEventKind.ADD:
      this.mx_collections_ComplexFieldChangeWatcher_watchArrayOfItems(event.items);
      break;
    case mx.events.CollectionEventKind.REMOVE:
      this.mx_collections_ComplexFieldChangeWatcher_unwatchArrayOfItems(event.items);
      break;
    case mx.events.CollectionEventKind.REFRESH:
    
    case mx.events.CollectionEventKind.RESET:
      this.mx_collections_ComplexFieldChangeWatcher_reset();
      break;
  }
};


/**
 * @private
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_reset = function() {
  this.mx_collections_ComplexFieldChangeWatcher_unwatchAllItems();
  this.mx_collections_ComplexFieldChangeWatcher_watchAllItems();
};


/**
 * @type {Array}
 */
mx.collections.ComplexFieldChangeWatcher.prototype.mx_collections_ComplexFieldChangeWatcher_sortFields;


mx.collections.ComplexFieldChangeWatcher.prototype.get__mx_collections_ComplexFieldChangeWatcher_sortFields = function() {
  return this.mx_collections_ComplexFieldChangeWatcher__listCollection && this.mx_collections_ComplexFieldChangeWatcher__listCollection.sort ? this.mx_collections_ComplexFieldChangeWatcher__listCollection.sort.fields : null;
};


/**
 * @nocollapse
 * @export
 * @type {mx.collections.IList}
 */
mx.collections.ComplexFieldChangeWatcher.prototype.http_$$www_adobe_com$2006$flex$mx$internal__list;


mx.collections.ComplexFieldChangeWatcher.prototype.http_$$www_adobe_com$2006$flex$mx$internal__set__list = function(value) {
  if (this.mx_collections_ComplexFieldChangeWatcher__list != value) {
    this.stopWatchingForComplexFieldChanges();
    this.mx_collections_ComplexFieldChangeWatcher__list = value;
    this.mx_collections_ComplexFieldChangeWatcher__listCollection = org.apache.royale.utils.Language.as(value, mx.collections.ICollectionView);
  }
};


/**
 * @nocollapse
 * @type {mx.collections.IList}
 */
mx.collections.ComplexFieldChangeWatcher.prototype.list;


mx.collections.ComplexFieldChangeWatcher.prototype.get__list = function() {
  return this.mx_collections_ComplexFieldChangeWatcher__list;
};


Object.defineProperties(mx.collections.ComplexFieldChangeWatcher.prototype, /** @lends {mx.collections.ComplexFieldChangeWatcher.prototype} */ {
/**
 * @type {Array}
 */
mx_collections_ComplexFieldChangeWatcher_sortFields: {
get: mx.collections.ComplexFieldChangeWatcher.prototype.get__mx_collections_ComplexFieldChangeWatcher_sortFields},
/**
 * @type {mx.collections.IList}
 */
http_$$www_adobe_com$2006$flex$mx$internal__list: {
set: mx.collections.ComplexFieldChangeWatcher.prototype.http_$$www_adobe_com$2006$flex$mx$internal__set__list},
/**
 * @type {mx.collections.IList}
 */
list: {
get: mx.collections.ComplexFieldChangeWatcher.prototype.get__list}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.ComplexFieldChangeWatcher.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ComplexFieldChangeWatcher', qName: 'mx.collections.ComplexFieldChangeWatcher', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.ComplexFieldChangeWatcher.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'http://www.adobe.com/2006/flex/mx/internal::list': { type: 'mx.collections.IList', access: 'writeonly', declaredBy: 'mx.collections.ComplexFieldChangeWatcher'}
      };
    },
    methods: function () {
      return {
        'stopWatchingForComplexFieldChanges': { type: 'void', declaredBy: 'mx.collections.ComplexFieldChangeWatcher'},
        'startWatchingForComplexFieldChanges': { type: 'void', declaredBy: 'mx.collections.ComplexFieldChangeWatcher'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.ComplexFieldChangeWatcher.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @constructor
 * @param {Object} cachedObject
 * @param {Function} cachedFunction
 */
mx.collections.ComplexFieldChangeWatcher.Closure = function(cachedObject, cachedFunction) {
  this.Closure__object = cachedObject;
  this.Closure__function = cachedFunction;
};


/**
 * @private
 * @type {Object}
 */
mx.collections.ComplexFieldChangeWatcher.Closure.prototype.Closure__object;


/**
 * @private
 * @type {Function}
 */
mx.collections.ComplexFieldChangeWatcher.Closure.prototype.Closure__function;


/**
 * @param {org.apache.royale.events.Event} event
 */
mx.collections.ComplexFieldChangeWatcher.Closure.prototype.callFunctionOnObject = function(event) {
  this.Closure__function.apply(null, [this.Closure__object]);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.ComplexFieldChangeWatcher.Closure.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Closure', qName: 'mx.collections.ComplexFieldChangeWatcher.Closure', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.ComplexFieldChangeWatcher.Closure.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'Closure': { type: '', declaredBy: 'mx.collections.ComplexFieldChangeWatcher.Closure', parameters: function () { return [ 'Object', false ,'Function', false ]; }},
        'callFunctionOnObject': { type: 'void', declaredBy: 'mx.collections.ComplexFieldChangeWatcher.Closure', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.ComplexFieldChangeWatcher.Closure.prototype.ROYALE_COMPILE_FLAGS = 10;