/**
 * Generated by Apache Royale Compiler from mx/collections/DefaultSummaryCalculator.as
 * mx.collections.DefaultSummaryCalculator
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.DefaultSummaryCalculator');

goog.require('mx.collections.SummaryField2');
goog.require('mx.collections.ISummaryCalculator');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 * @constructor
 * @implements {mx.collections.ISummaryCalculator}
 */
mx.collections.DefaultSummaryCalculator = function() {
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 4
 * @param {mx.collections.SummaryField2} field
 * @return {Object}
 */
mx.collections.DefaultSummaryCalculator.prototype.summaryCalculationBegin = function(field) {
  var /** @type {string} */ dataField = field.dataField;
  var /** @type {Object} */ newObj = {};
  switch (field.summaryOperation) {
    case "SUM":
      newObj[dataField] = 0;
      break;
    case "MIN":
      newObj[dataField] = Number.MAX_VALUE;
      break;
    case "MAX":
      newObj[dataField] = -Number.MAX_VALUE;
      break;
    case "COUNT":
      newObj[dataField] = [];
      newObj[dataField + "Counter"] = 0;
      break;
    case "AVG":
      newObj[dataField] = 0;
      newObj[dataField + "Count"] = 0;
      break;
  }
  return newObj;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 4
 * @param {Object} data
 * @param {mx.collections.SummaryField2} field
 * @param {Object} rowData
 */
mx.collections.DefaultSummaryCalculator.prototype.calculateSummary = function(data, field, rowData) {
  var /** @type {string} */ dataField = field.dataField;
  var /** @type {number} */ value = Number(rowData[dataField]);
  if (typeof(value) == "xml")
    value = Number(value.toString());
  switch (field.summaryOperation) {
    case "SUM":
      if (!data.hasOwnProperty(dataField))
        data[dataField] = value;
      else
        data[dataField] += value;
      break;
    case "MIN":
      if (!data.hasOwnProperty(dataField))
        data[dataField] = value;
      else
        data[dataField] = data[dataField] < value ? data[dataField] : value;
      break;
    case "MAX":
      if (!data.hasOwnProperty(dataField))
        data[dataField] = value;
      else
        data[dataField] = data[dataField] > value ? data[dataField] : value;
      break;
    case "COUNT":
      if (!data.hasOwnProperty(dataField)) {
        data[dataField] = [rowData[dataField]];
        data[dataField + "Counter"] = 1;
      } else {
        data[dataField].push(rowData[dataField]);
        data[dataField + "Counter"] = data[dataField + "Counter"] + 1;
      }
      break;
    case "AVG":
      if (!data.hasOwnProperty(dataField)) {
        data[dataField] = value;
        data[dataField + "Count"] = 1;
      } else {
        data[dataField] += value;
        data[dataField + "Count"] = data[dataField + "Count"] + 1;
      }
      break;
  }
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 4
 * @param {Object} data
 * @param {mx.collections.SummaryField2} field
 * @return {number}
 */
mx.collections.DefaultSummaryCalculator.prototype.returnSummary = function(data, field) {
  var /** @type {number} */ summary = 0;
  var /** @type {string} */ dataField = field.dataField;
  switch (field.summaryOperation) {
    case "SUM":
    
    case "MIN":
    
    case "MAX":
      summary = Number(data[dataField]);
      break;
    case "COUNT":
      summary = Number(data[dataField + "Counter"]);
      break;
    case "AVG":
      summary = data[dataField] / data[dataField + "Count"];
      break;
  }
  return summary;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 4
 * @param {Object} value
 * @param {mx.collections.SummaryField2} field
 * @return {Object}
 */
mx.collections.DefaultSummaryCalculator.prototype.summaryOfSummaryCalculationBegin = function(value, field) {
  var /** @type {Object} */ newObj = {};
  for (var /** @type {string} */ p in value) {
    newObj[p] = value[p];
  }
  return newObj;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 4
 * @param {Object} oldValue
 * @param {Object} newValue
 * @param {mx.collections.SummaryField2} field
 */
mx.collections.DefaultSummaryCalculator.prototype.calculateSummaryOfSummary = function(oldValue, newValue, field) {
  var /** @type {string} */ p;
  switch (field.summaryOperation) {
    case "AVG":
    
    case "SUM":
      for (p in newValue) {
        oldValue[p] += newValue[p];
      }
      break;
    case "MIN":
      for (p in newValue) {
        oldValue[p] = oldValue[p] < newValue[p] ? oldValue[p] : newValue[p];
      }
      break;
    case "MAX":
      for (p in newValue) {
        oldValue[p] = oldValue[p] > newValue[p] ? oldValue[p] : newValue[p];
      }
      break;
    case "COUNT":
      for (p in newValue) {
        if (org.apache.royale.utils.Language.is(oldValue[p], Array))
          oldValue[p] = oldValue[p].concat(newValue[p]);
        else
          oldValue[p] += newValue[p];
      }
      break;
  }
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 4
 * @param {Object} oldValue
 * @param {mx.collections.SummaryField2} field
 * @return {number}
 */
mx.collections.DefaultSummaryCalculator.prototype.returnSummaryOfSummary = function(oldValue, field) {
  var /** @type {number} */ summary = 0;
  var /** @type {string} */ dataField = field.dataField;
  switch (field.summaryOperation) {
    case "SUM":
    
    case "MIN":
    
    case "MAX":
      summary = Number(oldValue[dataField]);
      break;
    case "COUNT":
      summary = Number(oldValue[dataField + "Counter"]);
      break;
    case "AVG":
      summary = oldValue[dataField] / oldValue[dataField + "Count"];
      break;
  }
  return summary;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.DefaultSummaryCalculator.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'DefaultSummaryCalculator', qName: 'mx.collections.DefaultSummaryCalculator', kind: 'class' }], interfaces: [mx.collections.ISummaryCalculator] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.DefaultSummaryCalculator.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'summaryCalculationBegin': { type: 'Object', declaredBy: 'mx.collections.DefaultSummaryCalculator', parameters: function () { return [ 'mx.collections.SummaryField2', false ]; }},
        'calculateSummary': { type: 'void', declaredBy: 'mx.collections.DefaultSummaryCalculator', parameters: function () { return [ 'Object', false ,'mx.collections.SummaryField2', false ,'Object', false ]; }},
        'returnSummary': { type: 'Number', declaredBy: 'mx.collections.DefaultSummaryCalculator', parameters: function () { return [ 'Object', false ,'mx.collections.SummaryField2', false ]; }},
        'summaryOfSummaryCalculationBegin': { type: 'Object', declaredBy: 'mx.collections.DefaultSummaryCalculator', parameters: function () { return [ 'Object', false ,'mx.collections.SummaryField2', false ]; }},
        'calculateSummaryOfSummary': { type: 'void', declaredBy: 'mx.collections.DefaultSummaryCalculator', parameters: function () { return [ 'Object', false ,'Object', false ,'mx.collections.SummaryField2', false ]; }},
        'returnSummaryOfSummary': { type: 'Number', declaredBy: 'mx.collections.DefaultSummaryCalculator', parameters: function () { return [ 'Object', false ,'mx.collections.SummaryField2', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.DefaultSummaryCalculator.prototype.ROYALE_COMPILE_FLAGS = 10;