/**
 * Generated by Apache Royale Compiler from mx/collections/GroupingField.as
 * mx.collections.GroupingField
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.GroupingField');
goog.require('XML');



/**
 *  Constructor.
 *
 *  @asparam name The name of the property that this field uses for
 *              comparison.
 *              If the object is a simple type, pass <code>null</code>.
 *  @asparam caseInsensitive When sorting strings, tells the comparitor
 *              whether to ignore the case of the values.
 *  @asparam descending Tells the comparator whether to arrange items in
 *              descending order.
 *  @asparam numeric Tells the comparitor whether to compare sort items as
 *              numbers, instead of alphabetically.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @constructor
 * @param {string=} name
 * @param {boolean=} caseInsensitive
 * @param {boolean=} descending
 * @param {boolean=} numeric
 */
mx.collections.GroupingField = function(name, caseInsensitive, descending, numeric) {
  name = typeof name !== 'undefined' ? name : null;
  caseInsensitive = typeof caseInsensitive !== 'undefined' ? caseInsensitive : false;
  descending = typeof descending !== 'undefined' ? descending : false;
  numeric = typeof numeric !== 'undefined' ? numeric : false;
  ;
  this.mx_collections_GroupingField__name = name;
  this.mx_collections_GroupingField__caseInsensitive = caseInsensitive;
  this.mx_collections_GroupingField__descending = descending;
  this.mx_collections_GroupingField__numeric = numeric;
};


/**
 * @private
 * @type {boolean}
 */
mx.collections.GroupingField.prototype.mx_collections_GroupingField__caseInsensitive;


/**
 * @private
 * @type {Function}
 */
mx.collections.GroupingField.prototype.mx_collections_GroupingField__compareFunction;


/**
 * @private
 * @type {boolean}
 */
mx.collections.GroupingField.prototype.mx_collections_GroupingField__descending;


/**
 * @private
 * @type {string}
 */
mx.collections.GroupingField.prototype.mx_collections_GroupingField__name;


/**
 * @private
 * @type {boolean}
 */
mx.collections.GroupingField.prototype.mx_collections_GroupingField__numeric;


/**
 * @type {Function}
 */
mx.collections.GroupingField.prototype.groupingFunction;


/**
 * @type {Function}
 */
mx.collections.GroupingField.prototype.groupingObjectFunction;


/**
 * @type {Array}
 */
mx.collections.GroupingField.prototype.summaries;


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.collections.GroupingField.prototype.caseInsensitive;


mx.collections.GroupingField.prototype.get__caseInsensitive = function() {
  return this.mx_collections_GroupingField__caseInsensitive;
};


mx.collections.GroupingField.prototype.set__caseInsensitive = function(value) {
  if (value != this.mx_collections_GroupingField__caseInsensitive) {
    this.mx_collections_GroupingField__caseInsensitive = value;
  }
};


/**
 * @nocollapse
 * @export
 * @type {Function}
 */
mx.collections.GroupingField.prototype.compareFunction;


mx.collections.GroupingField.prototype.get__compareFunction = function() {
  return this.mx_collections_GroupingField__compareFunction;
};


mx.collections.GroupingField.prototype.set__compareFunction = function(c) {
  this.mx_collections_GroupingField__compareFunction = c;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.collections.GroupingField.prototype.descending;


mx.collections.GroupingField.prototype.get__descending = function() {
  return this.mx_collections_GroupingField__descending;
};


mx.collections.GroupingField.prototype.set__descending = function(value) {
  if (this.mx_collections_GroupingField__descending != value) {
    this.mx_collections_GroupingField__descending = value;
  }
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.collections.GroupingField.prototype.name;


mx.collections.GroupingField.prototype.get__name = function() {
  return this.mx_collections_GroupingField__name;
};


mx.collections.GroupingField.prototype.set__name = function(n) {
  this.mx_collections_GroupingField__name = n;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.collections.GroupingField.prototype.numeric;


mx.collections.GroupingField.prototype.get__numeric = function() {
  return this.mx_collections_GroupingField__numeric;
};


mx.collections.GroupingField.prototype.set__numeric = function(value) {
  if (this.mx_collections_GroupingField__numeric != value) {
    this.mx_collections_GroupingField__numeric = value;
  }
};


Object.defineProperties(mx.collections.GroupingField.prototype, /** @lends {mx.collections.GroupingField.prototype} */ {
/**
 * @type {boolean}
 */
caseInsensitive: {
get: mx.collections.GroupingField.prototype.get__caseInsensitive,
set: mx.collections.GroupingField.prototype.set__caseInsensitive},
/**
 * @type {Function}
 */
compareFunction: {
get: mx.collections.GroupingField.prototype.get__compareFunction,
set: mx.collections.GroupingField.prototype.set__compareFunction},
/**
 * @type {boolean}
 */
descending: {
get: mx.collections.GroupingField.prototype.get__descending,
set: mx.collections.GroupingField.prototype.set__descending},
/**
 * @type {string}
 */
name: {
get: mx.collections.GroupingField.prototype.get__name,
set: mx.collections.GroupingField.prototype.set__name},
/**
 * @type {boolean}
 */
numeric: {
get: mx.collections.GroupingField.prototype.get__numeric,
set: mx.collections.GroupingField.prototype.set__numeric}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.GroupingField.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'GroupingField', qName: 'mx.collections.GroupingField', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.GroupingField.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'groupingFunction': { type: 'Function', get_set: function (/** mx.collections.GroupingField */ inst, /** * */ v) {return v !== undefined ? inst.groupingFunction = v : inst.groupingFunction;}},
        'groupingObjectFunction': { type: 'Function', get_set: function (/** mx.collections.GroupingField */ inst, /** * */ v) {return v !== undefined ? inst.groupingObjectFunction = v : inst.groupingObjectFunction;}},
        'summaries': { type: 'Array', get_set: function (/** mx.collections.GroupingField */ inst, /** * */ v) {return v !== undefined ? inst.summaries = v : inst.summaries;}}
      };
    },
    accessors: function () {
      return {
        'caseInsensitive': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.collections.GroupingField'},
        'compareFunction': { type: 'Function', access: 'readwrite', declaredBy: 'mx.collections.GroupingField'},
        'descending': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.collections.GroupingField'},
        'name': { type: 'String', access: 'readwrite', declaredBy: 'mx.collections.GroupingField'},
        'numeric': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.collections.GroupingField'}
      };
    },
    methods: function () {
      return {
        'GroupingField': { type: '', declaredBy: 'mx.collections.GroupingField', parameters: function () { return [ 'String', true ,'Boolean', true ,'Boolean', true ,'Boolean', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.GroupingField.prototype.ROYALE_COMPILE_FLAGS = 10;