/**
 * Generated by Apache Royale Compiler from mx/collections/HierarchicalCollectionView.as
 * mx.collections.HierarchicalCollectionView
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.HierarchicalCollectionView');

goog.require('XML');
goog.require('XMLList');
goog.require('mx.collections.ArrayCollection');
goog.require('mx.collections.CursorBookmark');
goog.require('mx.collections.HierarchicalCollectionViewCursor');
goog.require('mx.collections.ICollectionView');
goog.require('mx.collections.IHierarchicalData');
goog.require('mx.collections.ISort');
goog.require('mx.collections.IViewCursor');
goog.require('mx.collections.SortField');
goog.require('mx.collections.XMLListAdapter');
goog.require('mx.collections.XMLListCollection');
goog.require('mx.core.mx_internal');
goog.require('mx.events.CollectionEvent');
goog.require('mx.events.CollectionEventKind');
goog.require('mx.events.PropertyChangeEvent');
goog.require('mx.utils.UIDUtil');
goog.require('mx.utils.XMLNotifier');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.events.ValueChangeEvent');
goog.require('mx.collections.IHierarchicalCollectionView');
goog.require('mx.utils.IXMLNotifiable');
goog.require('org.apache.royale.utils.Language');



/**
 *  Constructor.
 *
 *  @asparam hierarchicalData The data structure containing the hierarchical data.
 *
 *  @asparam argOpenNodes The Object that defines a node to appear as open.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {mx.collections.IHierarchicalCollectionView}
 * @implements {mx.utils.IXMLNotifiable}
 * @param {mx.collections.IHierarchicalData=} hierarchicalData
 * @param {Object=} argOpenNodes
 */
mx.collections.HierarchicalCollectionView = function(hierarchicalData, argOpenNodes) {
  hierarchicalData = typeof hierarchicalData !== 'undefined' ? hierarchicalData : null;
  argOpenNodes = typeof argOpenNodes !== 'undefined' ? argOpenNodes : null;
  
  this.mx_collections_HierarchicalCollectionView_childrenMapCache = {};
  mx.collections.HierarchicalCollectionView.base(this, 'constructor');
  if (hierarchicalData)
    this.mx_collections_HierarchicalCollectionView_initializeCollection(hierarchicalData.getRoot(), hierarchicalData, argOpenNodes);
};
goog.inherits(mx.collections.HierarchicalCollectionView, org.apache.royale.events.EventDispatcher);


/**
 * @private
 * @type {mx.collections.IHierarchicalData}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_hierarchicalData;


/**
 * @private
 * @type {number}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_currentLength = 0;


/**
 * @private
 * @type {XML}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_parentNode;


/**
 * @private
 * @type {Object}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_childrenMap;


/**
 * @private
 * @type {Object}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_childrenMapCache;


/**
 * @type {mx.collections.ICollectionView}
 */
mx.collections.HierarchicalCollectionView.prototype.http_$$www_adobe_com$2006$flex$mx$internal__treeData;


/**
 * @private
 * @type {Object}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_parentMap;


/**
 * @private
 * @type {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView__hasRoot;


/**
 * @private
 * @type {Object}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView__openNodes;


/**
 * @private
 * @type {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView__showRoot = true;


/**
 * @private
 * @type {Function}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView__filterFunction;


/**
 * @private
 * @type {mx.collections.ISort}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView__sort;


/**
 *  Returns a new instance of a view iterator over the items in this view.
 *
 *  @asreturn IViewCursor instance.
 *
 *  @see mx.collections.IViewCursor
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {mx.collections.IViewCursor}
 */
mx.collections.HierarchicalCollectionView.prototype.createCursor = function() {
  return new mx.collections.HierarchicalCollectionViewCursor(this, this.http_$$www_adobe_com$2006$flex$mx$internal__treeData, this.mx_collections_HierarchicalCollectionView_hierarchicalData);
};


/**
 *  Checks the collection for the data item using standard equality test.
 *
 *  @asparam item The Object that defines the node to look for.
 *
 *  @asreturn <code>true</code> if the data item is in the collection,
 *  and <code>false</code> if not.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} item
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.contains = function(item) {
  var /** @type {mx.collections.IViewCursor} */ cursor = this.createCursor();
  while (!cursor.afterLast) {
    if (cursor.current == item)
      return true;
    cursor.moveNext();
  }
  return false;
};


/**
 *  @asprivate
 */
mx.collections.HierarchicalCollectionView.prototype.disableAutoUpdate = function() {
  this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.disableAutoUpdate();
  for (var /** @type {Object} */ p in this.mx_collections_HierarchicalCollectionView_childrenMap)
    org.apache.royale.utils.Language.as(this.mx_collections_HierarchicalCollectionView_childrenMap[p], mx.collections.ICollectionView, true).disableAutoUpdate();
};


/**
 *  @asprivate
 */
mx.collections.HierarchicalCollectionView.prototype.enableAutoUpdate = function() {
  this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.enableAutoUpdate();
  for (var /** @type {Object} */ p in this.mx_collections_HierarchicalCollectionView_childrenMap)
    org.apache.royale.utils.Language.as(this.mx_collections_HierarchicalCollectionView_childrenMap[p], mx.collections.ICollectionView, true).enableAutoUpdate();
};


/**
 *  @asprivate
 * @param {Object} item
 * @param {Object=} property
 * @param {Object=} oldValue
 * @param {Object=} newValue
 */
mx.collections.HierarchicalCollectionView.prototype.itemUpdated = function(item, property, oldValue, newValue) {
  property = typeof property !== 'undefined' ? property : null;
  oldValue = typeof oldValue !== 'undefined' ? oldValue : null;
  newValue = typeof newValue !== 'undefined' ? newValue : null;
  var /** @type {mx.events.CollectionEvent} */ event = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE);
  event.kind = mx.events.CollectionEventKind.UPDATE;
  var /** @type {mx.events.PropertyChangeEvent} */ objEvent = new mx.events.PropertyChangeEvent(mx.events.PropertyChangeEvent.PROPERTY_CHANGE);
  objEvent.source = item;
  objEvent.property = property;
  objEvent.oldValue = oldValue;
  objEvent.newValue = newValue;
  event.items.push(objEvent);
  this.dispatchEvent(event);
};


/**
 *  @inheritDoc 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.refresh = function() {
  return this.mx_collections_HierarchicalCollectionView_internalRefresh(true);
};


/**
 * @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {number}
 */
mx.collections.HierarchicalCollectionView.prototype.getNodeDepth = function(node) {
  var /** @type {number} */ depth = 1;
  var /** @type {Object} */ parent = this.getParentItem(node);
  while (parent != null) {
    parent = this.getParentItem(parent);
    depth++;
  }
  depth = ((this.hasRoot && !this.showRoot) ? (depth - 1) : depth) >> 0;
  return ((depth < 1) ? 1 : depth) >> 0;
};


/**
 *  Returns the parent of a node.  
 *  The parent of a top-level node is <code>null</code>.
 *
 *  @asparam node The Object that defines the node.
 *
 *  @asreturn The parent node containing the node, 
 *  <code>null</code> for a top-level node,  
 *  and <code>undefined</code> if the parent cannot be determined.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {*}
 */
mx.collections.HierarchicalCollectionView.prototype.getParentItem = function(node) {
  var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(node);
  if (this.mx_collections_HierarchicalCollectionView_parentMap.hasOwnProperty(uid))
    return this.mx_collections_HierarchicalCollectionView_parentMap[uid];
  return undefined;
};


/**
 * @param {string} uid
 */
mx.collections.HierarchicalCollectionView.prototype.deleteParentMapping = function(uid) {
  delete this.mx_collections_HierarchicalCollectionView_parentMap[uid];
};


/**
 * @param {string} uid
 * @param {Object} parent
 * @param {boolean=} replaceExisting
 */
mx.collections.HierarchicalCollectionView.prototype.addParentMapping = function(uid, parent, replaceExisting) {
  replaceExisting = typeof replaceExisting !== 'undefined' ? replaceExisting : true;
  if (replaceExisting || !this.mx_collections_HierarchicalCollectionView_parentMap.hasOwnProperty(uid))
    this.mx_collections_HierarchicalCollectionView_parentMap[uid] = parent;
};


/**
 *  @inheritDoc 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {mx.collections.ICollectionView}
 */
mx.collections.HierarchicalCollectionView.prototype.getChildren = function(node) {
  var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(node);
  var /** @type {*} */ children = this.mx_collections_HierarchicalCollectionView_hierarchicalData.getChildren(node);
  var /** @type {mx.collections.ICollectionView} */ childrenCollection = this.mx_collections_HierarchicalCollectionView_childrenMapCache[uid];
  if (org.apache.royale.utils.Language.is(children, XMLList) && childrenCollection) {
    org.apache.royale.utils.Language.as(childrenCollection, mx.collections.XMLListCollection, true).http_$$www_adobe_com$2006$flex$mx$internal__dispatchResetEvent = false;
    org.apache.royale.utils.Language.as(childrenCollection, mx.collections.XMLListCollection, true).source = children;
    childrenCollection.refresh();
  }
  if (childrenCollection) {
    this.mx_collections_HierarchicalCollectionView_childrenMap[mx.utils.UIDUtil.getUID(node)] = childrenCollection;
    return childrenCollection;
  }
  if (!children)
    return null;
  if (org.apache.royale.utils.Language.is(children, mx.collections.ICollectionView)) {
    childrenCollection = org.apache.royale.utils.Language.as(children, mx.collections.ICollectionView, true);
  } else if (org.apache.royale.utils.Language.is(children, Array)) {
    childrenCollection = new mx.collections.ArrayCollection(children);
  } else if (org.apache.royale.utils.Language.is(children, XMLList)) {
    childrenCollection = new mx.collections.XMLListCollection(children);
  } else {
    var /** @type {Array} */ childArray = new Array(children);
    if (childArray != null) {
      childrenCollection = new mx.collections.ArrayCollection(childArray);
    }
  }
  this.mx_collections_HierarchicalCollectionView_childrenMapCache[uid] = childrenCollection;
  var /** @type {mx.collections.ICollectionView} */ oldChildren = this.mx_collections_HierarchicalCollectionView_childrenMap[mx.utils.UIDUtil.getUID(node)];
  if (oldChildren != childrenCollection) {
    if (oldChildren != null) {
      oldChildren.removeEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.nestedCollectionChangeHandler, this, 'nestedCollectionChangeHandler'));
    }
    childrenCollection.addEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.nestedCollectionChangeHandler, this, 'nestedCollectionChangeHandler'), false);
    this.mx_collections_HierarchicalCollectionView_childrenMap[mx.utils.UIDUtil.getUID(node)] = childrenCollection;
  }
  return childrenCollection;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 */
mx.collections.HierarchicalCollectionView.prototype.openNode = function(node) {
  var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(node);
  if (this.mx_collections_HierarchicalCollectionView__openNodes[uid] != null)
    return;
  var /** @type {*} */ parent = this.getParentItem(node);
  while (parent) {
    parent = this.getParentItem(parent);
  }
  if (parent === undefined)
    return;
  this.mx_collections_HierarchicalCollectionView__openNodes[uid] = node;
  var /** @type {mx.collections.ICollectionView} */ childrenCollection = this.getChildren(node);
  if (!childrenCollection)
    return;
  if (this.mx_collections_HierarchicalCollectionView_sortCanBeApplied(childrenCollection) && !(childrenCollection.sort == null && this.sort == null)) {
    childrenCollection.sort = this.sort;
  }
  if (!(childrenCollection.filterFunction == null && this.filterFunction == null)) {
    childrenCollection.filterFunction = this.filterFunction;
  }
  childrenCollection.refresh();
  this.mx_collections_HierarchicalCollectionView_updateParentMapAndLength(childrenCollection, node);
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 */
mx.collections.HierarchicalCollectionView.prototype.closeNode = function(node) {
  var /** @type {mx.collections.ICollectionView} */ childrenCollection = this.mx_collections_HierarchicalCollectionView_childrenMap[mx.utils.UIDUtil.getUID(node)];
  delete this.mx_collections_HierarchicalCollectionView__openNodes[mx.utils.UIDUtil.getUID(node)];
  if (childrenCollection) {
    var /** @type {mx.collections.IViewCursor} */ cursor = childrenCollection.createCursor();
    while (!cursor.afterLast) {
      var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(cursor.current);
      this.deleteParentMapping(uid);
      cursor.moveNext();
    }
  }
  this.mx_collections_HierarchicalCollectionView_updateLength();
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} parent
 * @param {Object} newChild
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.addChild = function(parent, newChild) {
  if (parent == null)
    return this.addChildAt(parent, newChild, this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.length);
  else
    return this.addChildAt(parent, newChild, this.getChildren(parent).length);
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} parent
 * @param {Object} child
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.removeChild = function(parent, child) {
  var /** @type {mx.collections.IViewCursor} */ cursor;
  if (parent == null) {
    cursor = this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.createCursor();
  } else {
    var /** @type {mx.collections.ICollectionView} */ children = this.getChildren(parent);
    cursor = children.createCursor();
  }
  while (!cursor.afterLast) {
    if (cursor.current == child) {
      cursor.remove();
      return true;
    }
    cursor.moveNext();
  }
  return false;
};


/**
 *  Add a child node to a node at the specified index. 
 *  This implementation does the following:
 * 
 *  <ul>
 *      <li>If the <code>parent</code> is null or undefined,
 *          inserts the <code>child</code> at the 
 *          specified <code>index</code> in the collection specified 
 *          by <code>source</code>.
 *      </li>
 *      <li>If the <code>parent</code> has a <code>children</code>
 *          field or property, the method adds the <code>child</code> 
 *          to it at the <code>index</code> location.
 *          In this case, the <code>source</code> is not required.
 *     </li>
 *     <li>If the <code>parent</code> does not have a <code>children</code>
 *          field or property, the method adds the <code>children</code> 
 *          to the <code>parent</code>. The method then adds the 
 *          <code>child</code> to the parent at the 
 *          <code>index</code> location. 
 *          In this case, the <code>source</code> is not required.
 *     </li>
 *     <li>If the <code>index</code> value is greater than the collection 
 *         length or number of children in the parent, adds the object as
 *         the last child.
 *     </li>
 * </ul>
 *
 *  @asparam parent The Object that defines the parent node.
 * 
 *  @asparam newChild The Object that defines the child node.
 * 
 *  @asparam index The 0-based index of where to insert the child node.
 *
 *  @asreturn <code>true</code> if the child is added successfully.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} parent
 * @param {Object} newChild
 * @param {number} index
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.addChildAt = function(parent, newChild, index) {
  var /** @type {mx.collections.IViewCursor} */ cursor;
  if (!parent) {
    cursor = this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.createCursor();
  } else {
    if (!this.mx_collections_HierarchicalCollectionView_hierarchicalData.canHaveChildren(parent))
      return false;
    var /** @type {mx.collections.ICollectionView} */ children = this.getChildren(parent);
    cursor = children.createCursor();
  }
  cursor.seek(mx.collections.CursorBookmark.FIRST, index);
  cursor.insert(newChild);
  return true;
};


/**
 *  Removes the child node from a node at the specified index.
 *
 *  @asparam parent The Object that defines the parent node.
 * 
 *  @asparam index The 0-based index of  the child node to remove relative to the parent.
 * 
 *  @asreturn <code>true</code> if the child is removed successfully.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} parent
 * @param {number} index
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.removeChildAt = function(parent, index) {
  var /** @type {mx.collections.IViewCursor} */ cursor;
  if (!parent) {
    cursor = this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.createCursor();
  } else {
    var /** @type {mx.collections.ICollectionView} */ children = this.getChildren(parent);
    cursor = children.createCursor();
  }
  cursor.seek(mx.collections.CursorBookmark.FIRST, index);
  if (cursor.beforeFirst || cursor.afterLast)
    return false;
  cursor.remove();
  return true;
};


/**
 * @asprivate
 * 
 * returns the collection view of the given object
 * @private
 * @param {Object} value
 * @return {mx.collections.ICollectionView}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_getCollection = function(value) {
  if (typeof(value) == "string")
    value = new XML(value);
  else if (org.apache.royale.utils.Language.is(value, XMLList))
    value = new mx.collections.XMLListCollection(org.apache.royale.utils.Language.as(value, XMLList));
  if (org.apache.royale.utils.Language.is(value, XML)) {
    var /** @type {XMLList} */ xl = new XMLList();
    xl = xl.plus(value);
    return new mx.collections.XMLListCollection(xl);
  } else if (org.apache.royale.utils.Language.is(value, mx.collections.ICollectionView)) {
    return org.apache.royale.utils.Language.as(value, mx.collections.ICollectionView, true);
  } else if (org.apache.royale.utils.Language.is(value, Array)) {
    return new mx.collections.ArrayCollection(org.apache.royale.utils.Language.as(value, Array));
  } else if (org.apache.royale.utils.Language.is(value, Object)) {
    var /** @type {Array} */ tmp = [];
    tmp.push(value);
    return new mx.collections.ArrayCollection(tmp);
  } else {
    return new mx.collections.ArrayCollection();
  }
};


/**
 *  @asprivate
 *  
 *  Initialize the collection. set its various properties and
 *  update its length.
 * @private
 * @param {Object} model
 * @param {mx.collections.IHierarchicalData} hierarchicalData
 * @param {Object=} argOpenNodes
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_initializeCollection = function(model, hierarchicalData, argOpenNodes) {
  argOpenNodes = typeof argOpenNodes !== 'undefined' ? argOpenNodes : null;
  this.mx_collections_HierarchicalCollectionView_parentMap = {};
  this.mx_collections_HierarchicalCollectionView_childrenMap = {};
  this.mx_collections_HierarchicalCollectionView_childrenMapCache = {};
  if (this.http_$$www_adobe_com$2006$flex$mx$internal__treeData)
    this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.removeEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.collectionChangeHandler, this, 'collectionChangeHandler'), false);
  if (this.mx_collections_HierarchicalCollectionView_hierarchicalData)
    this.mx_collections_HierarchicalCollectionView_hierarchicalData.removeEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.collectionChangeHandler, this, 'collectionChangeHandler'), false);
  this.http_$$www_adobe_com$2006$flex$mx$internal__treeData = this.mx_collections_HierarchicalCollectionView_getCollection(model);
  if (this.http_$$www_adobe_com$2006$flex$mx$internal__treeData)
    this.mx_collections_HierarchicalCollectionView__hasRoot = this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.length == 1;
  var /** @type {Object} */ tmpCollection = model;
  if (hierarchicalData && !this.showRoot && this.hasRoot) {
    var /** @type {Object} */ obj = this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.createCursor().current;
    if (hierarchicalData.hasChildren(obj)) {
      tmpCollection = hierarchicalData.getChildren(obj);
      this.http_$$www_adobe_com$2006$flex$mx$internal__treeData = this.mx_collections_HierarchicalCollectionView_getCollection(tmpCollection);
    }
  }
  this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.addEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.collectionChangeHandler, this, 'collectionChangeHandler'), false);
  this.mx_collections_HierarchicalCollectionView_hierarchicalData = hierarchicalData;
  this.mx_collections_HierarchicalCollectionView_hierarchicalData.addEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.collectionChangeHandler, this, 'collectionChangeHandler'), false);
  if (argOpenNodes)
    this.mx_collections_HierarchicalCollectionView__openNodes = argOpenNodes;
  else
    this.mx_collections_HierarchicalCollectionView__openNodes = {};
  this.mx_collections_HierarchicalCollectionView_currentLength = this.calculateLength();
};


/**
 *  @asprivate
 *  
 *  Update the parent map and adjust the length.
 * @private
 * @param {mx.collections.ICollectionView} collection
 * @param {Object} node
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_updateParentMapAndLength = function(collection, node) {
  var /** @type {mx.collections.IViewCursor} */ cursor = collection.createCursor();
  this.mx_collections_HierarchicalCollectionView_currentLength += collection.length;
  while (!cursor.afterLast) {
    var /** @type {Object} */ item = cursor.current;
    var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(item);
    this.addParentMapping(uid, node);
    if (this.mx_collections_HierarchicalCollectionView__openNodes[uid] != null) {
      var /** @type {mx.collections.ICollectionView} */ childrenCollection = this.getChildren(item);
      if (childrenCollection)
        this.mx_collections_HierarchicalCollectionView_updateParentMapAndLength(childrenCollection, item);
    }
    cursor.moveNext();
  }
};


/**
 *  @asprivate
 *  Calculate the total length of the collection, but only count nodes
 *  that we can reach.
 * @param {Object=} node
 * @param {Object=} parent
 * @return {number}
 */
mx.collections.HierarchicalCollectionView.prototype.calculateLength = function(node, parent) {
  node = typeof node !== 'undefined' ? node : null;
  parent = typeof parent !== 'undefined' ? parent : null;
  var /** @type {number} */ length = 0;
  var /** @type {mx.collections.ICollectionView} */ childNodes;
  var /** @type {number} */ modelOffset = 0;
  var /** @type {boolean} */ firstNode = true;
  if (node == null) {
    var /** @type {mx.collections.IViewCursor} */ modelCursor = this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.createCursor();
    if (modelCursor.beforeFirst) {
      return this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.length;
    }
    while (!modelCursor.afterLast) {
      node = modelCursor.current;
      if (org.apache.royale.utils.Language.is(node, XML)) {
        if (firstNode) {
          firstNode = false;
          var /** @type {*} */ parNode = node.parent();
          if (parNode != null) {
            this.mx_collections_HierarchicalCollectionView_startTrackUpdates(parNode);
            this.mx_collections_HierarchicalCollectionView_childrenMap[mx.utils.UIDUtil.getUID(parNode)] = this.http_$$www_adobe_com$2006$flex$mx$internal__treeData;
            this.mx_collections_HierarchicalCollectionView_parentNode = parNode;
          }
        }
        this.mx_collections_HierarchicalCollectionView_startTrackUpdates(node);
      }
      if (node === null)
        length += 1;
      else
        length += (this.calculateLength(node, null) + 1) >> 0;
      modelOffset++;
      modelCursor.moveNext();
    }
  } else {
    var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(node);
    this.addParentMapping(uid, parent);
    if (node != null && this.openNodes[uid] && this.mx_collections_HierarchicalCollectionView_hierarchicalData.canHaveChildren(node) && this.mx_collections_HierarchicalCollectionView_hierarchicalData.hasChildren(node)) {
      childNodes = this.getChildren(node);
      if (childNodes != null) {
        var /** @type {mx.collections.IViewCursor} */ childCursor = childNodes.createCursor();
        childCursor.seek(mx.collections.CursorBookmark.FIRST);
        while (!childCursor.afterLast) {
          if (org.apache.royale.utils.Language.is(node, XML))
            this.mx_collections_HierarchicalCollectionView_startTrackUpdates(childCursor.current);
          length += (this.calculateLength(childCursor.current, node) + 1) >> 0;
          modelOffset++;
          childCursor.moveNext();
        }
      }
    }
  }
  return length;
};


/**
 *  @asprivate
 * @private
 * @param {boolean} dispatch
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_internalRefresh = function(dispatch) {
  var /** @type {Object} */ obj;
  var /** @type {mx.collections.ICollectionView} */ coll;
  var /** @type {boolean} */ needUpdate = false;
  if (!(this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.filterFunction == null && this.filterFunction == null)) {
    this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.filterFunction = this.filterFunction;
    this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.refresh();
    needUpdate = true;
  }
  var foreachiter0_target = this.openNodes;
  for (var foreachiter0 in foreachiter0_target) 
  {
  obj = foreachiter0_target[foreachiter0];
  {
    coll = this.getChildren(obj);
    if (coll && !(coll.filterFunction == null && this.filterFunction == null)) {
      coll.filterFunction = this.filterFunction;
      coll.refresh();
      needUpdate = true;
    }
  }}
  
  if (needUpdate)
    this.mx_collections_HierarchicalCollectionView_updateLength();
  if (this.mx_collections_HierarchicalCollectionView_sortCanBeApplied(this.http_$$www_adobe_com$2006$flex$mx$internal__treeData) && !(this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.sort == null && this.sort == null)) {
    this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.sort = this.sort;
    this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.refresh();
    dispatch = true;
  }
  var foreachiter1_target = this.openNodes;
  for (var foreachiter1 in foreachiter1_target) 
  {
  obj = foreachiter1_target[foreachiter1];
  {
    coll = this.getChildren(obj);
    if (coll && this.mx_collections_HierarchicalCollectionView_sortCanBeApplied(coll) && !(coll.sort == null && this.sort == null)) {
      coll.sort = this.sort;
      coll.refresh();
      dispatch = true;
    }
  }}
  
  if (dispatch) {
    var /** @type {mx.events.CollectionEvent} */ refreshEvent = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE);
    refreshEvent.kind = mx.events.CollectionEventKind.REFRESH;
    this.dispatchEvent(refreshEvent);
  }
  return true;
};


/**
 * @asprivate
 * Check if a collection has the properties on which the sort is applied.   
 * @private
 * @param {mx.collections.ICollectionView} coll
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_sortCanBeApplied = function(coll) {
  if (this.sort == null)
    return true;
  var /** @type {Object} */ obj = coll.createCursor().current;
  if (!obj || !this.sort.fields)
    return false;
  for (var /** @type {number} */ i = 0; i < this.sort.fields.length; i++) {
    var /** @type {mx.collections.SortField} */ sf = this.sort.fields[i];
    if (!obj.hasOwnProperty(sf.name))
      return false;
  }
  return true;
};


/**
 * @asprivate
 * Force a recalculation of length
 * @private
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_updateLength = function() {
  this.mx_collections_HierarchicalCollectionView_currentLength = this.calculateLength();
};


/**
 * @asprivate
 *  Fill the node array with the node and all of its visible children
 *  update the parentMap as you go.
 * @private
 * @param {Object} node
 * @param {Object} parent
 * @param {Array} nodeArray
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_getVisibleNodes = function(node, parent, nodeArray) {
  var /** @type {mx.collections.ICollectionView} */ childNodes;
  nodeArray.push(node);
  var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(node);
  this.addParentMapping(uid, parent);
  if (this.openNodes[uid] != null && this.mx_collections_HierarchicalCollectionView_hierarchicalData.canHaveChildren(node) && this.mx_collections_HierarchicalCollectionView_hierarchicalData.hasChildren(node)) {
    childNodes = this.getChildren(node);
    if (childNodes != null) {
      var /** @type {mx.collections.IViewCursor} */ cursor = childNodes.createCursor();
      while (!cursor.afterLast) {
        this.mx_collections_HierarchicalCollectionView_getVisibleNodes(cursor.current, node, nodeArray);
        cursor.moveNext();
      }
    }
  }
};


/**
 *  @asprivate
 *  Factor in the available open children before this location in the model
 * @private
 * @param {number} oldLocation
 * @return {number}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_getVisibleLocation = function(oldLocation) {
  var /** @type {number} */ newLocation = 0;
  var /** @type {mx.collections.IViewCursor} */ modelCursor = this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.createCursor();
  for (var /** @type {number} */ i = 0; i < oldLocation && !modelCursor.afterLast; i++) {
    newLocation += (this.calculateLength(modelCursor.current, null) + 1) >> 0;
    modelCursor.moveNext();
  }
  return newLocation;
};


/**
 * @asprivate
 * factor in the open children before this location in a sub collection
 * @private
 * @param {Object} parent
 * @param {number} oldLocation
 * @return {number}
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_getVisibleLocationInSubCollection = function(parent, oldLocation) {
  var /** @type {number} */ newLocation = oldLocation;
  var /** @type {Object} */ target = parent;
  parent = this.getParentItem(parent);
  var /** @type {mx.collections.ICollectionView} */ children;
  var /** @type {mx.collections.IViewCursor} */ cursor;
  while (parent != null) {
    children = this.mx_collections_HierarchicalCollectionView_childrenMap[mx.utils.UIDUtil.getUID(parent)];
    cursor = children.createCursor();
    while (!cursor.afterLast) {
      if (cursor.current == target) {
        newLocation++;
        break;
      }
      newLocation += (this.calculateLength(cursor.current, parent) + 1) >> 0;
      cursor.moveNext();
    }
    target = parent;
    parent = this.getParentItem(parent);
  }
  cursor = this.http_$$www_adobe_com$2006$flex$mx$internal__treeData.createCursor();
  while (!cursor.afterLast) {
    if (cursor.current == target) {
      newLocation++;
      break;
    }
    newLocation += (this.calculateLength(cursor.current, parent) + 1) >> 0;
    cursor.moveNext();
  }
  return newLocation;
};


/**
 *  @asprivate
 * @param {mx.events.CollectionEvent} event
 */
mx.collections.HierarchicalCollectionView.prototype.collectionChangeHandler = function(event) {
  var /** @type {number} */ i = 0;
  var /** @type {number} */ n = 0;
  //var /** @type {number} */ i = 0;
  //var /** @type {number} */ n = 0;
  var /** @type {Object} */ node;
  var /** @type {mx.events.CollectionEvent} */ convertedEvent;
  if (org.apache.royale.utils.Language.is(event, mx.events.CollectionEvent)) {
    var /** @type {mx.events.CollectionEvent} */ ce = org.apache.royale.utils.Language.as(event, mx.events.CollectionEvent, true);
    if (ce.kind == mx.events.CollectionEventKind.REFRESH) {
      this.mx_collections_HierarchicalCollectionView_updateLength();
    } else if (ce.kind == mx.events.CollectionEventKind.RESET) {
      if (this.mx_collections_HierarchicalCollectionView_hierarchicalData)
        this.mx_collections_HierarchicalCollectionView_initializeCollection(this.mx_collections_HierarchicalCollectionView_hierarchicalData.getRoot(), this.mx_collections_HierarchicalCollectionView_hierarchicalData, this.openNodes);
      this.mx_collections_HierarchicalCollectionView_updateLength();
      this.mx_collections_HierarchicalCollectionView_internalRefresh(false);
      this.dispatchEvent(event);
    } else if (ce.kind == mx.events.CollectionEventKind.ADD) {
      n = (ce.items.length) >> 0;
      convertedEvent = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE, false, true, ce.kind);
      convertedEvent.location = this.mx_collections_HierarchicalCollectionView_getVisibleLocation(ce.location);
      for (i = 0; i < n; i++) {
        node = ce.items[i];
        if (org.apache.royale.utils.Language.is(node, XML))
          this.mx_collections_HierarchicalCollectionView_startTrackUpdates(node);
        this.mx_collections_HierarchicalCollectionView_getVisibleNodes(node, null, convertedEvent.items);
      }
      this.mx_collections_HierarchicalCollectionView_currentLength += (convertedEvent.items.length) >> 0;
      this.dispatchEvent(convertedEvent);
    } else if (ce.kind == mx.events.CollectionEventKind.REMOVE) {
      n = (ce.items.length) >> 0;
      convertedEvent = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE, false, true, ce.kind);
      convertedEvent.location = this.mx_collections_HierarchicalCollectionView_getVisibleLocation(ce.location);
      for (i = 0; i < n; i++) {
        node = ce.items[i];
        if (org.apache.royale.utils.Language.is(node, XML))
          this.mx_collections_HierarchicalCollectionView_stopTrackUpdates(node);
        this.mx_collections_HierarchicalCollectionView_getVisibleNodes(node, null, convertedEvent.items);
      }
      this.mx_collections_HierarchicalCollectionView_currentLength -= (convertedEvent.items.length) >> 0;
      this.dispatchEvent(convertedEvent);
      n = (convertedEvent.items.length) >> 0;
      for (i = 0; i < n; i++) {
        this.deleteParentMapping(mx.utils.UIDUtil.getUID(convertedEvent.items[i]));
      }
    } else if (ce.kind == mx.events.CollectionEventKind.UPDATE) {
      this.dispatchEvent(event);
    } else if (ce.kind == mx.events.CollectionEventKind.REPLACE) {
      n = (ce.items.length) >> 0;
      convertedEvent = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE, false, true, mx.events.CollectionEventKind.REMOVE);
      for (i = 0; i < n; i++) {
        node = ce.items[i].oldValue;
        if (org.apache.royale.utils.Language.is(node, XML))
          this.mx_collections_HierarchicalCollectionView_stopTrackUpdates(node);
        this.mx_collections_HierarchicalCollectionView_getVisibleNodes(node, null, convertedEvent.items);
      }
      for (i = 0; i < n; i++) {
        node = ce.items[i].oldValue;
        var /** @type {number} */ replacedNodePosition = (convertedEvent.items.indexOf(node)) >> 0;
        if (replacedNodePosition != -1)
          convertedEvent.items.splice(replacedNodePosition, 1);
      }
      if (convertedEvent.items.length) {
        this.mx_collections_HierarchicalCollectionView_currentLength -= (convertedEvent.items.length) >> 0;
        this.dispatchEvent(convertedEvent);
      }
      this.dispatchEvent(event);
    }
  }
};


/**
 *  @asprivate
 * @param {mx.events.CollectionEvent} event
 */
mx.collections.HierarchicalCollectionView.prototype.nestedCollectionChangeHandler = function(event) {
  var /** @type {number} */ i = 0;
  var /** @type {number} */ n = 0;
  //var /** @type {number} */ i = 0;
  //var /** @type {number} */ n = 0;
  var /** @type {Object} */ parentOfChangingNode;
  var /** @type {Object} */ changingNode;
  var /** @type {mx.events.CollectionEvent} */ convertedEvent;
  if (org.apache.royale.utils.Language.is(event, mx.events.CollectionEvent)) {
    var /** @type {mx.events.CollectionEvent} */ ce = org.apache.royale.utils.Language.as(event, mx.events.CollectionEvent, true);
    if (ce.kind == mx.events.CollectionEventKind.EXPAND) {
      event.stopImmediatePropagation();
    } else if (ce.kind == mx.events.CollectionEventKind.ADD) {
      this.mx_collections_HierarchicalCollectionView_updateLength();
      n = (ce.items.length) >> 0;
      convertedEvent = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE, false, true, ce.kind);
      for (i = 0; i < n; i++) {
        changingNode = ce.items[i];
        if (org.apache.royale.utils.Language.is(changingNode, XML))
          this.mx_collections_HierarchicalCollectionView_startTrackUpdates(changingNode);
        parentOfChangingNode = this.getParentItem(changingNode);
        if (parentOfChangingNode != null)
          this.mx_collections_HierarchicalCollectionView_getVisibleNodes(changingNode, parentOfChangingNode, convertedEvent.items);
      }
      convertedEvent.location = this.mx_collections_HierarchicalCollectionView_getVisibleLocationInSubCollection(parentOfChangingNode, ce.location);
      this.dispatchEvent(convertedEvent);
    } else if (ce.kind == mx.events.CollectionEventKind.REMOVE) {
      n = (ce.items.length) >> 0;
      convertedEvent = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE, false, true, ce.kind);
      for (i = 0; i < n; i++) {
        changingNode = ce.items[i];
        if (org.apache.royale.utils.Language.is(changingNode, XML))
          this.mx_collections_HierarchicalCollectionView_stopTrackUpdates(changingNode);
        parentOfChangingNode = this.getParentItem(changingNode);
        if (parentOfChangingNode != null)
          this.mx_collections_HierarchicalCollectionView_getVisibleNodes(changingNode, parentOfChangingNode, convertedEvent.items);
      }
      convertedEvent.location = this.mx_collections_HierarchicalCollectionView_getVisibleLocationInSubCollection(parentOfChangingNode, ce.location);
      this.mx_collections_HierarchicalCollectionView_currentLength -= (convertedEvent.items.length) >> 0;
      this.dispatchEvent(convertedEvent);
    } else if (ce.kind == mx.events.CollectionEventKind.UPDATE) {
      this.dispatchEvent(event);
    } else if (ce.kind == mx.events.CollectionEventKind.REPLACE) {
      n = (ce.items.length) >> 0;
      convertedEvent = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE, false, true, mx.events.CollectionEventKind.REMOVE);
      for (i = 0; i < n; i++) {
        changingNode = ce.items[i].oldValue;
        parentOfChangingNode = this.getParentItem(changingNode);
        if (parentOfChangingNode != null) {
          this.mx_collections_HierarchicalCollectionView_getVisibleNodes(changingNode, parentOfChangingNode, convertedEvent.items);
          if (this.mx_collections_HierarchicalCollectionView__openNodes[mx.utils.UIDUtil.getUID(parentOfChangingNode)] != null) {
            this.addParentMapping(mx.utils.UIDUtil.getUID(ce.items[i].newValue), parentOfChangingNode);
          }
        }
      }
      for (i = 0; i < n; i++) {
        changingNode = ce.items[i].oldValue;
        if (org.apache.royale.utils.Language.is(changingNode, XML))
          this.mx_collections_HierarchicalCollectionView_stopTrackUpdates(changingNode);
        var /** @type {number} */ replacedNodePosition = (convertedEvent.items.indexOf(changingNode)) >> 0;
        if (replacedNodePosition != -1)
          convertedEvent.items.splice(replacedNodePosition, 1);
      }
      if (convertedEvent.items.length) {
        this.mx_collections_HierarchicalCollectionView_currentLength -= (convertedEvent.items.length) >> 0;
        this.dispatchEvent(convertedEvent);
      }
      this.dispatchEvent(event);
      for (i = 0; i < n; i++) {
        changingNode = ce.items[i].oldValue;
        parentOfChangingNode = this.getParentItem(changingNode);
        if (parentOfChangingNode != null && this.mx_collections_HierarchicalCollectionView__openNodes[mx.utils.UIDUtil.getUID(parentOfChangingNode)] != null)
          this.deleteParentMapping(mx.utils.UIDUtil.getUID(changingNode));
      }
    } else if (ce.kind == mx.events.CollectionEventKind.RESET) {
      this.mx_collections_HierarchicalCollectionView_updateLength();
      convertedEvent = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE, false, true, mx.events.CollectionEventKind.REFRESH);
      this.dispatchEvent(convertedEvent);
    }
  }
};


/**
 *  @asprivate
 *  Called whenever an XML object contained in a list is updated
 *  in some way.  The initial implementation stab is very lenient,
 *  any changeType will cause an update no matter how much further down
 *  in a hierarchy.  
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} currentTarget
 * @param {string} type
 * @param {Object} target
 * @param {Object} value
 * @param {Object} detail
 */
mx.collections.HierarchicalCollectionView.prototype.xmlNotification = function(currentTarget, type, target, value, detail) {
  var /** @type {number} */ location = 0;
  var /** @type {mx.collections.XMLListCollection} */ children;
  //var /** @type {number} */ location = 0;
  var /** @type {mx.events.CollectionEvent} */ event;
  var /** @type {mx.collections.XMLListAdapter} */ list;
  if (currentTarget === target) {
    switch (type) {
      case "nodeAdded":
        for (var /** @type {*} */ q in this.mx_collections_HierarchicalCollectionView_childrenMap) {
          if (q === currentTarget) {
            list = org.apache.royale.utils.Language.as(this.mx_collections_HierarchicalCollectionView_childrenMap[q].list, mx.collections.XMLListAdapter);
            if (list && !list.busy()) {
              if (this.mx_collections_HierarchicalCollectionView_childrenMap[q] === this.http_$$www_adobe_com$2006$flex$mx$internal__treeData) {
                children = org.apache.royale.utils.Language.as(this.http_$$www_adobe_com$2006$flex$mx$internal__treeData, mx.collections.XMLListCollection);
                if (this.mx_collections_HierarchicalCollectionView_parentNode != null) {
                  children.http_$$www_adobe_com$2006$flex$mx$internal__dispatchResetEvent = false;
                  children.source = this.mx_collections_HierarchicalCollectionView_parentNode.child('*');
                  children.refresh();
                }
              } else {
                children = org.apache.royale.utils.Language.as(this.getChildren(q), mx.collections.XMLListCollection);
              }
              if (children) {
                location = (value.childIndex()) >> 0;
                event = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE);
                event.kind = mx.events.CollectionEventKind.ADD;
                event.location = location;
                event.items = [value];
                children.dispatchEvent(event);
              }
            }
            break;
          }
        }
        break;
      case "nodeRemoved":
        for (var /** @type {*} */ p in this.mx_collections_HierarchicalCollectionView_childrenMap) {
          if (p === currentTarget) {
            children = this.mx_collections_HierarchicalCollectionView_childrenMap[p];
            list = org.apache.royale.utils.Language.as(children.list, mx.collections.XMLListAdapter);
            if (list && !list.busy()) {
              var /** @type {XMLList} */ xmllist = org.apache.royale.utils.Language.as(children.source, XMLList);
              if (this.mx_collections_HierarchicalCollectionView_childrenMap[p] === this.http_$$www_adobe_com$2006$flex$mx$internal__treeData) {
                children = org.apache.royale.utils.Language.as(this.http_$$www_adobe_com$2006$flex$mx$internal__treeData, mx.collections.XMLListCollection);
                if (this.mx_collections_HierarchicalCollectionView_parentNode) {
                  children.http_$$www_adobe_com$2006$flex$mx$internal__dispatchResetEvent = false;
                  children.source = this.mx_collections_HierarchicalCollectionView_parentNode.child('*');
                  children.refresh();
                }
              } else {
                var /** @type {mx.collections.XMLListCollection} */ oldChildren = children;
                children = org.apache.royale.utils.Language.as(this.getChildren(p), mx.collections.XMLListCollection);
                if (!children) {
                  oldChildren.addEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.nestedCollectionChangeHandler, this, 'nestedCollectionChangeHandler'), false);
                  event = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE);
                  event.kind = mx.events.CollectionEventKind.REMOVE;
                  event.location = 0;
                  event.items = [value];
                  oldChildren.dispatchEvent(event);
                  oldChildren.removeEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.nestedCollectionChangeHandler, this, 'nestedCollectionChangeHandler'));
                }
              }
              if (children) {
                var /** @type {number} */ n = xmllist.length();
                for (var /** @type {number} */ i = 0; i < n; i++) {
                  if (xmllist[i] === value) {
                    event = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE);
                    event.kind = mx.events.CollectionEventKind.REMOVE;
                    event.location = location;
                    event.items = [value];
                    children.dispatchEvent(event);
                    break;
                  }
                }
              }
            }
            break;
          }
        }
        break;
      default:
        break;
    }
  }
};


/** 
 *  This is called by addItemAt and when the source is initially
 *  assigned.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @private
 * @param {Object} item
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_startTrackUpdates = function(item) {
  mx.utils.XMLNotifier.getInstance().watchXML(item, this);
};


/** 
 *  This is called by removeItemAt, removeAll, and before a new
 *  source is assigned.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @private
 * @param {Object} item
 */
mx.collections.HierarchicalCollectionView.prototype.mx_collections_HierarchicalCollectionView_stopTrackUpdates = function(item) {
  mx.utils.XMLNotifier.getInstance().unwatchXML(item, this);
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.hasRoot;


mx.collections.HierarchicalCollectionView.prototype.get__hasRoot = function() {
  return this.mx_collections_HierarchicalCollectionView__hasRoot;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.collections.HierarchicalCollectionView.prototype.openNodes;


mx.collections.HierarchicalCollectionView.prototype.get__openNodes = function() {
  return this.mx_collections_HierarchicalCollectionView__openNodes;
};


mx.collections.HierarchicalCollectionView.prototype.set__openNodes = function(value) {
  if (value) {
    this.mx_collections_HierarchicalCollectionView__openNodes = {};
    var foreachiter2_target = value;
    for (var foreachiter2 in foreachiter2_target) 
    {
    var item = foreachiter2_target[foreachiter2];
    {
      this.mx_collections_HierarchicalCollectionView__openNodes[mx.utils.UIDUtil.getUID(item)] = item;
    }}
    
  }
  else
    this.mx_collections_HierarchicalCollectionView__openNodes = {};
  if (this.mx_collections_HierarchicalCollectionView_hierarchicalData) {
    this.mx_collections_HierarchicalCollectionView_currentLength = this.calculateLength();
    var /** @type {mx.events.CollectionEvent} */ event = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE);
    event.kind = mx.events.CollectionEventKind.REFRESH;
    this.dispatchEvent(event);
  }
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.collections.HierarchicalCollectionView.prototype.showRoot;


mx.collections.HierarchicalCollectionView.prototype.get__showRoot = function() {
  return this.mx_collections_HierarchicalCollectionView__showRoot;
};


mx.collections.HierarchicalCollectionView.prototype.bindable__set__showRoot_mx_collections_HierarchicalCollectionView = function(value) {
  if (this.mx_collections_HierarchicalCollectionView__showRoot != value) {
    this.mx_collections_HierarchicalCollectionView__showRoot = value;
    if (this.mx_collections_HierarchicalCollectionView_hierarchicalData) {
      this.mx_collections_HierarchicalCollectionView_initializeCollection(this.mx_collections_HierarchicalCollectionView_hierarchicalData.getRoot(), this.mx_collections_HierarchicalCollectionView_hierarchicalData, this.openNodes);
      var /** @type {mx.events.CollectionEvent} */ event = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE);
      event.kind = mx.events.CollectionEventKind.RESET;
      this.dispatchEvent(event);
    }
  }
};


mx.collections.HierarchicalCollectionView.prototype.set__showRoot = function(value) {
var oldValue = this.get__showRoot();
if (oldValue != value) {
this.bindable__set__showRoot_mx_collections_HierarchicalCollectionView(value);
    this.dispatchEvent(org.apache.royale.events.ValueChangeEvent.createUpdateEvent(
         this, "showRoot", oldValue, value));
}
};


/**
 * @nocollapse
 * @export
 * @type {mx.collections.IHierarchicalData}
 */
mx.collections.HierarchicalCollectionView.prototype.source;


mx.collections.HierarchicalCollectionView.prototype.get__source = function() {
  return this.mx_collections_HierarchicalCollectionView_hierarchicalData;
};


mx.collections.HierarchicalCollectionView.prototype.set__source = function(value) {
  this.mx_collections_HierarchicalCollectionView_initializeCollection(value.getRoot(), value, this.openNodes);
};


/**
 * @nocollapse
 * @export
 * @type {Function}
 */
mx.collections.HierarchicalCollectionView.prototype.filterFunction;


mx.collections.HierarchicalCollectionView.prototype.get__filterFunction = function() {
  return this.mx_collections_HierarchicalCollectionView__filterFunction;
};


mx.collections.HierarchicalCollectionView.prototype.set__filterFunction = function(value) {
  this.mx_collections_HierarchicalCollectionView__filterFunction = value;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.collections.HierarchicalCollectionView.prototype.length;


mx.collections.HierarchicalCollectionView.prototype.get__length = function() {
  return this.mx_collections_HierarchicalCollectionView_currentLength;
};


/**
 * @nocollapse
 * @export
 * @type {mx.collections.ISort}
 */
mx.collections.HierarchicalCollectionView.prototype.sort;


mx.collections.HierarchicalCollectionView.prototype.get__sort = function() {
  return this.mx_collections_HierarchicalCollectionView__sort;
};


mx.collections.HierarchicalCollectionView.prototype.set__sort = function(value) {
  this.mx_collections_HierarchicalCollectionView__sort = value;
};


Object.defineProperties(mx.collections.HierarchicalCollectionView.prototype, /** @lends {mx.collections.HierarchicalCollectionView.prototype} */ {
/**
 * @type {boolean}
 */
hasRoot: {
get: mx.collections.HierarchicalCollectionView.prototype.get__hasRoot},
/**
 * @type {Object}
 */
openNodes: {
get: mx.collections.HierarchicalCollectionView.prototype.get__openNodes,
set: mx.collections.HierarchicalCollectionView.prototype.set__openNodes},
/**
 * @type {boolean}
 */
showRoot: {
get: mx.collections.HierarchicalCollectionView.prototype.get__showRoot,
set: mx.collections.HierarchicalCollectionView.prototype.set__showRoot},
/**
 * @type {mx.collections.IHierarchicalData}
 */
source: {
get: mx.collections.HierarchicalCollectionView.prototype.get__source,
set: mx.collections.HierarchicalCollectionView.prototype.set__source},
/**
 * @type {Function}
 */
filterFunction: {
get: mx.collections.HierarchicalCollectionView.prototype.get__filterFunction,
set: mx.collections.HierarchicalCollectionView.prototype.set__filterFunction},
/**
 * @type {number}
 */
length: {
get: mx.collections.HierarchicalCollectionView.prototype.get__length},
/**
 * @type {mx.collections.ISort}
 */
sort: {
get: mx.collections.HierarchicalCollectionView.prototype.get__sort,
set: mx.collections.HierarchicalCollectionView.prototype.set__sort}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.HierarchicalCollectionView.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HierarchicalCollectionView', qName: 'mx.collections.HierarchicalCollectionView', kind: 'class' }], interfaces: [mx.collections.IHierarchicalCollectionView, mx.utils.IXMLNotifiable] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.HierarchicalCollectionView.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'http://www.adobe.com/2006/flex/mx/internal::treeData': { type: 'mx.collections.ICollectionView', get_set: function (/** mx.collections.HierarchicalCollectionView */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__treeData = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__treeData;}}
      };
    },
    accessors: function () {
      return {
        'hasRoot': { type: 'Boolean', access: 'readonly', declaredBy: 'mx.collections.HierarchicalCollectionView'},
        'openNodes': { type: 'Object', access: 'readwrite', declaredBy: 'mx.collections.HierarchicalCollectionView'},
        'showRoot': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.collections.HierarchicalCollectionView', metadata: function () { return [ { name: 'Bindable' } ]; }},
        'source': { type: 'mx.collections.IHierarchicalData', access: 'readwrite', declaredBy: 'mx.collections.HierarchicalCollectionView'},
        'filterFunction': { type: 'Function', access: 'readwrite', declaredBy: 'mx.collections.HierarchicalCollectionView', metadata: function () { return [ { name: 'Bindable', args: [ { key: '', value: 'filterFunctionChanged' } ] } ]; }},
        'length': { type: 'int', access: 'readonly', declaredBy: 'mx.collections.HierarchicalCollectionView'},
        'sort': { type: 'mx.collections.ISort', access: 'readwrite', declaredBy: 'mx.collections.HierarchicalCollectionView', metadata: function () { return [ { name: 'Bindable', args: [ { key: '', value: 'sortChanged' } ] } ]; }}
      };
    },
    methods: function () {
      return {
        'HierarchicalCollectionView': { type: '', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'mx.collections.IHierarchicalData', true ,'Object', true ]; }},
        'createCursor': { type: 'mx.collections.IViewCursor', declaredBy: 'mx.collections.HierarchicalCollectionView'},
        'contains': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'disableAutoUpdate': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView'},
        'enableAutoUpdate': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView'},
        'itemUpdated': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'Object', true ,'Object', true ,'Object', true ]; }},
        'refresh': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionView'},
        'getNodeDepth': { type: 'int', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'getParentItem': { type: '*', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'deleteParentMapping': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'String', false ]; }},
        'addParentMapping': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'String', false ,'Object', false ,'Boolean', true ]; }},
        'getChildren': { type: 'mx.collections.ICollectionView', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'openNode': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'closeNode': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'addChild': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'Object', false ]; }},
        'removeChild': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'Object', false ]; }},
        'addChildAt': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'Object', false ,'int', false ]; }},
        'removeChildAt': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'int', false ]; }},
        'calculateLength': { type: 'int', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', true ,'Object', true ]; }},
        'collectionChangeHandler': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'mx.events.CollectionEvent', false ]; }},
        'nestedCollectionChangeHandler': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'mx.events.CollectionEvent', false ]; }},
        'xmlNotification': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'String', false ,'Object', false ,'Object', false ,'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.HierarchicalCollectionView.prototype.ROYALE_COMPILE_FLAGS = 10;