/**
 * Generated by Apache Royale Compiler from mx/collections/HierarchicalCollectionViewCursor.as
 * mx.collections.HierarchicalCollectionViewCursor
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.HierarchicalCollectionViewCursor');

goog.require('mx.collections.CursorBookmark');
goog.require('mx.collections.HierarchicalCollectionView');
goog.require('mx.collections.ICollectionView');
goog.require('mx.collections.IHierarchicalData');
goog.require('mx.collections.IViewCursor');
goog.require('mx.core.mx_internal');
goog.require('mx.events.CollectionEvent');
goog.require('mx.events.CollectionEventKind');
goog.require('mx.utils.ObjectUtil');
goog.require('mx.utils.UIDUtil');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('mx.collections.IHierarchicalCollectionViewCursor');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *
 *  @asparam collection The HierarchicalCollectionView instance referenced by this cursor.
 *
 *  @asparam model The source data collection.
 *
 *  @asparam hierarchicalData The data used to create the HierarchicalCollectionView instance.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {mx.collections.IHierarchicalCollectionViewCursor}
 * @param {mx.collections.HierarchicalCollectionView} collection
 * @param {mx.collections.ICollectionView} model
 * @param {mx.collections.IHierarchicalData} hierarchicalData
 */
mx.collections.HierarchicalCollectionViewCursor = function(collection, model, hierarchicalData) {
  
  this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = mx.collections.CursorBookmark.FIRST;
  this.mx_collections_HierarchicalCollectionViewCursor_parentNodes = [];
  this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack = [];
  mx.collections.HierarchicalCollectionViewCursor.base(this, 'constructor');
  this.mx_collections_HierarchicalCollectionViewCursor_collection = collection;
  this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData = hierarchicalData;
  this.mx_collections_HierarchicalCollectionViewCursor_model = model;
  collection.addEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.collectionChangeHandler, this, 'collectionChangeHandler'), false);
  this.mx_collections_HierarchicalCollectionViewCursor_modelCursor = model.createCursor();
  this.mx_collections_HierarchicalCollectionViewCursor_more = model.length > 1;
};
goog.inherits(mx.collections.HierarchicalCollectionViewCursor, org.apache.royale.events.EventDispatcher);


/**
 *  Finalizes the cursor, to clean up resources.
 *  Required because weak references are not available in JS.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.8
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.finalizeThis = function() {
  if (this.mx_collections_HierarchicalCollectionViewCursor_modelCursor)
    this.mx_collections_HierarchicalCollectionViewCursor_modelCursor.finalizeThis();
  if (this.mx_collections_HierarchicalCollectionViewCursor_collection)
    this.mx_collections_HierarchicalCollectionViewCursor_collection.removeEventListener(mx.events.CollectionEvent.COLLECTION_CHANGE, org.apache.royale.utils.Language.closure(this.collectionChangeHandler, this, 'collectionChangeHandler'));
};


/**
 * @private
 * @type {mx.collections.IHierarchicalData}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData;


/**
 * @private
 * @type {mx.collections.CursorBookmark}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark;


/**
 * @private
 * @type {number}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_currentIndex = 0;


/**
 * @private
 * @type {number}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor__currentDepth = 1;


/**
 * @private
 * @type {mx.collections.ICollectionView}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_childNodes;


/**
 * @private
 * @type {Array}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_parentNodes;


/**
 * @private
 * @type {Array}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack;


/**
 * @private
 * @type {mx.collections.ICollectionView}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_model;


/**
 * @private
 * @type {mx.collections.HierarchicalCollectionView}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_collection;


/**
 * @private
 * @type {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_more;


/**
 * @private
 * @type {mx.collections.IViewCursor}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_modelCursor;


/**
 *  <p>Note that for this class, the view does not need to be sorted in order to
 *  call this method. Also, if the item cannot be found, the cursor location is
 *  left on the last queried object.</p>
 *
 *  @inheritDoc
 * 
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} valuesToMatch
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.findAny = function(valuesToMatch) {
  this.seek(mx.collections.CursorBookmark.FIRST);
  do {
    if (mx.utils.ObjectUtil.valuesAreSubsetOfObject(valuesToMatch, this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.getData(this.current)))
      return true;
  } while (this.moveNext());
  return false;
};


/**
 *  <p>Note that for this class, the view does not need to be sorted in order to
 *  call this method. Also, if the item cannot be found, the cursor location is
 *  left on the last queried object.</p>
 *
 *  @inheritDoc
 *
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} values
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.findFirst = function(values) {
  return this.findAny(values);
};


/**
 *  <p>Note that for this class, the view does not need to be sorted in order to
 *  call this method. Also, if the item cannot be found, the cursor location is
 *  left on the last queried object.</p>
 *
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} valuesToMatch
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.findLast = function(valuesToMatch) {
  this.seek(mx.collections.CursorBookmark.LAST);
  do {
    if (mx.utils.ObjectUtil.valuesAreSubsetOfObject(valuesToMatch, this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.getData(this.current)))
      return true;
  } while (this.movePrevious());
  return false;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.moveNext = function() {
  var /** @type {Object} */ currentNode = this.current;
  if (currentNode == null)
    return false;
  var /** @type {mx.collections.IViewCursor} */ childCursor;
  var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(currentNode);
  if (this.mx_collections_HierarchicalCollectionViewCursor_collection.openNodes[uid] && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.canHaveChildren(currentNode) && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.hasChildren(currentNode)) {
    var /** @type {mx.collections.ICollectionView} */ previousChildNodes = this.mx_collections_HierarchicalCollectionViewCursor_childNodes;
    this.mx_collections_HierarchicalCollectionViewCursor_childNodes = this.mx_collections_HierarchicalCollectionViewCursor_collection.getChildren(currentNode);
    if (this.mx_collections_HierarchicalCollectionViewCursor_childNodes.length > 0) {
      this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack.push(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
      this.mx_collections_HierarchicalCollectionViewCursor_parentNodes.push(currentNode);
      this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = mx.collections.CursorBookmark.FIRST;
      childCursor = this.mx_collections_HierarchicalCollectionViewCursor_childNodes.createCursor();
      currentNode = childCursor.current;
      this.mx_collections_HierarchicalCollectionViewCursor_updateParentMap(currentNode);
      this.mx_collections_HierarchicalCollectionViewCursor_currentIndex++;
      this.mx_collections_HierarchicalCollectionViewCursor__currentDepth++;
      return true;
    } else {
      this.mx_collections_HierarchicalCollectionViewCursor_childNodes = previousChildNodes;
    }
  }
  while (true) {
    if (this.mx_collections_HierarchicalCollectionViewCursor_childNodes != null) {
      childCursor = this.mx_collections_HierarchicalCollectionViewCursor_childNodes.createCursor();
      childCursor.seek(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
      childCursor.moveNext();
    }
    var /** @type {Object} */ grandParent;
    if (this.mx_collections_HierarchicalCollectionViewCursor_childNodes != null && this.mx_collections_HierarchicalCollectionViewCursor_childNodes.length > 0 && (childCursor.bookmark == mx.collections.CursorBookmark.LAST || childCursor.afterLast)) {
      if (this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack.length < 1 && !this.mx_collections_HierarchicalCollectionViewCursor_more) {
        currentNode = null;
        this.mx_collections_HierarchicalCollectionViewCursor_currentIndex++;
        this.mx_collections_HierarchicalCollectionViewCursor__currentDepth = 1;
        return false;
      } else {
        currentNode = this.mx_collections_HierarchicalCollectionViewCursor_parentNodes.pop();
        grandParent = this.mx_collections_HierarchicalCollectionViewCursor_parentNodes[this.mx_collections_HierarchicalCollectionViewCursor_parentNodes.length - 1];
        if (grandParent != null && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.canHaveChildren(grandParent) && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.hasChildren(grandParent)) {
          this.mx_collections_HierarchicalCollectionViewCursor_childNodes = this.mx_collections_HierarchicalCollectionViewCursor_collection.getChildren(grandParent);
        } else {
          this.mx_collections_HierarchicalCollectionViewCursor_childNodes = null;
        }
        this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack.pop();
        this.mx_collections_HierarchicalCollectionViewCursor__currentDepth--;
      }
    } else {
      if (this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack.length == 0) {
        this.mx_collections_HierarchicalCollectionViewCursor__currentDepth = 1;
        this.mx_collections_HierarchicalCollectionViewCursor_more = this.mx_collections_HierarchicalCollectionViewCursor_modelCursor.moveNext();
        if (this.mx_collections_HierarchicalCollectionViewCursor_more) {
          currentNode = this.mx_collections_HierarchicalCollectionViewCursor_modelCursor.current;
          break;
        } else {
          this.mx_collections_HierarchicalCollectionViewCursor__currentDepth = 1;
          this.mx_collections_HierarchicalCollectionViewCursor_currentIndex++;
          currentNode = null;
          return false;
        }
      } else {
        childCursor = this.mx_collections_HierarchicalCollectionViewCursor_childNodes.createCursor();
        childCursor.seek(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
        childCursor.moveNext();
        this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = childCursor.bookmark;
        currentNode = childCursor.current;
        break;
      }
    }
  }
  this.mx_collections_HierarchicalCollectionViewCursor_updateParentMap(currentNode);
  this.mx_collections_HierarchicalCollectionViewCursor_currentIndex++;
  return true;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.movePrevious = function() {
  var /** @type {Object} */ currentNode = this.current;
  if (currentNode == null)
    return false;
  var /** @type {mx.collections.IViewCursor} */ childCursor;
  if (this.mx_collections_HierarchicalCollectionViewCursor_parentNodes && this.mx_collections_HierarchicalCollectionViewCursor_parentNodes.length > 0) {
    if (this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark == mx.collections.CursorBookmark.FIRST) {
      currentNode = this.mx_collections_HierarchicalCollectionViewCursor_parentNodes.pop();
      this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack.pop();
      var /** @type {Object} */ grandParent = this.mx_collections_HierarchicalCollectionViewCursor_parentNodes[this.mx_collections_HierarchicalCollectionViewCursor_parentNodes.length - 1];
      if (grandParent != null && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.canHaveChildren(grandParent) && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.hasChildren(grandParent)) {
        this.mx_collections_HierarchicalCollectionViewCursor_childNodes = this.mx_collections_HierarchicalCollectionViewCursor_collection.getChildren(grandParent);
      } else {
        this.mx_collections_HierarchicalCollectionViewCursor_childNodes = null;
      }
      this.mx_collections_HierarchicalCollectionViewCursor__currentDepth--;
      this.mx_collections_HierarchicalCollectionViewCursor_currentIndex--;
      return true;
    } else {
      childCursor = this.mx_collections_HierarchicalCollectionViewCursor_childNodes.createCursor();
      childCursor.seek(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
      childCursor.movePrevious();
      this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = childCursor.bookmark;
      currentNode = childCursor.current;
      childCursor.movePrevious();
      if (childCursor.bookmark == mx.collections.CursorBookmark.FIRST)
        this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = mx.collections.CursorBookmark.FIRST;
    }
  } else {
    this.mx_collections_HierarchicalCollectionViewCursor_more = this.mx_collections_HierarchicalCollectionViewCursor_modelCursor.movePrevious();
    if (this.mx_collections_HierarchicalCollectionViewCursor_more) {
      currentNode = this.mx_collections_HierarchicalCollectionViewCursor_modelCursor.current;
    } else {
      this.mx_collections_HierarchicalCollectionViewCursor_currentIndex = -1;
      currentNode = null;
      return false;
    }
  }
  while (true) {
    if (this.mx_collections_HierarchicalCollectionViewCursor_collection.openNodes[mx.utils.UIDUtil.getUID(currentNode)] && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.canHaveChildren(currentNode) && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.hasChildren(currentNode)) {
      var /** @type {mx.collections.ICollectionView} */ previousChildNodes = this.mx_collections_HierarchicalCollectionViewCursor_childNodes;
      this.mx_collections_HierarchicalCollectionViewCursor_childNodes = this.mx_collections_HierarchicalCollectionViewCursor_collection.getChildren(currentNode);
      if (this.mx_collections_HierarchicalCollectionViewCursor_childNodes.length > 0) {
        this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack.push(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
        this.mx_collections_HierarchicalCollectionViewCursor_parentNodes.push(currentNode);
        if (this.mx_collections_HierarchicalCollectionViewCursor_childNodes.length == 1)
          this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = mx.collections.CursorBookmark.FIRST;
        else
          this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = mx.collections.CursorBookmark.LAST;
        childCursor = this.mx_collections_HierarchicalCollectionViewCursor_childNodes.createCursor();
        childCursor.seek(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
        currentNode = childCursor.current;
        this.mx_collections_HierarchicalCollectionViewCursor__currentDepth++;
      } else {
        this.mx_collections_HierarchicalCollectionViewCursor_childNodes = previousChildNodes;
        break;
      }
    } else {
      break;
    }
  }
  this.mx_collections_HierarchicalCollectionViewCursor_updateParentMap(currentNode);
  this.mx_collections_HierarchicalCollectionViewCursor_currentIndex--;
  return true;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {mx.collections.CursorBookmark} bookmark
 * @param {number=} offset
 * @param {number=} prefetch
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.seek = function(bookmark, offset, prefetch) {
  offset = typeof offset !== 'undefined' ? offset : 0;
  prefetch = typeof prefetch !== 'undefined' ? prefetch : 0;
  var /** @type {number} */ value = 0;
  //var /** @type {number} */ value = 0;
  if (bookmark == mx.collections.CursorBookmark.FIRST) {
    value = 0;
  } else if (bookmark == mx.collections.CursorBookmark.CURRENT) {
    value = this.mx_collections_HierarchicalCollectionViewCursor_currentIndex;
  } else if (bookmark == mx.collections.CursorBookmark.LAST) {
    value = (this.mx_collections_HierarchicalCollectionViewCursor_collection.length - 1) >> 0;
  } else {
    value = org.apache.royale.utils.Language._int(bookmark.value);
  }
  value = (Math.max(Math.min(value + offset, this.mx_collections_HierarchicalCollectionViewCursor_collection.length), 0)) >> 0;
  var /** @type {number} */ dc = (Math.abs(this.mx_collections_HierarchicalCollectionViewCursor_currentIndex - value)) >> 0;
  var /** @type {number} */ de = (Math.abs(this.mx_collections_HierarchicalCollectionViewCursor_collection.length - value)) >> 0;
  var /** @type {boolean} */ movedown = true;
  if (dc < value) {
    if (de < dc) {
      this.moveToLast();
      if (de == 0) {
        this.moveNext();
        value = 0;
      } else {
        value = (de - 1) >> 0;
      }
      movedown = false;
    } else {
      movedown = this.mx_collections_HierarchicalCollectionViewCursor_currentIndex < value;
      value = dc;
      if (this.mx_collections_HierarchicalCollectionViewCursor_currentIndex == this.mx_collections_HierarchicalCollectionViewCursor_collection.length) {
        value--;
        this.moveToLast();
      }
    }
  } else {
    if (de < value) {
      this.moveToLast();
      if (de == 0) {
        this.moveNext();
        value = 0;
      } else {
        value = (de - 1) >> 0;
      }
      movedown = false;
    } else {
      this.mx_collections_HierarchicalCollectionViewCursor_moveToFirst();
    }
  }
  if (movedown) {
    while (value && value > 0) {
      this.moveNext();
      value--;
    }
  } else {
    while (value && value > 0) {
      this.movePrevious();
      value--;
    }
  }
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} item
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.insert = function(item) {
  var /** @type {Object} */ parent = this.mx_collections_HierarchicalCollectionViewCursor_collection.getParentItem(this.current);
  this.mx_collections_HierarchicalCollectionViewCursor_collection.addChildAt(parent, item, this.mx_collections_HierarchicalCollectionViewCursor_currentIndex);
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {Object}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.remove = function() {
  var /** @type {Object} */ obj = this.current;
  var /** @type {Object} */ parent = this.mx_collections_HierarchicalCollectionViewCursor_collection.getParentItem(this.current);
  this.mx_collections_HierarchicalCollectionViewCursor_collection.removeChild(parent, this.current);
  return obj;
};


/**
 *  @asprivate
 *  Determines if a node is visible on the screen
 * @private
 * @param {Object} node
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_isItemVisible = function(node) {
  var /** @type {Object} */ parentNode = this.mx_collections_HierarchicalCollectionViewCursor_collection.getParentItem(node);
  while (parentNode != null) {
    if (this.mx_collections_HierarchicalCollectionViewCursor_collection.openNodes[mx.utils.UIDUtil.getUID(parentNode)] == null)
      return false;
    parentNode = this.mx_collections_HierarchicalCollectionViewCursor_collection.getParentItem(parentNode);
  }
  return true;
};


/**
 * @asprivate
 * Update the parent map.
 * @private
 * @param {Object} currentNode
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_updateParentMap = function(currentNode) {
  if (currentNode != null) {
    var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(currentNode);
    this.mx_collections_HierarchicalCollectionViewCursor_collection.addParentMapping(uid, this.mx_collections_HierarchicalCollectionViewCursor_parentNodes[this.mx_collections_HierarchicalCollectionViewCursor_parentNodes.length - 1], false);
  }
};


/**
 *  @asprivate
 *  Creates a stack of parent nodes by walking upwards
 * @private
 * @param {Object} node
 * @return {Array}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_getParentStack = function(node) {
  var /** @type {Array} */ nodeParents = [];
  var /** @type {Object} */ obj = this.mx_collections_HierarchicalCollectionViewCursor_collection.getParentItem(node);
  while (obj != null) {
    nodeParents.unshift(obj);
    obj = this.mx_collections_HierarchicalCollectionViewCursor_collection.getParentItem(obj);
  }
  return nodeParents;
};


/**
 *  @asprivate
 *  When something happens to the tree, find out if it happened
 *  to children that occur before the current child in the tree walk.
 * @private
 * @param {Object} node
 * @param {Object} currentNode
 * @return {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_isNodeBefore = function(node, currentNode) {
  var /** @type {number} */ i = 0;
  if (currentNode == null)
    return false;
  //var /** @type {number} */ i = 0;
  var /** @type {mx.collections.ICollectionView} */ tmpChildNodes;
  var /** @type {Object} */ sameParent;
  var /** @type {Array} */ nodeParents = this.mx_collections_HierarchicalCollectionViewCursor_getParentStack(node);
  var /** @type {Array} */ curParents = this.mx_collections_HierarchicalCollectionViewCursor_getParentStack(currentNode);
  var /** @type {mx.collections.IViewCursor} */ cursor;
  var /** @type {Object} */ child;
  while (nodeParents.length != 0 && curParents.length != 0) {
    var /** @type {Object} */ nodeParent = nodeParents.shift();
    var /** @type {Object} */ curParent = curParents.shift();
    if (nodeParent != curParent) {
      sameParent = this.mx_collections_HierarchicalCollectionViewCursor_collection.getParentItem(nodeParent);
      if (sameParent != null && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.canHaveChildren(sameParent) && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.hasChildren(sameParent)) {
        tmpChildNodes = this.mx_collections_HierarchicalCollectionViewCursor_collection.getChildren(sameParent);
      } else {
        tmpChildNodes = this.mx_collections_HierarchicalCollectionViewCursor_model;
      }
      cursor = tmpChildNodes.createCursor();
      cursor.seek(mx.collections.CursorBookmark.FIRST, i);
      child = cursor.current;
      if (child == curParent)
        return false;
      if (child == nodeParent)
        return true;
    }
  }
  if (nodeParents.length)
    node = nodeParents.shift();
  if (curParents.length)
    currentNode = curParents.shift();
  tmpChildNodes = this.mx_collections_HierarchicalCollectionViewCursor_model;
  cursor = tmpChildNodes.createCursor();
  while (!cursor.afterLast) {
    child = cursor.current;
    if (child == currentNode)
      return false;
    if (child == node)
      return true;
    cursor.moveNext();
  }
  return false;
};


/**
 *  @asprivate
 * @private
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.mx_collections_HierarchicalCollectionViewCursor_moveToFirst = function() {
  this.mx_collections_HierarchicalCollectionViewCursor_childNodes = null;
  this.mx_collections_HierarchicalCollectionViewCursor_modelCursor.seek(mx.collections.CursorBookmark.FIRST, 0);
  this.mx_collections_HierarchicalCollectionViewCursor_more = this.mx_collections_HierarchicalCollectionViewCursor_model.length > 1;
  this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = mx.collections.CursorBookmark.FIRST;
  this.mx_collections_HierarchicalCollectionViewCursor_parentNodes = [];
  this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack = [];
  this.mx_collections_HierarchicalCollectionViewCursor_currentIndex = 0;
  this.mx_collections_HierarchicalCollectionViewCursor__currentDepth = 1;
};


/**
 *  @asprivate
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.moveToLast = function() {
  this.mx_collections_HierarchicalCollectionViewCursor_childNodes = null;
  this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack = [];
  this.mx_collections_HierarchicalCollectionViewCursor__currentDepth = 1;
  this.mx_collections_HierarchicalCollectionViewCursor_parentNodes = [];
  this.mx_collections_HierarchicalCollectionViewCursor_modelCursor.seek(mx.collections.CursorBookmark.LAST, 0);
  var /** @type {Object} */ currentNode = this.mx_collections_HierarchicalCollectionViewCursor_modelCursor.current;
  while (this.mx_collections_HierarchicalCollectionViewCursor_collection.openNodes[mx.utils.UIDUtil.getUID(currentNode)] && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.canHaveChildren(currentNode) && this.mx_collections_HierarchicalCollectionViewCursor_hierarchicalData.hasChildren(currentNode)) {
    var /** @type {mx.collections.ICollectionView} */ previousChildNodes = this.mx_collections_HierarchicalCollectionViewCursor_childNodes;
    this.mx_collections_HierarchicalCollectionViewCursor_childNodes = this.mx_collections_HierarchicalCollectionViewCursor_collection.getChildren(currentNode);
    if (this.mx_collections_HierarchicalCollectionViewCursor_childNodes != null && this.mx_collections_HierarchicalCollectionViewCursor_childNodes.length > 0) {
      var /** @type {mx.collections.IViewCursor} */ childCursor = this.mx_collections_HierarchicalCollectionViewCursor_childNodes.createCursor();
      childCursor.seek(mx.collections.CursorBookmark.LAST);
      this.mx_collections_HierarchicalCollectionViewCursor_parentNodes.push(currentNode);
      this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack.push(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
      currentNode = childCursor.current;
      this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = mx.collections.CursorBookmark.LAST;
      childCursor.movePrevious();
      if (childCursor.bookmark == mx.collections.CursorBookmark.FIRST)
        this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = mx.collections.CursorBookmark.FIRST;
      this.mx_collections_HierarchicalCollectionViewCursor__currentDepth++;
    } else {
      this.mx_collections_HierarchicalCollectionViewCursor_childNodes = previousChildNodes;
      break;
    }
  }
  this.mx_collections_HierarchicalCollectionViewCursor_currentIndex = (this.mx_collections_HierarchicalCollectionViewCursor_collection.length - 1) >> 0;
};


/**
 *  @asprivate
 * @param {mx.events.CollectionEvent} event
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.collectionChangeHandler = function(event) {
  var /** @type {number} */ i = 0;
  var /** @type {number} */ n = 0;
  var /** @type {number} */ changingNodeCollectionBookmarkIndex = 0;
  var /** @type {number} */ parentOfChangingNodeIndex = 0;
  //var /** @type {number} */ i = 0;
  //var /** @type {number} */ n = 0;
  var /** @type {Object} */ changingNode;
  var /** @type {Object} */ parentOfChangingNode;
  var /** @type {Object} */ parentOfCurrentNode;
  var /** @type {Array} */ parentStack;
  var /** @type {boolean} */ isBefore = false;
  //var /** @type {number} */ parentOfChangingNodeIndex = 0;
  var /** @type {boolean} */ isChangingNodeParentAncestorOfSelectedNode;
  var /** @type {mx.collections.CursorBookmark} */ bookmarkInChangingCollection;
  //var /** @type {number} */ changingNodeCollectionBookmarkIndex = 0;
  var /** @type {mx.collections.ICollectionView} */ changingNodeAndSiblings;
  var /** @type {mx.collections.IViewCursor} */ changingCollectionCursor;
  if (event.kind == mx.events.CollectionEventKind.ADD) {
    n = (event.items.length) >> 0;
    if (event.location <= this.mx_collections_HierarchicalCollectionViewCursor_currentIndex) {
      this.mx_collections_HierarchicalCollectionViewCursor_currentIndex += n;
      isBefore = true;
    }
    parentStack = this.mx_collections_HierarchicalCollectionViewCursor_getParentStack(this.current);
    parentOfCurrentNode = parentStack[parentStack.length - 1];
    for (i = 0; i < n; i++) {
      changingNode = event.items[i];
      if (isBefore) {
        parentOfChangingNode = this.mx_collections_HierarchicalCollectionViewCursor_collection.getParentItem(changingNode);
        changingNodeAndSiblings = this.mx_collections_HierarchicalCollectionViewCursor_collection.getChildren(parentOfChangingNode);
        if (parentOfChangingNode == parentOfCurrentNode) {
          if (changingNodeAndSiblings != null) {
            changingCollectionCursor = changingNodeAndSiblings.createCursor();
            changingCollectionCursor.seek(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
            changingCollectionCursor.moveNext();
            this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = changingCollectionCursor.bookmark;
          }
        } else {
          parentOfChangingNodeIndex = (parentStack.indexOf(parentOfChangingNode)) >> 0;
          isChangingNodeParentAncestorOfSelectedNode = parentOfChangingNodeIndex != -1;
          if (isChangingNodeParentAncestorOfSelectedNode) {
            if (changingNodeAndSiblings != null) {
              changingNodeCollectionBookmarkIndex = (parentOfChangingNodeIndex + 1) >> 0;
              changingCollectionCursor = changingNodeAndSiblings.createCursor();
              bookmarkInChangingCollection = this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack[changingNodeCollectionBookmarkIndex];
              changingCollectionCursor.seek(bookmarkInChangingCollection);
              changingCollectionCursor.moveNext();
              this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack[changingNodeCollectionBookmarkIndex] = changingCollectionCursor.bookmark;
            }
          }
        }
      }
    }
  } else if (event.kind == mx.events.CollectionEventKind.REMOVE) {
    n = (event.items.length) >> 0;
    if (event.location <= this.mx_collections_HierarchicalCollectionViewCursor_currentIndex) {
      var /** @type {number} */ lastIndexAffectedByDeletion = (event.location + n) >> 0;
      var /** @type {boolean} */ isCurrentIndexAmongRemovedNodes = lastIndexAffectedByDeletion >= this.mx_collections_HierarchicalCollectionViewCursor_currentIndex;
      var /** @type {boolean} */ currentItemNotFoundAmongItsSiblings = isCurrentIndexAmongRemovedNodes ? false : (!this.afterLast && !this.beforeFirst && this.current == null);
      if (isCurrentIndexAmongRemovedNodes || currentItemNotFoundAmongItsSiblings) {
        var /** @type {number} */ indexToReturnTo = (isCurrentIndexAmongRemovedNodes ? event.location : this.mx_collections_HierarchicalCollectionViewCursor_currentIndex - n) >> 0;
        this.mx_collections_HierarchicalCollectionViewCursor_moveToFirst();
        this.seek(mx.collections.CursorBookmark.FIRST, indexToReturnTo);
        return;
      }
      this.mx_collections_HierarchicalCollectionViewCursor_currentIndex -= n;
      isBefore = true;
    }
    parentStack = this.mx_collections_HierarchicalCollectionViewCursor_getParentStack(this.current);
    parentOfCurrentNode = parentStack[parentStack.length - 1];
    for (i = 0; i < n; i++) {
      changingNode = event.items[i];
      if (isBefore) {
        parentOfChangingNode = this.mx_collections_HierarchicalCollectionViewCursor_collection.getParentItem(changingNode);
        changingNodeAndSiblings = this.mx_collections_HierarchicalCollectionViewCursor_collection.getChildren(parentOfChangingNode);
        if (parentOfChangingNode == parentOfCurrentNode) {
          if (this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark == mx.collections.CursorBookmark.LAST)
            break;
          if (changingNodeAndSiblings != null) {
            changingCollectionCursor = changingNodeAndSiblings.createCursor();
            changingCollectionCursor.seek(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
            changingCollectionCursor.movePrevious();
            this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark = changingCollectionCursor.bookmark;
          }
        } else {
          parentOfChangingNodeIndex = (parentStack.indexOf(parentOfChangingNode)) >> 0;
          isChangingNodeParentAncestorOfSelectedNode = parentOfChangingNodeIndex != -1;
          if (isChangingNodeParentAncestorOfSelectedNode) {
            if (changingNodeAndSiblings != null) {
              changingNodeCollectionBookmarkIndex = (parentOfChangingNodeIndex + 1) >> 0;
              changingCollectionCursor = changingNodeAndSiblings.createCursor();
              bookmarkInChangingCollection = this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack[changingNodeCollectionBookmarkIndex];
              if (bookmarkInChangingCollection == mx.collections.CursorBookmark.LAST)
                break;
              changingCollectionCursor.seek(bookmarkInChangingCollection);
              changingCollectionCursor.movePrevious();
              this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack[changingNodeCollectionBookmarkIndex] = changingCollectionCursor.bookmark;
            }
          }
        }
      }
    }
  } else if (event.kind == mx.events.CollectionEventKind.RESET) {
    this.mx_collections_HierarchicalCollectionViewCursor_model = this.mx_collections_HierarchicalCollectionViewCursor_collection.http_$$www_adobe_com$2006$flex$mx$internal__treeData;
    this.mx_collections_HierarchicalCollectionViewCursor_modelCursor = this.mx_collections_HierarchicalCollectionViewCursor_model.createCursor();
  } else if (event.kind == mx.events.CollectionEventKind.REFRESH) {
    if (!(this.beforeFirst || this.afterLast)) {
      this.findFirst(this.current);
    }
  }
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.index;


mx.collections.HierarchicalCollectionViewCursor.prototype.get__index = function() {
  return this.mx_collections_HierarchicalCollectionViewCursor_currentIndex;
};


/**
 * @nocollapse
 * @export
 * @type {mx.collections.CursorBookmark}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.bookmark;


mx.collections.HierarchicalCollectionViewCursor.prototype.get__bookmark = function() {
  return new mx.collections.CursorBookmark(this.mx_collections_HierarchicalCollectionViewCursor_currentIndex.toString());
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.current;


mx.collections.HierarchicalCollectionViewCursor.prototype.get__current = function() {
  if (this.mx_collections_HierarchicalCollectionViewCursor_parentBookmarkStack.length == 0) {
    return this.mx_collections_HierarchicalCollectionViewCursor_modelCursor.current;
  } else {
    var /** @type {mx.collections.IViewCursor} */ childCursor = this.mx_collections_HierarchicalCollectionViewCursor_childNodes.createCursor();
    childCursor.seek(this.mx_collections_HierarchicalCollectionViewCursor_currentChildBookmark);
    return childCursor.current;
  }
  return null;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.currentDepth;


mx.collections.HierarchicalCollectionViewCursor.prototype.get__currentDepth = function() {
  return this.mx_collections_HierarchicalCollectionViewCursor__currentDepth;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.beforeFirst;


mx.collections.HierarchicalCollectionViewCursor.prototype.get__beforeFirst = function() {
  return this.mx_collections_HierarchicalCollectionViewCursor_currentIndex < 0 && this.current == null;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.afterLast;


mx.collections.HierarchicalCollectionViewCursor.prototype.get__afterLast = function() {
  return this.mx_collections_HierarchicalCollectionViewCursor_currentIndex >= this.mx_collections_HierarchicalCollectionViewCursor_collection.length && this.current == null;
};


/**
 * @nocollapse
 * @export
 * @type {mx.collections.ICollectionView}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.view;


mx.collections.HierarchicalCollectionViewCursor.prototype.get__view = function() {
  return this.mx_collections_HierarchicalCollectionViewCursor_model;
};


Object.defineProperties(mx.collections.HierarchicalCollectionViewCursor.prototype, /** @lends {mx.collections.HierarchicalCollectionViewCursor.prototype} */ {
/**
 * @type {number}
 */
index: {
get: mx.collections.HierarchicalCollectionViewCursor.prototype.get__index},
/**
 * @type {mx.collections.CursorBookmark}
 */
bookmark: {
get: mx.collections.HierarchicalCollectionViewCursor.prototype.get__bookmark},
/**
 * @type {Object}
 */
current: {
get: mx.collections.HierarchicalCollectionViewCursor.prototype.get__current},
/**
 * @type {number}
 */
currentDepth: {
get: mx.collections.HierarchicalCollectionViewCursor.prototype.get__currentDepth},
/**
 * @type {boolean}
 */
beforeFirst: {
get: mx.collections.HierarchicalCollectionViewCursor.prototype.get__beforeFirst},
/**
 * @type {boolean}
 */
afterLast: {
get: mx.collections.HierarchicalCollectionViewCursor.prototype.get__afterLast},
/**
 * @type {mx.collections.ICollectionView}
 */
view: {
get: mx.collections.HierarchicalCollectionViewCursor.prototype.get__view}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HierarchicalCollectionViewCursor', qName: 'mx.collections.HierarchicalCollectionViewCursor', kind: 'class' }], interfaces: [mx.collections.IHierarchicalCollectionViewCursor] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'index': { type: 'int', access: 'readonly', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'bookmark': { type: 'mx.collections.CursorBookmark', access: 'readonly', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'current': { type: 'Object', access: 'readonly', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'currentDepth': { type: 'int', access: 'readonly', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'beforeFirst': { type: 'Boolean', access: 'readonly', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'afterLast': { type: 'Boolean', access: 'readonly', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'view': { type: 'mx.collections.ICollectionView', access: 'readonly', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'}
      };
    },
    methods: function () {
      return {
        'HierarchicalCollectionViewCursor': { type: '', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor', parameters: function () { return [ 'mx.collections.HierarchicalCollectionView', false ,'mx.collections.ICollectionView', false ,'mx.collections.IHierarchicalData', false ]; }},
        'finalizeThis': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'findAny': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor', parameters: function () { return [ 'Object', false ]; }},
        'findFirst': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor', parameters: function () { return [ 'Object', false ]; }},
        'findLast': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor', parameters: function () { return [ 'Object', false ]; }},
        'moveNext': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'movePrevious': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'seek': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor', parameters: function () { return [ 'mx.collections.CursorBookmark', false ,'int', true ,'int', true ]; }},
        'insert': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor', parameters: function () { return [ 'Object', false ]; }},
        'remove': { type: 'Object', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'moveToLast': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor'},
        'collectionChangeHandler': { type: 'void', declaredBy: 'mx.collections.HierarchicalCollectionViewCursor', parameters: function () { return [ 'mx.events.CollectionEvent', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.HierarchicalCollectionViewCursor.prototype.ROYALE_COMPILE_FLAGS = 10;