/**
 * Generated by Apache Royale Compiler from mx/collections/HierarchicalData.as
 * mx.collections.HierarchicalData
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.HierarchicalData');

goog.require('XML');
goog.require('XMLList');
goog.require('mx.events.CollectionEvent');
goog.require('mx.events.CollectionEventKind');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('mx.collections.IHierarchicalData');
goog.require('org.apache.royale.utils.Language');



/**
 *  Constructor.
 *
 *  @asparam value The data used to populate the HierarchicalData instance.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {mx.collections.IHierarchicalData}
 * @param {Object=} value
 */
mx.collections.HierarchicalData = function(value) {
  value = typeof value !== 'undefined' ? value : null;
  mx.collections.HierarchicalData.base(this, 'constructor');
  this.source = value;
};
goog.inherits(mx.collections.HierarchicalData, org.apache.royale.events.EventDispatcher);


/**
 * @private
 * @type {string}
 */
mx.collections.HierarchicalData.prototype.mx_collections_HierarchicalData__childrenField = "children";


/**
 * @private
 * @type {Object}
 */
mx.collections.HierarchicalData.prototype.mx_collections_HierarchicalData__source;


/**
 * @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {boolean}
 */
mx.collections.HierarchicalData.prototype.canHaveChildren = function(node) {
  if (node == null)
    return false;
  var /** @type {boolean} */ branch = false;
  if (org.apache.royale.utils.Language.is(node, XML)) {
    var /** @type {XMLList} */ childList = this.childrenField == "children" ? node.children() : node.child(this.childrenField).children();
    var /** @type {XMLList} */ branchFlag = node.attribute('isBranch');
    if (branchFlag.length() == 1) {
      if (branchFlag[0] == "true")
        branch = true;
    } else if (childList.length() != 0) {
      branch = true;
    }
  } else if (org.apache.royale.utils.Language.is(node, Object)) {
    try {
      if (node[this.childrenField] != undefined) {
        branch = true;
      }
    } catch (e) {
    }
  }
  return branch;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {Object}
 */
mx.collections.HierarchicalData.prototype.getChildren = function(node) {
  if (node == null)
    return null;
  var /** @type {*} */ children;
  if (org.apache.royale.utils.Language.is(node, XML)) {
    children = this.childrenField == "children" ? org.apache.royale.utils.Language.as(node, XML).child('*') : org.apache.royale.utils.Language.as(node.child(this.childrenField), XML).child('*');
  } else if (org.apache.royale.utils.Language.is(node, Object)) {
    try {
      children = node[this.childrenField];
    } catch (e) {
    }
  }
  if (children === undefined)
    return null;
  return children;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {boolean}
 */
mx.collections.HierarchicalData.prototype.hasChildren = function(node) {
  if (node == null)
    return false;
  var /** @type {Object} */ children = this.getChildren(node);
  try {
    if (org.apache.royale.utils.Language.is(children, XMLList) || org.apache.royale.utils.Language.is(children, XML)) {
      if (children.length() > 0)
        return true;
    }
    if (children.length > 0)
      return true;
  } catch (e) {
  }
  return false;
};


/**
 *  @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {Object}
 */
mx.collections.HierarchicalData.prototype.getData = function(node) {
  return org.apache.royale.utils.Language.resolveUncertain(Object(node));
};


/**
 * @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {Object}
 */
mx.collections.HierarchicalData.prototype.getRoot = function() {
  return this.source;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.collections.HierarchicalData.prototype.childrenField;


mx.collections.HierarchicalData.prototype.get__childrenField = function() {
  return this.mx_collections_HierarchicalData__childrenField;
};


mx.collections.HierarchicalData.prototype.set__childrenField = function(value) {
  this.mx_collections_HierarchicalData__childrenField = value;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.collections.HierarchicalData.prototype.source;


mx.collections.HierarchicalData.prototype.get__source = function() {
  return this.mx_collections_HierarchicalData__source;
};


mx.collections.HierarchicalData.prototype.set__source = function(value) {
  this.mx_collections_HierarchicalData__source = value;
  var /** @type {mx.events.CollectionEvent} */ event = new mx.events.CollectionEvent(mx.events.CollectionEvent.COLLECTION_CHANGE);
  event.kind = mx.events.CollectionEventKind.RESET;
  this.dispatchEvent(event);
};


Object.defineProperties(mx.collections.HierarchicalData.prototype, /** @lends {mx.collections.HierarchicalData.prototype} */ {
/**
 * @type {string}
 */
childrenField: {
get: mx.collections.HierarchicalData.prototype.get__childrenField,
set: mx.collections.HierarchicalData.prototype.set__childrenField},
/**
 * @type {Object}
 */
source: {
get: mx.collections.HierarchicalData.prototype.get__source,
set: mx.collections.HierarchicalData.prototype.set__source}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.HierarchicalData.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HierarchicalData', qName: 'mx.collections.HierarchicalData', kind: 'class' }], interfaces: [mx.collections.IHierarchicalData] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.HierarchicalData.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'childrenField': { type: 'String', access: 'readwrite', declaredBy: 'mx.collections.HierarchicalData'},
        'source': { type: 'Object', access: 'readwrite', declaredBy: 'mx.collections.HierarchicalData'}
      };
    },
    methods: function () {
      return {
        'HierarchicalData': { type: '', declaredBy: 'mx.collections.HierarchicalData', parameters: function () { return [ 'Object', true ]; }},
        'canHaveChildren': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalData', parameters: function () { return [ 'Object', false ]; }},
        'getChildren': { type: 'Object', declaredBy: 'mx.collections.HierarchicalData', parameters: function () { return [ 'Object', false ]; }},
        'hasChildren': { type: 'Boolean', declaredBy: 'mx.collections.HierarchicalData', parameters: function () { return [ 'Object', false ]; }},
        'getData': { type: 'Object', declaredBy: 'mx.collections.HierarchicalData', parameters: function () { return [ 'Object', false ]; }},
        'getRoot': { type: 'Object', declaredBy: 'mx.collections.HierarchicalData'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.HierarchicalData.prototype.ROYALE_COMPILE_FLAGS = 10;