/**
 * Generated by Apache Royale Compiler from mx/collections/IGroupingCollection.as
 * mx.collections.IGroupingCollection
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.IGroupingCollection');

goog.require('mx.collections.Grouping');
goog.require('mx.collections.IHierarchicalData');
goog.require('XML');



/**
 * @interface
 * @extends {mx.collections.IHierarchicalData}
 */
mx.collections.IGroupingCollection = function() {
};
/**  * @type {mx.collections.Grouping}
 */mx.collections.IGroupingCollection.prototype.grouping;
/**
 *  Applies the grouping to the view.
 *  The IGroupingCollection does not detect changes to a group 
 *  automatically, so you must call the <code>refresh()</code>
 *  method to update the view after setting the <code>group</code> property.
 *
 *  <p>The <code>refresh()</code> method can be applied asynchronously
 *  by calling <code>refresh(true)</code>.</p>
 *  
 *  <p>When <code>refresh()</code> is called synchronously, 
 *  a client should wait for a CollectionEvent event
 *  with the value of the <code>kind</code> property set 
 *  to <code>CollectionEventKind.REFRESH</code> 
 *  to ensure that the <code>refresh()</code> method completed.</p>
 *
 *  @asparam async If <code>true</code>, defines the refresh to be asynchronous.
 *  By default it is <code>false</code> denoting synchronous refresh.
 *  
 *  @asreturn <code>true</code> if the <code>refresh()</code> method completed,
 *  and <code>false</code> if the refresh is incomplete, 
 *  which can mean that items are still pending.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {boolean=} async
 * @return {boolean}
 */
mx.collections.IGroupingCollection.prototype.refresh = function(async) {
};
mx.collections.IGroupingCollection.prototype.cancelRefresh = function() {
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.IGroupingCollection.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'IGroupingCollection', qName: 'mx.collections.IGroupingCollection', kind: 'interface' }], interfaces: [mx.collections.IHierarchicalData] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.IGroupingCollection.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'grouping': { type: 'mx.collections.Grouping', access: 'readwrite', declaredBy: 'mx.collections.IGroupingCollection'}
      };
    },
    methods: function () {
      return {
        'refresh': { type: 'Boolean', declaredBy: 'mx.collections.IGroupingCollection', parameters: function () { return [ 'Boolean', true ]; }},
        'cancelRefresh': { type: 'void', declaredBy: 'mx.collections.IGroupingCollection'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.IGroupingCollection.prototype.ROYALE_COMPILE_FLAGS = 10;