/**
 * Generated by Apache Royale Compiler from mx/collections/IGroupingCollection2.as
 * mx.collections.IGroupingCollection2
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.IGroupingCollection2');

goog.require('mx.collections.Grouping');
goog.require('mx.collections.IHierarchicalData');
goog.require('XML');



/**
 * @interface
 * @extends {mx.collections.IHierarchicalData}
 */
mx.collections.IGroupingCollection2 = function() {
};
/**  * @type {mx.collections.Grouping}
 */mx.collections.IGroupingCollection2.prototype.grouping;
/**
 *  Applies the grouping to the collection.
 *  The collection does not detect changes to a group 
 *  automatically, so you must call the <code>refresh()</code>
 *  method to update the collection after setting the <code>grouping</code>, 
 *  <code>source</code>, or <code>summaries</code> properties.
 *  You also call the <code>refresh()</code> method when you modify 
 *  a GroupingField of the collection, such as by changing the 
 *  <code>caseInsensitive</code>, <code>compareFunction</code>, 
 *  or <code>groupingFunction</code> properties.
 *
 *  <p>The <code>refresh()</code> method can be applied synchronously
 *  or asynchronously.</p>
 *  
 *  <p>When <code>refresh()</code> is called synchronously, 
 *  all groups and summaries are updated together before the method returns. 
 *  That means your application cannot perform other processing operations 
 *  for the duration of the call.
 *  A client should wait for a CollectionEvent event
 *  with the value of the <code>kind</code> property set 
 *  to <code>CollectionEventKind.REFRESH</code> 
 *  to ensure that the <code>refresh()</code> method completed.</p>
 *
 *  <p>In asynchronous refresh, all groups and summaries are updated individually. 
 *  The <code>refresh()</code> method returns before the groups and summaries 
 *  are updated so that your application can continue execution.
 *  Also, the control is updated during the refresh so that the 
 *  user can continue to interact with it.</p>
 *
 *  <p>The overhead of updating groups and summaries individually, 
 *  rather than all at once, makes an asynchronous refresh take longer 
 *  than a synchronous one. 
 *  However, for large data sets, your application continues 
 *  to operate during the refresh.</p>
 *
 *  @asparam async If <code>true</code>, defines the refresh to be asynchronous.
 *  By default it is <code>false</code> denoting synchronous refresh.
 * 
 *  @asparam dispatchCollectionEvents If <code>true</code>, events are
 *  dispatched when groups are formed.
 *  For better performance, set it to <code>false</code>.
 *  If <code>true</code>, then events are dispatched as groups and summaries are calculated 
 *  synchronously to update the control.
 *  Note: If <code>async</code> is <code>true</code>, 
 *  the <code>dispatchCollectionEvents</code> is always set to <code>true</code>.
 *  By default it is <code>false</code> denoting no events will be dispatched.
 *  
 *  @asreturn <code>true</code> if the <code>refresh()</code> method completed,
 *  and <code>false</code> if the refresh is incomplete, 
 *  which can mean that items are still pending.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 3
 * @param {boolean=} async
 * @param {boolean=} dispatchCollectionEvents
 * @return {boolean}
 */
mx.collections.IGroupingCollection2.prototype.refresh = function(async, dispatchCollectionEvents) {
};
mx.collections.IGroupingCollection2.prototype.cancelRefresh = function() {
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.IGroupingCollection2.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'IGroupingCollection2', qName: 'mx.collections.IGroupingCollection2', kind: 'interface' }], interfaces: [mx.collections.IHierarchicalData] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.IGroupingCollection2.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'grouping': { type: 'mx.collections.Grouping', access: 'readwrite', declaredBy: 'mx.collections.IGroupingCollection2'}
      };
    },
    methods: function () {
      return {
        'refresh': { type: 'Boolean', declaredBy: 'mx.collections.IGroupingCollection2', parameters: function () { return [ 'Boolean', true ,'Boolean', true ]; }},
        'cancelRefresh': { type: 'void', declaredBy: 'mx.collections.IGroupingCollection2'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.IGroupingCollection2.prototype.ROYALE_COMPILE_FLAGS = 10;