/**
 * Generated by Apache Royale Compiler from mx/collections/IHierarchicalCollectionView.as
 * mx.collections.IHierarchicalCollectionView
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.IHierarchicalCollectionView');

goog.require('mx.collections.ICollectionView');
goog.require('mx.collections.IHierarchicalData');
goog.require('XML');



/**
 * @interface
 * @extends {mx.collections.ICollectionView}
 */
mx.collections.IHierarchicalCollectionView = function() {
};
/**  * @type {Object}
 */mx.collections.IHierarchicalCollectionView.prototype.openNodes;
/**  * @type {boolean}
 */mx.collections.IHierarchicalCollectionView.prototype.hasRoot;
/**  * @type {boolean}
 */mx.collections.IHierarchicalCollectionView.prototype.showRoot;
/**  * @type {mx.collections.IHierarchicalData}
 */mx.collections.IHierarchicalCollectionView.prototype.source;
/**
 *  Opens a node to display its children.
 *
 *  @asparam node The Object that defines the node.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 */
mx.collections.IHierarchicalCollectionView.prototype.openNode = function(node) {
};
/**
 *  Closes a node to hide its children.
 *
 *  @asparam node The Object that defines the node.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 */
mx.collections.IHierarchicalCollectionView.prototype.closeNode = function(node) {
};
/**
 *  Returns a collection of children, if they exist. 
 *
 *  @asparam node The Object that defines the node. 
 *  If <code>null</code>, return a collection of top level nodes.
 *
 *  @asreturn ICollectionView instance containing the child nodes.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {mx.collections.ICollectionView}
 */
mx.collections.IHierarchicalCollectionView.prototype.getChildren = function(node) {
};
/**
 *  Adds a child node to a node of the data.
 *
 *  @asparam node The Object that defines the parent node.
 *
 *  @asparam child The Object that defines the new node.
 *
 *  @asreturn <code>true</code> if the node is added successfully.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} parent
 * @param {Object} newChild
 * @return {boolean}
 */
mx.collections.IHierarchicalCollectionView.prototype.addChild = function(parent, newChild) {
};
/**
 *  Removes the child node from the parent node.
 *
 *  @asparam node The Object that defines the parent node,  
 *   and <code>null</code> for top-level nodes.
 *
 *  @asparam child The Object that defines the child node to be removed.
 *
 *  @asreturn <code>true</code> if the node is removed successfully.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} parent
 * @param {Object} child
 * @return {boolean}
 */
mx.collections.IHierarchicalCollectionView.prototype.removeChild = function(parent, child) {
};
/**
 *  Adds a child node to a node of the data at a specific index in the data.
 *
 *  @asparam node The Object that defines the parent node.
 *
 *  @asparam child The Object that defines the new node.
 *
 *  @asparam index The zero-based index of where to insert the child node.
 *
 *  @asreturn <code>true</code> if the node is added successfully.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} parent
 * @param {Object} newChild
 * @param {number} index
 * @return {boolean}
 */
mx.collections.IHierarchicalCollectionView.prototype.addChildAt = function(parent, newChild, index) {
};
/**
 *  Removes the child node from a node at the specified index.
 *
 *  @asparam parent The node object that currently parents the child node.
 *  Set <code>parent</code> to <code>null</code> for top-level nodes.
 *
 *  @asparam index The zero-based index of the child node to remove relative to the parent.
 *
 *  @asreturn <code>true</code> if successful, and <code>false</code> if not.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} parent
 * @param {number} index
 * @return {boolean}
 */
mx.collections.IHierarchicalCollectionView.prototype.removeChildAt = function(parent, index) {
};
/**
 *  Returns the depth of the node in the collection.
 *
 *  @asparam node The Object that defines the node.
 * 
 *  @asreturn The depth of the node.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {number}
 */
mx.collections.IHierarchicalCollectionView.prototype.getNodeDepth = function(node) {
};
/**
 *  Returns the parent of a node.  
 *  The parent of a top-level node is <code>null</code>.
 *
 *  @asparam node The Object that defines the node.
 *
 *  @asreturn The parent node containing the node as child, 
 *  <code>null</code> for a top-level node,  
 *  and <code>undefined</code> if the parent cannot be determined.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {*}
 */
mx.collections.IHierarchicalCollectionView.prototype.getParentItem = function(node) {
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.IHierarchicalCollectionView.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'IHierarchicalCollectionView', qName: 'mx.collections.IHierarchicalCollectionView', kind: 'interface' }], interfaces: [mx.collections.ICollectionView] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.IHierarchicalCollectionView.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'openNodes': { type: 'Object', access: 'readwrite', declaredBy: 'mx.collections.IHierarchicalCollectionView'},
        'hasRoot': { type: 'Boolean', access: 'readonly', declaredBy: 'mx.collections.IHierarchicalCollectionView'},
        'showRoot': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.collections.IHierarchicalCollectionView'},
        'source': { type: 'mx.collections.IHierarchicalData', access: 'readwrite', declaredBy: 'mx.collections.IHierarchicalCollectionView'}
      };
    },
    methods: function () {
      return {
        'openNode': { type: 'void', declaredBy: 'mx.collections.IHierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'closeNode': { type: 'void', declaredBy: 'mx.collections.IHierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'getChildren': { type: 'mx.collections.ICollectionView', declaredBy: 'mx.collections.IHierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'addChild': { type: 'Boolean', declaredBy: 'mx.collections.IHierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'Object', false ]; }},
        'removeChild': { type: 'Boolean', declaredBy: 'mx.collections.IHierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'Object', false ]; }},
        'addChildAt': { type: 'Boolean', declaredBy: 'mx.collections.IHierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'Object', false ,'int', false ]; }},
        'removeChildAt': { type: 'Boolean', declaredBy: 'mx.collections.IHierarchicalCollectionView', parameters: function () { return [ 'Object', false ,'int', false ]; }},
        'getNodeDepth': { type: 'int', declaredBy: 'mx.collections.IHierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }},
        'getParentItem': { type: '*', declaredBy: 'mx.collections.IHierarchicalCollectionView', parameters: function () { return [ 'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.IHierarchicalCollectionView.prototype.ROYALE_COMPILE_FLAGS = 10;