/**
 * Generated by Apache Royale Compiler from mx/collections/IHierarchicalData.as
 * mx.collections.IHierarchicalData
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.IHierarchicalData');

goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('XML');



/**
 * @interface
 * @extends {org.apache.royale.events.IEventDispatcher}
 */
mx.collections.IHierarchicalData = function() {
};
/**
 *  Returns <code>true</code> if the node can contain children.
 *
 *  <p>Nodes do not have to contain children for the method
 *  to return <code>true</code>. 
 *  This method is useful in determining whether other 
 *  nodes can be appended as children to the specified node.</p>
 * 
 *  @asparam node The Object that defines the node.
 *
 *  @asreturn <code>true</code> if the node can contain children.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {boolean}
 */
mx.collections.IHierarchicalData.prototype.canHaveChildren = function(node) {
};
/**
 *  Returns <code>true</code> if the node has children. 
 * 
 *  @asparam node The Object that defines the node.
 *
 *  @asreturn <code>true</code> if the node has children.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {boolean}
 */
mx.collections.IHierarchicalData.prototype.hasChildren = function(node) {
};
/**
 *  Returns an Object representing the node's children. 
 *
 *  @asparam node The Object that defines the node.
 *  If <code>null</code>, return a collection of top-level nodes.
 *
 *  @asreturn An Object containing the children nodes.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {Object}
 */
mx.collections.IHierarchicalData.prototype.getChildren = function(node) {
};
/**
 *  Returns data from a node.
 *
 *  @asparam node The node Object from which to get the data.
 *
 *  @asreturn The requested data.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} node
 * @return {Object}
 */
mx.collections.IHierarchicalData.prototype.getData = function(node) {
};
/**
 * Returns the root data item.
 * 
 * @asreturn The Object containing the root data item.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {Object}
 */
mx.collections.IHierarchicalData.prototype.getRoot = function() {
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.IHierarchicalData.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'IHierarchicalData', qName: 'mx.collections.IHierarchicalData', kind: 'interface' }], interfaces: [org.apache.royale.events.IEventDispatcher] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.IHierarchicalData.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'canHaveChildren': { type: 'Boolean', declaredBy: 'mx.collections.IHierarchicalData', parameters: function () { return [ 'Object', false ]; }},
        'hasChildren': { type: 'Boolean', declaredBy: 'mx.collections.IHierarchicalData', parameters: function () { return [ 'Object', false ]; }},
        'getChildren': { type: 'Object', declaredBy: 'mx.collections.IHierarchicalData', parameters: function () { return [ 'Object', false ]; }},
        'getData': { type: 'Object', declaredBy: 'mx.collections.IHierarchicalData', parameters: function () { return [ 'Object', false ]; }},
        'getRoot': { type: 'Object', declaredBy: 'mx.collections.IHierarchicalData'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.IHierarchicalData.prototype.ROYALE_COMPILE_FLAGS = 10;