/**
 * Generated by Apache Royale Compiler from mx/collections/ISummaryCalculator.as
 * mx.collections.ISummaryCalculator
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.ISummaryCalculator');

goog.require('mx.collections.SummaryField2');
goog.require('XML');



/**
 * @interface
 */
mx.collections.ISummaryCalculator = function() {
};
/**
 *  Flex calls this method to start the computation of a summary value.
 *
 *  @asparam field The SummaryField2 for which the summary needs to calculated.
 *
 *  @asreturn An Object initialized for the summary calculation. 
 *  Use this Object to hold any information necessary to perform the calculation.
 *  You pass this Object to subsequent calls to the <code>calculateSummary()</code> 
 *  and <code>returnSummary()</code> methods.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {mx.collections.SummaryField2} field
 * @return {Object}
 */
mx.collections.ISummaryCalculator.prototype.summaryCalculationBegin = function(field) {
};
/**
 *  Flex calls this method when a new value needs to be added to the summary value.
 *
 *  @asparam data The Object returned by the call to the <code>summaryCalculationBegin()</code> method,
 *  or calculated by a previous call to the <code>calculateSummary()</code> method. 
 *  Use this Object to hold information necessary to perform the calculation.
 *  This method modifies this Object; it does not return a value.
 * 
 *  @asparam field The SummaryField2 for which the summary needs to calculated.
 *
 *  @asparam rowData The object representing the rows data that is being analyzed. 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} data
 * @param {mx.collections.SummaryField2} field
 * @param {Object} rowData
 */
mx.collections.ISummaryCalculator.prototype.calculateSummary = function(data, field, rowData) {
};
/**
 *  Flex calls this method to end the computation of the summary value. 
 *
 *  @asparam data The Object returned by the call to the <code>calculateSummary()</code> method.
 *  Use this Object to hold information necessary to perform the calculation.
 * 
 *  @asparam field The SummaryField2 for which the summary needs to calculated.
 *
 *  @asreturn The summary value.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} data
 * @param {mx.collections.SummaryField2} field
 * @return {number}
 */
mx.collections.ISummaryCalculator.prototype.returnSummary = function(data, field) {
};
/**
 *  Flex calls this method to start calculation of summary out of summary values. 
 *  Calculating the average value of a group of averages is an example of 
 *  an calculation of summary out of summary values.
 *
 *  @asparam value The Object returned by the call to the <code>calculateSummary()</code> method
 *  for a previous summary calculation. 
 *  Use this Object to hold the information necessary to perform the calculation.
 *  
 *  @asparam field The SummaryField2 for which the summary needs to calculated.
 *  
 *  @asreturn An Object initialized for the summary calculation. 
 *  Use this Object to hold any information necessary to perform the calculation.
 *  You pass this Object to subsequent calls to the <code>calculateSummaryOfSummary()</code> 
 *  and <code>returnSummaryOfSummary()</code> methods.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} value
 * @param {mx.collections.SummaryField2} field
 * @return {Object}
 */
mx.collections.ISummaryCalculator.prototype.summaryOfSummaryCalculationBegin = function(value, field) {
};
/**
 *  Flex calls this method when a new summary value needs to be added to the already computed summary.
 *
 *  @asparam value The Object returned by a call the <code>summaryOfSummaryCalculationBegin()</code> method,
 *  or calculated by a previous call to the <code>calculateSummaryOfSummary()</code> method.
 *  This method modifies this Object; it does not return a value.
 *
 *  @asparam newValue The Object returned by the call to the <code>returnSummary()</code> method
 *  for a previous aggregation.
 *  
 *  @asparam field The SummaryField2 for which the summary needs to calculated.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} value
 * @param {Object} newValue
 * @param {mx.collections.SummaryField2} field
 */
mx.collections.ISummaryCalculator.prototype.calculateSummaryOfSummary = function(value, newValue, field) {
};
/**
 *  Flex calls this method to end the summary calculation. 
 *
 *  @asparam value The Object returned by a call to the <code>calculateSummaryOfSummary()</code> method
 *  that is used to store the summary calculation results. 
 *  This method modifies this Object; it does not return a value.
 *
 *  @asparam field The SummaryField2 for which the summary needs to calculated.
 *
 *  @asreturn The summary value.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10
 *  @playerversion AIR 1.5
 *  @productversion Flex 4
 * @param {Object} value
 * @param {mx.collections.SummaryField2} field
 * @return {number}
 */
mx.collections.ISummaryCalculator.prototype.returnSummaryOfSummary = function(value, field) {
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.ISummaryCalculator.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ISummaryCalculator', qName: 'mx.collections.ISummaryCalculator', kind: 'interface' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.ISummaryCalculator.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'summaryCalculationBegin': { type: 'Object', declaredBy: 'mx.collections.ISummaryCalculator', parameters: function () { return [ 'mx.collections.SummaryField2', false ]; }},
        'calculateSummary': { type: 'void', declaredBy: 'mx.collections.ISummaryCalculator', parameters: function () { return [ 'Object', false ,'mx.collections.SummaryField2', false ,'Object', false ]; }},
        'returnSummary': { type: 'Number', declaredBy: 'mx.collections.ISummaryCalculator', parameters: function () { return [ 'Object', false ,'mx.collections.SummaryField2', false ]; }},
        'summaryOfSummaryCalculationBegin': { type: 'Object', declaredBy: 'mx.collections.ISummaryCalculator', parameters: function () { return [ 'Object', false ,'mx.collections.SummaryField2', false ]; }},
        'calculateSummaryOfSummary': { type: 'void', declaredBy: 'mx.collections.ISummaryCalculator', parameters: function () { return [ 'Object', false ,'Object', false ,'mx.collections.SummaryField2', false ]; }},
        'returnSummaryOfSummary': { type: 'Number', declaredBy: 'mx.collections.ISummaryCalculator', parameters: function () { return [ 'Object', false ,'mx.collections.SummaryField2', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.ISummaryCalculator.prototype.ROYALE_COMPILE_FLAGS = 10;