/**
 * Generated by Apache Royale Compiler from mx/collections/LeafNodeCursor.as
 * mx.collections.LeafNodeCursor
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.LeafNodeCursor');

goog.require('mx.collections.CursorBookmark');
goog.require('mx.collections.HierarchicalCollectionView');
goog.require('mx.collections.ICollectionView');
goog.require('mx.collections.IHierarchicalData');
goog.require('mx.collections.IViewCursor');
goog.require('mx.collections.SummaryObject');
goog.require('mx.core.mx_internal');
goog.require('mx.utils.UIDUtil');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('mx.collections.IHierarchicalCollectionViewCursor');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {mx.collections.IHierarchicalCollectionViewCursor}
 * @param {mx.collections.HierarchicalCollectionView} collection
 * @param {mx.collections.ICollectionView} model
 * @param {mx.collections.IHierarchicalData} hierarchicalData
 */
mx.collections.LeafNodeCursor = function(collection, model, hierarchicalData) {
  
  this.mx_collections_LeafNodeCursor_childNodes = [];
  this.mx_collections_LeafNodeCursor_parentNodes = [];
  this.mx_collections_LeafNodeCursor_childIndexStack = [];
  mx.collections.LeafNodeCursor.base(this, 'constructor');
  this.mx_collections_LeafNodeCursor_collection = collection;
  this.mx_collections_LeafNodeCursor_hierarchicalData = hierarchicalData;
  this.mx_collections_LeafNodeCursor_model = model;
  this.mx_collections_LeafNodeCursor_modelCursor = model.createCursor();
  if (model.length > 1)
    this.mx_collections_LeafNodeCursor_more = true;
  else
    this.mx_collections_LeafNodeCursor_more = false;
};
goog.inherits(mx.collections.LeafNodeCursor, org.apache.royale.events.EventDispatcher);


/**
 *  Finalizes the cursor, to clean up resources.
 *  Required because weak references are not available in JS.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.8
 */
mx.collections.LeafNodeCursor.prototype.finalizeThis = function() {
  if (this.mx_collections_LeafNodeCursor_modelCursor)
    this.mx_collections_LeafNodeCursor_modelCursor.finalizeThis();
};


/**
 * @private
 * @type {mx.collections.IHierarchicalData}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_hierarchicalData;


/**
 * @private
 * @type {number}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_currentIndex = 0;


/**
 * @private
 * @type {number}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_currentChildIndex = 0;


/**
 * @private
 * @type {number}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor__currentDepth = 1;


/**
 * @private
 * @type {Object}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_childNodes;


/**
 * @private
 * @type {Array}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_parentNodes;


/**
 * @private
 * @type {Array}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_childIndexStack;


/**
 * @private
 * @type {mx.collections.ICollectionView}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_model;


/**
 * @private
 * @type {mx.collections.HierarchicalCollectionView}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_collection;


/**
 * @private
 * @type {boolean}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_more;


/**
 * @private
 * @type {mx.collections.IViewCursor}
 */
mx.collections.LeafNodeCursor.prototype.mx_collections_LeafNodeCursor_modelCursor;


/**
 *  @asprivate
 * @param {Object} values
 * @return {boolean}
 */
mx.collections.LeafNodeCursor.prototype.findAny = function(values) {
  return false;
};


/**
 *  @asprivate
 * @param {Object} values
 * @return {boolean}
 */
mx.collections.LeafNodeCursor.prototype.findFirst = function(values) {
  return false;
};


/**
 *  @asprivate
 * @param {Object} values
 * @return {boolean}
 */
mx.collections.LeafNodeCursor.prototype.findLast = function(values) {
  return false;
};


/**
 *  @asprivate
 *  Move one node forward from current.  
 *  This may include moving up or down one or more levels.
 * @return {boolean}
 */
mx.collections.LeafNodeCursor.prototype.moveNext = function() {
  var /** @type {Object} */ currentNode = this.mx_collections_LeafNodeCursor_childIndexStack.length == 0 ? this.mx_collections_LeafNodeCursor_modelCursor.current : this.current;
  if (currentNode == null)
    return false;
  var /** @type {string} */ uid = mx.utils.UIDUtil.getUID(currentNode);
  this.mx_collections_LeafNodeCursor_collection.addParentMapping(uid, this.mx_collections_LeafNodeCursor_parentNodes[this.mx_collections_LeafNodeCursor_parentNodes.length - 1], false);
  var /** @type {boolean} */ flag = true;
  if (this.mx_collections_LeafNodeCursor_hierarchicalData.canHaveChildren(currentNode) && this.mx_collections_LeafNodeCursor_hierarchicalData.hasChildren(currentNode)) {
    var /** @type {Object} */ previousChildNodes = this.mx_collections_LeafNodeCursor_childNodes;
    this.mx_collections_LeafNodeCursor_childNodes = this.mx_collections_LeafNodeCursor_collection.getChildren(currentNode);
    if (this.mx_collections_LeafNodeCursor_childNodes.length > 0) {
      this.mx_collections_LeafNodeCursor_childIndexStack.push(this.mx_collections_LeafNodeCursor_currentChildIndex);
      this.mx_collections_LeafNodeCursor_parentNodes.push(currentNode);
      this.mx_collections_LeafNodeCursor_currentChildIndex = 0;
      currentNode = this.mx_collections_LeafNodeCursor_childNodes[0];
      this.mx_collections_LeafNodeCursor_currentIndex++;
      this.mx_collections_LeafNodeCursor__currentDepth++;
      if (this.mx_collections_LeafNodeCursor_hierarchicalData.canHaveChildren(currentNode) || org.apache.royale.utils.Language.is(currentNode, mx.collections.SummaryObject)) {
        flag = this.moveNext();
      }
      return flag;
    } else {
      this.mx_collections_LeafNodeCursor_childNodes = previousChildNodes;
    }
  }
  while (true) {
    if (this.mx_collections_LeafNodeCursor_childNodes != null && this.mx_collections_LeafNodeCursor_childNodes.length > 0 && this.mx_collections_LeafNodeCursor_currentChildIndex >= Math.max(this.mx_collections_LeafNodeCursor_childNodes.length - 1, 0)) {
      if (this.mx_collections_LeafNodeCursor_childIndexStack.length < 1 && !this.mx_collections_LeafNodeCursor_more) {
        currentNode = null;
        this.mx_collections_LeafNodeCursor_currentIndex++;
        this.mx_collections_LeafNodeCursor__currentDepth = 1;
        return false;
      } else {
        currentNode = this.mx_collections_LeafNodeCursor_parentNodes.pop();
        var /** @type {Object} */ grandParent = this.mx_collections_LeafNodeCursor_parentNodes[this.mx_collections_LeafNodeCursor_parentNodes.length - 1];
        if (grandParent != null && this.mx_collections_LeafNodeCursor_hierarchicalData.canHaveChildren(grandParent) && this.mx_collections_LeafNodeCursor_hierarchicalData.hasChildren(grandParent)) {
          this.mx_collections_LeafNodeCursor_childNodes = this.mx_collections_LeafNodeCursor_collection.getChildren(grandParent);
        } else {
          this.mx_collections_LeafNodeCursor_childNodes = [];
        }
        this.mx_collections_LeafNodeCursor_currentChildIndex = (this.mx_collections_LeafNodeCursor_childIndexStack.pop()) >> 0;
        this.mx_collections_LeafNodeCursor__currentDepth--;
      }
    } else {
      if (this.mx_collections_LeafNodeCursor_childIndexStack.length == 0) {
        this.mx_collections_LeafNodeCursor__currentDepth = 1;
        this.mx_collections_LeafNodeCursor_more = this.mx_collections_LeafNodeCursor_modelCursor.moveNext();
        if (this.mx_collections_LeafNodeCursor_more) {
          currentNode = this.mx_collections_LeafNodeCursor_modelCursor.current;
          break;
        } else {
          this.mx_collections_LeafNodeCursor__currentDepth = 1;
          this.mx_collections_LeafNodeCursor_currentIndex++;
          currentNode = null;
          return false;
        }
      } else {
        try {
          currentNode = this.mx_collections_LeafNodeCursor_childNodes[++this.mx_collections_LeafNodeCursor_currentChildIndex];
          break;
        } catch (e) {
          return false;
        }
      }
    }
  }
  this.mx_collections_LeafNodeCursor_currentIndex++;
  if (this.mx_collections_LeafNodeCursor_hierarchicalData.canHaveChildren(currentNode) || org.apache.royale.utils.Language.is(currentNode, mx.collections.SummaryObject)) {
    flag = this.moveNext();
  }
  return flag;
};


/**
 *  @asprivate
 *  Performs a backward tree walk.
 * @return {boolean}
 */
mx.collections.LeafNodeCursor.prototype.movePrevious = function() {
  var /** @type {Object} */ currentNode = this.current;
  if (currentNode == null)
    return false;
  var /** @type {boolean} */ flag = true;
  if (this.mx_collections_LeafNodeCursor_parentNodes && this.mx_collections_LeafNodeCursor_parentNodes.length > 0) {
    if (this.mx_collections_LeafNodeCursor_currentChildIndex == 0) {
      currentNode = this.mx_collections_LeafNodeCursor_parentNodes.pop();
      this.mx_collections_LeafNodeCursor_currentChildIndex = (this.mx_collections_LeafNodeCursor_childIndexStack.pop()) >> 0;
      var /** @type {Object} */ grandParent = this.mx_collections_LeafNodeCursor_parentNodes[this.mx_collections_LeafNodeCursor_parentNodes.length - 1];
      if (grandParent != null && this.mx_collections_LeafNodeCursor_hierarchicalData.canHaveChildren(grandParent) && this.mx_collections_LeafNodeCursor_hierarchicalData.hasChildren(grandParent)) {
        this.mx_collections_LeafNodeCursor_childNodes = this.mx_collections_LeafNodeCursor_collection.getChildren(grandParent);
      } else {
        this.mx_collections_LeafNodeCursor_childNodes = [];
      }
      this.mx_collections_LeafNodeCursor__currentDepth--;
      this.mx_collections_LeafNodeCursor_currentIndex--;
      if (!this.beforeFirst && (this.mx_collections_LeafNodeCursor_hierarchicalData.canHaveChildren(currentNode) || org.apache.royale.utils.Language.is(currentNode, mx.collections.SummaryObject))) {
        flag = this.movePrevious();
      }
      return flag;
    } else {
      try {
        currentNode = this.mx_collections_LeafNodeCursor_childNodes[--this.mx_collections_LeafNodeCursor_currentChildIndex];
      } catch (e) {
        return false;
      }
    }
  } else {
    this.mx_collections_LeafNodeCursor_more = this.mx_collections_LeafNodeCursor_modelCursor.movePrevious();
    if (this.mx_collections_LeafNodeCursor_more) {
      currentNode = this.mx_collections_LeafNodeCursor_modelCursor.current;
    } else {
      this.mx_collections_LeafNodeCursor_currentIndex = -1;
      currentNode = null;
      return false;
    }
  }
  while (true) {
    if (this.mx_collections_LeafNodeCursor_hierarchicalData.canHaveChildren(currentNode) && this.mx_collections_LeafNodeCursor_hierarchicalData.hasChildren(currentNode)) {
      var /** @type {Object} */ previousChildNodes = this.mx_collections_LeafNodeCursor_childNodes;
      this.mx_collections_LeafNodeCursor_childNodes = this.mx_collections_LeafNodeCursor_collection.getChildren(currentNode);
      if (this.mx_collections_LeafNodeCursor_childNodes.length > 0) {
        this.mx_collections_LeafNodeCursor_childIndexStack.push(this.mx_collections_LeafNodeCursor_currentChildIndex);
        this.mx_collections_LeafNodeCursor_parentNodes.push(currentNode);
        this.mx_collections_LeafNodeCursor_currentChildIndex = (this.mx_collections_LeafNodeCursor_childNodes.length - 1) >> 0;
        currentNode = this.mx_collections_LeafNodeCursor_childNodes[this.mx_collections_LeafNodeCursor_currentChildIndex];
        this.mx_collections_LeafNodeCursor__currentDepth++;
      } else {
        this.mx_collections_LeafNodeCursor_childNodes = previousChildNodes;
        break;
      }
    } else {
      break;
    }
  }
  this.mx_collections_LeafNodeCursor_currentIndex--;
  if (this.mx_collections_LeafNodeCursor_hierarchicalData.canHaveChildren(currentNode) || org.apache.royale.utils.Language.is(currentNode, mx.collections.SummaryObject)) {
    flag = this.movePrevious();
  }
  return flag;
};


/**
 *  @asprivate
 * @param {mx.collections.CursorBookmark} bookmark
 * @param {number=} offset
 * @param {number=} prefetch
 */
mx.collections.LeafNodeCursor.prototype.seek = function(bookmark, offset, prefetch) {
  offset = typeof offset !== 'undefined' ? offset : 0;
  prefetch = typeof prefetch !== 'undefined' ? prefetch : 0;
};


/**
 *  @asprivate
 * @param {Object} item
 */
mx.collections.LeafNodeCursor.prototype.insert = function(item) {
};


/**
 *  @asprivate
 * @return {Object}
 */
mx.collections.LeafNodeCursor.prototype.remove = function() {
  return null;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.collections.LeafNodeCursor.prototype.index;


mx.collections.LeafNodeCursor.prototype.get__index = function() {
  return this.mx_collections_LeafNodeCursor_currentIndex;
};


/**
 * @nocollapse
 * @export
 * @type {mx.collections.CursorBookmark}
 */
mx.collections.LeafNodeCursor.prototype.bookmark;


mx.collections.LeafNodeCursor.prototype.get__bookmark = function() {
  return null;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.collections.LeafNodeCursor.prototype.current;


mx.collections.LeafNodeCursor.prototype.get__current = function() {
  try {
    if (this.mx_collections_LeafNodeCursor_childIndexStack.length == 0) {
      if (this.mx_collections_LeafNodeCursor_hierarchicalData.canHaveChildren(this.mx_collections_LeafNodeCursor_modelCursor.current) || org.apache.royale.utils.Language.is(this.mx_collections_LeafNodeCursor_modelCursor.current, mx.collections.SummaryObject)) {
        this.moveNext();
      } else {
        return this.mx_collections_LeafNodeCursor_modelCursor.current;
      }
    }
    return this.mx_collections_LeafNodeCursor_childNodes[this.mx_collections_LeafNodeCursor_currentChildIndex];
  } catch (e) {
  }
  return null;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.collections.LeafNodeCursor.prototype.currentDepth;


mx.collections.LeafNodeCursor.prototype.get__currentDepth = function() {
  return this.mx_collections_LeafNodeCursor__currentDepth;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.collections.LeafNodeCursor.prototype.beforeFirst;


mx.collections.LeafNodeCursor.prototype.get__beforeFirst = function() {
  return this.mx_collections_LeafNodeCursor_currentIndex < 0 && this.current == null;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.collections.LeafNodeCursor.prototype.afterLast;


mx.collections.LeafNodeCursor.prototype.get__afterLast = function() {
  return this.mx_collections_LeafNodeCursor_currentIndex >= this.mx_collections_LeafNodeCursor_collection.length && this.current == null;
};


/**
 * @nocollapse
 * @export
 * @type {mx.collections.ICollectionView}
 */
mx.collections.LeafNodeCursor.prototype.view;


mx.collections.LeafNodeCursor.prototype.get__view = function() {
  return this.mx_collections_LeafNodeCursor_model;
};


Object.defineProperties(mx.collections.LeafNodeCursor.prototype, /** @lends {mx.collections.LeafNodeCursor.prototype} */ {
/**
 * @type {number}
 */
index: {
get: mx.collections.LeafNodeCursor.prototype.get__index},
/**
 * @type {mx.collections.CursorBookmark}
 */
bookmark: {
get: mx.collections.LeafNodeCursor.prototype.get__bookmark},
/**
 * @type {Object}
 */
current: {
get: mx.collections.LeafNodeCursor.prototype.get__current},
/**
 * @type {number}
 */
currentDepth: {
get: mx.collections.LeafNodeCursor.prototype.get__currentDepth},
/**
 * @type {boolean}
 */
beforeFirst: {
get: mx.collections.LeafNodeCursor.prototype.get__beforeFirst},
/**
 * @type {boolean}
 */
afterLast: {
get: mx.collections.LeafNodeCursor.prototype.get__afterLast},
/**
 * @type {mx.collections.ICollectionView}
 */
view: {
get: mx.collections.LeafNodeCursor.prototype.get__view}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.LeafNodeCursor.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'LeafNodeCursor', qName: 'mx.collections.LeafNodeCursor', kind: 'class' }], interfaces: [mx.collections.IHierarchicalCollectionViewCursor] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.LeafNodeCursor.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'index': { type: 'int', access: 'readonly', declaredBy: 'mx.collections.LeafNodeCursor'},
        'bookmark': { type: 'mx.collections.CursorBookmark', access: 'readonly', declaredBy: 'mx.collections.LeafNodeCursor'},
        'current': { type: 'Object', access: 'readonly', declaredBy: 'mx.collections.LeafNodeCursor'},
        'currentDepth': { type: 'int', access: 'readonly', declaredBy: 'mx.collections.LeafNodeCursor'},
        'beforeFirst': { type: 'Boolean', access: 'readonly', declaredBy: 'mx.collections.LeafNodeCursor'},
        'afterLast': { type: 'Boolean', access: 'readonly', declaredBy: 'mx.collections.LeafNodeCursor'},
        'view': { type: 'mx.collections.ICollectionView', access: 'readonly', declaredBy: 'mx.collections.LeafNodeCursor'}
      };
    },
    methods: function () {
      return {
        'LeafNodeCursor': { type: '', declaredBy: 'mx.collections.LeafNodeCursor', parameters: function () { return [ 'mx.collections.HierarchicalCollectionView', false ,'mx.collections.ICollectionView', false ,'mx.collections.IHierarchicalData', false ]; }},
        'finalizeThis': { type: 'void', declaredBy: 'mx.collections.LeafNodeCursor'},
        'findAny': { type: 'Boolean', declaredBy: 'mx.collections.LeafNodeCursor', parameters: function () { return [ 'Object', false ]; }},
        'findFirst': { type: 'Boolean', declaredBy: 'mx.collections.LeafNodeCursor', parameters: function () { return [ 'Object', false ]; }},
        'findLast': { type: 'Boolean', declaredBy: 'mx.collections.LeafNodeCursor', parameters: function () { return [ 'Object', false ]; }},
        'moveNext': { type: 'Boolean', declaredBy: 'mx.collections.LeafNodeCursor'},
        'movePrevious': { type: 'Boolean', declaredBy: 'mx.collections.LeafNodeCursor'},
        'seek': { type: 'void', declaredBy: 'mx.collections.LeafNodeCursor', parameters: function () { return [ 'mx.collections.CursorBookmark', false ,'int', true ,'int', true ]; }},
        'insert': { type: 'void', declaredBy: 'mx.collections.LeafNodeCursor', parameters: function () { return [ 'Object', false ]; }},
        'remove': { type: 'Object', declaredBy: 'mx.collections.LeafNodeCursor'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.LeafNodeCursor.prototype.ROYALE_COMPILE_FLAGS = 10;