/**
 * Generated by Apache Royale Compiler from mx/collections/errors/ItemPendingError.as
 * mx.collections.errors.ItemPendingError
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.collections.errors.ItemPendingError');

goog.require('mx.rpc.IResponder');
goog.require('XML');



/**
 *  Constructor.
 *
 *  <p>Called by the Flex Framework when a request is made 
 *  for an item that isn't local.</p>
 *
 *  @asparam message A message providing information about the error cause.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {Error}
 * @param {string} message
 */
mx.collections.errors.ItemPendingError = function(message) {
  mx.collections.errors.ItemPendingError.base(this, 'constructor', message);
};
goog.inherits(mx.collections.errors.ItemPendingError, Error);


/**
 * @private
 * @type {Array}
 */
mx.collections.errors.ItemPendingError.prototype.mx_collections_errors_ItemPendingError__responders;


/**
 *  <code>addResponder</code> adds a responder to an Array of responders. 
 *  The object assigned to the responder parameter must implement the 
 *  mx.rpc.IResponder interface.
 *
 *  @asparam responder A handler which will be called when the asynchronous request completes.
 * 
 *  @see	mx.rpc.IResponder
 *  @see	mx.collections.ItemResponder
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {mx.rpc.IResponder} responder
 */
mx.collections.errors.ItemPendingError.prototype.addResponder = function(responder) {
  if (!this.mx_collections_errors_ItemPendingError__responders)
    this.mx_collections_errors_ItemPendingError__responders = [];
  this.mx_collections_errors_ItemPendingError__responders.push(responder);
};


/**
 * @nocollapse
 * @export
 * @type {Array}
 */
mx.collections.errors.ItemPendingError.prototype.responders;


mx.collections.errors.ItemPendingError.prototype.get__responders = function() {
  return this.mx_collections_errors_ItemPendingError__responders;
};


Object.defineProperties(mx.collections.errors.ItemPendingError.prototype, /** @lends {mx.collections.errors.ItemPendingError.prototype} */ {
/**
 * @type {Array}
 */
responders: {
get: mx.collections.errors.ItemPendingError.prototype.get__responders}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.collections.errors.ItemPendingError.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ItemPendingError', qName: 'mx.collections.errors.ItemPendingError', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.collections.errors.ItemPendingError.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'responders': { type: 'Array', access: 'readonly', declaredBy: 'mx.collections.errors.ItemPendingError'}
      };
    },
    methods: function () {
      return {
        'ItemPendingError': { type: '', declaredBy: 'mx.collections.errors.ItemPendingError', parameters: function () { return [ 'String', false ]; }},
        'addResponder': { type: 'void', declaredBy: 'mx.collections.errors.ItemPendingError', parameters: function () { return [ 'mx.rpc.IResponder', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.collections.errors.ItemPendingError.prototype.ROYALE_COMPILE_FLAGS = 10;