/**
 * Generated by Apache Royale Compiler from mx/events/CollectionEvent.as
 * mx.events.CollectionEvent
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.events.CollectionEvent');

goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.IRoyaleEvent');
goog.require('XML');



/**
 *  Constructor.
 *
 *  @asparam type The event type; indicates the action that triggered the event.
 *
 *  @asparam bubbles Specifies whether the event can bubble
 *  up the display list hierarchy.
 *
 *  @asparam cancelable Specifies whether the behavior
 *  associated with the event can be prevented.
 *
 *  @asparam kind Indicates the kind of event that occured.
 *  The parameter value can be one of the values in the CollectionEventKind 
 *  class, or <code>null</code>, which indicates that the kind is unknown.
 *
 *  @asparam location When the <code>kind</code> is
 *  <code>CollectionEventKind.ADD</code>,
 *  <code>CollectionEventKind.MOVE</code>,
 *  <code>CollectionEventKind.REMOVE</code>, or
 *  <code>CollectionEventKind.REPLACE</code>,
 *  this value indicates at what location the item(s) specified
 *  in the <code>items property</code> can be found
 *  within the target collection.
 *
 *  @asparam oldLocation When the <code>kind</code> is
 *  <code>CollectionEventKind.MOVE</code>, this value indicates
 *  the old location within the target collection
 *  of the item(s) specified in the <code>items</code> property.
 *
 *  @asparam items Array of objects with information about the items 
 *  affected by the event, as described in the <code>items</code> property.
 *  When the <code>kind</code> is <code>CollectionEventKind.REFRESH</code>
 *  or <code>CollectionEventKind.RESET</code>, this Array has zero length.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {org.apache.royale.events.Event}
 * @param {string} type
 * @param {boolean=} bubbles
 * @param {boolean=} cancelable
 * @param {string=} kind
 * @param {number=} location
 * @param {number=} oldLocation
 * @param {Array=} items
 */
mx.events.CollectionEvent = function(type, bubbles, cancelable, kind, location, oldLocation, items) {
  bubbles = typeof bubbles !== 'undefined' ? bubbles : false;
  cancelable = typeof cancelable !== 'undefined' ? cancelable : false;
  kind = typeof kind !== 'undefined' ? kind : null;
  location = typeof location !== 'undefined' ? location : -1;
  oldLocation = typeof oldLocation !== 'undefined' ? oldLocation : -1;
  items = typeof items !== 'undefined' ? items : null;
  mx.events.CollectionEvent.base(this, 'constructor', type, bubbles, cancelable);
  this.kind = kind;
  this.location = location;
  this.oldLocation = oldLocation;
  this.items = items ? items : [];
};
goog.inherits(mx.events.CollectionEvent, org.apache.royale.events.Event);


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.CollectionEvent.COLLECTION_CHANGE = "collectionChange";


/**
 * @private
 * @type {string}
 */
mx.events.CollectionEvent.prototype.mx_events_CollectionEvent__kind;


/**
 * @private
 * @type {Array}
 */
mx.events.CollectionEvent.prototype.mx_events_CollectionEvent__items;


/**
 * @private
 * @type {number}
 */
mx.events.CollectionEvent.prototype.mx_events_CollectionEvent__location = 0;


/**
 * @private
 * @type {number}
 */
mx.events.CollectionEvent.prototype.mx_events_CollectionEvent__oldLocation = 0;


/**
 *  @asprivate
 * @override
 */
mx.events.CollectionEvent.prototype.cloneEvent = function() {
  return new mx.events.CollectionEvent(this.type, this.bubbles, this.cancelable, this.kind, this.location, this.oldLocation, this.items);
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.events.CollectionEvent.prototype.kind;


mx.events.CollectionEvent.prototype.get__kind = function() {
  return this.mx_events_CollectionEvent__kind;
};


mx.events.CollectionEvent.prototype.set__kind = function(value) {
  this.mx_events_CollectionEvent__kind = value;
};


/**
 * @nocollapse
 * @export
 * @type {Array}
 */
mx.events.CollectionEvent.prototype.items;


mx.events.CollectionEvent.prototype.get__items = function() {
  return this.mx_events_CollectionEvent__items;
};


mx.events.CollectionEvent.prototype.set__items = function(value) {
  this.mx_events_CollectionEvent__items = value;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.events.CollectionEvent.prototype.location;


mx.events.CollectionEvent.prototype.get__location = function() {
  return this.mx_events_CollectionEvent__location;
};


mx.events.CollectionEvent.prototype.set__location = function(value) {
  this.mx_events_CollectionEvent__location = value;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.events.CollectionEvent.prototype.oldLocation;


mx.events.CollectionEvent.prototype.get__oldLocation = function() {
  return this.mx_events_CollectionEvent__oldLocation;
};


mx.events.CollectionEvent.prototype.set__oldLocation = function(value) {
  this.mx_events_CollectionEvent__oldLocation = value;
};


Object.defineProperties(mx.events.CollectionEvent.prototype, /** @lends {mx.events.CollectionEvent.prototype} */ {
/**
 * @type {string}
 */
kind: {
get: mx.events.CollectionEvent.prototype.get__kind,
set: mx.events.CollectionEvent.prototype.set__kind},
/**
 * @type {Array}
 */
items: {
get: mx.events.CollectionEvent.prototype.get__items,
set: mx.events.CollectionEvent.prototype.set__items},
/**
 * @type {number}
 */
location: {
get: mx.events.CollectionEvent.prototype.get__location,
set: mx.events.CollectionEvent.prototype.set__location},
/**
 * @type {number}
 */
oldLocation: {
get: mx.events.CollectionEvent.prototype.get__oldLocation,
set: mx.events.CollectionEvent.prototype.set__oldLocation}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.events.CollectionEvent.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CollectionEvent', qName: 'mx.events.CollectionEvent', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.events.CollectionEvent.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'kind': { type: 'String', access: 'readwrite', declaredBy: 'mx.events.CollectionEvent'},
        'items': { type: 'Array', access: 'readwrite', declaredBy: 'mx.events.CollectionEvent'},
        'location': { type: 'int', access: 'readwrite', declaredBy: 'mx.events.CollectionEvent'},
        'oldLocation': { type: 'int', access: 'readwrite', declaredBy: 'mx.events.CollectionEvent'}
      };
    },
    methods: function () {
      return {
        'CollectionEvent': { type: '', declaredBy: 'mx.events.CollectionEvent', parameters: function () { return [ 'String', false ,'Boolean', true ,'Boolean', true ,'String', true ,'int', true ,'int', true ,'Array', true ]; }},
        'cloneEvent': { type: 'org.apache.royale.events.IRoyaleEvent', declaredBy: 'mx.events.CollectionEvent'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.events.CollectionEvent.prototype.ROYALE_COMPILE_FLAGS = 10;