/**
 * Generated by Apache Royale Compiler from mx/events/IndexChangedEvent.as
 * mx.events.IndexChangedEvent
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.events.IndexChangedEvent');

goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.IRoyaleEvent');
goog.require('XML');



/**
 *  Constructor.
 *  Normally called by a Flex control and not used in application code.
 *
 *  @asparam type The event type; indicates the action that caused the event.
 *
 *  @asparam bubbles Specifies whether the event can bubble
 *  up the display list hierarchy.
 *
 *  @asparam cancelable Specifies whether the behavior
 *  associated with the event can be prevented.
 *
 *  @asparam relatedObject The child object associated with the index change.
 *
 *  @asparam oldIndex The zero-based index before the change.
 *
 *  @asparam newIndex The zero-based index after the change.
 *
 *  @asparam triggerEvent The event that triggered this event.
 *  
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {org.apache.royale.events.Event}
 * @param {string} type
 * @param {boolean=} bubbles
 * @param {boolean=} cancelable
 * @param {Object=} relatedObject
 * @param {number=} oldIndex
 * @param {number=} newIndex
 * @param {org.apache.royale.events.Event=} triggerEvent
 */
mx.events.IndexChangedEvent = function(type, bubbles, cancelable, relatedObject, oldIndex, newIndex, triggerEvent) {
  bubbles = typeof bubbles !== 'undefined' ? bubbles : false;
  cancelable = typeof cancelable !== 'undefined' ? cancelable : false;
  relatedObject = typeof relatedObject !== 'undefined' ? relatedObject : null;
  oldIndex = typeof oldIndex !== 'undefined' ? oldIndex : -1;
  newIndex = typeof newIndex !== 'undefined' ? newIndex : -1;
  triggerEvent = typeof triggerEvent !== 'undefined' ? triggerEvent : null;
  mx.events.IndexChangedEvent.base(this, 'constructor', type, bubbles, cancelable);
  this.relatedObject = relatedObject;
  this.oldIndex = oldIndex;
  this.newIndex = newIndex;
  this.triggerEvent = triggerEvent;
};
goog.inherits(mx.events.IndexChangedEvent, org.apache.royale.events.Event);


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.IndexChangedEvent.CHANGE = "change";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.IndexChangedEvent.CHILD_INDEX_CHANGE = "childIndexChange";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.IndexChangedEvent.HEADER_SHIFT = "headerShift";


/**
 * @private
 * @type {number}
 */
mx.events.IndexChangedEvent.prototype.mx_events_IndexChangedEvent__newIndex;


/**
 * @private
 * @type {number}
 */
mx.events.IndexChangedEvent.prototype.mx_events_IndexChangedEvent__oldIndex;


/**
 * @private
 * @type {Object}
 */
mx.events.IndexChangedEvent.prototype.mx_events_IndexChangedEvent__relatedObject;


/**
 * @private
 * @type {org.apache.royale.events.Event}
 */
mx.events.IndexChangedEvent.prototype.mx_events_IndexChangedEvent__triggerEvent;


/**
 *  @asprivate
 * @override
 */
mx.events.IndexChangedEvent.prototype.cloneEvent = function() {
  return new mx.events.IndexChangedEvent(this.type, this.bubbles, this.cancelable, this.relatedObject, this.oldIndex, this.newIndex, this.triggerEvent);
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.events.IndexChangedEvent.prototype.newIndex;


mx.events.IndexChangedEvent.prototype.get__newIndex = function() {
  return this.mx_events_IndexChangedEvent__newIndex;
};


mx.events.IndexChangedEvent.prototype.set__newIndex = function(value) {
  this.mx_events_IndexChangedEvent__newIndex = value;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.events.IndexChangedEvent.prototype.oldIndex;


mx.events.IndexChangedEvent.prototype.get__oldIndex = function() {
  return this.mx_events_IndexChangedEvent__oldIndex;
};


mx.events.IndexChangedEvent.prototype.set__oldIndex = function(value) {
  this.mx_events_IndexChangedEvent__oldIndex = value;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.events.IndexChangedEvent.prototype.relatedObject;


mx.events.IndexChangedEvent.prototype.get__relatedObject = function() {
  return this.mx_events_IndexChangedEvent__relatedObject;
};


mx.events.IndexChangedEvent.prototype.set__relatedObject = function(value) {
  this.mx_events_IndexChangedEvent__relatedObject = value;
};


/**
 * @nocollapse
 * @export
 * @type {org.apache.royale.events.Event}
 */
mx.events.IndexChangedEvent.prototype.triggerEvent;


mx.events.IndexChangedEvent.prototype.get__triggerEvent = function() {
  return this.mx_events_IndexChangedEvent__triggerEvent;
};


mx.events.IndexChangedEvent.prototype.set__triggerEvent = function(value) {
  this.mx_events_IndexChangedEvent__triggerEvent = value;
};


Object.defineProperties(mx.events.IndexChangedEvent.prototype, /** @lends {mx.events.IndexChangedEvent.prototype} */ {
/**
 * @type {number}
 */
newIndex: {
get: mx.events.IndexChangedEvent.prototype.get__newIndex,
set: mx.events.IndexChangedEvent.prototype.set__newIndex},
/**
 * @type {number}
 */
oldIndex: {
get: mx.events.IndexChangedEvent.prototype.get__oldIndex,
set: mx.events.IndexChangedEvent.prototype.set__oldIndex},
/**
 * @type {Object}
 */
relatedObject: {
get: mx.events.IndexChangedEvent.prototype.get__relatedObject,
set: mx.events.IndexChangedEvent.prototype.set__relatedObject},
/**
 * @type {org.apache.royale.events.Event}
 */
triggerEvent: {
get: mx.events.IndexChangedEvent.prototype.get__triggerEvent,
set: mx.events.IndexChangedEvent.prototype.set__triggerEvent}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.events.IndexChangedEvent.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'IndexChangedEvent', qName: 'mx.events.IndexChangedEvent', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.events.IndexChangedEvent.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'newIndex': { type: 'Number', access: 'readwrite', declaredBy: 'mx.events.IndexChangedEvent'},
        'oldIndex': { type: 'Number', access: 'readwrite', declaredBy: 'mx.events.IndexChangedEvent'},
        'relatedObject': { type: 'Object', access: 'readwrite', declaredBy: 'mx.events.IndexChangedEvent'},
        'triggerEvent': { type: 'org.apache.royale.events.Event', access: 'readwrite', declaredBy: 'mx.events.IndexChangedEvent'}
      };
    },
    methods: function () {
      return {
        'IndexChangedEvent': { type: '', declaredBy: 'mx.events.IndexChangedEvent', parameters: function () { return [ 'String', false ,'Boolean', true ,'Boolean', true ,'Object', true ,'Number', true ,'Number', true ,'org.apache.royale.events.Event', true ]; }},
        'cloneEvent': { type: 'org.apache.royale.events.IRoyaleEvent', declaredBy: 'mx.events.IndexChangedEvent'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.events.IndexChangedEvent.prototype.ROYALE_COMPILE_FLAGS = 10;