/**
 * Generated by Apache Royale Compiler from mx/events/RSLEvent.as
 * mx.events.RSLEvent
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.events.RSLEvent');

goog.require('mx.events.ProgressEvent');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.net.URLRequest');
goog.require('XML');



/**
 *  Constructor.
 * 
 *  @asparam type The type of the event. Possible values are:
 *  <ul>
 *     <li>"rslProgress" (<code>RSLEvent.RSL_PROGRESS</code>);</li>
 *     <li>"rslComplete" (<code>RSLEvent.RSL_COMPLETE</code>);</li>
 *     <li>"rslError" (<code>RSLEvent.RSL_ERROR</code>);</li>
 *  </ul>
 *
 *  @asparam bubbles  Determines whether the Event object participates in the bubbling stage of the event flow.
 *
 *  @asparam cancelable Determines whether the Event object can be cancelled.
 *
 *  @asparam bytesLoaded The number of bytes loaded at the time the listener processes the event.
 *
 *  @asparam bytesTotal The total number of bytes that will ultimately be loaded if the loading process succeeds.
 *
 *  @asparam rslIndex The index number of the RSL relative to the total. This should be a value between 0 and <code>total - 1</code>.
 *
 *  @asparam rslTotal The total number of RSLs being loaded.
 *
 *  @asparam url The location of the RSL.
 *
 *  @asparam errorText The error message of the error when type is RSLEvent.RSL_ERROR.
 *
 *  @asparam isResourceModule True if the event occurred when loading a ResourceModule.
 *
 *  @tiptext Constructor for <code>RSLEvent</code> objects.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {mx.events.ProgressEvent}
 * @param {string} type
 * @param {boolean=} bubbles
 * @param {boolean=} cancelable
 * @param {number=} bytesLoaded
 * @param {number=} bytesTotal
 * @param {number=} rslIndex
 * @param {number=} rslTotal
 * @param {org.apache.royale.net.URLRequest=} url
 * @param {string=} errorText
 * @param {boolean=} isResourceModule
 * @param {Object=} loaderInfo
 */
mx.events.RSLEvent = function(type, bubbles, cancelable, bytesLoaded, bytesTotal, rslIndex, rslTotal, url, errorText, isResourceModule, loaderInfo) {
  bubbles = typeof bubbles !== 'undefined' ? bubbles : false;
  cancelable = typeof cancelable !== 'undefined' ? cancelable : false;
  bytesLoaded = typeof bytesLoaded !== 'undefined' ? bytesLoaded : -1;
  bytesTotal = typeof bytesTotal !== 'undefined' ? bytesTotal : -1;
  rslIndex = typeof rslIndex !== 'undefined' ? rslIndex : -1;
  rslTotal = typeof rslTotal !== 'undefined' ? rslTotal : -1;
  url = typeof url !== 'undefined' ? url : null;
  errorText = typeof errorText !== 'undefined' ? errorText : null;
  isResourceModule = typeof isResourceModule !== 'undefined' ? isResourceModule : false;
  loaderInfo = typeof loaderInfo !== 'undefined' ? loaderInfo : null;
  mx.events.RSLEvent.base(this, 'constructor', type, bubbles, cancelable, bytesLoaded, bytesTotal);
  this.rslIndex = rslIndex;
  this.rslTotal = rslTotal;
  this.url = url;
  this.errorText = errorText;
  this.isResourceModule = isResourceModule;
  this.loaderInfo = loaderInfo;
};
goog.inherits(mx.events.RSLEvent, mx.events.ProgressEvent);


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.RSLEvent.RSL_ADD_PRELOADED = "rslAddPreloaded";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.RSLEvent.RSL_COMPLETE = "rslComplete";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.RSLEvent.RSL_ERROR = "rslError";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.RSLEvent.RSL_PROGRESS = "rslProgress";


/**
 * @type {string}
 */
mx.events.RSLEvent.prototype.errorText;


/**
 * @type {boolean}
 */
mx.events.RSLEvent.prototype.isResourceModule;


/**
 * @type {Object}
 */
mx.events.RSLEvent.prototype.loaderInfo;


/**
 * @type {number}
 */
mx.events.RSLEvent.prototype.rslIndex = 0;


/**
 * @type {number}
 */
mx.events.RSLEvent.prototype.rslTotal = 0;


/**
 * @type {org.apache.royale.net.URLRequest}
 */
mx.events.RSLEvent.prototype.url;


/**
 *  @asprivate
 * @override
 */
mx.events.RSLEvent.prototype.cloneEvent = function() {
  return new mx.events.RSLEvent(this.type, this.bubbles, this.cancelable, this.bytesLoaded, this.bytesTotal, this.rslIndex, this.rslTotal, this.url, this.errorText, this.isResourceModule, this.loaderInfo);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.events.RSLEvent.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'RSLEvent', qName: 'mx.events.RSLEvent', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.events.RSLEvent.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'errorText': { type: 'String', get_set: function (/** mx.events.RSLEvent */ inst, /** * */ v) {return v !== undefined ? inst.errorText = v : inst.errorText;}},
        'isResourceModule': { type: 'Boolean', get_set: function (/** mx.events.RSLEvent */ inst, /** * */ v) {return v !== undefined ? inst.isResourceModule = v : inst.isResourceModule;}},
        'loaderInfo': { type: 'Object', get_set: function (/** mx.events.RSLEvent */ inst, /** * */ v) {return v !== undefined ? inst.loaderInfo = v : inst.loaderInfo;}},
        'rslIndex': { type: 'int', get_set: function (/** mx.events.RSLEvent */ inst, /** * */ v) {return v !== undefined ? inst.rslIndex = v : inst.rslIndex;}},
        'rslTotal': { type: 'int', get_set: function (/** mx.events.RSLEvent */ inst, /** * */ v) {return v !== undefined ? inst.rslTotal = v : inst.rslTotal;}},
        'url': { type: 'org.apache.royale.net.URLRequest', get_set: function (/** mx.events.RSLEvent */ inst, /** * */ v) {return v !== undefined ? inst.url = v : inst.url;}}
      };
    },
    methods: function () {
      return {
        'RSLEvent': { type: '', declaredBy: 'mx.events.RSLEvent', parameters: function () { return [ 'String', false ,'Boolean', true ,'Boolean', true ,'int', true ,'int', true ,'int', true ,'int', true ,'org.apache.royale.net.URLRequest', true ,'String', true ,'Boolean', true ,'Object', true ]; }},
        'cloneEvent': { type: 'org.apache.royale.events.Event', declaredBy: 'mx.events.RSLEvent'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.events.RSLEvent.prototype.ROYALE_COMPILE_FLAGS = 10;