/**
 * Generated by Apache Royale Compiler from mx/events/ResourceEvent.as
 * mx.events.ResourceEvent
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.events.ResourceEvent');

goog.require('mx.events.ProgressEvent');
goog.require('org.apache.royale.events.IRoyaleEvent');
goog.require('XML');



/**
 *  Constructor.
 * 
 *  @asparam type The value of the <code>type</code> property of the event object. Possible values are:
 *  <ul>
 *     <li><code>"progress"</code> (<code>ResourceEvent.PROGRESS</code>)</li>
 *     <li><code>"complete"</code> (<code>ResourceEvent.COMPLETE</code>)</li>
 *     <li><code>"error"</code> (<code>ResourceEvent.ERROR</code>)</li>
 *  </ul>
 *
 *  @asparam bubbles Determines whether the Event object
 *  participates in the bubbling stage of the event flow.
 *
 *  @asparam cancelable Determines whether the Event object can be cancelled.
 *
 *  @asparam bytesLoaded The number of bytes loaded
 *  at the time the listener processes the event.
 *
 *  @asparam bytesTotal The total number of bytes
 *  that will ultimately be loaded if the loading process succeeds.
 *
 *  @asparam errorText The error message of the error
 *  when <code>type</code> is <code>ResourceEvent.ERROR</code>.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {mx.events.ProgressEvent}
 * @param {string} type
 * @param {boolean=} bubbles
 * @param {boolean=} cancelable
 * @param {number=} bytesLoaded
 * @param {number=} bytesTotal
 * @param {string=} errorText
 */
mx.events.ResourceEvent = function(type, bubbles, cancelable, bytesLoaded, bytesTotal, errorText) {
  bubbles = typeof bubbles !== 'undefined' ? bubbles : false;
  cancelable = typeof cancelable !== 'undefined' ? cancelable : false;
  bytesLoaded = typeof bytesLoaded !== 'undefined' ? bytesLoaded : 0;
  bytesTotal = typeof bytesTotal !== 'undefined' ? bytesTotal : 0;
  errorText = typeof errorText !== 'undefined' ? errorText : null;
  mx.events.ResourceEvent.base(this, 'constructor', type, bubbles, cancelable, bytesLoaded, bytesTotal);
  this.errorText = errorText;
};
goog.inherits(mx.events.ResourceEvent, mx.events.ProgressEvent);


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.ResourceEvent.COMPLETE = "complete";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.ResourceEvent.ERROR = "error";


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.events.ResourceEvent.PROGRESS = "progress";


/**
 * @type {string}
 */
mx.events.ResourceEvent.prototype.errorText;


/**
 *  @asprivate
 * @override
 */
mx.events.ResourceEvent.prototype.cloneEvent = function() {
  return new mx.events.ResourceEvent(this.type, this.bubbles, this.cancelable, this.bytesLoaded, this.bytesTotal, this.errorText);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.events.ResourceEvent.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ResourceEvent', qName: 'mx.events.ResourceEvent', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.events.ResourceEvent.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'errorText': { type: 'String', get_set: function (/** mx.events.ResourceEvent */ inst, /** * */ v) {return v !== undefined ? inst.errorText = v : inst.errorText;}}
      };
    },
    methods: function () {
      return {
        'ResourceEvent': { type: '', declaredBy: 'mx.events.ResourceEvent', parameters: function () { return [ 'String', false ,'Boolean', true ,'Boolean', true ,'uint', true ,'uint', true ,'String', true ]; }},
        'cloneEvent': { type: 'org.apache.royale.events.IRoyaleEvent', declaredBy: 'mx.events.ResourceEvent'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.events.ResourceEvent.prototype.ROYALE_COMPILE_FLAGS = 10;