/**
 * Generated by Apache Royale Compiler from mx/external/ExternalInterface.as
 * mx.external.ExternalInterface
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.external.ExternalInterface');
goog.require('XML');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 */
mx.external.ExternalInterface = function() {
};


/**
 * @private
 * @type {string}
 */
mx.external.ExternalInterface._objectID = "ExternalInterface";


/** Registers an ActionScript method as callable from the container.
 *  After a successful invocation of addCallBack(), the registered
 *  function in the player can be called by JavaScript.
 *
 *  The JavaScript needs to obtain the appopriate element (set via <code>objectID</code>
 *  and then call the function as a property of this element. For example
 *  if <code>addCallback</code> has been called with <code>functionName>/code>
 *  set to "myFunction", the call can be made by:
 *  <code>document.getElementById("ExternalInterface").myFunction(args);</code>
 *
 * @asparam functionName The name by which the browser can invoke the function.
 * @asparam closure The function closure to invoke.
 * 
 * @royaleignorecoercion HTMLElement
 * @nocollapse
 * @param {string} functionName
 * @param {Function} closure
 */
mx.external.ExternalInterface.addCallback = function(functionName, closure) {
  
  var /** @type {HTMLElement} */ extInt = document.getElementById(mx.external.ExternalInterface._objectID);
  if (!extInt) {
    extInt = document.createElement("script");
    extInt.id = mx.external.ExternalInterface._objectID;
    document.body.appendChild(extInt);
  }
  extInt[functionName] = closure;
};


/** Calls a function exposed by the browser, passing zero or more arguments.
 *  If the function is not available, the call returns <code>null</code>,
 *  otherwise it returns the value provided by the function.
 *
 * @asparam functionName The name of the JavaScript function to call.
 * @asparam ... args The arguments to pass to the JavaScript function in the browser.
 * @nocollapse
 * @param {string} functionName
 * @param {...} args
 * @return {*}
 */
mx.external.ExternalInterface.call = function(functionName, args) {
  args = Array.prototype.slice.call(arguments, 1);
  
  var /** @type {Function} */ fnc;
  var /** @type {Object} */ base = window;
  if (functionName) {
    if (functionName.indexOf('function(') == -1) {
      var /** @type {number} */ dotIdx = (functionName.indexOf('.')) >> 0;
      var /** @type {boolean} */ err;
      if (dotIdx != -1) {
        while (!err && dotIdx != -1) {
          base = base[functionName.substr(0, dotIdx)];
          functionName = functionName.substr(dotIdx + 1);
          dotIdx = (functionName.indexOf('.')) >> 0;
          if (!base) {
            err = true;
          }
        }
      }
      fnc = !err ? org.apache.royale.utils.Language.as(base[functionName], Function) : null;
    }
    if (!fnc) {
      try {
        fnc = eval('(function(){ return (' + functionName + ')})()');
      } catch (e) {
      }
    }
  }
  if (fnc) {
    return fnc.apply(base, args);
  }
  return null;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.external.ExternalInterface.available;


mx.external.ExternalInterface.get__available = function() {
  
  return true;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.external.ExternalInterface.marshallExceptions;


mx.external.ExternalInterface.get__marshallExceptions = function() {
  
  return true;
};


mx.external.ExternalInterface.set__marshallExceptions = function(val) {
  
  if (!val)
    org.apache.royale.utils.Language.trace("WARNING: trying to set ExternalInterface.marshallExceptions to false; not supported in Royale");
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.external.ExternalInterface.objectID;


mx.external.ExternalInterface.get__objectID = function() {
  
  return mx.external.ExternalInterface._objectID;
};


mx.external.ExternalInterface.set__objectID = function(value) {
  mx.external.ExternalInterface._objectID = value;
};


Object.defineProperties(mx.external.ExternalInterface, /** @lends {mx.external.ExternalInterface} */ {
/**
 * @type {boolean}
 */
available: {
get: mx.external.ExternalInterface.get__available},
/**
 * @type {boolean}
 */
marshallExceptions: {
get: mx.external.ExternalInterface.get__marshallExceptions,
set: mx.external.ExternalInterface.set__marshallExceptions},
/**
 * @type {string}
 */
objectID: {
get: mx.external.ExternalInterface.get__objectID,
set: mx.external.ExternalInterface.set__objectID}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.external.ExternalInterface.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ExternalInterface', qName: 'mx.external.ExternalInterface', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.external.ExternalInterface.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        '|available': { type: 'Boolean', access: 'readonly', declaredBy: 'mx.external.ExternalInterface'},
        '|marshallExceptions': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.external.ExternalInterface'},
        '|objectID': { type: 'String', access: 'readwrite', declaredBy: 'mx.external.ExternalInterface'}
      };
    },
    methods: function () {
      return {
        '|addCallback': { type: 'void', declaredBy: 'mx.external.ExternalInterface', parameters: function () { return [ 'String', false ,'Function', false ]; }},
        '|call': { type: '*', declaredBy: 'mx.external.ExternalInterface', parameters: function () { return [ 'String', false ,'Array', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.external.ExternalInterface.prototype.ROYALE_COMPILE_FLAGS = 10;