/**
 * Generated by Apache Royale Compiler from mx/formatters/CurrencyFormatter.as
 * mx.formatters.CurrencyFormatter
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.formatters.CurrencyFormatter');

goog.require('mx.formatters.Formatter');
goog.require('mx.formatters.NumberBase');
goog.require('mx.formatters.NumberBaseRoundType');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {mx.formatters.Formatter}
 */
mx.formatters.CurrencyFormatter = function() {
  mx.formatters.CurrencyFormatter.base(this, 'constructor');
  if (!this.rounding) {
    this.rounding = null;
  }
};
goog.inherits(mx.formatters.CurrencyFormatter, mx.formatters.Formatter);


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__alignSymbol;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_alignSymbolOverride;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__currencySymbol;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_currencySymbolOverride;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__decimalSeparatorFrom;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_decimalSeparatorFromOverride;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__decimalSeparatorTo;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_decimalSeparatorToOverride;


/**
 * @private
 * @type {Object}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__precision;


/**
 * @private
 * @type {Object}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_precisionOverride;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__rounding;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_roundingOverride;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__thousandsSeparatorFrom;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_thousandsSeparatorFromOverride;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__thousandsSeparatorTo;


/**
 * @private
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_thousandsSeparatorToOverride;


/**
 * @private
 * @type {Object}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__useNegativeSign;


/**
 * @private
 * @type {Object}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_useNegativeSignOverride;


/**
 * @private
 * @type {Object}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter__useThousandsSeparator;


/**
 * @private
 * @type {Object}
 */
mx.formatters.CurrencyFormatter.prototype.mx_formatters_CurrencyFormatter_useThousandsSeparatorOverride;


/**
 *  Formats <code>value</code> as currency.
 *  If <code>value</code> cannot be formatted, return an empty String 
 *  and write a description of the error to the <code>error</code> property.
 *
 *  @asparam value Value to format.
 *
 *  @asreturn Formatted string. Empty if an error occurs.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @override
 */
mx.formatters.CurrencyFormatter.prototype.format = function(value) {
  if (this.error)
    this.error = null;
  if (this.useThousandsSeparator && (this.decimalSeparatorFrom == this.thousandsSeparatorFrom || this.decimalSeparatorTo == this.thousandsSeparatorTo)) {
    this.error = mx.formatters.Formatter.defaultInvalidFormatError;
    return "";
  }
  if (this.decimalSeparatorTo == "") {
    this.error = mx.formatters.Formatter.defaultInvalidFormatError;
    return "";
  }
  var /** @type {mx.formatters.NumberBase} */ dataFormatter = new mx.formatters.NumberBase(this.decimalSeparatorFrom, this.thousandsSeparatorFrom, this.decimalSeparatorTo, this.thousandsSeparatorTo);
  if (org.apache.royale.utils.Language.is(value, String)) {
    var /** @type {string} */ temp_value = dataFormatter.parseNumberString(String(value));
    if (temp_value == "0") {
      var /** @type {Array} */ valueArr = value.split(this.decimalSeparatorFrom);
      value = valueArr[0];
      if (valueArr[1] != undefined)
        value += "." + valueArr[1];
      else
        value = temp_value;
    }
    else
      value = temp_value;
  }
  if (value === null || isNaN(Number(value))) {
    this.error = mx.formatters.Formatter.defaultInvalidValueError;
    return "";
  }
  var /** @type {boolean} */ isNegative = (Number(value) < 0);
  var /** @type {string} */ numStr = value.toString();
  var /** @type {Array} */ numArrTemp = numStr.split(".");
  var /** @type {number} */ numFraction = (numArrTemp[1] ? String(numArrTemp[1]).length : 0) >> 0;
  if (this.precision <= numFraction) {
    if (this.rounding != mx.formatters.NumberBaseRoundType.NONE) {
      numStr = dataFormatter.formatRoundingWithPrecision(numStr, this.rounding, org.apache.royale.utils.Language._int(this.precision));
    }
  }
  var /** @type {number} */ numValue = Number(numStr);
  if (Math.abs(numValue) >= 1) {
    numArrTemp = numStr.split(".");
    var /** @type {string} */ front = this.useThousandsSeparator ? dataFormatter.formatThousands(String(numArrTemp[0])) : String(numArrTemp[0]);
    if (numArrTemp[1] != null && numArrTemp[1] != "")
      numStr = front + this.decimalSeparatorTo + numArrTemp[1];
    else
      numStr = front;
  } else if (Math.abs(numValue) >= 0) {
    if (numStr.indexOf("e") != -1) {
      var /** @type {number} */ temp = Math.abs(numValue) + 1;
      numStr = temp.toString();
    }
    var /** @type {number} */ position = numStr.indexOf(".");
    var /** @type {string} */ leading = position > 0 ? "0" : "";
    if (position != -1) {
      numStr = leading + this.decimalSeparatorTo + numStr.substring(position + 1);
    }
  }
  numStr = dataFormatter.formatPrecision(numStr, org.apache.royale.utils.Language._int(this.precision));
  if (Number(numStr) == 0) {
    isNegative = false;
  }
  if (isNegative)
    numStr = dataFormatter.formatNegative(numStr, !!(this.useNegativeSign));
  if (!dataFormatter.isValid) {
    this.error = mx.formatters.Formatter.defaultInvalidFormatError;
    return "";
  }
  if (this.alignSymbol == "left") {
    if (isNegative) {
      var /** @type {string} */ nSign = numStr.charAt(0);
      var /** @type {string} */ baseVal = numStr.substr(1, numStr.length - 1);
      numStr = nSign + this.currencySymbol + baseVal;
    } else {
      numStr = this.currencySymbol + numStr;
    }
  } else if (this.alignSymbol == "right") {
    var /** @type {string} */ lastChar = numStr.charAt(numStr.length - 1);
    if (isNegative && lastChar == ")") {
      baseVal = numStr.substr(0, numStr.length - 1);
      numStr = baseVal + this.currencySymbol + lastChar;
    } else {
      numStr = numStr + this.currencySymbol;
    }
  } else {
    this.error = mx.formatters.Formatter.defaultInvalidFormatError;
    return "";
  }
  return numStr;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.alignSymbol;


mx.formatters.CurrencyFormatter.prototype.get__alignSymbol = function() {
  return this.mx_formatters_CurrencyFormatter__alignSymbol;
};


mx.formatters.CurrencyFormatter.prototype.set__alignSymbol = function(value) {
  this.mx_formatters_CurrencyFormatter_alignSymbolOverride = value;
  this.mx_formatters_CurrencyFormatter__alignSymbol = value != null ? value : "right";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.currencySymbol;


mx.formatters.CurrencyFormatter.prototype.get__currencySymbol = function() {
  return this.mx_formatters_CurrencyFormatter__currencySymbol;
};


mx.formatters.CurrencyFormatter.prototype.set__currencySymbol = function(value) {
  this.mx_formatters_CurrencyFormatter_currencySymbolOverride = value;
  this.mx_formatters_CurrencyFormatter__currencySymbol = value != null ? value : " €";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.decimalSeparatorFrom;


mx.formatters.CurrencyFormatter.prototype.get__decimalSeparatorFrom = function() {
  return this.mx_formatters_CurrencyFormatter__decimalSeparatorFrom;
};


mx.formatters.CurrencyFormatter.prototype.set__decimalSeparatorFrom = function(value) {
  this.mx_formatters_CurrencyFormatter_decimalSeparatorFromOverride = value;
  this.mx_formatters_CurrencyFormatter__decimalSeparatorFrom = value != null ? value : ",";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.decimalSeparatorTo;


mx.formatters.CurrencyFormatter.prototype.get__decimalSeparatorTo = function() {
  return this.mx_formatters_CurrencyFormatter__decimalSeparatorTo;
};


mx.formatters.CurrencyFormatter.prototype.set__decimalSeparatorTo = function(value) {
  this.mx_formatters_CurrencyFormatter_decimalSeparatorToOverride = value;
  this.mx_formatters_CurrencyFormatter__decimalSeparatorTo = value != null ? value : ",";
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.formatters.CurrencyFormatter.prototype.precision;


mx.formatters.CurrencyFormatter.prototype.get__precision = function() {
  return this.mx_formatters_CurrencyFormatter__precision;
};


mx.formatters.CurrencyFormatter.prototype.set__precision = function(value) {
  this.mx_formatters_CurrencyFormatter_precisionOverride = value;
  this.mx_formatters_CurrencyFormatter__precision = value != null ? org.apache.royale.utils.Language._int(value) : -1;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.rounding;


mx.formatters.CurrencyFormatter.prototype.get__rounding = function() {
  return this.mx_formatters_CurrencyFormatter__rounding;
};


mx.formatters.CurrencyFormatter.prototype.set__rounding = function(value) {
  this.mx_formatters_CurrencyFormatter_roundingOverride = value;
  this.mx_formatters_CurrencyFormatter__rounding = value != null ? value : "none";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.thousandsSeparatorFrom;


mx.formatters.CurrencyFormatter.prototype.get__thousandsSeparatorFrom = function() {
  return this.mx_formatters_CurrencyFormatter__thousandsSeparatorFrom;
};


mx.formatters.CurrencyFormatter.prototype.set__thousandsSeparatorFrom = function(value) {
  this.mx_formatters_CurrencyFormatter_thousandsSeparatorFromOverride = value;
  this.mx_formatters_CurrencyFormatter__thousandsSeparatorFrom = value != null ? value : ".";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.CurrencyFormatter.prototype.thousandsSeparatorTo;


mx.formatters.CurrencyFormatter.prototype.get__thousandsSeparatorTo = function() {
  return this.mx_formatters_CurrencyFormatter__thousandsSeparatorTo;
};


mx.formatters.CurrencyFormatter.prototype.set__thousandsSeparatorTo = function(value) {
  this.mx_formatters_CurrencyFormatter_thousandsSeparatorToOverride = value;
  this.mx_formatters_CurrencyFormatter__thousandsSeparatorTo = value != null ? value : ".";
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.formatters.CurrencyFormatter.prototype.useNegativeSign;


mx.formatters.CurrencyFormatter.prototype.get__useNegativeSign = function() {
  return this.mx_formatters_CurrencyFormatter__useNegativeSign;
};


mx.formatters.CurrencyFormatter.prototype.set__useNegativeSign = function(value) {
  this.mx_formatters_CurrencyFormatter_useNegativeSignOverride = value;
  this.mx_formatters_CurrencyFormatter__useNegativeSign = value != null ? Boolean(value) : true;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.formatters.CurrencyFormatter.prototype.useThousandsSeparator;


mx.formatters.CurrencyFormatter.prototype.get__useThousandsSeparator = function() {
  return this.mx_formatters_CurrencyFormatter__useThousandsSeparator;
};


mx.formatters.CurrencyFormatter.prototype.set__useThousandsSeparator = function(value) {
  this.mx_formatters_CurrencyFormatter_useThousandsSeparatorOverride = value;
  this.mx_formatters_CurrencyFormatter__useThousandsSeparator = value != null ? Boolean(value) : true;
};


Object.defineProperties(mx.formatters.CurrencyFormatter.prototype, /** @lends {mx.formatters.CurrencyFormatter.prototype} */ {
/**
 * @type {string}
 */
alignSymbol: {
get: mx.formatters.CurrencyFormatter.prototype.get__alignSymbol,
set: mx.formatters.CurrencyFormatter.prototype.set__alignSymbol},
/**
 * @type {string}
 */
currencySymbol: {
get: mx.formatters.CurrencyFormatter.prototype.get__currencySymbol,
set: mx.formatters.CurrencyFormatter.prototype.set__currencySymbol},
/**
 * @type {string}
 */
decimalSeparatorFrom: {
get: mx.formatters.CurrencyFormatter.prototype.get__decimalSeparatorFrom,
set: mx.formatters.CurrencyFormatter.prototype.set__decimalSeparatorFrom},
/**
 * @type {string}
 */
decimalSeparatorTo: {
get: mx.formatters.CurrencyFormatter.prototype.get__decimalSeparatorTo,
set: mx.formatters.CurrencyFormatter.prototype.set__decimalSeparatorTo},
/**
 * @type {Object}
 */
precision: {
get: mx.formatters.CurrencyFormatter.prototype.get__precision,
set: mx.formatters.CurrencyFormatter.prototype.set__precision},
/**
 * @type {string}
 */
rounding: {
get: mx.formatters.CurrencyFormatter.prototype.get__rounding,
set: mx.formatters.CurrencyFormatter.prototype.set__rounding},
/**
 * @type {string}
 */
thousandsSeparatorFrom: {
get: mx.formatters.CurrencyFormatter.prototype.get__thousandsSeparatorFrom,
set: mx.formatters.CurrencyFormatter.prototype.set__thousandsSeparatorFrom},
/**
 * @type {string}
 */
thousandsSeparatorTo: {
get: mx.formatters.CurrencyFormatter.prototype.get__thousandsSeparatorTo,
set: mx.formatters.CurrencyFormatter.prototype.set__thousandsSeparatorTo},
/**
 * @type {Object}
 */
useNegativeSign: {
get: mx.formatters.CurrencyFormatter.prototype.get__useNegativeSign,
set: mx.formatters.CurrencyFormatter.prototype.set__useNegativeSign},
/**
 * @type {Object}
 */
useThousandsSeparator: {
get: mx.formatters.CurrencyFormatter.prototype.get__useThousandsSeparator,
set: mx.formatters.CurrencyFormatter.prototype.set__useThousandsSeparator}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.formatters.CurrencyFormatter.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CurrencyFormatter', qName: 'mx.formatters.CurrencyFormatter', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.formatters.CurrencyFormatter.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'alignSymbol': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'currencySymbol': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'decimalSeparatorFrom': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'decimalSeparatorTo': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'precision': { type: 'Object', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'rounding': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'thousandsSeparatorFrom': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'thousandsSeparatorTo': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'useNegativeSign': { type: 'Object', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'useThousandsSeparator': { type: 'Object', access: 'readwrite', declaredBy: 'mx.formatters.CurrencyFormatter'}
      };
    },
    methods: function () {
      return {
        'CurrencyFormatter': { type: '', declaredBy: 'mx.formatters.CurrencyFormatter'},
        'format': { type: 'String', declaredBy: 'mx.formatters.CurrencyFormatter', parameters: function () { return [ 'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.formatters.CurrencyFormatter.prototype.ROYALE_COMPILE_FLAGS = 10;