/**
 * Generated by Apache Royale Compiler from mx/formatters/NumberFormatter.as
 * mx.formatters.NumberFormatter
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.formatters.NumberFormatter');

goog.require('mx.formatters.Formatter');
goog.require('mx.formatters.NumberBase');
goog.require('mx.formatters.NumberBaseRoundType');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @constructor
 * @extends {mx.formatters.Formatter}
 */
mx.formatters.NumberFormatter = function() {
  mx.formatters.NumberFormatter.base(this, 'constructor');
};
goog.inherits(mx.formatters.NumberFormatter, mx.formatters.Formatter);


/**
 * @private
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.mx_formatters_NumberFormatter__decimalSeparatorFrom = ".";


/**
 * @private
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.mx_formatters_NumberFormatter__decimalSeparatorTo = ".";


/**
 * @private
 * @type {Object}
 */
mx.formatters.NumberFormatter.prototype.mx_formatters_NumberFormatter__precision = -1;


/**
 * @private
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.mx_formatters_NumberFormatter__rounding = "none";


/**
 * @private
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.mx_formatters_NumberFormatter__thousandsSeparatorFrom = ",";


/**
 * @private
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.mx_formatters_NumberFormatter__thousandsSeparatorTo = ",";


/**
 * @private
 * @type {Object}
 */
mx.formatters.NumberFormatter.prototype.mx_formatters_NumberFormatter__useNegativeSign = true;


/**
 * @private
 * @type {Object}
 */
mx.formatters.NumberFormatter.prototype.mx_formatters_NumberFormatter__useThousandsSeparator = true;


/**
 *  Formats the number as a String.
 *  If <code>value</code> cannot be formatted, return an empty String
 *  and write a description of the error to the <code>error</code> property.
 *
 *  @asparam value Value to format.
 *
 *  @asreturn Formatted String. Empty if an error occurs.
 *
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @override
 */
mx.formatters.NumberFormatter.prototype.format = function(value) {
  if (this.useThousandsSeparator && ((this.decimalSeparatorFrom == this.thousandsSeparatorFrom) || (this.decimalSeparatorTo == this.thousandsSeparatorTo))) {
    return "";
  }
  if (this.decimalSeparatorTo == "" || !isNaN(Number(this.decimalSeparatorTo))) {
    return "";
  }
  var /** @type {mx.formatters.NumberBase} */ dataFormatter = new mx.formatters.NumberBase(this.decimalSeparatorFrom, this.thousandsSeparatorFrom, this.decimalSeparatorTo, this.thousandsSeparatorTo);
  if (org.apache.royale.utils.Language.is(value, String))
    value = dataFormatter.parseNumberString(String(value));
  if (value === null || isNaN(Number(value))) {
    return "";
  }
  var /** @type {boolean} */ isNegative = (Number(value) < 0);
  var /** @type {string} */ numStr = value.toString();
  numStr = numStr.toLowerCase();
  var /** @type {number} */ e = (numStr.indexOf("e")) >> 0;
  if (e != -1)
    numStr = dataFormatter.expandExponents(numStr);
  var /** @type {Array} */ numArrTemp = numStr.split(".");
  var /** @type {number} */ numFraction = (numArrTemp[1] ? String(numArrTemp[1]).length : 0) >> 0;
  if (this.precision < numFraction) {
    if (this.rounding != mx.formatters.NumberBaseRoundType.NONE) {
      numStr = dataFormatter.formatRoundingWithPrecision(numStr, this.rounding, org.apache.royale.utils.Language._int(this.precision));
    }
  }
  var /** @type {number} */ numValue = Number(numStr);
  if (Math.abs(numValue) >= 1) {
    numArrTemp = numStr.split(".");
    var /** @type {string} */ front = this.useThousandsSeparator ? dataFormatter.formatThousands(String(numArrTemp[0])) : String(numArrTemp[0]);
    if (numArrTemp[1] != null && numArrTemp[1] != "")
      numStr = front + this.decimalSeparatorTo + numArrTemp[1];
    else
      numStr = front;
  } else if (Math.abs(numValue) > 0) {
    numStr = numStr.toLowerCase();
    if (numStr.indexOf("e") != -1) {
      var /** @type {number} */ temp = Math.abs(numValue) + 1;
      numStr = temp.toString();
    }
    numStr = this.decimalSeparatorTo + numStr.substring(numStr.indexOf(".") + 1);
  }
  numStr = dataFormatter.formatPrecision(numStr, org.apache.royale.utils.Language._int(this.precision));
  if (Number(numStr) == 0) {
    isNegative = false;
  }
  if (isNegative)
    numStr = dataFormatter.formatNegative(numStr, !!(this.useNegativeSign));
  if (!dataFormatter.isValid) {
    this.error = mx.formatters.Formatter.defaultInvalidFormatError;
    return "";
  }
  return numStr;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.decimalSeparatorFrom;


mx.formatters.NumberFormatter.prototype.get__decimalSeparatorFrom = function() {
  return this.mx_formatters_NumberFormatter__decimalSeparatorFrom;
};


mx.formatters.NumberFormatter.prototype.set__decimalSeparatorFrom = function(value) {
  this.mx_formatters_NumberFormatter__decimalSeparatorFrom = value != null ? value : value;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.decimalSeparatorTo;


mx.formatters.NumberFormatter.prototype.get__decimalSeparatorTo = function() {
  return this.mx_formatters_NumberFormatter__decimalSeparatorTo;
};


mx.formatters.NumberFormatter.prototype.set__decimalSeparatorTo = function(value) {
  this.mx_formatters_NumberFormatter__decimalSeparatorTo = value != null ? value : value;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.formatters.NumberFormatter.prototype.precision;


mx.formatters.NumberFormatter.prototype.get__precision = function() {
  return this.mx_formatters_NumberFormatter__precision;
};


mx.formatters.NumberFormatter.prototype.set__precision = function(value) {
  this.mx_formatters_NumberFormatter__precision = value != null ? org.apache.royale.utils.Language._int(value) : org.apache.royale.utils.Language._int(value);
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.rounding;


mx.formatters.NumberFormatter.prototype.get__rounding = function() {
  return this.mx_formatters_NumberFormatter__rounding;
};


mx.formatters.NumberFormatter.prototype.set__rounding = function(value) {
  this.mx_formatters_NumberFormatter__rounding = value != null ? value : value;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.thousandsSeparatorFrom;


mx.formatters.NumberFormatter.prototype.get__thousandsSeparatorFrom = function() {
  return this.mx_formatters_NumberFormatter__thousandsSeparatorFrom;
};


mx.formatters.NumberFormatter.prototype.set__thousandsSeparatorFrom = function(value) {
  this.mx_formatters_NumberFormatter__thousandsSeparatorFrom = value != null ? value : value;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.NumberFormatter.prototype.thousandsSeparatorTo;


mx.formatters.NumberFormatter.prototype.get__thousandsSeparatorTo = function() {
  return this.mx_formatters_NumberFormatter__thousandsSeparatorTo;
};


mx.formatters.NumberFormatter.prototype.set__thousandsSeparatorTo = function(value) {
  this.mx_formatters_NumberFormatter__thousandsSeparatorTo = value != null ? value : value;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.formatters.NumberFormatter.prototype.useNegativeSign;


mx.formatters.NumberFormatter.prototype.get__useNegativeSign = function() {
  return this.mx_formatters_NumberFormatter__useNegativeSign;
};


mx.formatters.NumberFormatter.prototype.set__useNegativeSign = function(value) {
  this.mx_formatters_NumberFormatter__useNegativeSign = value != null ? Boolean(value) : Boolean(value);
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.formatters.NumberFormatter.prototype.useThousandsSeparator;


mx.formatters.NumberFormatter.prototype.get__useThousandsSeparator = function() {
  return this.mx_formatters_NumberFormatter__useThousandsSeparator;
};


mx.formatters.NumberFormatter.prototype.set__useThousandsSeparator = function(value) {
  this.mx_formatters_NumberFormatter__useThousandsSeparator = value != null ? Boolean(value) : Boolean(value);
};


Object.defineProperties(mx.formatters.NumberFormatter.prototype, /** @lends {mx.formatters.NumberFormatter.prototype} */ {
/**
 * @type {string}
 */
decimalSeparatorFrom: {
get: mx.formatters.NumberFormatter.prototype.get__decimalSeparatorFrom,
set: mx.formatters.NumberFormatter.prototype.set__decimalSeparatorFrom},
/**
 * @type {string}
 */
decimalSeparatorTo: {
get: mx.formatters.NumberFormatter.prototype.get__decimalSeparatorTo,
set: mx.formatters.NumberFormatter.prototype.set__decimalSeparatorTo},
/**
 * @type {Object}
 */
precision: {
get: mx.formatters.NumberFormatter.prototype.get__precision,
set: mx.formatters.NumberFormatter.prototype.set__precision},
/**
 * @type {string}
 */
rounding: {
get: mx.formatters.NumberFormatter.prototype.get__rounding,
set: mx.formatters.NumberFormatter.prototype.set__rounding},
/**
 * @type {string}
 */
thousandsSeparatorFrom: {
get: mx.formatters.NumberFormatter.prototype.get__thousandsSeparatorFrom,
set: mx.formatters.NumberFormatter.prototype.set__thousandsSeparatorFrom},
/**
 * @type {string}
 */
thousandsSeparatorTo: {
get: mx.formatters.NumberFormatter.prototype.get__thousandsSeparatorTo,
set: mx.formatters.NumberFormatter.prototype.set__thousandsSeparatorTo},
/**
 * @type {Object}
 */
useNegativeSign: {
get: mx.formatters.NumberFormatter.prototype.get__useNegativeSign,
set: mx.formatters.NumberFormatter.prototype.set__useNegativeSign},
/**
 * @type {Object}
 */
useThousandsSeparator: {
get: mx.formatters.NumberFormatter.prototype.get__useThousandsSeparator,
set: mx.formatters.NumberFormatter.prototype.set__useThousandsSeparator}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.formatters.NumberFormatter.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'NumberFormatter', qName: 'mx.formatters.NumberFormatter', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.formatters.NumberFormatter.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'decimalSeparatorFrom': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.NumberFormatter'},
        'decimalSeparatorTo': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.NumberFormatter'},
        'precision': { type: 'Object', access: 'readwrite', declaredBy: 'mx.formatters.NumberFormatter'},
        'rounding': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.NumberFormatter'},
        'thousandsSeparatorFrom': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.NumberFormatter'},
        'thousandsSeparatorTo': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.NumberFormatter'},
        'useNegativeSign': { type: 'Object', access: 'readwrite', declaredBy: 'mx.formatters.NumberFormatter'},
        'useThousandsSeparator': { type: 'Object', access: 'readwrite', declaredBy: 'mx.formatters.NumberFormatter'}
      };
    },
    methods: function () {
      return {
        'NumberFormatter': { type: '', declaredBy: 'mx.formatters.NumberFormatter'},
        'format': { type: 'String', declaredBy: 'mx.formatters.NumberFormatter', parameters: function () { return [ 'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.formatters.NumberFormatter.prototype.ROYALE_COMPILE_FLAGS = 10;