/**
 * Generated by Apache Royale Compiler from mx/formatters/ZipCodeFormatter.as
 * mx.formatters.ZipCodeFormatter
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.formatters.ZipCodeFormatter');

goog.require('mx.formatters.Formatter');
goog.require('mx.formatters.SwitchSymbolFormatter');
goog.require('XML');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {mx.formatters.Formatter}
 */
mx.formatters.ZipCodeFormatter = function() {
  mx.formatters.ZipCodeFormatter.base(this, 'constructor');
};
goog.inherits(mx.formatters.ZipCodeFormatter, mx.formatters.Formatter);


/**
 * @private
 * @const
 * @type {string}
 */
mx.formatters.ZipCodeFormatter.VALID_LENGTHS = "9,5,6";


/**
 * @private
 * @type {string}
 */
mx.formatters.ZipCodeFormatter.prototype.mx_formatters_ZipCodeFormatter__formatString;


/**
 * @private
 * @type {string}
 */
mx.formatters.ZipCodeFormatter.prototype.mx_formatters_ZipCodeFormatter_formatStringOverride;


/**
 *  Formats the String by using the specified format.
 *  If the value cannot be formatted, return an empty String 
 *  and write a description of the error to the <code>error</code> property.
 *
 *  @asparam value Value to format.
 *
 *  @asreturn Formatted String. Empty if an error occurs. A description 
 *  of the error condition is written to the <code>error</code> property.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @override
 */
mx.formatters.ZipCodeFormatter.prototype.format = function(value) {
  var /** @type {number} */ fStrLen = 0;
  if (this.error)
    this.error = null;
  //var /** @type {number} */ fStrLen = 0;
  var /** @type {number} */ uStrLen = (String(value).length) >> 0;
  if (mx.formatters.ZipCodeFormatter.VALID_LENGTHS.indexOf("" + uStrLen) == -1) {
    this.error = mx.formatters.Formatter.defaultInvalidValueError;
    return "";
  }
  if (this.formatString == "#####-####" || this.formatString == "##### ####") {
    if (uStrLen != 5 && uStrLen != 9) {
      this.error = mx.formatters.Formatter.defaultInvalidValueError;
      return "";
    }
    fStrLen = 9;
  } else if (this.formatString == "#####") {
    if (uStrLen != 5 && uStrLen != 9) {
      this.error = mx.formatters.Formatter.defaultInvalidValueError;
      return "";
    }
    fStrLen = 5;
  } else if (this.formatString == "### ###" || this.formatString == "###-###") {
    if (uStrLen != 6) {
      this.error = mx.formatters.Formatter.defaultInvalidValueError;
      return "";
    }
    fStrLen = 6;
  } else {
    this.error = mx.formatters.Formatter.defaultInvalidFormatError;
    return "";
  }
  if (fStrLen == 6 && uStrLen != 6) {
    this.error = mx.formatters.Formatter.defaultInvalidValueError;
    return "";
  }
  if (fStrLen == 6) {
    for (var /** @type {number} */ i = 0; i < uStrLen; i++) {
      if ((value.charCodeAt(i) < 64 || value.charCodeAt(i) > 90) && (value.charCodeAt(i) < 48 || value.charCodeAt(i) > 57)) {
        this.error = mx.formatters.Formatter.defaultInvalidValueError;
        return "";
      }
    }
  } else {
    if (value === null || isNaN(Number(value))) {
      this.error = mx.formatters.Formatter.defaultInvalidValueError;
      return "";
    }
  }
  if (fStrLen == 9 && uStrLen == 5)
    value = String(value).concat("0000");
  if (fStrLen == 5 && uStrLen == 9)
    value = value.substr(0, 5);
  var /** @type {mx.formatters.SwitchSymbolFormatter} */ dataFormatter = new mx.formatters.SwitchSymbolFormatter();
  return dataFormatter.formatValue(this.formatString, value);
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.formatters.ZipCodeFormatter.prototype.formatString;


mx.formatters.ZipCodeFormatter.prototype.get__formatString = function() {
  return this.mx_formatters_ZipCodeFormatter__formatString;
};


mx.formatters.ZipCodeFormatter.prototype.set__formatString = function(value) {
  this.mx_formatters_ZipCodeFormatter_formatStringOverride = value;
  this.mx_formatters_ZipCodeFormatter__formatString = value != null ? value : '#####';
};


Object.defineProperties(mx.formatters.ZipCodeFormatter.prototype, /** @lends {mx.formatters.ZipCodeFormatter.prototype} */ {
/**
 * @type {string}
 */
formatString: {
get: mx.formatters.ZipCodeFormatter.prototype.get__formatString,
set: mx.formatters.ZipCodeFormatter.prototype.set__formatString}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.formatters.ZipCodeFormatter.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ZipCodeFormatter', qName: 'mx.formatters.ZipCodeFormatter', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.formatters.ZipCodeFormatter.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'formatString': { type: 'String', access: 'readwrite', declaredBy: 'mx.formatters.ZipCodeFormatter'}
      };
    },
    methods: function () {
      return {
        'ZipCodeFormatter': { type: '', declaredBy: 'mx.formatters.ZipCodeFormatter'},
        'format': { type: 'String', declaredBy: 'mx.formatters.ZipCodeFormatter', parameters: function () { return [ 'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.formatters.ZipCodeFormatter.prototype.ROYALE_COMPILE_FLAGS = 10;