/**
 * Generated by Apache Royale Compiler from mx/globalization/NumberParseResult.as
 * mx.globalization.NumberParseResult
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.globalization.NumberParseResult');
goog.require('XML');



/**
 *  Constructs a number parse result object.  NumberParseResult objects are 
 *  usually created by the <code>NumberFormatter.parse()</code> and 
 *  <code>NumberFormatter.parseNumber()</code> methods, rather than by calling
 *  this constructor directly.
 *
 *  @asparam value The value of the numeric portion of the input string.
 *  @asparam startIndex The index of the first character of the number in the 
 *          input string.
 *  @asparam endIndex The index of the character after the last character of the
 *          number in the input string.
 *
 *  @see NumberFormatter#parse()
 *  @see NumberFormatter#parseNumber()
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.1
 *  @playerversion AIR 2.0
 *  @productversion Royale 0.9.8
 * @constructor
 * @param {number=} value
 * @param {number=} startIndex
 * @param {number=} endIndex
 */
mx.globalization.NumberParseResult = function(value, startIndex, endIndex) {
  value = typeof value !== 'undefined' ? value : NaN;
  startIndex = typeof startIndex !== 'undefined' ? startIndex : 0x7fffffff;
  endIndex = typeof endIndex !== 'undefined' ? endIndex : 0x7fffffff;
  this.value = value;
  this.startIndex = startIndex;
  this.endIndex = endIndex;
};


/**
 * @type {number}
 */
mx.globalization.NumberParseResult.prototype.endIndex = 0;


/**
 * @type {number}
 */
mx.globalization.NumberParseResult.prototype.startIndex = 0;


/**
 * @type {number}
 */
mx.globalization.NumberParseResult.prototype.value;


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.globalization.NumberParseResult.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'NumberParseResult', qName: 'mx.globalization.NumberParseResult', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.globalization.NumberParseResult.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'endIndex': { type: 'int', get_set: function (/** mx.globalization.NumberParseResult */ inst, /** * */ v) {return v !== undefined ? inst.endIndex = v : inst.endIndex;}},
        'startIndex': { type: 'int', get_set: function (/** mx.globalization.NumberParseResult */ inst, /** * */ v) {return v !== undefined ? inst.startIndex = v : inst.startIndex;}},
        'value': { type: 'Number', get_set: function (/** mx.globalization.NumberParseResult */ inst, /** * */ v) {return v !== undefined ? inst.value = v : inst.value;}}
      };
    },
    methods: function () {
      return {
        'NumberParseResult': { type: '', declaredBy: 'mx.globalization.NumberParseResult', parameters: function () { return [ 'Number', true ,'int', true ,'int', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.globalization.NumberParseResult.prototype.ROYALE_COMPILE_FLAGS = 10;