/**
 * Generated by Apache Royale Compiler from mx/logging/AbstractTarget.as
 * mx.logging.AbstractTarget
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.logging.AbstractTarget');

goog.require('mx.logging.ILogger');
goog.require('mx.logging.Log');
goog.require('mx.logging.LogEvent');
goog.require('mx.logging.LogEventLevel');
goog.require('mx.logging.errors.InvalidFilterError');
goog.require('mx.resources.IResourceManager');
goog.require('mx.resources.ResourceManager');
goog.require('org.apache.royale.utils.UIDUtil');
goog.require('mx.logging.ILoggingTarget');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @implements {mx.logging.ILoggingTarget}
 */
mx.logging.AbstractTarget = function() {
  
  this.mx_logging_AbstractTarget_resourceManager = mx.resources.ResourceManager.getInstance();
  this.mx_logging_AbstractTarget__filters = ["*"];
  this.mx_logging_AbstractTarget__level = mx.logging.LogEventLevel.ALL;
  ;
  this.mx_logging_AbstractTarget__id = org.apache.royale.utils.UIDUtil.createUID();
};


/**
 * @private
 * @type {number}
 */
mx.logging.AbstractTarget.prototype.mx_logging_AbstractTarget__loggerCount = 0;


/**
 * @private
 * @type {mx.resources.IResourceManager}
 */
mx.logging.AbstractTarget.prototype.mx_logging_AbstractTarget_resourceManager;


/**
 * @private
 * @type {Array}
 */
mx.logging.AbstractTarget.prototype.mx_logging_AbstractTarget__filters;


/**
 * @private
 * @type {string}
 */
mx.logging.AbstractTarget.prototype.mx_logging_AbstractTarget__id;


/**
 * @private
 * @type {number}
 */
mx.logging.AbstractTarget.prototype.mx_logging_AbstractTarget__level;


/**
 *  Sets up this target with the specified logger.
 *  This allows this target to receive log events from the specified logger.
 *
 *  @asparam logger The ILogger that this target should listen to.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {mx.logging.ILogger} logger
 */
mx.logging.AbstractTarget.prototype.addLogger = function(logger) {
  if (logger) {
    this.mx_logging_AbstractTarget__loggerCount++;
    logger.addEventListener(mx.logging.LogEvent.LOG, org.apache.royale.utils.Language.closure(this.mx_logging_AbstractTarget_logHandler, this, 'mx_logging_AbstractTarget_logHandler'));
  }
};


/**
 *  Stops this target from receiving events from the specified logger.
 *
 *  @asparam logger The ILogger that this target should ignore.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {mx.logging.ILogger} logger
 */
mx.logging.AbstractTarget.prototype.removeLogger = function(logger) {
  if (logger) {
    this.mx_logging_AbstractTarget__loggerCount--;
    logger.removeEventListener(mx.logging.LogEvent.LOG, org.apache.royale.utils.Language.closure(this.mx_logging_AbstractTarget_logHandler, this, 'mx_logging_AbstractTarget_logHandler'));
  }
};


/**
 *  Called after the implementing object has been created
 *  and all properties specified on the tag have been assigned.
 *
 *  @asparam document MXML document that created this object.
 *
 *  @asparam id Used by the document to refer to this object.
 *  If the object is a deep property on the document, id is null.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} document
 * @param {string} id
 */
mx.logging.AbstractTarget.prototype.initialized = function(document, id) {
  this.mx_logging_AbstractTarget__id = id;
  mx.logging.Log.addTarget(this);
};


/**
 *  This method handles a <code>LogEvent</code> from an associated logger.
 *  A target uses this method to translate the event into the appropriate
 *  format for transmission, storage, or display.
 *  This method will be called only if the event's level is in range of the
 *  target's level.
 *
 *  <p><b><i>NOTE: Descendants must override this method to make it useful.</i></b></p>
 *  
 *  @asparam event An event from an associated logger.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {mx.logging.LogEvent} event
 */
mx.logging.AbstractTarget.prototype.logEvent = function(event) {
};


/**
 *  @asprivate
 *  This method will call the <code>logEvent</code> method if the level of the
 *  event is appropriate for the current level.
 * @private
 * @param {mx.logging.LogEvent} event
 */
mx.logging.AbstractTarget.prototype.mx_logging_AbstractTarget_logHandler = function(event) {
  if (event.level >= this.level)
    this.logEvent(event);
};


/**
 * @nocollapse
 * @export
 * @type {Array}
 */
mx.logging.AbstractTarget.prototype.filters;


mx.logging.AbstractTarget.prototype.get__filters = function() {
  return this.mx_logging_AbstractTarget__filters;
};


mx.logging.AbstractTarget.prototype.set__filters = function(value) {
  var /** @type {number} */ index = 0;
  if (value && value.length > 0) {
    var /** @type {string} */ filter;
    //var /** @type {number} */ index = 0;
    var /** @type {string} */ message;
    for (var /** @type {number} */ i = 0; i < value.length; i++) {
      filter = org.apache.royale.utils.Language.string(value[i]);
      if (mx.logging.Log.hasIllegalCharacters(filter)) {
        message = this.mx_logging_AbstractTarget_resourceManager.getString("logging", "charsInvalid", [filter]);
        throw new mx.logging.errors.InvalidFilterError(message);
      }
      index = (filter.indexOf("*")) >> 0;
      if ((index >= 0) && (index != (filter.length - 1))) {
        message = this.mx_logging_AbstractTarget_resourceManager.getString("logging", "charPlacement", [filter]);
        throw new mx.logging.errors.InvalidFilterError(message);
      }
    }
  } else {
    value = ["*"];
  }
  if (this.mx_logging_AbstractTarget__loggerCount > 0) {
    mx.logging.Log.removeTarget(this);
    this.mx_logging_AbstractTarget__filters = value;
    mx.logging.Log.addTarget(this);
  } else {
    this.mx_logging_AbstractTarget__filters = value;
  }
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.logging.AbstractTarget.prototype.id;


mx.logging.AbstractTarget.prototype.get__id = function() {
  return this.mx_logging_AbstractTarget__id;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.logging.AbstractTarget.prototype.level;


mx.logging.AbstractTarget.prototype.get__level = function() {
  return this.mx_logging_AbstractTarget__level;
};


mx.logging.AbstractTarget.prototype.set__level = function(value) {
  mx.logging.Log.removeTarget(this);
  this.mx_logging_AbstractTarget__level = value;
  mx.logging.Log.addTarget(this);
};


Object.defineProperties(mx.logging.AbstractTarget.prototype, /** @lends {mx.logging.AbstractTarget.prototype} */ {
/**
 * @type {Array}
 */
filters: {
get: mx.logging.AbstractTarget.prototype.get__filters,
set: mx.logging.AbstractTarget.prototype.set__filters},
/**
 * @type {string}
 */
id: {
get: mx.logging.AbstractTarget.prototype.get__id},
/**
 * @type {number}
 */
level: {
get: mx.logging.AbstractTarget.prototype.get__level,
set: mx.logging.AbstractTarget.prototype.set__level}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.logging.AbstractTarget.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AbstractTarget', qName: 'mx.logging.AbstractTarget', kind: 'class' }], interfaces: [mx.logging.ILoggingTarget] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.logging.AbstractTarget.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'filters': { type: 'Array', access: 'readwrite', declaredBy: 'mx.logging.AbstractTarget'},
        'id': { type: 'String', access: 'readonly', declaredBy: 'mx.logging.AbstractTarget'},
        'level': { type: 'int', access: 'readwrite', declaredBy: 'mx.logging.AbstractTarget'}
      };
    },
    methods: function () {
      return {
        'AbstractTarget': { type: '', declaredBy: 'mx.logging.AbstractTarget'},
        'addLogger': { type: 'void', declaredBy: 'mx.logging.AbstractTarget', parameters: function () { return [ 'mx.logging.ILogger', false ]; }},
        'removeLogger': { type: 'void', declaredBy: 'mx.logging.AbstractTarget', parameters: function () { return [ 'mx.logging.ILogger', false ]; }},
        'initialized': { type: 'void', declaredBy: 'mx.logging.AbstractTarget', parameters: function () { return [ 'Object', false ,'String', false ]; }},
        'logEvent': { type: 'void', declaredBy: 'mx.logging.AbstractTarget', parameters: function () { return [ 'mx.logging.LogEvent', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.logging.AbstractTarget.prototype.ROYALE_COMPILE_FLAGS = 10;