/**
 * Generated by Apache Royale Compiler from mx/logging/targets/TraceTarget.as
 * mx.logging.targets.TraceTarget
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.logging.targets.TraceTarget');

goog.require('mx.logging.targets.LineFormattedTarget');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *
 *  <p>Constructs an instance of a logger target that will send
 *  the log data to the global <code>trace()</code> method.
 *  All output will be directed to flashlog.txt by default.</p>
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @constructor
 * @extends {mx.logging.targets.LineFormattedTarget}
 */
mx.logging.targets.TraceTarget = function() {
  mx.logging.targets.TraceTarget.base(this, 'constructor');
};
goog.inherits(mx.logging.targets.TraceTarget, mx.logging.targets.LineFormattedTarget);


/**
 *  Implementation to log the message via the <code>trace()</code> method.
 *
 *  @asparam  message String containing preprocessed log message which may
 *              include time, date, category, etc. based on property settings,
 *              such as <code>includeDate</code>, <code>includeCategory</code>,
 *          etc.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @protected
 * @override
 */
mx.logging.targets.TraceTarget.prototype.internalLog = function(message) {
  org.apache.royale.utils.Language.trace(message);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.logging.targets.TraceTarget.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'TraceTarget', qName: 'mx.logging.targets.TraceTarget', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.logging.targets.TraceTarget.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'TraceTarget': { type: '', declaredBy: 'mx.logging.targets.TraceTarget'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.logging.targets.TraceTarget.prototype.ROYALE_COMPILE_FLAGS = 10;