/**
 * Generated by Apache Royale Compiler from mx/messaging/channels/HTTPChannel.as
 * mx.messaging.channels.HTTPChannel
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.messaging.channels.HTTPChannel');
goog.provide('mx.messaging.channels.HTTPChannel.ChannelRequestLoader');
goog.provide('mx.messaging.channels.HTTPChannel.HTTPMessageResponder');
goog.provide('mx.messaging.channels.HTTPChannel.HTTPWrapperResponder');

goog.require('XML');
goog.require('mx.core.mx_internal');
goog.require('mx.events.ErrorEvent');
goog.require('mx.events.IOErrorEvent');
goog.require('mx.events.SecurityErrorEvent');
goog.require('mx.messaging.MessageAgent');
goog.require('mx.messaging.MessageResponder');
goog.require('mx.messaging.RoyaleClient');
goog.require('mx.messaging.channels.PollingChannel');
goog.require('mx.messaging.channels.amfx.AMFXDecoder');
goog.require('mx.messaging.channels.amfx.AMFXEncoder');
goog.require('mx.messaging.channels.amfx.AMFXHeader');
goog.require('mx.messaging.channels.amfx.AMFXResult');
goog.require('mx.messaging.config.ConfigMap');
goog.require('mx.messaging.config.LoaderConfig');
goog.require('mx.messaging.config.ServerConfig');
goog.require('mx.messaging.errors.MessageSerializationError');
goog.require('mx.messaging.events.ChannelFaultEvent');
goog.require('mx.messaging.messages.AbstractMessage');
goog.require('mx.messaging.messages.AcknowledgeMessage');
goog.require('mx.messaging.messages.AsyncMessage');
goog.require('mx.messaging.messages.CommandMessage');
goog.require('mx.messaging.messages.ErrorMessage');
goog.require('mx.messaging.messages.HTTPRequestMessage');
goog.require('mx.messaging.messages.IMessage');
goog.require('mx.messaging.messages.MessagePerformanceInfo');
goog.require('mx.messaging.messages.MessagePerformanceUtils');
goog.require('mx.net.URLLoader');
goog.require('mx.netmon.NetworkMonitor');
goog.require('mx.resources.IResourceManager');
goog.require('mx.resources.ResourceManager');
goog.require('mx.utils.ObjectUtil');
goog.require('mx.utils.StringUtil');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.net.URLRequest');
goog.require('org.apache.royale.utils.Language');



/**
 *  Constructor.
 *
 *  @asparam id The id of this Channel.
 *  @asparam uri The uri for this Channel.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @constructor
 * @extends {mx.messaging.channels.PollingChannel}
 * @param {string=} id
 * @param {string=} uri
 */
mx.messaging.channels.HTTPChannel = function(id, uri) {
  id = typeof id !== 'undefined' ? id : null;
  uri = typeof uri !== 'undefined' ? uri : null;
  mx.messaging.channels.HTTPChannel.base(this, 'constructor', id, uri);
  this.mx_messaging_channels_HTTPChannel__encoder = new mx.messaging.channels.amfx.AMFXEncoder();
  this.mx_messaging_channels_HTTPChannel__appendToURL = "";
  this.mx_messaging_channels_HTTPChannel__messageQueue = [];
};
goog.inherits(mx.messaging.channels.HTTPChannel, mx.messaging.channels.PollingChannel);


/**
 * @private
 * @type {string}
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel__appendToURL;


/**
 * @private
 * @type {mx.messaging.channels.HTTPChannel.ChannelRequestLoader}
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel__connectLoader;


/**
 * @private
 * @type {mx.messaging.channels.amfx.AMFXEncoder}
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel__encoder;


/**
 * @private
 * @type {mx.messaging.channels.HTTPChannel.ChannelRequestLoader}
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel__pendingRequest = null;


/**
 * @private
 * @type {Array}
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel__messageQueue;


/**
 *  @asprivate
 *  Processes polling related configuration settings.
 * @override
 */
mx.messaging.channels.HTTPChannel.prototype.applySettings = function(settings) {
  mx.messaging.channels.HTTPChannel.superClass_.applySettings.apply(this, [settings]);
  this.applyPollingSettings(settings);
};


/**
 *  @asprivate
 * @protected
 * @override
 */
mx.messaging.channels.HTTPChannel.prototype.connectTimeoutHandler = function(event) {
  this.mx_messaging_channels_HTTPChannel__connectLoader.close();
  mx.messaging.channels.HTTPChannel.superClass_.connectTimeoutHandler.apply(this, [event]);
};


/**
 *  @asprivate
 * @protected
 * @override
 */
mx.messaging.channels.HTTPChannel.prototype.getDefaultMessageResponder = function(agent, msg) {
  return new mx.messaging.channels.HTTPChannel.HTTPMessageResponder(agent, msg, this);
};


/**
 *  @asprivate
 *  Attempts to connect to the remote destination with the current endpoint
 *  specified for this channel.
 *  This will determine if a connection can be established.
 * @protected
 * @override
 */
mx.messaging.channels.HTTPChannel.prototype.internalConnect = function() {
  var /** @type {mx.messaging.messages.CommandMessage} */ msg = new mx.messaging.messages.CommandMessage();
  if (this.credentials != null) {
    msg.operation = mx.messaging.messages.CommandMessage.LOGIN_OPERATION;
    msg.body = this.credentials;
  } else {
    msg.operation = mx.messaging.messages.CommandMessage.CLIENT_PING_OPERATION;
  }
  if (mx.messaging.config.ServerConfig.http_$$www_adobe_com$2006$flex$mx$internal__needsConfig(this))
    msg.headers[mx.messaging.messages.CommandMessage.NEEDS_CONFIG_HEADER] = true;
  this.setRoyaleClientIdOnMessage(msg);
  var /** @type {org.apache.royale.net.URLRequest} */ urlRequest = this.http_$$www_adobe_com$2006$flex$mx$internal__createURLRequest(msg);
  this.mx_messaging_channels_HTTPChannel__connectLoader = new mx.messaging.channels.HTTPChannel.ChannelRequestLoader();
  this.mx_messaging_channels_HTTPChannel__connectLoader.setErrorCallbacks(org.apache.royale.utils.Language.closure(this.mx_messaging_channels_HTTPChannel_pingErrorHandler, this, 'mx_messaging_channels_HTTPChannel_pingErrorHandler'));
  this.mx_messaging_channels_HTTPChannel__connectLoader.completeCallback = org.apache.royale.utils.Language.closure(this.mx_messaging_channels_HTTPChannel_pingCompleteHandler, this, 'mx_messaging_channels_HTTPChannel_pingCompleteHandler');
  this.mx_messaging_channels_HTTPChannel__connectLoader.load(urlRequest);
};


/**
 *  @asprivate
 *  Disconnects from the remote destination.
 * @protected
 * @override
 */
mx.messaging.channels.HTTPChannel.prototype.internalDisconnect = function(rejected) {
  rejected = typeof rejected !== 'undefined' ? rejected : false;
  if (!rejected && !this.shouldBeConnected) {
    var /** @type {mx.messaging.messages.CommandMessage} */ msg = new mx.messaging.messages.CommandMessage();
    msg.operation = mx.messaging.messages.CommandMessage.DISCONNECT_OPERATION;
    this.internalSend(new mx.messaging.MessageResponder(null, msg, null));
  }
  this.setConnected(false);
  mx.messaging.channels.HTTPChannel.superClass_.internalDisconnect.apply(this, [rejected]);
  this.disconnectSuccess(rejected);
};


/**
 *  @asprivate
 * @protected
 * @override
 */
mx.messaging.channels.HTTPChannel.prototype.internalSend = function(msgResp) {
  if (this.mx_messaging_channels_HTTPChannel__pendingRequest != null) {
    this.mx_messaging_channels_HTTPChannel__messageQueue.push(msgResp);
  } else {
    this.setRoyaleClientIdOnMessage(msgResp.message);
    try {
      if (this.mpiEnabled) {
        var /** @type {mx.messaging.messages.MessagePerformanceInfo} */ mpii = new mx.messaging.messages.MessagePerformanceInfo();
        if (this.recordMessageTimes)
          mpii.sendTime = new Date().getTime();
        msgResp.message.headers[mx.messaging.messages.MessagePerformanceUtils.MPI_HEADER_IN] = mpii;
      }
      var /** @type {mx.messaging.channels.HTTPChannel.ChannelRequestLoader} */ urlLoader;
      var /** @type {org.apache.royale.net.URLRequest} */ urlRequest = this.http_$$www_adobe_com$2006$flex$mx$internal__createURLRequest(msgResp.message);
      if (org.apache.royale.utils.Language.is(msgResp, mx.messaging.channels.HTTPChannel.HTTPMessageResponder)) {
        var /** @type {mx.messaging.channels.HTTPChannel.HTTPMessageResponder} */ httpMsgResp = org.apache.royale.utils.Language.as(msgResp, mx.messaging.channels.HTTPChannel.HTTPMessageResponder, true);
        urlLoader = httpMsgResp.urlLoader;
        urlLoader.completeCallback = org.apache.royale.utils.Language.closure(httpMsgResp.completeHandler, httpMsgResp, 'completeHandler');
        urlLoader.errorCallback = org.apache.royale.utils.Language.closure(httpMsgResp.errorHandler, httpMsgResp, 'errorHandler');
        urlLoader.ioErrorCallback = org.apache.royale.utils.Language.closure(httpMsgResp.ioErrorHandler, httpMsgResp, 'ioErrorHandler');
        urlLoader.securityErrorCallback = org.apache.royale.utils.Language.closure(httpMsgResp.securityErrorHandler, httpMsgResp, 'securityErrorHandler');
      } else {
        var /** @type {mx.messaging.channels.HTTPChannel.HTTPWrapperResponder} */ responderWrapper = new mx.messaging.channels.HTTPChannel.HTTPWrapperResponder(msgResp);
        urlLoader = new mx.messaging.channels.HTTPChannel.ChannelRequestLoader();
        urlLoader.completeCallback = org.apache.royale.utils.Language.closure(responderWrapper.completeHandler, responderWrapper, 'completeHandler');
        urlLoader.setErrorCallbacks(org.apache.royale.utils.Language.closure(responderWrapper.errorHandler, responderWrapper, 'errorHandler'));
      }
      urlLoader.requestProcessedCallback = org.apache.royale.utils.Language.closure(this.mx_messaging_channels_HTTPChannel_requestProcessedHandler, this, 'mx_messaging_channels_HTTPChannel_requestProcessedHandler');
      if (!(org.apache.royale.utils.Language.is(msgResp.message, mx.messaging.messages.CommandMessage) && org.apache.royale.utils.Language.as(msgResp.message, mx.messaging.messages.CommandMessage, true).operation == mx.messaging.messages.CommandMessage.POLL_OPERATION))
        this.mx_messaging_channels_HTTPChannel__pendingRequest = urlLoader;
      urlLoader.load(urlRequest);
    } catch (e) {
      msgResp.agent.fault(e.fault, msgResp.message);
    }
  }
};


/**
 *  @asprivate
 *  Utility function to handle a connection related ErrorMessage.
 *
 *  @asparam msg The ErrorMessage returned during a connect attempt.
 * @param {mx.messaging.messages.ErrorMessage} msg
 */
mx.messaging.channels.HTTPChannel.prototype.http_$$www_adobe_com$2006$flex$mx$internal__connectionError = function(msg) {
  var /** @type {mx.messaging.events.ChannelFaultEvent} */ faultEvent = mx.messaging.events.ChannelFaultEvent.createEvent(this, false, "Channel.Connect.Failed", "error", msg.faultDetail + " url: '" + this.endpoint + (this.mx_messaging_channels_HTTPChannel__appendToURL != null ? this.mx_messaging_channels_HTTPChannel__appendToURL : "") + "'");
  faultEvent.rootCause = msg;
  this.connectFailed(faultEvent);
};


/**
 *  @asprivate
 *  This method will serialize the specified message into a new instance of
 *  a URLRequest and return it.
 *
 *  @asparam   message Message to serialize
 *  @asreturn  URLRequest
 * @param {mx.messaging.messages.IMessage} message
 * @return {org.apache.royale.net.URLRequest}
 */
mx.messaging.channels.HTTPChannel.prototype.http_$$www_adobe_com$2006$flex$mx$internal__createURLRequest = function(message) {
  var /** @type {org.apache.royale.net.URLRequest} */ result = new org.apache.royale.net.URLRequest();
  if (this.mx_messaging_channels_HTTPChannel__appendToURL)
    result.url = this.endpoint + this.mx_messaging_channels_HTTPChannel__appendToURL;
  else
    result.url = this.endpoint;
  if ("idleTimeout" in result && this.requestTimeout > 0)
    result["idleTimeout"] = this.requestTimeout * 1000;
  this.mx_messaging_channels_HTTPChannel_monitorRpcMessage(message, result);
  result.contentType = mx.messaging.messages.HTTPRequestMessage.CONTENT_TYPE_XML;
  var /** @type {XML} */ packet = this.mx_messaging_channels_HTTPChannel__encoder.encode(message, null);
  result.data = packet.toString();
  result.method = "POST";
  return result;
};


/**
 * change the result url to redirect request to Network Monitor
 * @private
 * @param {mx.messaging.messages.IMessage} message
 * @param {org.apache.royale.net.URLRequest} result
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel_monitorRpcMessage = function(message, result) {
  if (mx.netmon.NetworkMonitor.isMonitoring()) {
    var /** @type {string} */ redirectedUrl = mx.netmon.NetworkMonitor.adjustNetConnectionURL(mx.messaging.config.LoaderConfig.url, result.url);
    if (redirectedUrl != null) {
      result.url = redirectedUrl;
    }
  }
};


/**
 * @asprivate
 * @protected
 * @param {mx.messaging.messages.AsyncMessage} msg
 */
mx.messaging.channels.HTTPChannel.prototype.internalPingComplete = function(msg) {
  if (msg != null) {
    mx.messaging.config.ServerConfig.http_$$www_adobe_com$2006$flex$mx$internal__updateServerConfigData(org.apache.royale.utils.Language.as(msg.body, mx.messaging.config.ConfigMap), this.endpoint);
    if (mx.messaging.RoyaleClient.getInstance().id == null && msg.headers[mx.messaging.messages.AbstractMessage.FLEX_CLIENT_ID_HEADER] != null)
      mx.messaging.RoyaleClient.getInstance().id = org.apache.royale.utils.Language.string(msg.headers[mx.messaging.messages.AbstractMessage.FLEX_CLIENT_ID_HEADER]);
  }
  this.connectSuccess();
  if (this.credentials != null && !org.apache.royale.utils.Language.is(msg, mx.messaging.messages.ErrorMessage))
    this.http_$$www_adobe_com$2006$flex$mx$internal__setAuthenticated(true);
};


/**
 *  @asprivate
 *  Special handler for AMFX packet level header "AppendToGatewayUrl".
 *  When we receive this header we assume the server detected that a session
 *  was created but it believed the client could not accept its session
 *  cookie, so we need to decorate the channel endpoint with the session id.
 *
 *  We do not modify the underlying endpoint property, however, as this
 *  session is transient and should not apply if the channel is disconnected
 *  and re-connected at some point in the future.
 * @private
 * @param {string} value
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel_AppendToGatewayUrl = function(value) {
  if (value != null)
    this.http_$$www_adobe_com$2006$flex$mx$internal__appendToURL = value;
};


/**
 * @private
 * @param {org.apache.royale.events.Event} event
 * @return {mx.messaging.channels.amfx.AMFXResult}
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel_decodePacket = function(event) {
  var /** @type {string} */ raw = String(org.apache.royale.utils.Language.as(event.target, mx.net.URLLoader, true).data);
  var /** @type {XML} */ xmlData = new XML(raw);
  var /** @type {mx.messaging.channels.amfx.AMFXDecoder} */ _decoder = new mx.messaging.channels.amfx.AMFXDecoder();
  var /** @type {mx.messaging.channels.amfx.AMFXResult} */ packet = _decoder.decode(xmlData);
  return packet;
};


/**
 *  @asprivate
 *  Attempts to replicate the packet-level header functionality that AMFChannel
 *  uses for response headers such as AppendToGatewayUrl for session id tracking.
 * @private
 * @param {mx.messaging.channels.amfx.AMFXResult} packet
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel_processHeaders = function(packet) {
  if (packet.headers != null) {
    try {
      for (var /** @type {number} */ i = 0; i < packet.headers.length; i++) {
        var /** @type {mx.messaging.channels.amfx.AMFXHeader} */ header = packet.headers[i];
        if (header != null && header.name == mx.messaging.channels.HTTPChannel.APPEND_TO_URL_HEADER) {
          this.mx_messaging_channels_HTTPChannel_AppendToGatewayUrl(String(header.content));
        }
      }
    } catch (e) {
    }
  }
};


/**
 *  @asprivate
 *  This method indicates that we successfully connected to the endpoint.
 *  Called as a result of the ping operation performed in the
 *  internalConnect() method.
 * @private
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel_pingCompleteHandler = function(event) {
  var /** @type {mx.messaging.channels.amfx.AMFXResult} */ packet = this.mx_messaging_channels_HTTPChannel_decodePacket(event);
  this.mx_messaging_channels_HTTPChannel_processHeaders(packet);
  var /** @type {mx.messaging.messages.AsyncMessage} */ msg = org.apache.royale.utils.Language.as(packet.result, mx.messaging.messages.AsyncMessage);
  if (msg != null && org.apache.royale.utils.Language.is(msg, mx.messaging.messages.ErrorMessage) && org.apache.royale.utils.Language.as(msg, mx.messaging.messages.ErrorMessage, true).faultCode == "Client.Authentication") {
    this.internalPingComplete(msg);
    var /** @type {mx.messaging.events.ChannelFaultEvent} */ faultEvent = mx.messaging.events.ChannelFaultEvent.createEvent(this, false, "Channel.Authentication.Error", "warn");
    faultEvent.rootCause = org.apache.royale.utils.Language.as(msg, mx.messaging.messages.ErrorMessage, true);
    this.dispatchEvent(faultEvent);
  } else {
    this.internalPingComplete(msg);
  }
};


/**
 *  @asprivate
 *  This method dispatches the appropriate error to any message agents, and
 *  is called as a result of the ping operation performed in the
 *  internalConnect() method.
 * @private
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel_pingErrorHandler = function(event) {
  this._log.debug("'{0}' fault handler called. {1}", this.id, event.toString());
  var /** @type {mx.messaging.events.ChannelFaultEvent} */ faultEvent = mx.messaging.events.ChannelFaultEvent.createEvent(this, false, "Channel.Ping.Failed", "error", " url: '" + this.endpoint + (this.mx_messaging_channels_HTTPChannel__appendToURL == null ? "" : this.mx_messaging_channels_HTTPChannel__appendToURL + "'") + "'");
  faultEvent.rootCause = event;
  this.connectFailed(faultEvent);
};


/**
 *  @asprivate
 *  Chains sends for pending messages.
 * @private
 * @param {mx.messaging.channels.HTTPChannel.ChannelRequestLoader} loader
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.prototype.mx_messaging_channels_HTTPChannel_requestProcessedHandler = function(loader, event) {
  if (this.mx_messaging_channels_HTTPChannel__pendingRequest == loader) {
    this.mx_messaging_channels_HTTPChannel__pendingRequest = null;
  }
  while ((this.mx_messaging_channels_HTTPChannel__messageQueue.length > 0) && (this.mx_messaging_channels_HTTPChannel__pendingRequest == null)) {
    this.internalSend(org.apache.royale.utils.Language.as(this.mx_messaging_channels_HTTPChannel__messageQueue.shift(), mx.messaging.MessageResponder, true));
  }
};


/**
 * @private
 * @const
 * @type {string}
 */
mx.messaging.channels.HTTPChannel.APPEND_TO_URL_HEADER = "AppendToGatewayUrl";


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.messaging.channels.HTTPChannel.prototype.polling;


mx.messaging.channels.HTTPChannel.prototype.get__polling = function() {
  return this.http_$$www_adobe_com$2006$flex$mx$internal__pollOutstanding;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.messaging.channels.HTTPChannel.prototype.piggybackingEnabled;


mx.messaging.channels.HTTPChannel.prototype.get__piggybackingEnabled = function() {
  return this.internalPiggybackingEnabled;
};


mx.messaging.channels.HTTPChannel.prototype.set__piggybackingEnabled = function(value) {
  this.internalPiggybackingEnabled = value;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.messaging.channels.HTTPChannel.prototype.pollingEnabled;


mx.messaging.channels.HTTPChannel.prototype.get__pollingEnabled = function() {
  return this.internalPollingEnabled;
};


mx.messaging.channels.HTTPChannel.prototype.set__pollingEnabled = function(value) {
  this.internalPollingEnabled = value;
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.messaging.channels.HTTPChannel.prototype.pollingInterval;


mx.messaging.channels.HTTPChannel.prototype.get__pollingInterval = function() {
  return this.http_$$www_adobe_com$2006$flex$mx$internal__internalPollingInterval;
};


mx.messaging.channels.HTTPChannel.prototype.set__pollingInterval = function(value) {
  this.http_$$www_adobe_com$2006$flex$mx$internal__internalPollingInterval = value;
};


mx.messaging.channels.HTTPChannel.prototype.get__protocol = function() {
  return "http";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.messaging.channels.HTTPChannel.prototype.http_$$www_adobe_com$2006$flex$mx$internal__appendToURL;


mx.messaging.channels.HTTPChannel.prototype.http_$$www_adobe_com$2006$flex$mx$internal__get__appendToURL = function() {
  return this.mx_messaging_channels_HTTPChannel__appendToURL;
};


mx.messaging.channels.HTTPChannel.prototype.http_$$www_adobe_com$2006$flex$mx$internal__set__appendToURL = function(value) {
  if (value && this.endpoint) {
    this.mx_messaging_channels_HTTPChannel__appendToURL = value;
  }
};


Object.defineProperties(mx.messaging.channels.HTTPChannel.prototype, /** @lends {mx.messaging.channels.HTTPChannel.prototype} */ {
/**
 * @type {boolean}
 */
polling: {
get: mx.messaging.channels.HTTPChannel.prototype.get__polling},
/**
 * @type {boolean}
 */
piggybackingEnabled: {
get: mx.messaging.channels.HTTPChannel.prototype.get__piggybackingEnabled,
set: mx.messaging.channels.HTTPChannel.prototype.set__piggybackingEnabled},
/**
 * @type {boolean}
 */
pollingEnabled: {
get: mx.messaging.channels.HTTPChannel.prototype.get__pollingEnabled,
set: mx.messaging.channels.HTTPChannel.prototype.set__pollingEnabled},
/**
 * @type {number}
 */
pollingInterval: {
get: mx.messaging.channels.HTTPChannel.prototype.get__pollingInterval,
set: mx.messaging.channels.HTTPChannel.prototype.set__pollingInterval},
/**
 * @type {string}
 */
protocol: {
get: mx.messaging.channels.HTTPChannel.prototype.get__protocol},
/**
 * @type {string}
 */
http_$$www_adobe_com$2006$flex$mx$internal__appendToURL: {
get: mx.messaging.channels.HTTPChannel.prototype.http_$$www_adobe_com$2006$flex$mx$internal__get__appendToURL,
set: mx.messaging.channels.HTTPChannel.prototype.http_$$www_adobe_com$2006$flex$mx$internal__set__appendToURL}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.messaging.channels.HTTPChannel.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HTTPChannel', qName: 'mx.messaging.channels.HTTPChannel', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.messaging.channels.HTTPChannel.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'polling': { type: 'Boolean', access: 'readonly', declaredBy: 'mx.messaging.channels.HTTPChannel'},
        'piggybackingEnabled': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.messaging.channels.HTTPChannel'},
        'pollingEnabled': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.messaging.channels.HTTPChannel'},
        'pollingInterval': { type: 'Number', access: 'readwrite', declaredBy: 'mx.messaging.channels.HTTPChannel'},
        'protocol': { type: 'String', access: 'readonly', declaredBy: 'mx.messaging.channels.HTTPChannel'},
        'http://www.adobe.com/2006/flex/mx/internal::appendToURL': { type: 'String', access: 'readwrite', declaredBy: 'mx.messaging.channels.HTTPChannel'}
      };
    },
    methods: function () {
      return {
        'HTTPChannel': { type: '', declaredBy: 'mx.messaging.channels.HTTPChannel', parameters: function () { return [ 'String', true ,'String', true ]; }},
        'applySettings': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel', parameters: function () { return [ 'XML', false ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::connectionError': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel', parameters: function () { return [ 'mx.messaging.messages.ErrorMessage', false ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::createURLRequest': { type: 'org.apache.royale.net.URLRequest', declaredBy: 'mx.messaging.channels.HTTPChannel', parameters: function () { return [ 'mx.messaging.messages.IMessage', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.messaging.channels.HTTPChannel.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 *  @asprivate
 *  Constructs a HTTPWrappedResponder.
 *
 *  @asparam wrappedResponder The responder to wrap.
 * @constructor
 * @param {mx.messaging.MessageResponder} wrappedResponder
 */
mx.messaging.channels.HTTPChannel.HTTPWrapperResponder = function(wrappedResponder) {
  
  this.HTTPWrapperResponder_resourceManager = mx.resources.ResourceManager.getInstance();
  ;
  this.HTTPWrapperResponder__wrappedResponder = wrappedResponder;
};


/**
 * @private
 * @type {mx.messaging.MessageResponder}
 */
mx.messaging.channels.HTTPChannel.HTTPWrapperResponder.prototype.HTTPWrapperResponder__wrappedResponder;


/**
 * @private
 * @type {mx.resources.IResourceManager}
 */
mx.messaging.channels.HTTPChannel.HTTPWrapperResponder.prototype.HTTPWrapperResponder_resourceManager;


/**
 *  @asprivate
 *  Handles a result returned from the remote destination.
 *
 *  @asparam event The completion event from the associated URLLoader.
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.HTTPWrapperResponder.prototype.completeHandler = function(event) {
  var /** @type {string} */ raw = String(org.apache.royale.utils.Language.as(event.target, mx.net.URLLoader, true).data);
  var /** @type {XML} */ xmlData = new XML(raw);
  var /** @type {mx.messaging.channels.amfx.AMFXDecoder} */ _decoder = new mx.messaging.channels.amfx.AMFXDecoder();
  var /** @type {mx.messaging.channels.amfx.AMFXResult} */ packet = _decoder.decode(xmlData);
  if (org.apache.royale.utils.Language.is(packet.result, mx.messaging.messages.ErrorMessage)) {
    this.HTTPWrapperResponder__wrappedResponder.status(org.apache.royale.utils.Language.as(packet.result, mx.messaging.messages.ErrorMessage, true));
  } else if (org.apache.royale.utils.Language.is(packet.result, mx.messaging.messages.AsyncMessage)) {
    this.HTTPWrapperResponder__wrappedResponder.result(org.apache.royale.utils.Language.as(packet.result, mx.messaging.messages.AsyncMessage, true));
  }
};


/**
 *  @asprivate
 *  Handles an error for an outbound request.
 *
 *  @asparam event The error event from the associated URLLoader.
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.HTTPWrapperResponder.prototype.errorHandler = function(event) {
  var /** @type {mx.messaging.messages.ErrorMessage} */ msg = new mx.messaging.messages.ErrorMessage();
  msg.correlationId = this.HTTPWrapperResponder__wrappedResponder.message.messageId;
  msg.faultCode = "Server.Error.Request";
  msg.faultString = "HTTP request error";
  var /** @type {string} */ details = event.toString();
  if (org.apache.royale.utils.Language.is(this.HTTPWrapperResponder__wrappedResponder.message, mx.messaging.messages.HTTPRequestMessage)) {
    details += ". URL: ";
    details += org.apache.royale.utils.Language.as(this.HTTPWrapperResponder__wrappedResponder.message, mx.messaging.messages.HTTPRequestMessage, true).url;
  }
  msg.faultDetail = mx.utils.StringUtil.substitute("Error: {0}", details);
  msg.rootCause = event;
  this.HTTPWrapperResponder__wrappedResponder.status(msg);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.messaging.channels.HTTPChannel.HTTPWrapperResponder.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HTTPWrapperResponder', qName: 'mx.messaging.channels.HTTPChannel.HTTPWrapperResponder', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.messaging.channels.HTTPChannel.HTTPWrapperResponder.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'HTTPWrapperResponder': { type: '', declaredBy: 'mx.messaging.channels.HTTPChannel.HTTPWrapperResponder', parameters: function () { return [ 'mx.messaging.MessageResponder', false ]; }},
        'completeHandler': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel.HTTPWrapperResponder', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }},
        'errorHandler': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel.HTTPWrapperResponder', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.messaging.channels.HTTPChannel.HTTPWrapperResponder.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 *  @asprivate
 *  Constructs an HTTPMessageResponder.
 *
 *  @asparam agent The associated MessageAgent.
 *
 *  @asparam msg The message to send.
 *
 *  @asparam channel The Channel to send the message over.
 * @constructor
 * @extends {mx.messaging.MessageResponder}
 * @param {mx.messaging.MessageAgent} agent
 * @param {mx.messaging.messages.IMessage} msg
 * @param {mx.messaging.channels.HTTPChannel} channel
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder = function(agent, msg, channel) {
  
  this.HTTPMessageResponder_resourceManager = mx.resources.ResourceManager.getInstance();
  mx.messaging.channels.HTTPChannel.HTTPMessageResponder.base(this, 'constructor', agent, msg, channel);
  this.HTTPMessageResponder_decoder = new mx.messaging.channels.amfx.AMFXDecoder();
  this.urlLoader = new mx.messaging.channels.HTTPChannel.ChannelRequestLoader();
};
goog.inherits(mx.messaging.channels.HTTPChannel.HTTPMessageResponder, mx.messaging.MessageResponder);


/**
 * @private
 * @type {mx.messaging.channels.amfx.AMFXDecoder}
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.HTTPMessageResponder_decoder;


/**
 * @private
 * @type {mx.resources.IResourceManager}
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.HTTPMessageResponder_resourceManager;


/**
 * @type {mx.messaging.channels.HTTPChannel.ChannelRequestLoader}
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.urlLoader;


/**
 *  @asprivate
 * @protected
 * @override
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.resultHandler = function(response) {
  var /** @type {mx.messaging.messages.ErrorMessage} */ errorMsg;
  if (org.apache.royale.utils.Language.is(response, mx.messaging.messages.AsyncMessage)) {
    if (org.apache.royale.utils.Language.is(response, mx.messaging.messages.ErrorMessage)) {
      this.agent.fault(org.apache.royale.utils.Language.as(response, mx.messaging.messages.ErrorMessage, true), this.message);
    } else if (org.apache.royale.utils.Language.as(response, mx.messaging.messages.AsyncMessage, true).correlationId == this.message.messageId) {
      this.agent.acknowledge(org.apache.royale.utils.Language.as(response, mx.messaging.messages.AcknowledgeMessage, true), this.message);
    } else {
      errorMsg = new mx.messaging.messages.ErrorMessage();
      errorMsg.faultCode = "Server.Acknowledge.Failed";
      errorMsg.faultString = "Didn't receive an acknowledgement of message";
      errorMsg.faultDetail = mx.utils.StringUtil.substitute("Was expecting message '{0}' but received '{1}'.", this.message.messageId, org.apache.royale.utils.Language.as(response, mx.messaging.messages.AsyncMessage, true).correlationId);
      this.agent.fault(errorMsg, this.message);
    }
  } else if (response != null) {
    errorMsg = new mx.messaging.messages.ErrorMessage();
    errorMsg.faultCode = "Server.Acknowledge.Failed";
    errorMsg.faultString = "Didn't receive an acknowledge message";
    errorMsg.faultDetail = mx.utils.StringUtil.substitute("Was expecting mx.messaging.messages.AcknowledgeMessage, but received {0}", mx.utils.ObjectUtil.toString(response));
    this.agent.fault(errorMsg, this.message);
  }
};


/**
 *  @asprivate
 *  Handle a request timeout by closing our associated URLLoader and
 *  faulting the message to the agent.
 * @protected
 * @override
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.requestTimedOut = function() {
  this.urlLoader.close();
  this.status(null);
  var /** @type {mx.messaging.messages.AcknowledgeMessage} */ ack = new mx.messaging.messages.AcknowledgeMessage();
  ack.correlationId = this.message.messageId;
  ack.headers[mx.messaging.messages.AcknowledgeMessage.ERROR_HINT_HEADER] = true;
  this.agent.acknowledge(ack, this.message);
  this.agent.fault(this.createRequestTimeoutErrorMessage(), this.message);
};


/**
 *  @asprivate
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.completeHandler = function(event) {
  this.result(null);
  var /** @type {string} */ raw = String(org.apache.royale.utils.Language.as(event.target, mx.net.URLLoader, true).data);
  var /** @type {XML} */ xmlData = new XML(raw);
  var /** @type {mx.messaging.channels.amfx.AMFXResult} */ packet = this.HTTPMessageResponder_decoder.decode(xmlData);
  if (org.apache.royale.utils.Language.is(packet.result, mx.messaging.messages.IMessage)) {
    this.resultHandler(org.apache.royale.utils.Language.as(packet.result, mx.messaging.messages.IMessage, true));
  }
};


/**
 *  @asprivate
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.errorHandler = function(event) {
  this.status(null);
  var /** @type {mx.messaging.messages.AcknowledgeMessage} */ ack = new mx.messaging.messages.AcknowledgeMessage();
  ack.correlationId = this.message.messageId;
  ack.headers[mx.messaging.messages.AcknowledgeMessage.ERROR_HINT_HEADER] = true;
  this.agent.acknowledge(ack, this.message);
  var /** @type {mx.messaging.messages.ErrorMessage} */ msg = new mx.messaging.messages.ErrorMessage();
  msg.correlationId = this.message.messageId;
  msg.faultCode = "Server.Error.Request";
  msg.faultString = "HTTP request error";
  var /** @type {string} */ details = event.toString();
  if (org.apache.royale.utils.Language.is(this.message, mx.messaging.messages.HTTPRequestMessage)) {
    details += ". URL: ";
    details += org.apache.royale.utils.Language.as(this.message, mx.messaging.messages.HTTPRequestMessage, true).url;
  }
  msg.faultDetail = mx.utils.StringUtil.substitute("Error: {0}", details);
  msg.rootCause = event;
  this.agent.fault(msg, this.message);
};


/**
 *  @asprivate
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.ioErrorHandler = function(event) {
  this.status(null);
  var /** @type {mx.messaging.messages.AcknowledgeMessage} */ ack = new mx.messaging.messages.AcknowledgeMessage();
  ack.correlationId = this.message.messageId;
  ack.headers[mx.messaging.messages.AcknowledgeMessage.ERROR_HINT_HEADER] = true;
  this.agent.acknowledge(ack, this.message);
  var /** @type {mx.messaging.messages.ErrorMessage} */ msg = new mx.messaging.messages.ErrorMessage();
  msg.correlationId = this.message.messageId;
  msg.faultCode = "Server.Error.Request";
  msg.faultString = "HTTP request error";
  var /** @type {string} */ details = event.toString();
  if (org.apache.royale.utils.Language.is(this.message, mx.messaging.messages.HTTPRequestMessage)) {
    details += ". URL: ";
    details += org.apache.royale.utils.Language.as(this.message, mx.messaging.messages.HTTPRequestMessage, true).url;
  }
  msg.faultDetail = mx.utils.StringUtil.substitute("Error: {0}", details);
  msg.rootCause = event;
  org.apache.royale.utils.Language.as(this.channel, mx.messaging.channels.HTTPChannel).http_$$www_adobe_com$2006$flex$mx$internal__connectionError(msg);
  this.agent.fault(msg, this.message);
};


/**
 *  @asprivate
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.securityErrorHandler = function(event) {
  this.status(null);
  var /** @type {mx.messaging.messages.AcknowledgeMessage} */ ack = new mx.messaging.messages.AcknowledgeMessage();
  ack.correlationId = this.message.messageId;
  ack.headers[mx.messaging.messages.AcknowledgeMessage.ERROR_HINT_HEADER] = true;
  this.agent.acknowledge(ack, this.message);
  var /** @type {mx.messaging.messages.ErrorMessage} */ msg = new mx.messaging.messages.ErrorMessage();
  msg.correlationId = this.message.messageId;
  msg.faultCode = "Channel.Security.Error";
  msg.faultString = "Security error accessing url";
  msg.faultDetail = mx.utils.StringUtil.substitute("Destination: {0}", this.message.destination);
  msg.rootCause = event;
  this.agent.fault(msg, this.message);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HTTPMessageResponder', qName: 'mx.messaging.channels.HTTPChannel.HTTPMessageResponder', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'urlLoader': { type: 'mx.messaging.channels.HTTPChannel.ChannelRequestLoader', get_set: function (/** mx.messaging.channels.HTTPChannel.HTTPMessageResponder */ inst, /** * */ v) {return v !== undefined ? inst.urlLoader = v : inst.urlLoader;}}
      };
    },
    methods: function () {
      return {
        'HTTPMessageResponder': { type: '', declaredBy: 'mx.messaging.channels.HTTPChannel.HTTPMessageResponder', parameters: function () { return [ 'mx.messaging.MessageAgent', false ,'mx.messaging.messages.IMessage', false ,'mx.messaging.channels.HTTPChannel', false ]; }},
        'completeHandler': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel.HTTPMessageResponder', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }},
        'errorHandler': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel.HTTPMessageResponder', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }},
        'ioErrorHandler': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel.HTTPMessageResponder', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }},
        'securityErrorHandler': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel.HTTPMessageResponder', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.messaging.channels.HTTPChannel.HTTPMessageResponder.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 *  @asprivate
 *  Constructs a ChannelRequestLoader.
 * @constructor
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader = function() {
  ;
  this.ChannelRequestLoader__urlLoader = new mx.net.URLLoader();
  this.ChannelRequestLoader__urlLoader.addEventListener(mx.events.ErrorEvent.ERROR, org.apache.royale.utils.Language.closure(this.ChannelRequestLoader_errorHandler, this, 'ChannelRequestLoader_errorHandler'));
  this.ChannelRequestLoader__urlLoader.addEventListener(mx.events.IOErrorEvent.IO_ERROR, org.apache.royale.utils.Language.closure(this.ChannelRequestLoader_ioErrorHandler, this, 'ChannelRequestLoader_ioErrorHandler'));
  this.ChannelRequestLoader__urlLoader.addEventListener(mx.events.SecurityErrorEvent.SECURITY_ERROR, org.apache.royale.utils.Language.closure(this.ChannelRequestLoader_securityErrorHandler, this, 'ChannelRequestLoader_securityErrorHandler'));
  this.ChannelRequestLoader__urlLoader.addEventListener(org.apache.royale.events.Event.COMPLETE, org.apache.royale.utils.Language.closure(this.ChannelRequestLoader_completeHandler, this, 'ChannelRequestLoader_completeHandler'));
};


/**
 * @private
 * @type {mx.net.URLLoader}
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ChannelRequestLoader__urlLoader;


/**
 * @type {Function}
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.errorCallback;


/**
 * @type {Function}
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ioErrorCallback;


/**
 * @type {Function}
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.securityErrorCallback;


/**
 * @type {Function}
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.completeCallback;


/**
 * @type {Function}
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.requestProcessedCallback;


/**
 *  @asprivate
 * @param {org.apache.royale.net.URLRequest} request
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.load = function(request) {
  this.ChannelRequestLoader__urlLoader.load(request);
};


/**
 *  @asprivate
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.close = function() {
  this.ChannelRequestLoader__urlLoader.removeEventListener(mx.events.ErrorEvent.ERROR, org.apache.royale.utils.Language.closure(this.ChannelRequestLoader_errorHandler, this, 'ChannelRequestLoader_errorHandler'));
  this.ChannelRequestLoader__urlLoader.removeEventListener(mx.events.IOErrorEvent.IO_ERROR, org.apache.royale.utils.Language.closure(this.ChannelRequestLoader_ioErrorHandler, this, 'ChannelRequestLoader_ioErrorHandler'));
  this.ChannelRequestLoader__urlLoader.removeEventListener(mx.events.SecurityErrorEvent.SECURITY_ERROR, org.apache.royale.utils.Language.closure(this.ChannelRequestLoader_securityErrorHandler, this, 'ChannelRequestLoader_securityErrorHandler'));
  this.ChannelRequestLoader__urlLoader.removeEventListener(org.apache.royale.events.Event.COMPLETE, org.apache.royale.utils.Language.closure(this.ChannelRequestLoader_completeHandler, this, 'ChannelRequestLoader_completeHandler'));
  this.ChannelRequestLoader__urlLoader.close();
};


/**
 *  @asprivate
 * @param {Function} callback
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.setErrorCallbacks = function(callback) {
  this.errorCallback = callback;
  this.ioErrorCallback = callback;
  this.securityErrorCallback = callback;
};


/**
 *  @asprivate
 * @private
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ChannelRequestLoader_callRequestProcessedCallback = function(event) {
  if (this.requestProcessedCallback != null)
    this.requestProcessedCallback(this, event);
};


/**
 *  @asprivate
 * @private
 * @param {Function} callback
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ChannelRequestLoader_callEventCallback = function(callback, event) {
  if (callback != null)
    callback(event);
};


/**
 *  @asprivate
 * @private
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ChannelRequestLoader_errorHandler = function(event) {
  this.ChannelRequestLoader_callRequestProcessedCallback(event);
  this.ChannelRequestLoader_callEventCallback(this.requestProcessedCallback, event);
};


/**
 *  @asprivate
 * @private
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ChannelRequestLoader_ioErrorHandler = function(event) {
  this.ChannelRequestLoader_callRequestProcessedCallback(event);
  this.ChannelRequestLoader_callEventCallback(this.ioErrorCallback, event);
};


/**
 *  @asprivate
 * @private
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ChannelRequestLoader_securityErrorHandler = function(event) {
  this.ChannelRequestLoader_callRequestProcessedCallback(event);
  this.ChannelRequestLoader_callEventCallback(this.securityErrorCallback, event);
};


/**
 *  @asprivate
 * @private
 * @param {org.apache.royale.events.Event} event
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ChannelRequestLoader_completeHandler = function(event) {
  this.ChannelRequestLoader_callRequestProcessedCallback(event);
  this.ChannelRequestLoader_callEventCallback(this.completeCallback, event);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'ChannelRequestLoader', qName: 'mx.messaging.channels.HTTPChannel.ChannelRequestLoader', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'errorCallback': { type: 'Function', get_set: function (/** mx.messaging.channels.HTTPChannel.ChannelRequestLoader */ inst, /** * */ v) {return v !== undefined ? inst.errorCallback = v : inst.errorCallback;}},
        'ioErrorCallback': { type: 'Function', get_set: function (/** mx.messaging.channels.HTTPChannel.ChannelRequestLoader */ inst, /** * */ v) {return v !== undefined ? inst.ioErrorCallback = v : inst.ioErrorCallback;}},
        'securityErrorCallback': { type: 'Function', get_set: function (/** mx.messaging.channels.HTTPChannel.ChannelRequestLoader */ inst, /** * */ v) {return v !== undefined ? inst.securityErrorCallback = v : inst.securityErrorCallback;}},
        'completeCallback': { type: 'Function', get_set: function (/** mx.messaging.channels.HTTPChannel.ChannelRequestLoader */ inst, /** * */ v) {return v !== undefined ? inst.completeCallback = v : inst.completeCallback;}},
        'requestProcessedCallback': { type: 'Function', get_set: function (/** mx.messaging.channels.HTTPChannel.ChannelRequestLoader */ inst, /** * */ v) {return v !== undefined ? inst.requestProcessedCallback = v : inst.requestProcessedCallback;}}
      };
    },
    methods: function () {
      return {
        'ChannelRequestLoader': { type: '', declaredBy: 'mx.messaging.channels.HTTPChannel.ChannelRequestLoader'},
        'load': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel.ChannelRequestLoader', parameters: function () { return [ 'org.apache.royale.net.URLRequest', false ]; }},
        'close': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel.ChannelRequestLoader'},
        'setErrorCallbacks': { type: 'void', declaredBy: 'mx.messaging.channels.HTTPChannel.ChannelRequestLoader', parameters: function () { return [ 'Function', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.messaging.channels.HTTPChannel.ChannelRequestLoader.prototype.ROYALE_COMPILE_FLAGS = 10;