/**
 * Generated by Apache Royale Compiler from mx/messaging/channels/amfx/AMFXContext.as
 * mx.messaging.channels.amfx.AMFXContext
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.messaging.channels.amfx.AMFXContext');

goog.require('mx.logging.ILogger');
goog.require('XML');



/**
 * Constructor.
 * Initializes object, trait info and string reference tables.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @constructor
 */
mx.messaging.channels.amfx.AMFXContext = function() {
  ;
  this.reset();
};


/**
 * Resets the trait info, object and string reference tables.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 */
mx.messaging.channels.amfx.AMFXContext.prototype.reset = function() {
  this.traits = [];
  this.objects = [];
  this.strings = [];
};


/**
 * Check whether the trait info reference table
 * already contains this list of traits. If found,
 * the index of the trait info is returned, starting
 * from 0. If not found -1 is returned.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @param {Object} traitInfo
 * @return {number}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.findTraitInfo = function(traitInfo) {
  for (var /** @type {number} */ i = 0; i < this.traits.length; i++) {
    var /** @type {Object} */ ti = this.traits[i];
    if (ti.alias == traitInfo.alias && ti.properties.length == traitInfo.properties.length) {
      var /** @type {number} */ j = 0;
      for (; j < ti.properties.length; j++) {
        if (ti.properties[i] != traitInfo.properties[j]) {
          break;
        }
      }
      if (j == traitInfo.properties.length) {
        return (i) >> 0;
      }
    }
  }
  return -1;
};


/**
 * Check whether the object reference table
 * already contains this object. If found, the index
 * of the object is returned, starting from 0. If
 * not found -1 is returned.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @param {Object} object
 * @return {number}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.findObject = function(object) {
  for (var /** @type {number} */ i = 0; i < this.objects.length; i++) {
    var /** @type {Object} */ o = this.objects[i];
    if (o === object) {
      return (i) >> 0;
    }
  }
  return -1;
};


/**
 * Check whether the string reference table
 * already contains this string. If found, the index
 * of the string is returned, starting from 0. If
 * not found (or if the value passed is the empty string)
 * -1 is returned.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @param {string} str
 * @return {number}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.findString = function(str) {
  if (str != "") {
    for (var /** @type {number} */ i = 0; i < this.strings.length; i++) {
      var /** @type {string} */ s = org.apache.royale.utils.Language.string(this.strings[i]);
      if (s == str) {
        return (i) >> 0;
      }
    }
  }
  return -1;
};


/**
 * Remember the trait info for an object in this context
 * for an encoding or decoding session.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @param {Object} traitInfo
 */
mx.messaging.channels.amfx.AMFXContext.prototype.addTraitInfo = function(traitInfo) {
  this.traits.push(traitInfo);
};


/**
 * Remember an object in this context for an encoding
 * or decoding session.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @param {Object} obj
 */
mx.messaging.channels.amfx.AMFXContext.prototype.addObject = function(obj) {
  this.objects.push(obj);
};


/**
 * Remember a string in this context for an encoding
 * or decoding session. Note that the empty string
 * is not remembered as it should not be serialized
 * by reference.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @param {string} str
 */
mx.messaging.channels.amfx.AMFXContext.prototype.addString = function(str) {
  if (str != "") {
    this.strings.push(str);
  }
};


/**
 * Retrieve trait info for an object by its reference
 * table index.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @param {number} ref
 * @return {*}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.getTraitInfo = function(ref) {
  return this.traits[ref];
};


/**
 * Retrieve an object by its reference table index.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @param {number} ref
 * @return {*}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.getObject = function(ref) {
  return this.objects[ref];
};


/**
 * Retrieve a string by its reference table index.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @param {number} ref
 * @return {string}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.getString = function(ref) {
  return org.apache.royale.utils.Language.string(this.strings[ref]);
};


/**
 * @package
 * @type {Array}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.traits;


/**
 * @package
 * @type {Array}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.objects;


/**
 * @package
 * @type {Array}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.strings;


/**
 * @type {mx.logging.ILogger}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.log;


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AMFXContext', qName: 'mx.messaging.channels.amfx.AMFXContext', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'log': { type: 'mx.logging.ILogger', get_set: function (/** mx.messaging.channels.amfx.AMFXContext */ inst, /** * */ v) {return v !== undefined ? inst.log = v : inst.log;}}
      };
    },
    methods: function () {
      return {
        'AMFXContext': { type: '', declaredBy: 'mx.messaging.channels.amfx.AMFXContext'},
        'reset': { type: 'void', declaredBy: 'mx.messaging.channels.amfx.AMFXContext'},
        'findTraitInfo': { type: 'int', declaredBy: 'mx.messaging.channels.amfx.AMFXContext', parameters: function () { return [ 'Object', false ]; }},
        'findObject': { type: 'int', declaredBy: 'mx.messaging.channels.amfx.AMFXContext', parameters: function () { return [ 'Object', false ]; }},
        'findString': { type: 'int', declaredBy: 'mx.messaging.channels.amfx.AMFXContext', parameters: function () { return [ 'String', false ]; }},
        'addTraitInfo': { type: 'void', declaredBy: 'mx.messaging.channels.amfx.AMFXContext', parameters: function () { return [ 'Object', false ]; }},
        'addObject': { type: 'void', declaredBy: 'mx.messaging.channels.amfx.AMFXContext', parameters: function () { return [ 'Object', false ]; }},
        'addString': { type: 'void', declaredBy: 'mx.messaging.channels.amfx.AMFXContext', parameters: function () { return [ 'String', false ]; }},
        'getTraitInfo': { type: '*', declaredBy: 'mx.messaging.channels.amfx.AMFXContext', parameters: function () { return [ 'uint', false ]; }},
        'getObject': { type: '*', declaredBy: 'mx.messaging.channels.amfx.AMFXContext', parameters: function () { return [ 'uint', false ]; }},
        'getString': { type: 'String', declaredBy: 'mx.messaging.channels.amfx.AMFXContext', parameters: function () { return [ 'uint', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.messaging.channels.amfx.AMFXContext.prototype.ROYALE_COMPILE_FLAGS = 10;