/**
 * Generated by Apache Royale Compiler from mx/messaging/channels/amfx/AMFXEncoder.as
 * mx.messaging.channels.amfx.AMFXEncoder
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.messaging.channels.amfx.AMFXEncoder');
/* Royale Static Dependency List: org.apache.royale.utils.Language,XML*/

goog.require('Namespace');
goog.require('XML');
goog.require('mx.logging.Log');
goog.require('mx.messaging.channels.amfx.AMFXContext');
goog.require('mx.utils.ByteArray');
goog.require('mx.utils.HexEncoder');
goog.require('mx.utils.ObjectUtil');
goog.require('org.apache.royale.utils.net.IExternalizable');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 */
mx.messaging.channels.amfx.AMFXEncoder = function() {
  ;
  this.mx_messaging_channels_amfx_AMFXEncoder_settings = {};
  this.mx_messaging_channels_amfx_AMFXEncoder_settings.prettyPrinting = false;
};


/**
 * @param {Object} obj
 * @param {Array=} headers
 * @return {XML}
 */
mx.messaging.channels.amfx.AMFXEncoder.prototype.encode = function(obj, headers) {
  headers = typeof headers !== 'undefined' ? headers : null;
  XML.setSettings(this.mx_messaging_channels_amfx_AMFXEncoder_settings);
  var /** @type {XML} */ xml = new XML("<amfx />");
  xml.setNamespace(mx.messaging.channels.amfx.AMFXEncoder.NAMESPACE);
  xml.setAttribute("ver", mx.messaging.channels.amfx.AMFXEncoder.CURRENT_VERSION);
  var /** @type {mx.messaging.channels.amfx.AMFXContext} */ context = new mx.messaging.channels.amfx.AMFXContext();
  context.log = mx.logging.Log.getLogger("mx.messaging.channels.amfx.AMFXEncoder");
  mx.messaging.channels.amfx.AMFXEncoder.encodePacket(xml, obj, headers, context);
  return xml;
};


/**
 * @private
 * @param {XML} xml
 * @param {Object} obj
 * @param {Array=} headers
 * @param {mx.messaging.channels.amfx.AMFXContext=} context
 */
mx.messaging.channels.amfx.AMFXEncoder.encodePacket = function(xml, obj, headers, context) {
  headers = typeof headers !== 'undefined' ? headers : null;
  context = typeof context !== 'undefined' ? context : null;
  if (headers)
    mx.messaging.channels.amfx.AMFXEncoder.encodeHeaders(xml, headers, context);
  mx.messaging.channels.amfx.AMFXEncoder.encodeBody(xml, obj, context);
};


/**
 * @private
 * @param {XML} xml
 * @param {Array} headers
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeHeaders = function(xml, headers, context) {
  for (var /** @type {number} */ i = 0; i < headers.length; i++) {
    var /** @type {Object} */ header = headers[i];
    var /** @type {XML} */ element = new XML( '<header />');
    element.setAttribute("name", header.name);
    element.setAttribute("mustUnderstand", (header.mustUnderstand == true));
    mx.messaging.channels.amfx.AMFXEncoder.encodeValue(element, header.content, context);
    xml.appendChild(element);
  }
};


/**
 * @private
 * @param {XML} xml
 * @param {*} obj
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeBody = function(xml, obj, context) {
  var /** @type {XML} */ element = new XML( '<body />');
  mx.messaging.channels.amfx.AMFXEncoder.encodeValue(element, obj, context);
  xml.appendChild(element);
};


/**
 * @nocollapse
 * @param {XML} xml
 * @param {*} obj
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeValue = function(xml, obj, context) {
  if (obj != null) {
    if (org.apache.royale.utils.Language.is(obj, String)) {
      mx.messaging.channels.amfx.AMFXEncoder.encodeString(xml, String(obj), context);
    } else if (org.apache.royale.utils.Language.is(obj, Number)) {
      mx.messaging.channels.amfx.AMFXEncoder.encodeNumber(xml, Number(obj));
    } else if (org.apache.royale.utils.Language.is(obj, Boolean)) {
      mx.messaging.channels.amfx.AMFXEncoder.encodeBoolean(xml, Boolean(obj));
    } else if (org.apache.royale.utils.Language.is(obj, mx.utils.ByteArray)) {
      mx.messaging.channels.amfx.AMFXEncoder.encodeByteArray(xml, org.apache.royale.utils.Language.as(obj, mx.utils.ByteArray, true));
    } else if (org.apache.royale.utils.Language.is(obj, Array)) {
      mx.messaging.channels.amfx.AMFXEncoder.encodeArray(xml, org.apache.royale.utils.Language.as(obj, Array), context);
    } else if (org.apache.royale.utils.Language.is(obj, Date)) {
      mx.messaging.channels.amfx.AMFXEncoder.encodeDate(xml, org.apache.royale.utils.Language.as(obj, Date), context);
    } else if (org.apache.royale.utils.Language.is(obj, org.apache.royale.utils.Language.synthType('Class'))) {
      if (context.log)
        context.log.warn("Cannot serialize type Class");
    } else {
      mx.messaging.channels.amfx.AMFXEncoder.encodeObject(xml, obj, context);
    }
  } else if (obj === undefined) {
    xml.appendChild(mx.messaging.channels.amfx.AMFXEncoder.X_UNDEFINED.copy());
  } else {
    xml.appendChild(mx.messaging.channels.amfx.AMFXEncoder.X_NULL.copy());
  }
};


/**
 * @private
 * @param {XML} xml
 * @param {Array} array
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeArray = function(xml, array, context) {
  var /** @type {number} */ ref = context.findObject(array);
  var /** @type {XML} */ element;
  if (ref >= 0) {
    element = new XML( '<ref />');
    element.setAttribute("id", String(ref));
  } else {
    mx.messaging.channels.amfx.AMFXEncoder.rememberObject(context, array);
    element = new XML( '<array />');
    var /** @type {Object} */ named = {};
    var /** @type {Array} */ ordinal = [];
    var /** @type {boolean} */ isECMAArray = false;
    for (var /** @type {string} */ member in array) {
      if (isNaN(Number(member))) {
        named[member] = array[member];
        isECMAArray = true;
      } else {
        var /** @type {number} */ num = (parseInt(member, 0)) >> 0;
        ordinal[num] = array[num];
      }
    }
    for (var /** @type {string} */ n in named) {
      mx.messaging.channels.amfx.AMFXEncoder.encodeArrayItem(element, n, named[n], context);
    }
    var /** @type {number} */ ordinalLength = 0;
    var /** @type {boolean} */ dense = true;
    for (var /** @type {number} */ i = 0; i < ordinal.length; i++) {
      var /** @type {*} */ o = ordinal[i];
      if (o !== undefined) {
        if (dense) {
          mx.messaging.channels.amfx.AMFXEncoder.encodeValue(element, o, context);
          ordinalLength++;
        } else {
          isECMAArray = true;
          mx.messaging.channels.amfx.AMFXEncoder.encodeArrayItem(element, String(i), o, context);
        }
      } else {
        dense = false;
      }
    }
    element.setAttribute("length", String(ordinalLength));
    if (isECMAArray) {
      element.setAttribute("ecma", "true");
    }
  }
  xml.appendChild(element);
};


/**
 * @private
 * @param {XML} xml
 * @param {string} name
 * @param {*} value
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeArrayItem = function(xml, name, value, context) {
  var /** @type {XML} */ item = new XML( '<item />');
  item.setAttribute("name", name);
  mx.messaging.channels.amfx.AMFXEncoder.encodeValue(item, value, context);
  xml.appendChild(item);
};


/**
 * @private
 * @param {XML} xml
 * @param {boolean} bool
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeBoolean = function(xml, bool) {
  if (bool)
    xml.appendChild(mx.messaging.channels.amfx.AMFXEncoder.X_TRUE.copy());
  else
    xml.appendChild(mx.messaging.channels.amfx.AMFXEncoder.X_FALSE.copy());
};


/**
 * @private
 * @param {XML} xml
 * @param {mx.utils.ByteArray} obj
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeByteArray = function(xml, obj) {
  var /** @type {XML} */ element = new XML( '<bytearray/>');
  var /** @type {mx.utils.HexEncoder} */ encoder = new mx.utils.HexEncoder();
  encoder.encode(obj);
  var /** @type {string} */ encoded = encoder.flush();
  element.appendChild(encoded);
  xml.appendChild(element);
};


/**
 * @private
 * @param {XML} xml
 * @param {Date} date
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeDate = function(xml, date, context) {
  var /** @type {number} */ ref = context.findObject(date);
  var /** @type {XML} */ element;
  if (ref >= 0) {
    element = new XML( '<ref />');
    element.setAttribute("id", String(ref));
  } else {
    mx.messaging.channels.amfx.AMFXEncoder.rememberObject(context, date);
    element = new XML( '<date />');
    element.appendChild(new XML(date.getTime().toString()));
  }
  xml.appendChild(element);
};


/**
 * @private
 * @param {XML} xml
 * @param {number} num
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeNumber = function(xml, num) {
  var /** @type {XML} */ element = null;
  if (org.apache.royale.utils.Language.is(num, org.apache.royale.utils.Language.synthType('int')) || org.apache.royale.utils.Language.is(num, org.apache.royale.utils.Language.synthType('uint'))) {
    element = new XML( '<int />');
  } else {
    element = new XML( '<double />');
  }
  element.appendChild(new XML(num.toString()));
  xml.appendChild(element);
};


/**
 * @private
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 * @param {*} obj
 */
mx.messaging.channels.amfx.AMFXEncoder.rememberObject = function(context, obj) {
  context.addObject(obj);
};


/**
 * @private
 * @param {XML} xml
 * @param {*} obj
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeObject = function(xml, obj, context) {
  var /** @type {number} */ ref = context.findObject(obj);
  var /** @type {XML} */ element;
  if (ref >= 0) {
    element = new XML( '<ref />');
    element.setAttribute("id", String(ref));
  } else {
    mx.messaging.channels.amfx.AMFXEncoder.rememberObject(context, obj);
    element = new XML( '<object />');
    var /** @type {Object} */ classInfo = mx.utils.ObjectUtil.getClassInfo(obj, null, mx.messaging.channels.amfx.AMFXEncoder.CLASS_INFO_OPTIONS);
    var /** @type {string} */ className = org.apache.royale.utils.Language.string(classInfo.name);
    var /** @type {string} */ classAlias = org.apache.royale.utils.Language.string(classInfo.alias);
    var /** @type {Array} */ properties = classInfo.properties;
    var /** @type {number} */ count = (properties.length) >>> 0;
    var /** @type {string} */ remoteClassName = ((classAlias != null) ? classAlias : className);
    if (remoteClassName && remoteClassName != "Object" && remoteClassName != "Array") {
      element.setAttribute("type", remoteClassName.replace(mx.messaging.channels.amfx.AMFXEncoder.REGEX_CLASSNAME, "."));
    }
    if (org.apache.royale.utils.Language.is(obj, org.apache.royale.utils.net.IExternalizable)) {
      classInfo.externalizable = true;
      mx.messaging.channels.amfx.AMFXEncoder.encodeTraits(element, classInfo, context);
      var /** @type {org.apache.royale.utils.net.IExternalizable} */ ext = org.apache.royale.utils.Language.as(obj, org.apache.royale.utils.net.IExternalizable, true);
      var /** @type {mx.utils.ByteArray} */ ba = new mx.utils.ByteArray();
      ext.writeExternal(ba);
      mx.messaging.channels.amfx.AMFXEncoder.encodeByteArray(element, ba);
    } else {
      classInfo.externalizable = false;
      mx.messaging.channels.amfx.AMFXEncoder.encodeTraits(element, classInfo, context);
      for (var /** @type {number} */ i = 0; i < count; i++) {
        var /** @type {string} */ prop = org.apache.royale.utils.Language.string(properties[i]);
        mx.messaging.channels.amfx.AMFXEncoder.encodeValue(element, obj[prop], context);
      }
    }
  }
  xml.appendChild(element);
};


/**
 * @private
 * @param {XML} xml
 * @param {string} str
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 * @param {boolean=} isTrait
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeString = function(xml, str, context, isTrait) {
  isTrait = typeof isTrait !== 'undefined' ? isTrait : false;
  var /** @type {number} */ ref = context.findString(str);
  var /** @type {XML} */ element = new XML( '<string />');
  if (ref >= 0) {
    element.setAttribute("id", String(ref));
  } else {
    context.addString(str);
    if (str.length > 0) {
      if (!isTrait)
        str = mx.messaging.channels.amfx.AMFXEncoder.escapeXMLString(str);
      var /** @type {XML} */ x = new XML(str);
      element.appendChild(x);
    }
  }
  xml.appendChild(element);
};


/**
 * @private
 * @param {XML} xml
 * @param {Object} classInfo
 * @param {mx.messaging.channels.amfx.AMFXContext} context
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeTraits = function(xml, classInfo, context) {
  var /** @type {XML} */ element = new XML( '<traits />');
  var /** @type {number} */ ref = context.findTraitInfo(classInfo);
  if (ref >= 0) {
    element.setAttribute("id", String(ref));
  } else {
    context.addTraitInfo(classInfo);
    if (classInfo.externalizable) {
      element.setAttribute("externalizable", "true");
    } else {
      var /** @type {Array} */ properties = classInfo.properties;
      if (properties != null) {
        var /** @type {number} */ count = (properties.length) >>> 0;
        for (var /** @type {number} */ i = 0; i < count; i++) {
          var /** @type {string} */ prop = org.apache.royale.utils.Language.string(properties[i]);
          mx.messaging.channels.amfx.AMFXEncoder.encodeString(element, prop, context, true);
        }
      }
    }
  }
  xml.appendChild(element);
};


/**
 * @private
 * @param {XML} xml
 * @param {Object} xmlObject
 */
mx.messaging.channels.amfx.AMFXEncoder.encodeXML = function(xml, xmlObject) {
  var /** @type {XML} */ element = new XML( '<xml />');
  var /** @type {string} */ str;
  if (org.apache.royale.utils.Language.is(xmlObject, XML))
    str = XML.conversion(xmlObject).toXMLString();
  else
    str = xmlObject.toString();
  if (str.length > 0) {
    str = mx.messaging.channels.amfx.AMFXEncoder.escapeXMLString(str);
    var /** @type {XML} */ x = new XML(str);
    element.appendChild(x);
  }
  xml.appendChild(element);
};


/**
 * @private
 * @param {string} str
 * @return {string}
 */
mx.messaging.channels.amfx.AMFXEncoder.escapeXMLString = function(str) {
  if (str.length > 0) {
    if ((str.indexOf("<") != -1) || (str.indexOf("&") != -1)) {
      if (str.indexOf("]]>") != -1) {
        str = str.replace(mx.messaging.channels.amfx.AMFXEncoder.REGEX_CLOSE_CDATA, "]]&gt;");
      }
      str = "<![CDATA[" + str + "]]>";
    }
  }
  return str;
};


/**
 * @private
 * @type {Object}
 */
mx.messaging.channels.amfx.AMFXEncoder.prototype.mx_messaging_channels_amfx_AMFXEncoder_settings;


/**
 * @nocollapse
 * @const
 * @type {number}
 */
mx.messaging.channels.amfx.AMFXEncoder.CURRENT_VERSION = 3;


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.messaging.channels.amfx.AMFXEncoder.NAMESPACE_URI = "http://www.macromedia.com/2005/amfx";


mx.messaging.channels.amfx.AMFXEncoder.get__NAMESPACE = function() {
  var value = new Namespace("", mx.messaging.channels.amfx.AMFXEncoder.NAMESPACE_URI);
  Object.defineProperties(mx.messaging.channels.amfx.AMFXEncoder, { NAMESPACE: { value: value, writable: false }});
  return value;
};
/**
 * @nocollapse
 * @const
 * @type {Namespace}
 */
mx.messaging.channels.amfx.AMFXEncoder.NAMESPACE;

Object.defineProperties(mx.messaging.channels.amfx.AMFXEncoder, /** @lends {mx.messaging.channels.amfx.AMFXEncoder} */ {
/**
 * @nocollapse
 * @const
 * @type {Namespace}
 */
NAMESPACE: {
  get: mx.messaging.channels.amfx.AMFXEncoder.get__NAMESPACE,
  configurable: true}});


/**
 * @private
 * @const
 * @type {RegExp}
 */
mx.messaging.channels.amfx.AMFXEncoder.REGEX_CLASSNAME = new RegExp("\\:\\:", "g");


/**
 * @private
 * @const
 * @type {RegExp}
 */
mx.messaging.channels.amfx.AMFXEncoder.REGEX_CLOSE_CDATA = new RegExp("]]>", "g");


/**
 * @private
 * @const
 * @type {Object}
 */
mx.messaging.channels.amfx.AMFXEncoder.CLASS_INFO_OPTIONS = {includeReadOnly:false, includeTransient:false};


/**
 * @private
 * @const
 * @type {XML}
 */
mx.messaging.channels.amfx.AMFXEncoder.X_FALSE = new XML( '<false />');


/**
 * @private
 * @const
 * @type {XML}
 */
mx.messaging.channels.amfx.AMFXEncoder.X_NULL = new XML( '<null />');


/**
 * @private
 * @const
 * @type {XML}
 */
mx.messaging.channels.amfx.AMFXEncoder.X_TRUE = new XML( '<true />');


/**
 * @private
 * @const
 * @type {XML}
 */
mx.messaging.channels.amfx.AMFXEncoder.X_UNDEFINED = new XML( '<undefined />');


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.messaging.channels.amfx.AMFXEncoder.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'AMFXEncoder', qName: 'mx.messaging.channels.amfx.AMFXEncoder', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.messaging.channels.amfx.AMFXEncoder.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        'AMFXEncoder': { type: '', declaredBy: 'mx.messaging.channels.amfx.AMFXEncoder'},
        'encode': { type: 'XML', declaredBy: 'mx.messaging.channels.amfx.AMFXEncoder', parameters: function () { return [ 'Object', false ,'Array', true ]; }},
        '|encodeValue': { type: 'void', declaredBy: 'mx.messaging.channels.amfx.AMFXEncoder', parameters: function () { return [ 'XML', false ,'*', false ,'mx.messaging.channels.amfx.AMFXContext', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.messaging.channels.amfx.AMFXEncoder.prototype.ROYALE_COMPILE_FLAGS = 10;