/**
 * Generated by Apache Royale Compiler from mx/messaging/events/MessageFaultEvent.as
 * mx.messaging.events.MessageFaultEvent
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.messaging.events.MessageFaultEvent');

goog.require('mx.messaging.messages.ErrorMessage');
goog.require('org.apache.royale.events.Event');
goog.require('XML');



/**
 *  Constructs an instance of a fault message event for the specified message
 *  and fault information.
 * 
 *  @asparam type The type for the MessageAckEvent.
 * 
 *  @asparam bubbles Specifies whether the event can bubble up the display 
 *  list hierarchy.
 * 
 *  @asparam cancelable Indicates whether the behavior associated with the 
 *  event can be prevented.
 * 
 *  @asparam message The ErrorMessage associated with the fault.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @constructor
 * @extends {org.apache.royale.events.Event}
 * @param {string} type
 * @param {boolean=} bubbles
 * @param {boolean=} cancelable
 * @param {mx.messaging.messages.ErrorMessage=} message
 */
mx.messaging.events.MessageFaultEvent = function(type, bubbles, cancelable, message) {
  bubbles = typeof bubbles !== 'undefined' ? bubbles : false;
  cancelable = typeof cancelable !== 'undefined' ? cancelable : false;
  message = typeof message !== 'undefined' ? message : null;
  mx.messaging.events.MessageFaultEvent.base(this, 'constructor', type, bubbles, cancelable);
  this.message = message;
};
goog.inherits(mx.messaging.events.MessageFaultEvent, org.apache.royale.events.Event);


/**
 * @nocollapse
 * @const
 * @type {string}
 */
mx.messaging.events.MessageFaultEvent.FAULT = "fault";


/**
 *  Utility method to create a new MessageFaultEvent that doesn't bubble and
 *  is not cancelable.
 * 
 *  @asparam message The ErrorMessage associated with the fault.
 * 
 *  @asreturn New MessageFaultEvent.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @nocollapse
 * @param {mx.messaging.messages.ErrorMessage} msg
 * @return {mx.messaging.events.MessageFaultEvent}
 */
mx.messaging.events.MessageFaultEvent.createEvent = function(msg) {
  return new mx.messaging.events.MessageFaultEvent(mx.messaging.events.MessageFaultEvent.FAULT, false, false, msg);
};


/**
 * @type {mx.messaging.messages.ErrorMessage}
 */
mx.messaging.events.MessageFaultEvent.prototype.message;


/**
 *  Clones the MessageFaultEvent.
 *
 *  @asreturn Copy of this MessageFaultEvent.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @return {org.apache.royale.events.Event}
 */
mx.messaging.events.MessageFaultEvent.prototype.clone = function() {
  return new mx.messaging.events.MessageFaultEvent(this.type, this.bubbles, this.cancelable, this.message);
};


/**
 *  Returns a string representation of the MessageFaultEvent.
 *
 *  @asreturn String representation of the MessageFaultEvent.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion BlazeDS 4
 *  @productversion LCDS 3 
 * @return {string}
 */
mx.messaging.events.MessageFaultEvent.prototype.toString = function() {
  return this.formatToString("MessageFaultEvent", "faultCode", "faultDetail", "faultString", "rootCause", "type", "bubbles", "cancelable", "eventPhase");
};


/**
 * @override
 */
mx.messaging.events.MessageFaultEvent.prototype.formatToString = function(className, args) {
  args = Array.prototype.slice.call(arguments, 1);
  var foreachiter0_target = args;
  for (var foreachiter0 in foreachiter0_target) 
  {
  var s = foreachiter0_target[foreachiter0];
  
    className += " " + s;}
  
  return className;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.messaging.events.MessageFaultEvent.prototype.faultCode;


mx.messaging.events.MessageFaultEvent.prototype.get__faultCode = function() {
  return this.message.faultCode;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.messaging.events.MessageFaultEvent.prototype.faultDetail;


mx.messaging.events.MessageFaultEvent.prototype.get__faultDetail = function() {
  return this.message.faultDetail;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.messaging.events.MessageFaultEvent.prototype.faultString;


mx.messaging.events.MessageFaultEvent.prototype.get__faultString = function() {
  return this.message.faultString;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.messaging.events.MessageFaultEvent.prototype.rootCause;


mx.messaging.events.MessageFaultEvent.prototype.get__rootCause = function() {
  return this.message.rootCause;
};


Object.defineProperties(mx.messaging.events.MessageFaultEvent.prototype, /** @lends {mx.messaging.events.MessageFaultEvent.prototype} */ {
/**
 * @type {string}
 */
faultCode: {
get: mx.messaging.events.MessageFaultEvent.prototype.get__faultCode},
/**
 * @type {string}
 */
faultDetail: {
get: mx.messaging.events.MessageFaultEvent.prototype.get__faultDetail},
/**
 * @type {string}
 */
faultString: {
get: mx.messaging.events.MessageFaultEvent.prototype.get__faultString},
/**
 * @type {Object}
 */
rootCause: {
get: mx.messaging.events.MessageFaultEvent.prototype.get__rootCause}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.messaging.events.MessageFaultEvent.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'MessageFaultEvent', qName: 'mx.messaging.events.MessageFaultEvent', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.messaging.events.MessageFaultEvent.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'message': { type: 'mx.messaging.messages.ErrorMessage', get_set: function (/** mx.messaging.events.MessageFaultEvent */ inst, /** * */ v) {return v !== undefined ? inst.message = v : inst.message;}}
      };
    },
    accessors: function () {
      return {
        'faultCode': { type: 'String', access: 'readonly', declaredBy: 'mx.messaging.events.MessageFaultEvent'},
        'faultDetail': { type: 'String', access: 'readonly', declaredBy: 'mx.messaging.events.MessageFaultEvent'},
        'faultString': { type: 'String', access: 'readonly', declaredBy: 'mx.messaging.events.MessageFaultEvent'},
        'rootCause': { type: 'Object', access: 'readonly', declaredBy: 'mx.messaging.events.MessageFaultEvent'}
      };
    },
    methods: function () {
      return {
        '|createEvent': { type: 'mx.messaging.events.MessageFaultEvent', declaredBy: 'mx.messaging.events.MessageFaultEvent', parameters: function () { return [ 'mx.messaging.messages.ErrorMessage', false ]; }},
        'MessageFaultEvent': { type: '', declaredBy: 'mx.messaging.events.MessageFaultEvent', parameters: function () { return [ 'String', false ,'Boolean', true ,'Boolean', true ,'mx.messaging.messages.ErrorMessage', true ]; }},
        'clone': { type: 'org.apache.royale.events.Event', declaredBy: 'mx.messaging.events.MessageFaultEvent'},
        'toString': { type: 'String', declaredBy: 'mx.messaging.events.MessageFaultEvent'},
        'formatToString': { type: 'String', declaredBy: 'mx.messaging.events.MessageFaultEvent', parameters: function () { return [ 'String', false ,'Array', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.messaging.events.MessageFaultEvent.prototype.ROYALE_COMPILE_FLAGS = 10;