/**
 * Generated by Apache Royale Compiler from mx/net/FileReference.as
 * mx.net.FileReference
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.net.FileReference');

goog.require('mx.net.FileFilter');
goog.require('mx.net.beads.FileUploaderUsingFormData');
goog.require('mx.net.supportClasses.ByteArrayFileLoader');
goog.require('mx.utils.ByteArray');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.file.FileProxy');
goog.require('org.apache.royale.file.beads.FileBrowserWithFilter');
goog.require('org.apache.royale.file.beads.FileLoader');
goog.require('org.apache.royale.file.beads.FileLoaderAndUploader');
goog.require('org.apache.royale.file.beads.FileModel');
goog.require('org.apache.royale.file.beads.FileUploader');
goog.require('org.apache.royale.net.URLRequest');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 * @constructor
 * @extends {org.apache.royale.file.FileProxy}
 */
mx.net.FileReference = function() {
  mx.net.FileReference.base(this, 'constructor');
  this.mx_net_FileReference__model = new org.apache.royale.file.beads.FileModel();
  this.mx_net_FileReference__browser = new org.apache.royale.file.beads.FileBrowserWithFilter();
  this.mx_net_FileReference__uploader = new org.apache.royale.file.beads.FileLoaderAndUploader();
  this.addBead(new mx.net.beads.FileUploaderUsingFormData());
  this.addBead(this.mx_net_FileReference__model);
  this.addBead(this.mx_net_FileReference__browser);
  this.addBead(this.mx_net_FileReference__uploader);
  var /** @type {org.apache.royale.file.beads.FileUploader} */ uploadBead = org.apache.royale.utils.Language.as(this.getBeadByType(org.apache.royale.file.beads.FileUploader), org.apache.royale.file.beads.FileUploader);
  uploadBead.contentType = "multipart/form-data";
  this.addEventListener("modelChanged", org.apache.royale.utils.Language.closure(this.mx_net_FileReference_modelChangedHandler, this, 'mx_net_FileReference_modelChangedHandler'));
};
goog.inherits(mx.net.FileReference, org.apache.royale.file.FileProxy);


/**
 * @private
 * @type {org.apache.royale.file.beads.FileModel}
 */
mx.net.FileReference.prototype.mx_net_FileReference__model;


/**
 * @private
 * @type {org.apache.royale.file.beads.FileBrowserWithFilter}
 */
mx.net.FileReference.prototype.mx_net_FileReference__browser;


/**
 * @private
 * @type {org.apache.royale.file.beads.FileLoader}
 */
mx.net.FileReference.prototype.mx_net_FileReference__loader;


/**
 * @private
 * @type {org.apache.royale.file.beads.FileLoaderAndUploader}
 */
mx.net.FileReference.prototype.mx_net_FileReference__uploader;


/**
 * @param {Array=} typeFilter
 * @return {boolean}
 */
mx.net.FileReference.prototype.browse = function(typeFilter) {
  typeFilter = typeof typeFilter !== 'undefined' ? typeFilter : null;
  var /** @type {Array} */ allFilters = [];
  if (typeFilter) {
    for (var /** @type {number} */ i = 0; i < typeFilter.length; i++) {
      var /** @type {mx.net.FileFilter} */ fileFilter = org.apache.royale.utils.Language.as(typeFilter[i], mx.net.FileFilter);
      var /** @type {Array} */ filters = fileFilter.extension.split(";");
      for (var /** @type {number} */ j = 0; j < filters.length; j++) {
        var /** @type {string} */ filter = org.apache.royale.utils.Language.string(filters[j]);
        if (filter.charAt(0) == '*') {
          filter = filter.substring(1);
          filters[j] = filter;
        }
      }
      allFilters = allFilters.concat(filters);
    }
    this.mx_net_FileReference__browser.filter = allFilters.join(",");
  }
  this.mx_net_FileReference__browser.browse();
  return true;
};


/**
 */
mx.net.FileReference.prototype.load = function() {
  if (!this.mx_net_FileReference__loader) {
    this.mx_net_FileReference__loader = org.apache.royale.utils.Language.as(this.getBeadByType(mx.net.supportClasses.ByteArrayFileLoader), org.apache.royale.file.beads.FileLoader);
    if (!this.mx_net_FileReference__loader) {
      this.mx_net_FileReference__loader = new mx.net.supportClasses.ByteArrayFileLoader();
      this.addBead(this.mx_net_FileReference__loader);
    }
  }
  this.mx_net_FileReference__loader.addEventListener(org.apache.royale.events.Event.COMPLETE, org.apache.royale.utils.Language.closure(this.loaderCompleteHandler, this, 'loaderCompleteHandler'));
  this.mx_net_FileReference__loader.load();
};


/**
 */
mx.net.FileReference.prototype.cancel = function() {
  this.mx_net_FileReference__uploader.cancel();
};


/**
 * @param {org.apache.royale.events.Event} event
 */
mx.net.FileReference.prototype.loaderCompleteHandler = function(event) {
  this.dispatchEvent(new org.apache.royale.events.Event(org.apache.royale.events.Event.COMPLETE));
};


/**
 * @param {org.apache.royale.net.URLRequest} request
 * @param {string=} uploadDataFieldName
 * @param {boolean=} testUpload
 */
mx.net.FileReference.prototype.upload = function(request, uploadDataFieldName, testUpload) {
  uploadDataFieldName = typeof uploadDataFieldName !== 'undefined' ? uploadDataFieldName : "Filedata";
  testUpload = typeof testUpload !== 'undefined' ? testUpload : false;
  this.mx_net_FileReference__uploader.upload(request.url);
};


/**
 * @param {org.apache.royale.net.URLRequest} request
 * @param {string=} defaultFileName
 */
mx.net.FileReference.prototype.download = function(request, defaultFileName) {
  defaultFileName = typeof defaultFileName !== 'undefined' ? defaultFileName : null;
};


/**
 * @private
 * @param {org.apache.royale.events.Event} event
 */
mx.net.FileReference.prototype.mx_net_FileReference_modelChangedHandler = function(event) {
  this.dispatchEvent(new org.apache.royale.events.Event(org.apache.royale.events.Event.SELECT));
};


/**
 *  @royaleignorecoercion HTMLAnchorElement
 * @param {*} data
 * @param {string=} defaultFileName
 */
mx.net.FileReference.prototype.save = function(data, defaultFileName) {
  defaultFileName = typeof defaultFileName !== 'undefined' ? defaultFileName : null;
  var /** @type {HTMLAnchorElement} */ a = document.createElement("a");
  a.href = URL.createObjectURL(new Blob([data]));
  if (defaultFileName == null) {
    a.setAttribute("download", "download.pdf");
    a.text = "download.pdf";
  } else {
    a.setAttribute("download", defaultFileName);
    a.text = defaultFileName;
  }
  document.body.appendChild(a);
  a.click();
  document.body.removeChild(a);
};


/**
 * @nocollapse
 * @export
 * @type {mx.utils.ByteArray}
 */
mx.net.FileReference.prototype.data;


mx.net.FileReference.prototype.get__data = function() {
  return org.apache.royale.utils.Language.as(this.blob, mx.utils.ByteArray);
};


Object.defineProperties(mx.net.FileReference.prototype, /** @lends {mx.net.FileReference.prototype} */ {
/**
 * @type {mx.utils.ByteArray}
 */
data: {
get: mx.net.FileReference.prototype.get__data}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.net.FileReference.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'FileReference', qName: 'mx.net.FileReference', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.net.FileReference.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'data': { type: 'mx.utils.ByteArray', access: 'readonly', declaredBy: 'mx.net.FileReference'}
      };
    },
    methods: function () {
      return {
        'FileReference': { type: '', declaredBy: 'mx.net.FileReference'},
        'browse': { type: 'Boolean', declaredBy: 'mx.net.FileReference', parameters: function () { return [ 'Array', true ]; }},
        'load': { type: 'void', declaredBy: 'mx.net.FileReference'},
        'cancel': { type: 'void', declaredBy: 'mx.net.FileReference'},
        'loaderCompleteHandler': { type: 'void', declaredBy: 'mx.net.FileReference', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }},
        'upload': { type: 'void', declaredBy: 'mx.net.FileReference', parameters: function () { return [ 'org.apache.royale.net.URLRequest', false ,'String', true ,'Boolean', true ]; }},
        'download': { type: 'void', declaredBy: 'mx.net.FileReference', parameters: function () { return [ 'org.apache.royale.net.URLRequest', false ,'String', true ]; }},
        'save': { type: 'void', declaredBy: 'mx.net.FileReference', parameters: function () { return [ '*', false ,'String', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.net.FileReference.prototype.ROYALE_COMPILE_FLAGS = 10;