/**
 * Generated by Apache Royale Compiler from mx/net/SharedObject.as
 * mx.net.SharedObject
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.net.SharedObject');

goog.require('mx.events.NetStatusEvent');
goog.require('mx.net.SharedObjectFlushStatus');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.net.remoting.amf.AMFBinaryData');
goog.require('XML');



/**
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 */
mx.net.SharedObject = function() {
  mx.net.SharedObject.base(this, 'constructor');
  if (!mx.net.SharedObject.unlocked)
    throw new Error('ArgumentError: Error #2012: SharedObject class cannot be instantiated.');
};
goog.inherits(mx.net.SharedObject, org.apache.royale.events.EventDispatcher);


/**
 * @private
 * @const
 * @type {Object}
 */
mx.net.SharedObject.map = {};


/**
 * @private
 * @type {boolean}
 */
mx.net.SharedObject.unlocked;


/**
 * @type {number}
 */
mx.net.SharedObject.prototype._size = 0;


/**
 * @nocollapse
 * @param {string} name
 * @param {string=} localPath
 * @param {boolean=} secure
 * @return {mx.net.SharedObject}
 */
mx.net.SharedObject.getLocal = function(name, localPath, secure) {
  localPath = typeof localPath !== 'undefined' ? localPath : null;
  secure = typeof secure !== 'undefined' ? secure : false;
  var /** @type {string} */ pathKey = localPath == null ? '$null$' : localPath;
  localPath = pathKey;
  var /** @type {mx.net.SharedObject} */ cached = mx.net.SharedObject.map[pathKey + '::' + name];
  if (!cached) {
    mx.net.SharedObject.unlocked = true;
    cached = new mx.net.SharedObject();
    mx.net.SharedObject.unlocked = false;
    mx.net.SharedObject.map[pathKey + '::' + name] = cached;
    cached.mx_net_SharedObject_setName(name);
    cached.mx_net_SharedObject_setLocalPath(localPath);
    cached.mx_net_SharedObject_createSO(secure);
  }
  if (!mx.net.SharedObject.map['#']) {
    window.addEventListener('pagehide', mx.net.SharedObject.unloadHandler);
    mx.net.SharedObject.map['#'] = true;
  }
  return cached;
};


/**
 * @private
 * @param {PageTransitionEvent} event
 */
mx.net.SharedObject.unloadHandler = function(event) {
  for (var /** @type {string} */ key in mx.net.SharedObject.map) {
    if (key != '#') {
      var /** @type {mx.net.SharedObject} */ so = mx.net.SharedObject.map[key];
      so.flush();
    }
  }
};


/**
 * @private
 * @type {Storage}
 */
mx.net.SharedObject.prototype.mx_net_SharedObject__ls;


/**
 *
 * @asparam minDiskSpace ignored for javascript targets
 * @asreturn a string indicating the flush status. This can be (on swf) SharedObjectFlushStatus.FLUSHED or SharedObjectFlushStatus.PENDING on swf. For JS is it SharedObjectFlushStatus.FLUSHED or SharedObjectFlushStatus.FAILED
 *
 * @throws Error #2044: Unhandled NetStatusEvent
 * @param {number=} minDiskSpace
 * @return {string}
 */
mx.net.SharedObject.prototype.flush = function(minDiskSpace) {
  minDiskSpace = typeof minDiskSpace !== 'undefined' ? minDiskSpace : 0;
  if (this.mx_net_SharedObject__data) {
    try {
      var /** @type {org.apache.royale.net.remoting.amf.AMFBinaryData} */ amf = new org.apache.royale.net.remoting.amf.AMFBinaryData();
      amf.writeObject(this.mx_net_SharedObject__data);
      var /** @type {string} */ base64 = org.apache.royale.utils.Language.string(window['btoa'](String.fromCharCode.apply(null, amf.array)));
      this.mx_net_SharedObject__ls.setItem(this.mx_net_SharedObject__localPath + "::" + this.mx_net_SharedObject__name, base64);
    } catch (e) {
      if (this.hasEventListener(mx.events.NetStatusEvent.NET_STATUS)) {
        var /** @type {mx.events.NetStatusEvent} */ event = new mx.events.NetStatusEvent(mx.events.NetStatusEvent.NET_STATUS);
        event.info = {"code":"SharedObject.Flush.Failed", "level":"error"};
        this.dispatchEvent(event);
        return mx.net.SharedObjectFlushStatus.FAILED;
      } else {
        throw new Error('Error #2044: Unhandled NetStatusEvent:. level=error, code=SharedObject.Flush.Failed');
      }
    }
  }
  return mx.net.SharedObjectFlushStatus.FLUSHED;
  
};


/**
 */
mx.net.SharedObject.prototype.clear = function() {
  
  if (this.mx_net_SharedObject__data) {
    if (this.mx_net_SharedObject__ls) {
      this.mx_net_SharedObject__ls.removeItem(this.mx_net_SharedObject__localPath + "::" + this.mx_net_SharedObject__name);
    }
    this.mx_net_SharedObject__data = null;
  }
};


/**
 * @private
 * @type {Object}
 */
mx.net.SharedObject.prototype.mx_net_SharedObject__data;


/**
 * @private
 * @type {string}
 */
mx.net.SharedObject.prototype.mx_net_SharedObject__name;


/**
 * @private
 * @param {string} name
 */
mx.net.SharedObject.prototype.mx_net_SharedObject_setName = function(name) {
  if (/[~%&\\;:"',<>?#\s]/.test(name))
    throw new Error('Error #2134: Cannot create SharedObject.');
  this.mx_net_SharedObject__name = name;
};


/**
 * @private
 * @type {string}
 */
mx.net.SharedObject.prototype.mx_net_SharedObject__localPath;


/**
 * @private
 * @param {string} localPath
 */
mx.net.SharedObject.prototype.mx_net_SharedObject_setLocalPath = function(localPath) {
  this.mx_net_SharedObject__localPath = localPath;
};


/**
 * @private
 * @param {boolean} secure
 */
mx.net.SharedObject.prototype.mx_net_SharedObject_createSO = function(secure) {
  var self = this;
  
  this.mx_net_SharedObject__ls = window.localStorage;
  if (!this.mx_net_SharedObject__ls && typeof(Storage) != "undefined") {
    var /** @type {string} */ p = window.location.pathname.replace(/(^..)(:)/, "$1$$");
    window.location.href = window.location.protocol + "//127.0.0.1" + p;
    this.mx_net_SharedObject__ls = window.localStorage;
  }
  if (!this.mx_net_SharedObject__ls) {
    throw new Error('local storage not supported');
  }
  var /** @type {string} */ base64 = this.mx_net_SharedObject__ls.getItem(this.mx_net_SharedObject__localPath + "::" + this.mx_net_SharedObject__name);
  if (base64) {
    var /** @type {string} */ binary_string = org.apache.royale.utils.Language.string(window['atob'](base64));
    var /** @type {Uint8Array} */ arr = new Uint8Array(binary_string.split('').map(function(charStr) {
      return (charStr.charCodeAt(0)) >>> 0;
    }));
    var /** @type {org.apache.royale.net.remoting.amf.AMFBinaryData} */ amf = new org.apache.royale.net.remoting.amf.AMFBinaryData(arr.buffer);
    this.mx_net_SharedObject__data = amf.readObject();
  }
};


/**
 * @nocollapse
 * @export
 * @type {number}
 */
mx.net.SharedObject.prototype.size;


mx.net.SharedObject.prototype.get__size = function() {
  return this._size;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.net.SharedObject.prototype.data;


mx.net.SharedObject.prototype.get__data = function() {
  
  if (!this.mx_net_SharedObject__data) {
    this.mx_net_SharedObject__data = {};
  }
  return this.mx_net_SharedObject__data;
};


Object.defineProperties(mx.net.SharedObject.prototype, /** @lends {mx.net.SharedObject.prototype} */ {
/**
 * @type {number}
 */
size: {
get: mx.net.SharedObject.prototype.get__size},
/**
 * @type {Object}
 */
data: {
get: mx.net.SharedObject.prototype.get__data}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.net.SharedObject.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'SharedObject', qName: 'mx.net.SharedObject', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.net.SharedObject.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        '_size': { type: 'uint', get_set: function (/** mx.net.SharedObject */ inst, /** * */ v) {return v !== undefined ? inst._size = v : inst._size;}}
      };
    },
    accessors: function () {
      return {
        'size': { type: 'uint', access: 'readonly', declaredBy: 'mx.net.SharedObject'},
        'data': { type: 'Object', access: 'readonly', declaredBy: 'mx.net.SharedObject'}
      };
    },
    methods: function () {
      return {
        '|getLocal': { type: 'mx.net.SharedObject', declaredBy: 'mx.net.SharedObject', parameters: function () { return [ 'String', false ,'String', true ,'Boolean', true ]; }},
        'SharedObject': { type: '', declaredBy: 'mx.net.SharedObject'},
        'flush': { type: 'String', declaredBy: 'mx.net.SharedObject', parameters: function () { return [ 'int', true ]; }},
        'clear': { type: 'void', declaredBy: 'mx.net.SharedObject'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.net.SharedObject.prototype.ROYALE_COMPILE_FLAGS = 10;