/**
 * Generated by Apache Royale Compiler from mx/net/SharedObjectJSON.as
 * mx.net.SharedObjectJSON
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.net.SharedObjectJSON');

goog.require('mx.events.NetStatusEvent');
goog.require('mx.net.SharedObject');
goog.require('mx.net.SharedObjectFlushStatus');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('XML');



/**
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 */
mx.net.SharedObjectJSON = function() {
  mx.net.SharedObjectJSON.base(this, 'constructor');
  if (!mx.net.SharedObjectJSON.unlocked)
    throw new Error('ArgumentError: Error #2012: SharedObjectJSON class cannot be instantiated.');
};
goog.inherits(mx.net.SharedObjectJSON, org.apache.royale.events.EventDispatcher);


/**
 * @private
 * @const
 * @type {Object}
 */
mx.net.SharedObjectJSON.map = {};


/**
 * @private
 * @type {boolean}
 */
mx.net.SharedObjectJSON.unlocked;


/**
 * @nocollapse
 * @param {string} name
 * @param {string=} localPath
 * @param {boolean=} secure
 * @return {mx.net.SharedObjectJSON}
 */
mx.net.SharedObjectJSON.getLocal = function(name, localPath, secure) {
  localPath = typeof localPath !== 'undefined' ? localPath : null;
  secure = typeof secure !== 'undefined' ? secure : false;
  var /** @type {string} */ pathKey = localPath == null ? '$null$' : localPath;
  localPath = pathKey;
  var /** @type {mx.net.SharedObjectJSON} */ cached = mx.net.SharedObjectJSON.map[pathKey + '::' + name];
  if (!cached) {
    mx.net.SharedObjectJSON.unlocked = true;
    cached = new mx.net.SharedObjectJSON();
    mx.net.SharedObjectJSON.unlocked = false;
    mx.net.SharedObjectJSON.map[pathKey + '::' + name] = cached;
    cached.mx_net_SharedObjectJSON_setName(name);
    cached.mx_net_SharedObjectJSON_setLocalPath(localPath);
    cached.mx_net_SharedObjectJSON_createSO(secure);
  }
  if (!mx.net.SharedObjectJSON.map['#']) {
    window.addEventListener('pagehide', mx.net.SharedObjectJSON.unloadHandler);
    mx.net.SharedObjectJSON.map['#'] = true;
  }
  return cached;
};


/**
 * @private
 * @param {PageTransitionEvent} event
 */
mx.net.SharedObjectJSON.unloadHandler = function(event) {
  for (var /** @type {string} */ key in mx.net.SharedObjectJSON.map) {
    if (key != '#') {
      var /** @type {mx.net.SharedObject} */ so = mx.net.SharedObjectJSON.map[key];
      so.flush();
    }
  }
};


/**
 * @private
 * @type {Storage}
 */
mx.net.SharedObjectJSON.prototype.mx_net_SharedObjectJSON__ls;


/**
 *
 * @asparam minDiskSpace ignored for javascript targets
 * @asreturn a string indicating the flush status. This can be (on swf) SharedObjectFlushStatus.FLUSHED or SharedObjectFlushStatus.PENDING on swf. For JS is it SharedObjectFlushStatus.FLUSHED or SharedObjectFlushStatus.FAILED
 *
 * @throws Error #2044: Unhandled NetStatusEvent
 * @param {number=} minDiskSpace
 * @return {string}
 */
mx.net.SharedObjectJSON.prototype.flush = function(minDiskSpace) {
  minDiskSpace = typeof minDiskSpace !== 'undefined' ? minDiskSpace : 0;
  if (this.mx_net_SharedObjectJSON__data) {
    try {
      this.mx_net_SharedObjectJSON__ls.setItem(this.mx_net_SharedObjectJSON__localPath + "::" + this.mx_net_SharedObjectJSON__name, JSON.stringify(this.mx_net_SharedObjectJSON__data));
    } catch (e) {
      if (this.hasEventListener(mx.events.NetStatusEvent.NET_STATUS)) {
        var /** @type {mx.events.NetStatusEvent} */ event = new mx.events.NetStatusEvent(mx.events.NetStatusEvent.NET_STATUS);
        event.info = {"code":"SharedObject.Flush.Failed", "level":"error"};
        this.dispatchEvent(event);
        return mx.net.SharedObjectFlushStatus.FAILED;
      } else {
        throw new Error('Error #2044: Unhandled NetStatusEvent:. level=error, code=SharedObject.Flush.Failed');
      }
    }
  }
  return mx.net.SharedObjectFlushStatus.FLUSHED;
  
};


/**
 */
mx.net.SharedObjectJSON.prototype.clear = function() {
  
  if (this.mx_net_SharedObjectJSON__data) {
    if (this.mx_net_SharedObjectJSON__ls) {
      this.mx_net_SharedObjectJSON__ls.removeItem(this.mx_net_SharedObjectJSON__localPath + "::" + this.mx_net_SharedObjectJSON__name);
    }
    this.mx_net_SharedObjectJSON__data = null;
  }
};


/**
 * @private
 * @type {Object}
 */
mx.net.SharedObjectJSON.prototype.mx_net_SharedObjectJSON__data;


/**
 * @private
 * @type {string}
 */
mx.net.SharedObjectJSON.prototype.mx_net_SharedObjectJSON__name;


/**
 * @private
 * @param {string} name
 */
mx.net.SharedObjectJSON.prototype.mx_net_SharedObjectJSON_setName = function(name) {
  if (/[~%&\\;:"',<>?#\s]/.test(name))
    throw new Error('Error #2134: Cannot create SharedObjectJSON.');
  this.mx_net_SharedObjectJSON__name = name;
};


/**
 * @private
 * @type {string}
 */
mx.net.SharedObjectJSON.prototype.mx_net_SharedObjectJSON__localPath;


/**
 * @private
 * @param {string} localPath
 */
mx.net.SharedObjectJSON.prototype.mx_net_SharedObjectJSON_setLocalPath = function(localPath) {
  localPath += '$jsonContent$';
  this.mx_net_SharedObjectJSON__localPath = localPath;
};


/**
 * @private
 * @param {boolean} secure
 */
mx.net.SharedObjectJSON.prototype.mx_net_SharedObjectJSON_createSO = function(secure) {
  
  this.mx_net_SharedObjectJSON__ls = window.localStorage;
  if (!this.mx_net_SharedObjectJSON__ls && typeof(Storage) != "undefined") {
    var /** @type {string} */ p = window.location.pathname.replace(/(^..)(:)/, "$1$$");
    window.location.href = window.location.protocol + "//127.0.0.1" + p;
    this.mx_net_SharedObjectJSON__ls = window.localStorage;
  }
  if (!this.mx_net_SharedObjectJSON__ls) {
    throw new Error('local storage not supported');
  }
  var /** @type {string} */ json = this.mx_net_SharedObjectJSON__ls.getItem(this.mx_net_SharedObjectJSON__localPath + "::" + this.mx_net_SharedObjectJSON__name);
  if (json) {
    try {
      this.mx_net_SharedObjectJSON__data = JSON.parse(json);
    } catch (e) {
      throw new Error('Error #2134: Bad data. Cannot create SharedObjectJSON.');
    }
  }
};


/**
 * @return {Object}
 */
mx.net.SharedObjectJSON.prototype.toJSON = function() {
  return this.data;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.net.SharedObjectJSON.prototype.data;


mx.net.SharedObjectJSON.prototype.get__data = function() {
  
  if (!this.mx_net_SharedObjectJSON__data) {
    this.mx_net_SharedObjectJSON__data = {};
  }
  return this.mx_net_SharedObjectJSON__data;
};


Object.defineProperties(mx.net.SharedObjectJSON.prototype, /** @lends {mx.net.SharedObjectJSON.prototype} */ {
/**
 * @type {Object}
 */
data: {
get: mx.net.SharedObjectJSON.prototype.get__data}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.net.SharedObjectJSON.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'SharedObjectJSON', qName: 'mx.net.SharedObjectJSON', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.net.SharedObjectJSON.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'data': { type: 'Object', access: 'readonly', declaredBy: 'mx.net.SharedObjectJSON'}
      };
    },
    methods: function () {
      return {
        '|getLocal': { type: 'mx.net.SharedObjectJSON', declaredBy: 'mx.net.SharedObjectJSON', parameters: function () { return [ 'String', false ,'String', true ,'Boolean', true ]; }},
        'SharedObjectJSON': { type: '', declaredBy: 'mx.net.SharedObjectJSON'},
        'flush': { type: 'String', declaredBy: 'mx.net.SharedObjectJSON', parameters: function () { return [ 'int', true ]; }},
        'clear': { type: 'void', declaredBy: 'mx.net.SharedObjectJSON'},
        'toJSON': { type: 'Object', declaredBy: 'mx.net.SharedObjectJSON'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.net.SharedObjectJSON.prototype.ROYALE_COMPILE_FLAGS = 10;