/**
 * Generated by Apache Royale Compiler from mx/resources/Locale.as
 * mx.resources.Locale
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.resources.Locale');
goog.require('XML');



/**
 *  Constructor.
 *
 *  @asparam localeString A 1-, 2-, or 3-part locale String,
 *  such as <code>"en"</code>, <code>"en_US"</code>, or <code>"en_US_MAC"</code>.
 *  The parts are separated by underscore characters.
 *  The first part is a two-letter lowercase language code
 *  as defined by ISO-639, such as <code>"en"</code> for English.
 *  The second part is a two-letter uppercase country code
 *  as defined by ISO-3166, such as <code>"US"</code> for the United States.
 *  The third part is a variant String, which can be used 
 *  to optionally distinguish multiple locales for the same language and country.
 *  It is sometimes used to indicate the operating system
 *  that the locale should be used with, such as <code>"MAC"</code>, <code>"WIN"</code>, or <code>"UNIX"</code>.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @param {string} localeString
 */
mx.resources.Locale = function(localeString) {
  ;
  this.mx_resources_Locale_localeString = localeString;
  var /** @type {Array} */ parts = localeString.split("_");
  if (parts.length > 0)
    this.mx_resources_Locale__language = org.apache.royale.utils.Language.string(parts[0]);
  if (parts.length > 1)
    this.mx_resources_Locale__country = org.apache.royale.utils.Language.string(parts[1]);
  if (parts.length > 2)
    this.mx_resources_Locale__variant = parts.slice(2).join("_");
};


/**
 * @private
 * @type {mx.resources.Locale}
 */
mx.resources.Locale.currentLocale;


/**
 * @private
 * @type {string}
 */
mx.resources.Locale.prototype.mx_resources_Locale_localeString;


/**
 * @private
 * @type {string}
 */
mx.resources.Locale.prototype.mx_resources_Locale__language;


/**
 * @private
 * @type {string}
 */
mx.resources.Locale.prototype.mx_resources_Locale__country;


/**
 * @private
 * @type {string}
 */
mx.resources.Locale.prototype.mx_resources_Locale__variant;


/**
 *  Returns the locale String that was used to construct
 *  this Locale instance. For example:
 *
 *  <pre>
 *  var locale:Locale = new Locale("en_US_MAC");
 *  trace(locale.toString()); // outputs "en_US_MAC"
 *  </pre>
 *
 *  @asreturn Returns the locale String that was used to
 *  construct this Locale instance.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {string}
 */
mx.resources.Locale.prototype.toString = function() {
  return this.mx_resources_Locale_localeString;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.resources.Locale.prototype.language;


mx.resources.Locale.prototype.get__language = function() {
  return this.mx_resources_Locale__language;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.resources.Locale.prototype.country;


mx.resources.Locale.prototype.get__country = function() {
  return this.mx_resources_Locale__country;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.resources.Locale.prototype.variant;


mx.resources.Locale.prototype.get__variant = function() {
  return this.mx_resources_Locale__variant;
};


Object.defineProperties(mx.resources.Locale.prototype, /** @lends {mx.resources.Locale.prototype} */ {
/**
 * @type {string}
 */
language: {
get: mx.resources.Locale.prototype.get__language},
/**
 * @type {string}
 */
country: {
get: mx.resources.Locale.prototype.get__country},
/**
 * @type {string}
 */
variant: {
get: mx.resources.Locale.prototype.get__variant}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.resources.Locale.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Locale', qName: 'mx.resources.Locale', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.resources.Locale.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'language': { type: 'String', access: 'readonly', declaredBy: 'mx.resources.Locale'},
        'country': { type: 'String', access: 'readonly', declaredBy: 'mx.resources.Locale'},
        'variant': { type: 'String', access: 'readonly', declaredBy: 'mx.resources.Locale'}
      };
    },
    methods: function () {
      return {
        'Locale': { type: '', declaredBy: 'mx.resources.Locale', parameters: function () { return [ 'String', false ]; }},
        'toString': { type: 'String', declaredBy: 'mx.resources.Locale'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.resources.Locale.prototype.ROYALE_COMPILE_FLAGS = 10;