/**
 * Generated by Apache Royale Compiler from mx/rpc/CallResponder.as
 * mx.rpc.CallResponder
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.rpc.CallResponder');

goog.require('mx.rpc.AsyncToken');
goog.require('mx.rpc.events.FaultEvent');
goog.require('mx.rpc.events.ResultEvent');
goog.require('mx.utils.ArrayUtil');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.events.ValueChangeEvent');
goog.require('mx.rpc.IResponder');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 * @implements {mx.rpc.IResponder}
 */
mx.rpc.CallResponder = function() {
  mx.rpc.CallResponder.base(this, 'constructor');
};
goog.inherits(mx.rpc.CallResponder, org.apache.royale.events.EventDispatcher);


/**
 * @private
 * @type {mx.rpc.AsyncToken}
 */
mx.rpc.CallResponder.prototype.mx_rpc_CallResponder__token;/**
 *  Each CallResponder dispatches result and fault events received
 *  from a single token.  This property value specifies that token.  You typically
 *  set this property to the AsyncToken object returned by the service.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {mx.rpc.AsyncToken} t
 */
mx.rpc.CallResponder.prototype.__bindingWrappedSetter__token = function(t) {
  if (this.mx_rpc_CallResponder__token != null) {
    var /** @type {Array} */ resps = this.mx_rpc_CallResponder__token.responders;
    var /** @type {number} */ ix = mx.utils.ArrayUtil.getItemIndex(this, resps);
    if (ix != -1)
      resps.splice(ix, 1);
  }
  if (t != null)
    t.addResponder(this);
  this.mx_rpc_CallResponder__token = t;
}



/**
 *  This method is called by the AsyncToken when it wants to deliver a 
 *  <code>ResultEvent</code> to the CallResponder.  You do not call
 *  this method directly.
 *
 *  @asparam data The ResultEvent delivered by the AsyncToken
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} data
 */
mx.rpc.CallResponder.prototype.result = function(data) {
  var /** @type {mx.rpc.events.ResultEvent} */ resultEvent = org.apache.royale.utils.Language.as(data, mx.rpc.events.ResultEvent, true);
  this.lastResult = resultEvent.result;
  this.dispatchEvent(resultEvent);
};


/**
 *  This method is called by the AsyncToken when it wants to deliver a 
 *  <code>FaultEvent</code> to the CallResponder.  You do not call
 *  this method directly.
 *
 *  @asparam data The FaultEvent delivered by the AsyncToken
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} data
 */
mx.rpc.CallResponder.prototype.fault = function(data) {
  var /** @type {mx.rpc.events.FaultEvent} */ faultEvent = org.apache.royale.utils.Language.as(data, mx.rpc.events.FaultEvent, true);
  this.dispatchEvent(faultEvent);
};


/**
 * @type {*}
 */
mx.rpc.CallResponder.prototype.lastResult_;Object.defineProperties(mx.rpc.CallResponder.prototype, /** @lends {mx.rpc.CallResponder.prototype} */ {
/**
 * @type {*}
 */
lastResult: {
/** @this {mx.rpc.CallResponder} */
  get: function() {
  return this.lastResult_;
  },

/** @this {mx.rpc.CallResponder} */
set: function(value) {
if (value != this.lastResult_) {
    var oldValue = this.lastResult_;
    this.lastResult_ = value;
    this.dispatchEvent(org.apache.royale.events.ValueChangeEvent.createUpdateEvent(
         this, "lastResult", oldValue, value));
}
}}}
);


/**
 * @nocollapse
 * @export
 * @type {mx.rpc.AsyncToken}
 */
mx.rpc.CallResponder.prototype.token;


mx.rpc.CallResponder.prototype.get__token = function() {
  return this.mx_rpc_CallResponder__token;
};


mx.rpc.CallResponder.prototype.bindable__set__token_mx_rpc_CallResponder = function(t) {
var oldValue = this.token;
if (oldValue === t) return;
this.__bindingWrappedSetter__token(t);
    this.dispatchEvent(org.apache.royale.events.ValueChangeEvent.createUpdateEvent(
         this, "token", oldValue, t));
}

;


mx.rpc.CallResponder.prototype.set__token = function(value) {
var oldValue = this.get__token();
if (oldValue != value) {
this.bindable__set__token_mx_rpc_CallResponder(value);
    this.dispatchEvent(org.apache.royale.events.ValueChangeEvent.createUpdateEvent(
         this, "token", oldValue, value));
}
};


Object.defineProperties(mx.rpc.CallResponder.prototype, /** @lends {mx.rpc.CallResponder.prototype} */ {
/**
 * @type {mx.rpc.AsyncToken}
 */
token: {
get: mx.rpc.CallResponder.prototype.get__token,
set: mx.rpc.CallResponder.prototype.set__token}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.rpc.CallResponder.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CallResponder', qName: 'mx.rpc.CallResponder', kind: 'class' }], interfaces: [mx.rpc.IResponder] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.rpc.CallResponder.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'lastResult': { type: '*', access: 'readwrite', declaredBy: 'mx.rpc.CallResponder', metadata: function () { return [ { name: 'Bindable' } ]; }},
        'token': { type: 'mx.rpc.AsyncToken', access: 'readwrite', declaredBy: 'mx.rpc.CallResponder', metadata: function () { return [ { name: 'Bindable' } ]; }}
      };
    },
    methods: function () {
      return {
        'result': { type: 'void', declaredBy: 'mx.rpc.CallResponder', parameters: function () { return [ 'Object', false ]; }},
        'fault': { type: 'void', declaredBy: 'mx.rpc.CallResponder', parameters: function () { return [ 'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.rpc.CallResponder.prototype.ROYALE_COMPILE_FLAGS = 10;