/**
 * Generated by Apache Royale Compiler from mx/rpc/Fault.as
 * mx.rpc.Fault
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.rpc.Fault');
goog.require('XML');



/**
 * Creates a new Fault object.
 *
 * @asparam faultCode A simple code describing the fault.
 * @asparam faultString Text description of the fault.
 * @asparam faultDetail Additional details describing the fault.
 * 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {Error}
 * @param {string} faultCode
 * @param {string} faultString
 * @param {string=} faultDetail
 */
mx.rpc.Fault = function(faultCode, faultString, faultDetail) {
  faultDetail = typeof faultDetail !== 'undefined' ? faultDetail : null;
  mx.rpc.Fault.base(this, 'constructor', "faultCode:" + faultCode + " faultString:'" + faultString + "' faultDetail:'" + faultDetail + "'");
  this._faultCode = faultCode;
  this._faultString = faultString ? faultString : "";
  this._faultDetail = faultDetail;
};
goog.inherits(mx.rpc.Fault, Error);


/**
 * @return {string}
 */
mx.rpc.Fault.prototype.getStackTrace = function() {
  return null;
};


/**
 * @type {Object}
 */
mx.rpc.Fault.prototype.content;


/**
 * @type {Object}
 */
mx.rpc.Fault.prototype.rootCause;


/**
 * Returns the string representation of a Fault object.
 *
 * @asreturn Returns the string representation of a Fault object.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @return {string}
 */
mx.rpc.Fault.prototype.toString = function() {
  var /** @type {string} */ s = "[RPC Fault";
  s += " faultString=\"" + this.faultString + "\"";
  s += " faultCode=\"" + this.faultCode + "\"";
  s += " faultDetail=\"" + this.faultDetail + "\"]";
  return s;
};


/**
 * @protected
 * @type {string}
 */
mx.rpc.Fault.prototype._faultCode;


/**
 * @protected
 * @type {string}
 */
mx.rpc.Fault.prototype._faultString;


/**
 * @protected
 * @type {string}
 */
mx.rpc.Fault.prototype._faultDetail;


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.Fault.prototype.faultCode;


mx.rpc.Fault.prototype.get__faultCode = function() {
  return this._faultCode;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.Fault.prototype.faultDetail;


mx.rpc.Fault.prototype.get__faultDetail = function() {
  return this._faultDetail;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.Fault.prototype.faultString;


mx.rpc.Fault.prototype.get__faultString = function() {
  return this._faultString;
};


Object.defineProperties(mx.rpc.Fault.prototype, /** @lends {mx.rpc.Fault.prototype} */ {
/**
 * @type {string}
 */
faultCode: {
get: mx.rpc.Fault.prototype.get__faultCode},
/**
 * @type {string}
 */
faultDetail: {
get: mx.rpc.Fault.prototype.get__faultDetail},
/**
 * @type {string}
 */
faultString: {
get: mx.rpc.Fault.prototype.get__faultString}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.rpc.Fault.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Fault', qName: 'mx.rpc.Fault', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.rpc.Fault.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'content': { type: 'Object', get_set: function (/** mx.rpc.Fault */ inst, /** * */ v) {return v !== undefined ? inst.content = v : inst.content;}},
        'rootCause': { type: 'Object', get_set: function (/** mx.rpc.Fault */ inst, /** * */ v) {return v !== undefined ? inst.rootCause = v : inst.rootCause;}}
      };
    },
    accessors: function () {
      return {
        'faultCode': { type: 'String', access: 'readonly', declaredBy: 'mx.rpc.Fault'},
        'faultDetail': { type: 'String', access: 'readonly', declaredBy: 'mx.rpc.Fault'},
        'faultString': { type: 'String', access: 'readonly', declaredBy: 'mx.rpc.Fault'}
      };
    },
    methods: function () {
      return {
        'getStackTrace': { type: 'String', declaredBy: 'mx.rpc.Fault'},
        'Fault': { type: '', declaredBy: 'mx.rpc.Fault', parameters: function () { return [ 'String', false ,'String', false ,'String', true ]; }},
        'toString': { type: 'String', declaredBy: 'mx.rpc.Fault'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.rpc.Fault.prototype.ROYALE_COMPILE_FLAGS = 10;