/**
 * Generated by Apache Royale Compiler from mx/rpc/http/HTTPMultiService.as
 * mx.rpc.http.HTTPMultiService
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.rpc.http.HTTPMultiService');

goog.require('mx.core.mx_internal');
goog.require('mx.logging.ILogger');
goog.require('mx.logging.Log');
goog.require('mx.messaging.ChannelSet');
goog.require('mx.messaging.channels.DirectHTTPChannel');
goog.require('mx.messaging.config.LoaderConfig');
goog.require('mx.messaging.errors.ArgumentError');
goog.require('mx.messaging.messages.HTTPRequestMessage');
goog.require('mx.resources.IResourceManager');
goog.require('mx.resources.ResourceManager');
goog.require('mx.rpc.AbstractService');
goog.require('mx.rpc.http.AbstractOperation');
goog.require('mx.rpc.http.HTTPService');
goog.require('mx.rpc.http.SerializationFilter');
goog.require('mx.rpc.mxml.Concurrency');
goog.require('mx.utils.URLUtil');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Creates a new HTTPService. If you expect the service to send using relative URLs you may
 *  wish to specify the <code>baseURL</code> that will be the basis for determining the full URL (one example
 *  would be <code>Application.application.url</code>).
 *
 *  @asparam baseURL The URL the HTTPService should use when computing relative URLS.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {mx.rpc.AbstractService}
 * @param {string=} baseURL
 * @param {string=} destination
 */
mx.rpc.http.HTTPMultiService = function(baseURL, destination) {
  baseURL = typeof baseURL !== 'undefined' ? baseURL : null;
  destination = typeof destination !== 'undefined' ? destination : null;
  
  this.mx_rpc_http_HTTPMultiService_resourceManager = mx.resources.ResourceManager.getInstance();
  this.mx_rpc_http_HTTPMultiService__contentType = mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__CONTENT_TYPE_FORM;
  this.mx_rpc_http_HTTPMultiService__headers = {};
  this.mx_rpc_http_HTTPMultiService__method = mx.messaging.messages.HTTPRequestMessage.GET_METHOD;
  this.mx_rpc_http_HTTPMultiService__resultFormat = mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_OBJECT;
  mx.rpc.http.HTTPMultiService.base(this, 'constructor');
  this.makeObjectsBindable = false;
  if (destination == null) {
    if (mx.utils.URLUtil.isHttpsURL(mx.messaging.config.LoaderConfig.url))
      this.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest.destination = mx.rpc.http.HTTPService.DEFAULT_DESTINATION_HTTPS;
    else
      this.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest.destination = mx.rpc.http.HTTPService.DEFAULT_DESTINATION_HTTP;
  }
  else
    this.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest.destination = destination;
  this.mx_rpc_http_HTTPMultiService__log = mx.logging.Log.getLogger("mx.rpc.http.HTTPMultiService");
  this.baseURL = baseURL;
  this.concurrency = mx.rpc.mxml.Concurrency.MULTIPLE;
};
goog.inherits(mx.rpc.http.HTTPMultiService, mx.rpc.AbstractService);


/**
 * @private
 * @type {mx.messaging.ChannelSet}
 */
mx.rpc.http.HTTPMultiService._directChannelSet;


/**
 * @private
 * @type {mx.logging.ILogger}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__log;


/**
 * @private
 * @type {mx.resources.IResourceManager}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService_resourceManager;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__showBusyCursor = false;


/**
 * @private
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__concurrency;


/**
 * @private
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__contentType;


/**
 * @private
 * @type {Object}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__headers;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__makeObjectsBindable = true;


/**
 * @private
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__method;


/**
 * @private
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__resultFormat;


/**
 * @private
 * @type {mx.rpc.http.SerializationFilter}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__serializationFilter;


/**
 * @private
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__baseURL;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.HTTPMultiService.prototype.mx_rpc_http_HTTPMultiService__useProxy = false;


/**
 * @return {mx.messaging.ChannelSet}
 */
mx.rpc.http.HTTPMultiService.prototype.http_$$www_adobe_com$2006$flex$mx$internal__getDirectChannelSet = function() {
  if (mx.rpc.http.HTTPMultiService._directChannelSet == null) {
    var /** @type {mx.messaging.ChannelSet} */ dcs = new mx.messaging.ChannelSet();
    var /** @type {mx.messaging.channels.DirectHTTPChannel} */ dhc = new mx.messaging.channels.DirectHTTPChannel("direct_http_channel");
    dhc.requestTimeout = this.requestTimeout;
    dcs.addChannel(dhc);
    mx.rpc.http.HTTPMultiService._directChannelSet = dcs;
  }
  return mx.rpc.http.HTTPMultiService._directChannelSet;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.contentType;


mx.rpc.http.HTTPMultiService.prototype.get__contentType = function() {
  return this.mx_rpc_http_HTTPMultiService__contentType;
};


mx.rpc.http.HTTPMultiService.prototype.set__contentType = function(value) {
  this.mx_rpc_http_HTTPMultiService__contentType = value;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.concurrency;


mx.rpc.http.HTTPMultiService.prototype.get__concurrency = function() {
  return this.mx_rpc_http_HTTPMultiService__concurrency;
};


mx.rpc.http.HTTPMultiService.prototype.set__concurrency = function(c) {
  this.mx_rpc_http_HTTPMultiService__concurrency = c;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.rpc.http.HTTPMultiService.prototype.showBusyCursor;


mx.rpc.http.HTTPMultiService.prototype.get__showBusyCursor = function() {
  return this.mx_rpc_http_HTTPMultiService__showBusyCursor;
};


mx.rpc.http.HTTPMultiService.prototype.set__showBusyCursor = function(sbc) {
  this.mx_rpc_http_HTTPMultiService__showBusyCursor = sbc;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.rpc.http.HTTPMultiService.prototype.headers;


mx.rpc.http.HTTPMultiService.prototype.get__headers = function() {
  return this.mx_rpc_http_HTTPMultiService__headers;
};


mx.rpc.http.HTTPMultiService.prototype.set__headers = function(value) {
  this.mx_rpc_http_HTTPMultiService__headers = value;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.rpc.http.HTTPMultiService.prototype.makeObjectsBindable;


mx.rpc.http.HTTPMultiService.prototype.get__makeObjectsBindable = function() {
  return this.mx_rpc_http_HTTPMultiService__makeObjectsBindable;
};


mx.rpc.http.HTTPMultiService.prototype.set__makeObjectsBindable = function(value) {
  this.mx_rpc_http_HTTPMultiService__makeObjectsBindable = value;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.method;


mx.rpc.http.HTTPMultiService.prototype.get__method = function() {
  return this.mx_rpc_http_HTTPMultiService__method;
};


mx.rpc.http.HTTPMultiService.prototype.set__method = function(value) {
  this.mx_rpc_http_HTTPMultiService__method = value;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.resultFormat;


mx.rpc.http.HTTPMultiService.prototype.get__resultFormat = function() {
  return this.mx_rpc_http_HTTPMultiService__resultFormat;
};


mx.rpc.http.HTTPMultiService.prototype.set__resultFormat = function(value) {
  switch (value) {
    case mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_OBJECT:
    
    case mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_ARRAY:
    
    case mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_E4X:
    
    case mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_TEXT:
    
    case mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_FLASHVARS:
      break;
    default:
      if (value != null && (this.serializationFilter = mx.rpc.http.SerializationFilter.http_$$www_adobe_com$2006$flex$mx$internal__filterForResultFormatTable[value]) == null) {
        var /** @type {string} */ message = this.mx_rpc_http_HTTPMultiService_resourceManager.getString("rpc", "invalidResultFormat", [value, mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_OBJECT, mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_ARRAY, mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_E4X, mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_TEXT, mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__RESULT_FORMAT_FLASHVARS]);
        throw new mx.messaging.errors.ArgumentError(message);
      }
  }
  this.mx_rpc_http_HTTPMultiService__resultFormat = value;
};


/**
 * @nocollapse
 * @export
 * @type {mx.rpc.http.SerializationFilter}
 */
mx.rpc.http.HTTPMultiService.prototype.serializationFilter;


mx.rpc.http.HTTPMultiService.prototype.get__serializationFilter = function() {
  return this.mx_rpc_http_HTTPMultiService__serializationFilter;
};


mx.rpc.http.HTTPMultiService.prototype.set__serializationFilter = function(value) {
  this.mx_rpc_http_HTTPMultiService__serializationFilter = value;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.http.HTTPMultiService.prototype.baseURL;


mx.rpc.http.HTTPMultiService.prototype.get__baseURL = function() {
  return this.mx_rpc_http_HTTPMultiService__baseURL;
};


mx.rpc.http.HTTPMultiService.prototype.set__baseURL = function(value) {
  this.mx_rpc_http_HTTPMultiService__baseURL = value;
};


mx.rpc.http.HTTPMultiService.prototype.set__destination = function(value) {
  this.useProxy = true;
  mx.rpc.http.HTTPMultiService.superClass_.set__destination.apply(this, [value]);
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.rpc.http.HTTPMultiService.prototype.useProxy;


mx.rpc.http.HTTPMultiService.prototype.get__useProxy = function() {
  return this.mx_rpc_http_HTTPMultiService__useProxy;
};


mx.rpc.http.HTTPMultiService.prototype.set__useProxy = function(value) {
  if (value != this.mx_rpc_http_HTTPMultiService__useProxy) {
    this.mx_rpc_http_HTTPMultiService__useProxy = value;
    var /** @type {mx.messaging.ChannelSet} */ dcs = this.http_$$www_adobe_com$2006$flex$mx$internal__getDirectChannelSet();
    if (!this.useProxy) {
      if (dcs != this.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest.channelSet)
        this.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest.channelSet = dcs;
    } else {
      if (this.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest.channelSet == dcs)
        this.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest.channelSet = null;
    }
  }
};


/**
 * @nocollapse
 * @export
 * @type {Array}
 */
mx.rpc.http.HTTPMultiService.prototype.operationList;


mx.rpc.http.HTTPMultiService.prototype.get__operationList = function() {
  if (this.operations == null)
    return null;
  var /** @type {Array} */ ol = [];
  for (var /** @type {string} */ i in this.operations) {
    var /** @type {mx.rpc.http.AbstractOperation} */ op = this.operations[i];
    ol.push(op);
  }
  return ol;
};


mx.rpc.http.HTTPMultiService.prototype.set__operationList = function(ol) {
  if (ol == null)
    this.operations = null; else {
    var /** @type {mx.rpc.http.AbstractOperation} */ op;
    var /** @type {Object} */ ops = {};
    for (var /** @type {number} */ i = 0; i < ol.length; i++) {
      op = org.apache.royale.utils.Language.as(ol[i], mx.rpc.http.AbstractOperation, true);
      var /** @type {string} */ name = op.name;
      if (!name)
        throw new mx.messaging.errors.ArgumentError("Operations must have a name property value for HTTPMultiService");
      ops[name] = op;
    }
    this.operations = ops;
  }
};


Object.defineProperties(mx.rpc.http.HTTPMultiService.prototype, /** @lends {mx.rpc.http.HTTPMultiService.prototype} */ {
/**
 * @type {string}
 */
contentType: {
get: mx.rpc.http.HTTPMultiService.prototype.get__contentType,
set: mx.rpc.http.HTTPMultiService.prototype.set__contentType},
/**
 * @type {string}
 */
concurrency: {
get: mx.rpc.http.HTTPMultiService.prototype.get__concurrency,
set: mx.rpc.http.HTTPMultiService.prototype.set__concurrency},
/**
 * @type {boolean}
 */
showBusyCursor: {
get: mx.rpc.http.HTTPMultiService.prototype.get__showBusyCursor,
set: mx.rpc.http.HTTPMultiService.prototype.set__showBusyCursor},
/**
 * @type {Object}
 */
headers: {
get: mx.rpc.http.HTTPMultiService.prototype.get__headers,
set: mx.rpc.http.HTTPMultiService.prototype.set__headers},
/**
 * @type {boolean}
 */
makeObjectsBindable: {
get: mx.rpc.http.HTTPMultiService.prototype.get__makeObjectsBindable,
set: mx.rpc.http.HTTPMultiService.prototype.set__makeObjectsBindable},
/**
 * @type {string}
 */
method: {
get: mx.rpc.http.HTTPMultiService.prototype.get__method,
set: mx.rpc.http.HTTPMultiService.prototype.set__method},
/**
 * @type {string}
 */
resultFormat: {
get: mx.rpc.http.HTTPMultiService.prototype.get__resultFormat,
set: mx.rpc.http.HTTPMultiService.prototype.set__resultFormat},
/**
 * @type {mx.rpc.http.SerializationFilter}
 */
serializationFilter: {
get: mx.rpc.http.HTTPMultiService.prototype.get__serializationFilter,
set: mx.rpc.http.HTTPMultiService.prototype.set__serializationFilter},
/**
 * @type {string}
 */
baseURL: {
get: mx.rpc.http.HTTPMultiService.prototype.get__baseURL,
set: mx.rpc.http.HTTPMultiService.prototype.set__baseURL},
/**
 * @type {string}
 */
destination: {
get: mx.rpc.AbstractService.prototype.get__destination,
set: mx.rpc.http.HTTPMultiService.prototype.set__destination},
/**
 * @type {boolean}
 */
useProxy: {
get: mx.rpc.http.HTTPMultiService.prototype.get__useProxy,
set: mx.rpc.http.HTTPMultiService.prototype.set__useProxy},
/**
 * @type {Array}
 */
operationList: {
get: mx.rpc.http.HTTPMultiService.prototype.get__operationList,
set: mx.rpc.http.HTTPMultiService.prototype.set__operationList}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.rpc.http.HTTPMultiService.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'HTTPMultiService', qName: 'mx.rpc.http.HTTPMultiService', kind: 'class', isDynamic: true}] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.rpc.http.HTTPMultiService.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'contentType': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'concurrency': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'showBusyCursor': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'headers': { type: 'Object', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'makeObjectsBindable': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'method': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'resultFormat': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'serializationFilter': { type: 'mx.rpc.http.SerializationFilter', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'baseURL': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'destination': { type: 'String', access: 'writeonly', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'useProxy': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'},
        'operationList': { type: 'Array', access: 'readwrite', declaredBy: 'mx.rpc.http.HTTPMultiService'}
      };
    },
    methods: function () {
      return {
        'HTTPMultiService': { type: '', declaredBy: 'mx.rpc.http.HTTPMultiService', parameters: function () { return [ 'String', true ,'String', true ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::getDirectChannelSet': { type: 'mx.messaging.ChannelSet', declaredBy: 'mx.rpc.http.HTTPMultiService'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.rpc.http.HTTPMultiService.prototype.ROYALE_COMPILE_FLAGS = 10;