/**
 * Generated by Apache Royale Compiler from mx/rpc/http/Operation.as
 * mx.rpc.http.Operation
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.rpc.http.Operation');

goog.require('mx.core.mx_internal');
goog.require('mx.logging.Log');
goog.require('mx.messaging.errors.ArgumentError');
goog.require('mx.rpc.AbstractService');
goog.require('mx.rpc.AsyncRequest');
goog.require('mx.rpc.AsyncToken');
goog.require('mx.rpc.http.AbstractOperation');
goog.require('mx.rpc.http.HTTPMultiService');
goog.require('mx.rpc.http.SerializationFilter');
goog.require('mx.utils.URLUtil');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Creates a new Operation. 
 *
 *  @asparam service The HTTPMultiService object defining the service.
 *
 *  @asparam name The name of the service.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 
 *  Creates a new Operation. 
 *
 *  @asparam service The HTTPMultiService object defining the service.
 *
 *  @asparam name The name of the service.
 * @constructor
 * @extends {mx.rpc.http.AbstractOperation}
 * @param {mx.rpc.http.HTTPMultiService=} service
 * @param {string=} name
 */
mx.rpc.http.Operation = function(service, name) {
  service = typeof service !== 'undefined' ? service : null;
  name = typeof name !== 'undefined' ? name : null;
  mx.rpc.http.Operation.base(this, 'constructor', service, name);
  this.mx_rpc_http_Operation__concurrencySet = false;
  this.mx_rpc_http_Operation__multiService = service;
  this.http_$$www_adobe_com$2006$flex$mx$internal___log = mx.logging.Log.getLogger("mx.rpc.http.HTTPMultiService");
};
goog.inherits(mx.rpc.http.Operation, mx.rpc.http.AbstractOperation);


/**
 * @private
 * @type {mx.rpc.http.HTTPMultiService}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__multiService;


/**
 * @private
 * @type {string}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__concurrency;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__concurrencySet;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__makeObjectsBindableSet;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__methodSet = false;


/**
 * @private
 * @type {string}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__method;


/**
 * @override
 */
mx.rpc.http.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__setService = function(s) {
  mx.rpc.http.Operation.superClass_.http_$$www_adobe_com$2006$flex$mx$internal__setService.apply(this, [s]);
  if (org.apache.royale.utils.Language.is(s, mx.rpc.http.HTTPMultiService))
    this.mx_rpc_http_Operation__multiService = org.apache.royale.utils.Language.as(s, mx.rpc.http.HTTPMultiService);
};


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__showBusyCursorSet = false;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__useProxySet = false;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__contentTypeSet = false;


/**
 * Executes the http operation. Any arguments passed in are passed along as part of
 * the operation call. If there are no arguments passed, the arguments property of
 * class is used as the source of parameters.  HTTP operations commonly take named
 * parameters, not positional parameters.  To supply the names for these parameters,
 * you can also set the argumentNames property to an array of the property names.
 *
 * @asparam args Optional arguments passed in as part of the method call. If there
 * are no arguments passed, the arguments object is used as the source of 
 * parameters.
 *
 * @asreturn AsyncToken Call using the asynchronous completion token pattern.
 * The same object is available in the <code>result</code> and
 * <code>fault</code> events from the <code>token</code> property.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @override
 */
mx.rpc.http.Operation.prototype.send = function(args) {
  args = Array.prototype.slice.call(arguments, 0);
  if (this.mx_rpc_http_Operation__multiService != null)
    this.mx_rpc_http_Operation__multiService.initialize();
  if (this.operationManager != null)
    return this.operationManager(args);
  var /** @type {Object} */ params;
  var /** @type {mx.rpc.http.SerializationFilter} */ filter = this.getSerializationFilter();
  if (filter != null) {
    params = filter.serializeParameters(this, args);
  } else {
    params = args;
    if (!params || (params.length == 0 && this.request)) {
      params = this.request;
    }
    if (org.apache.royale.utils.Language.is(params, Array) && this.argumentNames != null) {
      args = org.apache.royale.utils.Language.as(params, Array);
      params = new Object();
      if (args.length != this.argumentNames.length) {
        throw new mx.messaging.errors.ArgumentError("HTTPMultiService operation called with " + this.argumentNames.length + " argumentNames and " + args.length + " number of parameters.  When argumentNames is specified, it must match the number of arguments passed to the invocation");
      } else {
        if (this.argumentNames.length == 1 && this.contentType == mx.rpc.http.AbstractOperation.http_$$www_adobe_com$2006$flex$mx$internal__CONTENT_TYPE_XML) {
          params = args[0];
        } else {
          for (var /** @type {number} */ i = 0; i < this.argumentNames.length; i++)
            params[this.argumentNames[i]] = args[i];
        }
      }
    } else if (args.length == 1) {
      params = args[0];
    } else if (args.length != 0) {
      throw new mx.messaging.errors.ArgumentError("HTTPMultiService - you must set argumentNames to an array of parameter names if you use more than one parameter.");
    }
  }
  return this.sendBody(params);
};


/**
 * @private
 * @type {boolean}
 */
mx.rpc.http.Operation.prototype.mx_rpc_http_Operation__resultFormatSet = false;


/**
 *  @asprivate
 * @protected
 * @override
 */
mx.rpc.http.Operation.prototype.getSerializationFilter = function() {
  var /** @type {mx.rpc.http.SerializationFilter} */ sf = this.serializationFilter;
  if (sf == null)
    return this.mx_rpc_http_Operation__multiService.serializationFilter;
  return sf;
};


/**
 *  @asprivate
 * @protected
 * @override
 */
mx.rpc.http.Operation.prototype.getHeaders = function() {
  if (this.headers != null)
    return this.headers;
  else
    return this.mx_rpc_http_Operation__multiService.headers;
};


mx.rpc.http.Operation.prototype.get__concurrency = function() {
  if (this.mx_rpc_http_Operation__concurrencySet) {
    return this.mx_rpc_http_Operation__concurrency;
  }
  return this.mx_rpc_http_Operation__multiService.concurrency;
};


mx.rpc.http.Operation.prototype.set__concurrency = function(c) {
  this.mx_rpc_http_Operation__concurrency = c;
  this.mx_rpc_http_Operation__concurrencySet = true;
};


mx.rpc.http.Operation.prototype.get__makeObjectsBindable = function() {
  if (this.mx_rpc_http_Operation__makeObjectsBindableSet)
    return this.http_$$www_adobe_com$2006$flex$mx$internal___makeObjectsBindable;
  return this.mx_rpc_http_Operation__multiService.makeObjectsBindable;
};


mx.rpc.http.Operation.prototype.set__makeObjectsBindable = function(b) {
  this.http_$$www_adobe_com$2006$flex$mx$internal___makeObjectsBindable = b;
  this.mx_rpc_http_Operation__makeObjectsBindableSet = true;
};


mx.rpc.http.Operation.prototype.get__method = function() {
  if (this.mx_rpc_http_Operation__methodSet)
    return this.mx_rpc_http_Operation__method;
  return this.mx_rpc_http_Operation__multiService.method;
};


mx.rpc.http.Operation.prototype.set__method = function(m) {
  this.mx_rpc_http_Operation__method = m;
  this.mx_rpc_http_Operation__methodSet = m != null;
};


mx.rpc.http.Operation.prototype.get__showBusyCursor = function() {
  if (this.mx_rpc_http_Operation__showBusyCursorSet)
    return mx.rpc.http.Operation.superClass_.get__showBusyCursor.apply(this);
  return this.mx_rpc_http_Operation__multiService.showBusyCursor;
};


mx.rpc.http.Operation.prototype.set__showBusyCursor = function(b) {
  mx.rpc.http.Operation.superClass_.set__showBusyCursor.apply(this, [b]);
  this.mx_rpc_http_Operation__showBusyCursorSet = true;
};


mx.rpc.http.Operation.prototype.get__rootURL = function() {
  if (this.http_$$www_adobe_com$2006$flex$mx$internal___rootURL == null) {
    var /** @type {string} */ useRootURL = this.mx_rpc_http_Operation__multiService.baseURL;
    if (useRootURL != null && useRootURL.length > 0) {
      if (useRootURL.charAt(useRootURL.length - 1) != '/')
        useRootURL = useRootURL + "/";
      if (useRootURL.charAt(0) == "/")
        useRootURL = mx.utils.URLUtil.getFullURL(mx.rpc.http.Operation.superClass_.get__rootURL.apply(this), useRootURL);
      return useRootURL;
    }
    else
      return mx.rpc.http.Operation.superClass_.get__rootURL.apply(this);
  }
  return this.http_$$www_adobe_com$2006$flex$mx$internal___rootURL;
};


mx.rpc.http.Operation.prototype.get__useProxy = function() {
  if (this.mx_rpc_http_Operation__useProxySet)
    return mx.rpc.http.Operation.superClass_.get__useProxy.apply(this);
  return this.mx_rpc_http_Operation__multiService.useProxy;
};


mx.rpc.http.Operation.prototype.set__useProxy = function(value) {
  this.mx_rpc_http_Operation__useProxySet = true;
  mx.rpc.http.Operation.superClass_.set__useProxy.apply(this, [value]);
};


mx.rpc.http.Operation.prototype.get__contentType = function() {
  if (this.mx_rpc_http_Operation__contentTypeSet)
    return mx.rpc.http.Operation.superClass_.get__contentType.apply(this);
  return this.mx_rpc_http_Operation__multiService.contentType;
};


mx.rpc.http.Operation.prototype.set__contentType = function(ct) {
  this.mx_rpc_http_Operation__contentTypeSet = ct != null;
  mx.rpc.http.Operation.superClass_.set__contentType.apply(this, [ct]);
};


mx.rpc.http.Operation.prototype.get__resultFormat = function() {
  if (this.mx_rpc_http_Operation__resultFormatSet)
    return mx.rpc.http.Operation.superClass_.get__resultFormat.apply(this);
  return this.mx_rpc_http_Operation__multiService.resultFormat;
};


mx.rpc.http.Operation.prototype.set__resultFormat = function(rf) {
  this.mx_rpc_http_Operation__resultFormatSet = rf != null;
  mx.rpc.http.Operation.superClass_.set__resultFormat.apply(this, [rf]);
};


mx.rpc.http.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__get__asyncRequest = function() {
  return this.mx_rpc_http_Operation__multiService.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest;
};


Object.defineProperties(mx.rpc.http.Operation.prototype, /** @lends {mx.rpc.http.Operation.prototype} */ {
/**
 * @type {string}
 */
concurrency: {
get: mx.rpc.http.Operation.prototype.get__concurrency,
set: mx.rpc.http.Operation.prototype.set__concurrency},
/**
 * @type {boolean}
 */
makeObjectsBindable: {
get: mx.rpc.http.Operation.prototype.get__makeObjectsBindable,
set: mx.rpc.http.Operation.prototype.set__makeObjectsBindable},
/**
 * @type {string}
 */
method: {
get: mx.rpc.http.Operation.prototype.get__method,
set: mx.rpc.http.Operation.prototype.set__method},
/**
 * @type {boolean}
 */
showBusyCursor: {
get: mx.rpc.http.Operation.prototype.get__showBusyCursor,
set: mx.rpc.http.Operation.prototype.set__showBusyCursor},
/**
 * @type {string}
 */
rootURL: {
get: mx.rpc.http.Operation.prototype.get__rootURL,
set: mx.rpc.http.AbstractOperation.prototype.set__rootURL},
/**
 * @type {boolean}
 */
useProxy: {
get: mx.rpc.http.Operation.prototype.get__useProxy,
set: mx.rpc.http.Operation.prototype.set__useProxy},
/**
 * @type {string}
 */
contentType: {
get: mx.rpc.http.Operation.prototype.get__contentType,
set: mx.rpc.http.Operation.prototype.set__contentType},
/**
 * @type {string}
 */
resultFormat: {
get: mx.rpc.http.Operation.prototype.get__resultFormat,
set: mx.rpc.http.Operation.prototype.set__resultFormat},
/**
 * @type {mx.rpc.AsyncRequest}
 */
http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest: {
get: mx.rpc.http.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__get__asyncRequest,
set: mx.rpc.AbstractInvoker.prototype.http_$$www_adobe_com$2006$flex$mx$internal__set__asyncRequest}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.rpc.http.Operation.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Operation', qName: 'mx.rpc.http.Operation', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.rpc.http.Operation.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'concurrency': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.http.Operation'},
        'makeObjectsBindable': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.http.Operation'},
        'method': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.http.Operation'},
        'showBusyCursor': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.http.Operation'},
        'rootURL': { type: 'String', access: 'readonly', declaredBy: 'mx.rpc.http.Operation'},
        'useProxy': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.http.Operation'},
        'contentType': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.http.Operation'},
        'resultFormat': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.http.Operation'},
        'http://www.adobe.com/2006/flex/mx/internal::asyncRequest': { type: 'mx.rpc.AsyncRequest', access: 'readonly', declaredBy: 'mx.rpc.http.Operation'}
      };
    },
    methods: function () {
      return {
        'Operation': { type: '', declaredBy: 'mx.rpc.http.Operation', parameters: function () { return [ 'mx.rpc.http.HTTPMultiService', true ,'String', true ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::setService': { type: 'void', declaredBy: 'mx.rpc.http.Operation', parameters: function () { return [ 'mx.rpc.AbstractService', false ]; }},
        'send': { type: 'mx.rpc.AsyncToken', declaredBy: 'mx.rpc.http.Operation', parameters: function () { return [ 'Array', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.rpc.http.Operation.prototype.ROYALE_COMPILE_FLAGS = 10;