/**
 * Generated by Apache Royale Compiler from mx/rpc/remoting/CompressedRemoteObject.as
 * mx.rpc.remoting.CompressedRemoteObject
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.rpc.remoting.CompressedRemoteObject');

goog.require('mx.collections.IList');
goog.require('mx.rpc.AbstractOperation');
goog.require('mx.rpc.remoting.RemoteObject');
goog.require('org.apache.royale.net.remoting.amf.AMFBinaryData');
goog.require('org.apache.royale.reflection.getQualifiedClassName');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 * Uses the pako library for the zlib compression algorithm
 *
 * <inject_script>
 * var script = document.createElement("script");
 * script.setAttribute("src", "https://cdnjs.cloudflare.com/ajax/libs/pako/1.0.6/pako.min.js");
 * document.head.appendChild(script);
 * </inject_script>
 * @constructor
 * @extends {mx.rpc.remoting.RemoteObject}
 * @param {string=} destination
 */
mx.rpc.remoting.CompressedRemoteObject = function(destination) {
  destination = typeof destination !== 'undefined' ? destination : null;
  mx.rpc.remoting.CompressedRemoteObject.base(this, 'constructor', destination);
};
goog.inherits(mx.rpc.remoting.CompressedRemoteObject, mx.rpc.remoting.RemoteObject);


/**
 * @nocollapse
 * @type {boolean}
 */
mx.rpc.remoting.CompressedRemoteObject.disableCompression;


/**
 * @nocollapse
 * @type {Array}
 */
mx.rpc.remoting.CompressedRemoteObject.includePackages = ["org.apache.royale."];


/**
 * @nocollapse
 * @type {Array}
 */
mx.rpc.remoting.CompressedRemoteObject.includeClasses;


/**
 * @nocollapse
 * @type {Array}
 */
mx.rpc.remoting.CompressedRemoteObject.excludeClasses;


/**
 * @type {Array}
 */
mx.rpc.remoting.CompressedRemoteObject.prototype.includePackages;


/**
 * @type {Array}
 */
mx.rpc.remoting.CompressedRemoteObject.prototype.includeClasses;


/**
 * @type {Array}
 */
mx.rpc.remoting.CompressedRemoteObject.prototype.excludeClasses;


/**
 * @override
 */
mx.rpc.remoting.CompressedRemoteObject.prototype.initialize = function() {
  mx.rpc.remoting.CompressedRemoteObject.superClass_.initialize.apply(this);
  this.convertParametersHandler = org.apache.royale.utils.Language.closure(this.mx_rpc_remoting_CompressedRemoteObject_serializeParameters, this, 'mx_rpc_remoting_CompressedRemoteObject_serializeParameters');
  this.convertResultHandler = org.apache.royale.utils.Language.closure(this.mx_rpc_remoting_CompressedRemoteObject_deserializeResult, this, 'mx_rpc_remoting_CompressedRemoteObject_deserializeResult');
};


/**
 * @private
 * @param {Array} parameters
 * @return {Array}
 */
mx.rpc.remoting.CompressedRemoteObject.prototype.mx_rpc_remoting_CompressedRemoteObject_serializeParameters = function(parameters) {
  var /** @type {Array} */ includePackages = this.includePackages ? this.includePackages : mx.rpc.remoting.CompressedRemoteObject.includePackages;
  var /** @type {Array} */ includeClasses = this.includeClasses ? this.includeClasses : mx.rpc.remoting.CompressedRemoteObject.includeClasses;
  var /** @type {Array} */ excludeClasses = this.excludeClasses ? this.excludeClasses : mx.rpc.remoting.CompressedRemoteObject.excludeClasses;
  for (var /** @type {number} */ i = 0; i < parameters.length; i++) {
    var /** @type {Object} */ parameter = parameters[i];
    if (org.apache.royale.utils.Language.is(parameter, Array) && org.apache.royale.utils.Language.as(parameter, Array).length > 0) {
      parameter = parameter[0];
    } else if (org.apache.royale.utils.Language.is(parameter, mx.collections.IList) && org.apache.royale.utils.Language.as(parameter, mx.collections.IList, true).length > 0) {
      parameter = parameter[0];
    }
    var /** @type {string} */ parameterClassName = org.apache.royale.reflection.getQualifiedClassName(parameter);
    if (parameterClassName) {
      parameterClassName = parameterClassName.replace("::", ".");
      var /** @type {boolean} */ included;
      if (includePackages && includePackages.length > 0) {
        var foreachiter0_target = includePackages;
        for (var foreachiter0 in foreachiter0_target) 
        {
        var includePackage = foreachiter0_target[foreachiter0];
        {
          if (parameterClassName.indexOf(includePackage) >= 0) {
            included = true;
            break;
          }
        }}
        
      }
      if (!included && includeClasses && includeClasses.length > 0) {
        included = includeClasses.indexOf(parameterClassName) != -1;
      }
      if (included && excludeClasses && excludeClasses.length > 0) {
        included = excludeClasses.indexOf(parameterClassName) == -1;
      }
    }
  }
  return parameters;
};


/**
 * @royaleignorecoercion org.apache.royale.net.remoting.amf.AMFBinaryData
 * @private
 * @param {*} result
 * @param {mx.rpc.AbstractOperation} operation
 * @return {*}
 */
mx.rpc.remoting.CompressedRemoteObject.prototype.mx_rpc_remoting_CompressedRemoteObject_deserializeResult = function(result, operation) {
  
  if (!mx.rpc.remoting.CompressedRemoteObject.disableCompression && org.apache.royale.utils.Language.is(result, org.apache.royale.net.remoting.amf.AMFBinaryData)) {
    var /** @type {Object} */ original = result;
    var /** @type {Object} */ uncompressed = new org.apache.royale.net.remoting.amf.AMFBinaryData(window["pako"]["inflate"](original.array).buffer);
    return uncompressed.readObject();
  } else {
    return result;
  }
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.rpc.remoting.CompressedRemoteObject.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CompressedRemoteObject', qName: 'mx.rpc.remoting.CompressedRemoteObject', kind: 'class', isDynamic: true}] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.rpc.remoting.CompressedRemoteObject.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        '|disableCompression': { type: 'Boolean', get_set: function (/** * */ v) {return v !== undefined ? mx.rpc.remoting.CompressedRemoteObject.disableCompression = v : mx.rpc.remoting.CompressedRemoteObject.disableCompression;}},
        '|includePackages': { type: 'Array', get_set: function (/** * */ v) {return v !== undefined ? mx.rpc.remoting.CompressedRemoteObject.includePackages = v : mx.rpc.remoting.CompressedRemoteObject.includePackages;}},
        '|includeClasses': { type: 'Array', get_set: function (/** * */ v) {return v !== undefined ? mx.rpc.remoting.CompressedRemoteObject.includeClasses = v : mx.rpc.remoting.CompressedRemoteObject.includeClasses;}},
        '|excludeClasses': { type: 'Array', get_set: function (/** * */ v) {return v !== undefined ? mx.rpc.remoting.CompressedRemoteObject.excludeClasses = v : mx.rpc.remoting.CompressedRemoteObject.excludeClasses;}},
        'includePackages': { type: 'Array', get_set: function (/** mx.rpc.remoting.CompressedRemoteObject */ inst, /** * */ v) {return v !== undefined ? inst.includePackages = v : inst.includePackages;}},
        'includeClasses': { type: 'Array', get_set: function (/** mx.rpc.remoting.CompressedRemoteObject */ inst, /** * */ v) {return v !== undefined ? inst.includeClasses = v : inst.includeClasses;}},
        'excludeClasses': { type: 'Array', get_set: function (/** mx.rpc.remoting.CompressedRemoteObject */ inst, /** * */ v) {return v !== undefined ? inst.excludeClasses = v : inst.excludeClasses;}}
      };
    },
    methods: function () {
      return {
        'CompressedRemoteObject': { type: '', declaredBy: 'mx.rpc.remoting.CompressedRemoteObject', parameters: function () { return [ 'String', true ]; }},
        'initialize': { type: 'void', declaredBy: 'mx.rpc.remoting.CompressedRemoteObject'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.rpc.remoting.CompressedRemoteObject.prototype.ROYALE_COMPILE_FLAGS = 10;