/**
 * Generated by Apache Royale Compiler from mx/rpc/remoting/Operation.as
 * mx.rpc.remoting.Operation
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.rpc.remoting.Operation');

goog.require('mx.core.mx_internal');
goog.require('mx.managers.CursorManager');
goog.require('mx.messaging.events.MessageEvent');
goog.require('mx.messaging.messages.AsyncMessage');
goog.require('mx.messaging.messages.IMessage');
goog.require('mx.messaging.messages.RemotingMessage');
goog.require('mx.resources.IResourceManager');
goog.require('mx.resources.ResourceManager');
goog.require('mx.rpc.AbstractOperation');
goog.require('mx.rpc.AbstractService');
goog.require('mx.rpc.AsyncDispatcher');
goog.require('mx.rpc.AsyncToken');
goog.require('mx.rpc.Fault');
goog.require('mx.rpc.events.FaultEvent');
goog.require('mx.rpc.mxml.Concurrency');
goog.require('mx.rpc.remoting.RemoteObject');
goog.require('mx.rpc.remoting.mxml.RemoteObject');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.events.ValueChangeEvent');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 * Creates a new Operation. This is usually done directly automatically by the RemoteObject
 * when an unknown operation has been accessed. It is not recommended that a developer use this constructor
 * directly.
 * 
 *  @asparam service The RemoteObject object defining the service.
 *
 *  @asparam name The name of the service.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {mx.rpc.AbstractOperation}
 * @param {mx.rpc.AbstractService=} remoteObject
 * @param {string=} name
 */
mx.rpc.remoting.Operation = function(remoteObject, name) {
  remoteObject = typeof remoteObject !== 'undefined' ? remoteObject : null;
  name = typeof name !== 'undefined' ? name : null;
  
  this.mx_rpc_remoting_Operation_resourceManager = mx.resources.ResourceManager.getInstance();
  mx.rpc.remoting.Operation.base(this, 'constructor', remoteObject, name);
  this.argumentNames = [];
  this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject = org.apache.royale.utils.Language.as(remoteObject, mx.rpc.remoting.RemoteObject, true);
};
goog.inherits(mx.rpc.remoting.Operation, mx.rpc.AbstractOperation);


/**
 * @private
 * @type {Array}
 */
mx.rpc.remoting.Operation.prototype.mx_rpc_remoting_Operation__argumentNames;


/**
 * @private
 * @type {string}
 */
mx.rpc.remoting.Operation.prototype.mx_rpc_remoting_Operation__concurrency;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.remoting.Operation.prototype.mx_rpc_remoting_Operation__concurrencySet;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.remoting.Operation.prototype.mx_rpc_remoting_Operation__makeObjectsBindableSet;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.remoting.Operation.prototype.mx_rpc_remoting_Operation__showBusyCursor;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.remoting.Operation.prototype.mx_rpc_remoting_Operation__showBusyCursorSet;


/**
 * inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @override
 */
mx.rpc.remoting.Operation.prototype.send = function(args) {
  args = Array.prototype.slice.call(arguments, 0);
  if (this.service != null)
    this.service.initialize();
  if (this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject.convertParametersHandler != null)
    args = this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject.convertParametersHandler(args);
  if (this.operationManager != null)
    return this.operationManager(args);
  if (mx.rpc.mxml.Concurrency.SINGLE == this.concurrency && this.http_$$www_adobe_com$2006$flex$mx$internal__activeCalls.hasActiveCalls()) {
    var /** @type {mx.rpc.AsyncToken} */ token = new mx.rpc.AsyncToken(null);
    var /** @type {string} */ m = this.mx_rpc_remoting_Operation_resourceManager.getString("rpc", "pendingCallExists");
    var /** @type {mx.rpc.Fault} */ fault = new mx.rpc.Fault("ConcurrencyError", m);
    var /** @type {mx.rpc.events.FaultEvent} */ faultEvent = mx.rpc.events.FaultEvent.createEvent(fault, token);
    new mx.rpc.AsyncDispatcher(org.apache.royale.utils.Language.closure(this.http_$$www_adobe_com$2006$flex$mx$internal__dispatchRpcEvent, this, 'http://www.adobe.com/2006/flex/mx/internal::dispatchRpcEvent'), [faultEvent], 10);
    return token;
  }
  if (this.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest.channelSet == null && this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject.endpoint != null) {
    this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject[new QName(mx.core.mx_internal, 'initEndpoint').objectAccessFormat()]();
  }
  if (!args || (args.length == 0 && this.arguments)) {
    if (org.apache.royale.utils.Language.is(this.arguments, Array)) {
      args = org.apache.royale.utils.Language.as(this.arguments, Array);
    } else {
      args = [];
      for (var /** @type {number} */ i = 0; i < this.argumentNames.length; ++i) {
        args[i] = this.arguments[this.argumentNames[i]];
      }
    }
  }
  var /** @type {mx.messaging.messages.RemotingMessage} */ message = new mx.messaging.messages.RemotingMessage();
  message.operation = this.name;
  message.body = args;
  message.source = org.apache.royale.utils.Language.as(this.service, mx.rpc.remoting.RemoteObject).source;
  return this.http_$$www_adobe_com$2006$flex$mx$internal__invoke(message);
};


/**
 * inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @override
 */
mx.rpc.remoting.Operation.prototype.cancel = function(id) {
  id = typeof id !== 'undefined' ? id : null;
  if (this.showBusyCursor) {
    mx.managers.CursorManager.removeBusyCursor();
  }
  return mx.rpc.remoting.Operation.superClass_.cancel.apply(this, [id]);
};


/**
 * @override
 */
mx.rpc.remoting.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__setService = function(ro) {
  mx.rpc.remoting.Operation.superClass_.http_$$www_adobe_com$2006$flex$mx$internal__setService.apply(this, [ro]);
  this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject = org.apache.royale.utils.Language.as(ro, mx.rpc.remoting.RemoteObject, true);
};


/**
 * @override
 */
mx.rpc.remoting.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__invoke = function(message, token) {
  token = typeof token !== 'undefined' ? token : null;
  if (this.showBusyCursor) {
    mx.managers.CursorManager.setBusyCursor();
  }
  return mx.rpc.remoting.Operation.superClass_.http_$$www_adobe_com$2006$flex$mx$internal__invoke.apply(this, [message, token]);
};


/**
 * @override
 */
mx.rpc.remoting.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__preHandle = function(event) {
  if (this.showBusyCursor) {
    mx.managers.CursorManager.removeBusyCursor();
  }
  var /** @type {boolean} */ wasLastCall = this.http_$$www_adobe_com$2006$flex$mx$internal__activeCalls.wasLastCall(org.apache.royale.utils.Language.as(event.message, mx.messaging.messages.AsyncMessage, true).correlationId);
  var /** @type {mx.rpc.AsyncToken} */ token = mx.rpc.remoting.Operation.superClass_.http_$$www_adobe_com$2006$flex$mx$internal__preHandle.apply(this, [event]);
  if (mx.rpc.mxml.Concurrency.LAST == this.concurrency && !wasLastCall) {
    return null;
  }
  return token;
};


/**
 * @override
 */
mx.rpc.remoting.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__processResult = function(message, token) {
  if (mx.rpc.remoting.Operation.superClass_.http_$$www_adobe_com$2006$flex$mx$internal__processResult.apply(this, [message, token])) {
    if (this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject.convertResultHandler != null)
      this.http_$$www_adobe_com$2006$flex$mx$internal___result = this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject.convertResultHandler(this.http_$$www_adobe_com$2006$flex$mx$internal___result, this);
    return true;
  }
  return false;
};


/**
 * @protected
 * @override
 */
mx.rpc.remoting.Operation.prototype.resultHandler = function(event) {
  mx.rpc.remoting.Operation.superClass_.resultHandler.apply(this, [event]);
  if (org.apache.royale.utils.Language.is(this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject, mx.rpc.remoting.mxml.RemoteObject)) {
    var /** @type {Object} */ document = org.apache.royale.utils.Language.as(this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject, mx.rpc.remoting.mxml.RemoteObject).getDocument();
    org.apache.royale.utils.Language.as(document, org.apache.royale.events.IEventDispatcher).dispatchEvent(org.apache.royale.events.ValueChangeEvent.createUpdateEvent(document, org.apache.royale.utils.Language.as(this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject, mx.rpc.remoting.mxml.RemoteObject).getID(), this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject, this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject));
  }
};


/**
 * @private
 * @type {mx.resources.IResourceManager}
 */
mx.rpc.remoting.Operation.prototype.mx_rpc_remoting_Operation_resourceManager;


/**
 * @type {mx.rpc.remoting.RemoteObject}
 */
mx.rpc.remoting.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject;


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.remoting.Operation.prototype.concurrency;


mx.rpc.remoting.Operation.prototype.get__concurrency = function() {
  if (this.mx_rpc_remoting_Operation__concurrencySet) {
    return this.mx_rpc_remoting_Operation__concurrency;
  }
  return this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject.concurrency;
};


mx.rpc.remoting.Operation.prototype.set__concurrency = function(c) {
  this.mx_rpc_remoting_Operation__concurrency = c;
  this.mx_rpc_remoting_Operation__concurrencySet = true;
};


mx.rpc.remoting.Operation.prototype.get__makeObjectsBindable = function() {
  if (this.mx_rpc_remoting_Operation__makeObjectsBindableSet) {
    return this.http_$$www_adobe_com$2006$flex$mx$internal___makeObjectsBindable;
  }
  return org.apache.royale.utils.Language.as(this.service, mx.rpc.remoting.RemoteObject).makeObjectsBindable;
};


mx.rpc.remoting.Operation.prototype.set__makeObjectsBindable = function(b) {
  this.http_$$www_adobe_com$2006$flex$mx$internal___makeObjectsBindable = b;
  this.mx_rpc_remoting_Operation__makeObjectsBindableSet = true;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.rpc.remoting.Operation.prototype.showBusyCursor;


mx.rpc.remoting.Operation.prototype.get__showBusyCursor = function() {
  if (this.mx_rpc_remoting_Operation__showBusyCursorSet) {
    return this.mx_rpc_remoting_Operation__showBusyCursor;
  }
  return this.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject.showBusyCursor;
};


mx.rpc.remoting.Operation.prototype.set__showBusyCursor = function(sbc) {
  this.mx_rpc_remoting_Operation__showBusyCursor = sbc;
  this.mx_rpc_remoting_Operation__showBusyCursorSet = true;
};


/**
 * @nocollapse
 * @export
 * @type {Array}
 */
mx.rpc.remoting.Operation.prototype.argumentNames;


mx.rpc.remoting.Operation.prototype.get__argumentNames = function() {
  return this.mx_rpc_remoting_Operation__argumentNames;
};


mx.rpc.remoting.Operation.prototype.set__argumentNames = function(value) {
  this.mx_rpc_remoting_Operation__argumentNames = value;
};


Object.defineProperties(mx.rpc.remoting.Operation.prototype, /** @lends {mx.rpc.remoting.Operation.prototype} */ {
/**
 * @type {string}
 */
concurrency: {
get: mx.rpc.remoting.Operation.prototype.get__concurrency,
set: mx.rpc.remoting.Operation.prototype.set__concurrency},
/**
 * @type {boolean}
 */
makeObjectsBindable: {
get: mx.rpc.remoting.Operation.prototype.get__makeObjectsBindable,
set: mx.rpc.remoting.Operation.prototype.set__makeObjectsBindable},
/**
 * @type {boolean}
 */
showBusyCursor: {
get: mx.rpc.remoting.Operation.prototype.get__showBusyCursor,
set: mx.rpc.remoting.Operation.prototype.set__showBusyCursor},
/**
 * @type {Array}
 */
argumentNames: {
get: mx.rpc.remoting.Operation.prototype.get__argumentNames,
set: mx.rpc.remoting.Operation.prototype.set__argumentNames}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.rpc.remoting.Operation.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Operation', qName: 'mx.rpc.remoting.Operation', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.rpc.remoting.Operation.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'http://www.adobe.com/2006/flex/mx/internal::remoteObject': { type: 'mx.rpc.remoting.RemoteObject', get_set: function (/** mx.rpc.remoting.Operation */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__remoteObject;}}
      };
    },
    accessors: function () {
      return {
        'concurrency': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.remoting.Operation'},
        'makeObjectsBindable': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.remoting.Operation'},
        'showBusyCursor': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.remoting.Operation'},
        'argumentNames': { type: 'Array', access: 'readwrite', declaredBy: 'mx.rpc.remoting.Operation'}
      };
    },
    methods: function () {
      return {
        'Operation': { type: '', declaredBy: 'mx.rpc.remoting.Operation', parameters: function () { return [ 'mx.rpc.AbstractService', true ,'String', true ]; }},
        'send': { type: 'mx.rpc.AsyncToken', declaredBy: 'mx.rpc.remoting.Operation', parameters: function () { return [ 'Array', false ]; }},
        'cancel': { type: 'mx.rpc.AsyncToken', declaredBy: 'mx.rpc.remoting.Operation', parameters: function () { return [ 'String', true ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::setService': { type: 'void', declaredBy: 'mx.rpc.remoting.Operation', parameters: function () { return [ 'mx.rpc.AbstractService', false ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::invoke': { type: 'mx.rpc.AsyncToken', declaredBy: 'mx.rpc.remoting.Operation', parameters: function () { return [ 'mx.messaging.messages.IMessage', false ,'mx.rpc.AsyncToken', true ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::preHandle': { type: 'mx.rpc.AsyncToken', declaredBy: 'mx.rpc.remoting.Operation', parameters: function () { return [ 'mx.messaging.events.MessageEvent', false ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::processResult': { type: 'Boolean', declaredBy: 'mx.rpc.remoting.Operation', parameters: function () { return [ 'mx.messaging.messages.IMessage', false ,'mx.rpc.AsyncToken', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.rpc.remoting.Operation.prototype.ROYALE_COMPILE_FLAGS = 10;