/**
 * Generated by Apache Royale Compiler from mx/rpc/soap/mxml/Operation.as
 * mx.rpc.soap.mxml.Operation
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.rpc.soap.mxml.Operation');

goog.require('mx.core.mx_internal');
goog.require('mx.managers.CursorManager');
goog.require('mx.messaging.events.MessageEvent');
goog.require('mx.messaging.messages.AsyncMessage');
goog.require('mx.messaging.messages.IMessage');
goog.require('mx.resources.IResourceManager');
goog.require('mx.resources.ResourceManager');
goog.require('mx.rpc.AbstractService');
goog.require('mx.rpc.AsyncDispatcher');
goog.require('mx.rpc.AsyncToken');
goog.require('mx.rpc.Fault');
goog.require('mx.rpc.events.FaultEvent');
goog.require('mx.rpc.mxml.Concurrency');
goog.require('mx.rpc.soap.Operation');
goog.require('mx.rpc.soap.WebService');
goog.require('mx.rpc.soap.mxml.WebService');
goog.require('mx.rpc.mxml.IMXMLSupport');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 * Creates a new Operation. 
 *
 * @asparam webService The web service upon which this Operation is invoked.
 *
 * @asparam name The name of this Operation.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {mx.rpc.soap.Operation}
 * @implements {mx.rpc.mxml.IMXMLSupport}
 * @param {mx.rpc.soap.WebService=} webService
 * @param {string=} name
 */
mx.rpc.soap.mxml.Operation = function(webService, name) {
  webService = typeof webService !== 'undefined' ? webService : null;
  name = typeof name !== 'undefined' ? name : null;
  
  this.mx_rpc_soap_mxml_Operation_resourceManager = mx.resources.ResourceManager.getInstance();
  mx.rpc.soap.mxml.Operation.base(this, 'constructor', webService, name);
  this.mx_rpc_soap_mxml_Operation_webService = org.apache.royale.utils.Language.as(webService, mx.rpc.soap.mxml.WebService, true);
};
goog.inherits(mx.rpc.soap.mxml.Operation, mx.rpc.soap.Operation);


/**
 * @private
 * @type {mx.resources.IResourceManager}
 */
mx.rpc.soap.mxml.Operation.prototype.mx_rpc_soap_mxml_Operation_resourceManager;


/**
 * @override
 */
mx.rpc.soap.mxml.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__setService = function(ro) {
  mx.rpc.soap.mxml.Operation.superClass_.http_$$www_adobe_com$2006$flex$mx$internal__setService.apply(this, [ro]);
  this.mx_rpc_soap_mxml_Operation_webService = org.apache.royale.utils.Language.as(ro, mx.rpc.soap.mxml.WebService, true);
};


/**
 * @inheritDoc
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @override
 */
mx.rpc.soap.mxml.Operation.prototype.cancel = function(id) {
  id = typeof id !== 'undefined' ? id : null;
  if (this.showBusyCursor) {
    mx.managers.CursorManager.removeBusyCursor();
  }
  return mx.rpc.soap.mxml.Operation.superClass_.cancel.apply(this, [id]);
};


/**
 * @asprivate
 * @override
 */
mx.rpc.soap.mxml.Operation.prototype.send = function(args) {
  args = Array.prototype.slice.call(arguments, 0);
  if (mx.rpc.mxml.Concurrency.SINGLE == this.concurrency && (this.http_$$www_adobe_com$2006$flex$mx$internal__hasPendingInvocations() || this.http_$$www_adobe_com$2006$flex$mx$internal__activeCalls.hasActiveCalls())) {
    var /** @type {mx.rpc.AsyncToken} */ token = new mx.rpc.AsyncToken(null);
    var /** @type {string} */ message = "pendingCallExists";
    var /** @type {mx.rpc.Fault} */ fault = new mx.rpc.Fault("ConcurrencyError", message);
    var /** @type {mx.rpc.events.FaultEvent} */ faultEvent = mx.rpc.events.FaultEvent.createEvent(fault, token);
    new mx.rpc.AsyncDispatcher(org.apache.royale.utils.Language.closure(this.http_$$www_adobe_com$2006$flex$mx$internal__dispatchRpcEvent, this, 'http://www.adobe.com/2006/flex/mx/internal::dispatchRpcEvent'), [faultEvent], 10);
    return token;
  }
  return mx.rpc.soap.mxml.Operation.superClass_.send.apply(this, args);
};


/**
 * @asprivate
 * Return the id for the NetworkMonitor
 * @override
 */
mx.rpc.soap.mxml.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__getNetmonId = function() {
  return this.mx_rpc_soap_mxml_Operation_webService.http_$$www_adobe_com$2006$flex$mx$internal__id;
};


/**
 * @override
 */
mx.rpc.soap.mxml.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__invoke = function(message, token) {
  token = typeof token !== 'undefined' ? token : null;
  if (this.showBusyCursor) {
    mx.managers.CursorManager.setBusyCursor();
  }
  return mx.rpc.soap.mxml.Operation.superClass_.http_$$www_adobe_com$2006$flex$mx$internal__invoke.apply(this, [message, token]);
};


/**
 * @override
 */
mx.rpc.soap.mxml.Operation.prototype.http_$$www_adobe_com$2006$flex$mx$internal__preHandle = function(event) {
  if (this.showBusyCursor) {
    mx.managers.CursorManager.removeBusyCursor();
  }
  var /** @type {boolean} */ wasLastCall = this.http_$$www_adobe_com$2006$flex$mx$internal__activeCalls.wasLastCall(org.apache.royale.utils.Language.as(event.message, mx.messaging.messages.AsyncMessage, true).correlationId);
  var /** @type {mx.rpc.AsyncToken} */ token = mx.rpc.soap.mxml.Operation.superClass_.http_$$www_adobe_com$2006$flex$mx$internal__preHandle.apply(this, [event]);
  if (mx.rpc.mxml.Concurrency.LAST == this.concurrency && !wasLastCall) {
    return null;
  }
  return token;
};


/**
 * @private
 * @type {string}
 */
mx.rpc.soap.mxml.Operation.prototype.mx_rpc_soap_mxml_Operation__concurrency;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.soap.mxml.Operation.prototype.mx_rpc_soap_mxml_Operation__concurrencySet;


/**
 * @private
 * @type {mx.rpc.soap.mxml.WebService}
 */
mx.rpc.soap.mxml.Operation.prototype.mx_rpc_soap_mxml_Operation_webService;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.soap.mxml.Operation.prototype.mx_rpc_soap_mxml_Operation__showBusyCursor;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.soap.mxml.Operation.prototype.mx_rpc_soap_mxml_Operation__showBusyCursorSet;


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.soap.mxml.Operation.prototype.concurrency;


mx.rpc.soap.mxml.Operation.prototype.get__concurrency = function() {
  if (this.mx_rpc_soap_mxml_Operation__concurrencySet) {
    return this.mx_rpc_soap_mxml_Operation__concurrency;
  }
  return this.mx_rpc_soap_mxml_Operation_webService.concurrency;
};


mx.rpc.soap.mxml.Operation.prototype.set__concurrency = function(c) {
  this.mx_rpc_soap_mxml_Operation__concurrency = c;
  this.mx_rpc_soap_mxml_Operation__concurrencySet = true;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.rpc.soap.mxml.Operation.prototype.showBusyCursor;


mx.rpc.soap.mxml.Operation.prototype.get__showBusyCursor = function() {
  if (this.mx_rpc_soap_mxml_Operation__showBusyCursorSet) {
    return this.mx_rpc_soap_mxml_Operation__showBusyCursor;
  }
  return this.mx_rpc_soap_mxml_Operation_webService.showBusyCursor;
};


mx.rpc.soap.mxml.Operation.prototype.set__showBusyCursor = function(sbc) {
  this.mx_rpc_soap_mxml_Operation__showBusyCursor = sbc;
  this.mx_rpc_soap_mxml_Operation__showBusyCursorSet = true;
};


Object.defineProperties(mx.rpc.soap.mxml.Operation.prototype, /** @lends {mx.rpc.soap.mxml.Operation.prototype} */ {
/**
 * @type {string}
 */
concurrency: {
get: mx.rpc.soap.mxml.Operation.prototype.get__concurrency,
set: mx.rpc.soap.mxml.Operation.prototype.set__concurrency},
/**
 * @type {boolean}
 */
showBusyCursor: {
get: mx.rpc.soap.mxml.Operation.prototype.get__showBusyCursor,
set: mx.rpc.soap.mxml.Operation.prototype.set__showBusyCursor}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.rpc.soap.mxml.Operation.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Operation', qName: 'mx.rpc.soap.mxml.Operation', kind: 'class' }], interfaces: [mx.rpc.mxml.IMXMLSupport] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.rpc.soap.mxml.Operation.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'concurrency': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.soap.mxml.Operation'},
        'showBusyCursor': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.soap.mxml.Operation'}
      };
    },
    methods: function () {
      return {
        'Operation': { type: '', declaredBy: 'mx.rpc.soap.mxml.Operation', parameters: function () { return [ 'mx.rpc.soap.WebService', true ,'String', true ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::setService': { type: 'void', declaredBy: 'mx.rpc.soap.mxml.Operation', parameters: function () { return [ 'mx.rpc.AbstractService', false ]; }},
        'cancel': { type: 'mx.rpc.AsyncToken', declaredBy: 'mx.rpc.soap.mxml.Operation', parameters: function () { return [ 'String', true ]; }},
        'send': { type: 'mx.rpc.AsyncToken', declaredBy: 'mx.rpc.soap.mxml.Operation', parameters: function () { return [ 'Array', false ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::getNetmonId': { type: 'String', declaredBy: 'mx.rpc.soap.mxml.Operation'},
        'http://www.adobe.com/2006/flex/mx/internal::invoke': { type: 'mx.rpc.AsyncToken', declaredBy: 'mx.rpc.soap.mxml.Operation', parameters: function () { return [ 'mx.messaging.messages.IMessage', false ,'mx.rpc.AsyncToken', true ]; }},
        'http://www.adobe.com/2006/flex/mx/internal::preHandle': { type: 'mx.rpc.AsyncToken', declaredBy: 'mx.rpc.soap.mxml.Operation', parameters: function () { return [ 'mx.messaging.events.MessageEvent', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.rpc.soap.mxml.Operation.prototype.ROYALE_COMPILE_FLAGS = 10;