/**
 * Generated by Apache Royale Compiler from mx/rpc/soap/mxml/WebService.as
 * mx.rpc.soap.mxml.WebService
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.rpc.soap.mxml.WebService');

goog.require('XML');
goog.require('mx.core.IFlexModuleFactory');
goog.require('mx.core.IUIComponent');
goog.require('mx.core.mx_internal');
goog.require('mx.events.ErrorEvent');
goog.require('mx.messaging.config.ServerConfig');
goog.require('mx.resources.IResourceManager');
goog.require('mx.resources.ResourceManager');
goog.require('mx.rpc.AbstractOperation');
goog.require('mx.rpc.events.FaultEvent');
goog.require('mx.rpc.mxml.Concurrency');
goog.require('mx.rpc.soap.WebService');
goog.require('mx.rpc.soap.mxml.Operation');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('mx.core.IMXMLObject');
goog.require('mx.rpc.mxml.IMXMLSupport');
goog.require('org.apache.royale.core.IDocument');
goog.require('org.apache.royale.utils.Language');



/**
 * Creates a new WebService component.
 *
 * @asparam destination The destination of the WebService, which should
 * match a destination name in the services-config.xml file. If
 * unspecified, the WebService component uses the DefaultHTTP destination.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @constructor
 * @extends {mx.rpc.soap.WebService}
 * @implements {mx.rpc.mxml.IMXMLSupport}
 * @implements {mx.core.IMXMLObject}
 * @implements {org.apache.royale.core.IDocument}
 * @param {string=} destination
 */
mx.rpc.soap.mxml.WebService = function(destination) {
  destination = typeof destination !== 'undefined' ? destination : null;
  
  this.mx_rpc_soap_mxml_WebService_resourceManager = mx.resources.ResourceManager.getInstance();
  mx.rpc.soap.mxml.WebService.base(this, 'constructor', destination);
  this.concurrency = mx.rpc.mxml.Concurrency.MULTIPLE;
  this.showBusyCursor = false;
};
goog.inherits(mx.rpc.soap.mxml.WebService, mx.rpc.soap.WebService);


/**
 * @private
 * @type {mx.resources.IResourceManager}
 */
mx.rpc.soap.mxml.WebService.prototype.mx_rpc_soap_mxml_WebService_resourceManager;


/**
 * This handler is called after the document fires the creationComplete event so that
 * if errors occur while loading the WSDL all components will be ready to handle the fault.
 * @asprivate
 * @param {org.apache.royale.events.Event} event
 */
mx.rpc.soap.mxml.WebService.prototype.creationComplete = function(event) {
  if (this.canLoadWSDL()) {
    this.loadWSDL();
  }
};


/**
 * If this event is an error or fault, and the event type does not
 * have a listener, we notify the parent document.  If the     
 * parent document does not have a listener, then we throw
 * a runtime exception.  However, this is an asynchronous runtime
 * exception which is only exposed through the debug player.
 * A listener should be defined.
 *
 * @asprivate
 * @override
 */
mx.rpc.soap.mxml.WebService.prototype.dispatchEvent = function(event) {
  if (this.hasEventListener(event.type)) {
    return mx.rpc.soap.mxml.WebService.superClass_.dispatchEvent.apply(this, [event]);
  } else if ((org.apache.royale.utils.Language.is(event, mx.rpc.events.FaultEvent) && !this.http_$$www_adobe_com$2006$flex$mx$internal__hasTokenResponders(event)) || org.apache.royale.utils.Language.is(event, mx.events.ErrorEvent)) {
    var /** @type {string} */ reason = org.apache.royale.utils.Language.is(event, mx.rpc.events.FaultEvent) ? org.apache.royale.utils.Language.as(event, mx.rpc.events.FaultEvent, true).fault.faultString : org.apache.royale.utils.Language.as(event, mx.events.ErrorEvent, true).text;
    if (this.http_$$www_adobe_com$2006$flex$mx$internal__document && this.http_$$www_adobe_com$2006$flex$mx$internal__document.willTrigger(mx.events.ErrorEvent.ERROR)) {
      var /** @type {mx.events.ErrorEvent} */ evt = new mx.events.ErrorEvent(mx.events.ErrorEvent.ERROR, true, true);
      evt.text = reason;
      return !!(this.http_$$www_adobe_com$2006$flex$mx$internal__document.dispatchEvent(evt));
    } else if (org.apache.royale.utils.Language.is(event, mx.rpc.events.FaultEvent)) {
      throw org.apache.royale.utils.Language.as(event, mx.rpc.events.FaultEvent, true).fault;
    } else {
      var /** @type {string} */ message = this.mx_rpc_soap_mxml_WebService_resourceManager.getString("rpc", "noListenerForEvent", [reason]);
      throw new Error(message);
    }
  }
  return false;
};


/**
 * Returns an Operation of the given name. If the Operation wasn't
 * created beforehand, a new <code>mx.rpc.soap.mxml.Operation</code> is
 * created during this call. Operations are usually accessible by simply
 * naming them after the service variable
 * (<code>myService.someOperation</code>), but if your Operation name
 * happens to match a defined method on the service
 * (like <code>setCredentials</code>), you can use this method to get the
 * Operation instead.
 * @asparam name Name of the Operation.
 * @asreturn Operation that executes for this name.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @override
 */
mx.rpc.soap.mxml.WebService.prototype.getOperation = function(name) {
  var /** @type {Object} */ o = this.http_$$www_adobe_com$2006$flex$mx$internal___operations[name];
  var /** @type {mx.rpc.AbstractOperation} */ op = org.apache.royale.utils.Language.is(o, mx.rpc.AbstractOperation) ? org.apache.royale.utils.Language.as(o, mx.rpc.AbstractOperation, true) : null;
  if (op == null) {
    op = new mx.rpc.soap.mxml.Operation(this, name);
    this.http_$$www_adobe_com$2006$flex$mx$internal___operations[name] = op;
    op.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest = this.http_$$www_adobe_com$2006$flex$mx$internal__asyncRequest;
    op.http_$$www_adobe_com$2006$flex$mx$internal__setKeepLastResultIfNotSet(this._keepLastResult);
    this.initializeOperation(org.apache.royale.utils.Language.as(op, mx.rpc.soap.mxml.Operation));
  }
  return op;
};


/**
 * Called automatically by the MXML compiler if the WebService is setup using a tag.  If you create
 * the WebService through ActionScript you may want to call this method yourself as it is useful for
 * validating any arguments.
 *
 * @asparam document the MXML document on which this WebService lives
 * @asparam id the id of this WebService within the document
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @param {Object} document
 * @param {string} id
 */
mx.rpc.soap.mxml.WebService.prototype.initialized = function(document, id) {
  this.http_$$www_adobe_com$2006$flex$mx$internal__document = document;
  this.http_$$www_adobe_com$2006$flex$mx$internal__id = id;
  if (org.apache.royale.utils.Language.is(document, org.apache.royale.events.IEventDispatcher)) {
    org.apache.royale.utils.Language.as(document, org.apache.royale.events.IEventDispatcher, true).addEventListener("creationComplete", org.apache.royale.utils.Language.closure(this.creationComplete, this, 'creationComplete'));
  }
  this.initialize();
};


/**
 * @param {Object} document
 * @param {string=} id
 */
mx.rpc.soap.mxml.WebService.prototype.setDocument = function(document, id) {
  id = typeof id !== 'undefined' ? id : null;
  this.http_$$www_adobe_com$2006$flex$mx$internal__document = document;
  this.http_$$www_adobe_com$2006$flex$mx$internal__id = id;
  if (org.apache.royale.utils.Language.is(document, org.apache.royale.events.IEventDispatcher)) {
    org.apache.royale.utils.Language.as(document, org.apache.royale.events.IEventDispatcher, true).addEventListener("creationComplete", org.apache.royale.utils.Language.closure(this.creationComplete, this, 'creationComplete'));
  }
  if (org.apache.royale.utils.Language.is(document, mx.core.IUIComponent)) {
    mx.messaging.config.ServerConfig.xml = new XML(org.apache.royale.utils.Language.as(org.apache.royale.utils.Language.as(document, mx.core.IUIComponent).systemManager, mx.core.IFlexModuleFactory).info()["servicesConfig"]);
  }
  this.initialize();
};


/**
 * @type {Object}
 */
mx.rpc.soap.mxml.WebService.prototype.http_$$www_adobe_com$2006$flex$mx$internal__document;


/**
 * @type {string}
 */
mx.rpc.soap.mxml.WebService.prototype.http_$$www_adobe_com$2006$flex$mx$internal__id;


/**
 * @private
 * @type {string}
 */
mx.rpc.soap.mxml.WebService.prototype.mx_rpc_soap_mxml_WebService__concurrency;


/**
 * @private
 * @type {boolean}
 */
mx.rpc.soap.mxml.WebService.prototype.mx_rpc_soap_mxml_WebService__showBusyCursor;


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.soap.mxml.WebService.prototype.concurrency;


mx.rpc.soap.mxml.WebService.prototype.get__concurrency = function() {
  return this.mx_rpc_soap_mxml_WebService__concurrency;
};


mx.rpc.soap.mxml.WebService.prototype.set__concurrency = function(c) {
  this.mx_rpc_soap_mxml_WebService__concurrency = c;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.soap.mxml.WebService.prototype.protocol;


mx.rpc.soap.mxml.WebService.prototype.set__protocol = function(protocol) {
  if (this.destination == mx.rpc.soap.WebService.DEFAULT_DESTINATION_HTTP || this.destination == mx.rpc.soap.WebService.DEFAULT_DESTINATION_HTTP) {
    if (protocol == "http") {
      this.destination = mx.rpc.soap.WebService.DEFAULT_DESTINATION_HTTP;
    } else if (protocol == "https") {
      this.destination = mx.rpc.soap.WebService.DEFAULT_DESTINATION_HTTPS;
    } else {
      var /** @type {string} */ message = this.mx_rpc_soap_mxml_WebService_resourceManager.getString("rpc", "unknownProtocol", [protocol]);
      throw new Error(message);
    }
  }
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.rpc.soap.mxml.WebService.prototype.serviceName;


mx.rpc.soap.mxml.WebService.prototype.get__serviceName = function() {
  return this.destination;
};


mx.rpc.soap.mxml.WebService.prototype.set__serviceName = function(sn) {
  this.destination = sn;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.rpc.soap.mxml.WebService.prototype.showBusyCursor;


mx.rpc.soap.mxml.WebService.prototype.get__showBusyCursor = function() {
  return this.mx_rpc_soap_mxml_WebService__showBusyCursor;
};


mx.rpc.soap.mxml.WebService.prototype.set__showBusyCursor = function(sbc) {
  this.mx_rpc_soap_mxml_WebService__showBusyCursor = sbc;
};


Object.defineProperties(mx.rpc.soap.mxml.WebService.prototype, /** @lends {mx.rpc.soap.mxml.WebService.prototype} */ {
/**
 * @type {string}
 */
concurrency: {
get: mx.rpc.soap.mxml.WebService.prototype.get__concurrency,
set: mx.rpc.soap.mxml.WebService.prototype.set__concurrency},
/**
 * @type {string}
 */
protocol: {
set: mx.rpc.soap.mxml.WebService.prototype.set__protocol},
/**
 * @type {string}
 */
serviceName: {
get: mx.rpc.soap.mxml.WebService.prototype.get__serviceName,
set: mx.rpc.soap.mxml.WebService.prototype.set__serviceName},
/**
 * @type {boolean}
 */
showBusyCursor: {
get: mx.rpc.soap.mxml.WebService.prototype.get__showBusyCursor,
set: mx.rpc.soap.mxml.WebService.prototype.set__showBusyCursor}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.rpc.soap.mxml.WebService.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'WebService', qName: 'mx.rpc.soap.mxml.WebService', kind: 'class', isDynamic: true}], interfaces: [mx.rpc.mxml.IMXMLSupport, mx.core.IMXMLObject, org.apache.royale.core.IDocument] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.rpc.soap.mxml.WebService.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'http://www.adobe.com/2006/flex/mx/internal::document': { type: 'Object', get_set: function (/** mx.rpc.soap.mxml.WebService */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__document = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__document;}},
        'http://www.adobe.com/2006/flex/mx/internal::id': { type: 'String', get_set: function (/** mx.rpc.soap.mxml.WebService */ inst, /** * */ v) {return v !== undefined ? inst.http_$$www_adobe_com$2006$flex$mx$internal__id = v : inst.http_$$www_adobe_com$2006$flex$mx$internal__id;}}
      };
    },
    accessors: function () {
      return {
        'concurrency': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.soap.mxml.WebService'},
        'protocol': { type: 'String', access: 'writeonly', declaredBy: 'mx.rpc.soap.mxml.WebService'},
        'serviceName': { type: 'String', access: 'readwrite', declaredBy: 'mx.rpc.soap.mxml.WebService'},
        'showBusyCursor': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.rpc.soap.mxml.WebService'}
      };
    },
    methods: function () {
      return {
        'WebService': { type: '', declaredBy: 'mx.rpc.soap.mxml.WebService', parameters: function () { return [ 'String', true ]; }},
        'creationComplete': { type: 'void', declaredBy: 'mx.rpc.soap.mxml.WebService', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }},
        'dispatchEvent': { type: 'Boolean', declaredBy: 'mx.rpc.soap.mxml.WebService', parameters: function () { return [ 'org.apache.royale.events.Event', false ]; }},
        'getOperation': { type: 'mx.rpc.AbstractOperation', declaredBy: 'mx.rpc.soap.mxml.WebService', parameters: function () { return [ 'String', false ]; }},
        'initialized': { type: 'void', declaredBy: 'mx.rpc.soap.mxml.WebService', parameters: function () { return [ 'Object', false ,'String', false ]; }},
        'setDocument': { type: 'void', declaredBy: 'mx.rpc.soap.mxml.WebService', parameters: function () { return [ 'Object', false ,'String', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.rpc.soap.mxml.WebService.prototype.ROYALE_COMPILE_FLAGS = 10;