/**
 * Generated by Apache Royale Compiler from mx/utils/NameUtil.as
 * mx.utils.NameUtil
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.utils.NameUtil');

goog.require('org.apache.royale.reflection.getQualifiedClassName');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 * @constructor
 */
mx.utils.NameUtil = function() {
};


/**
 * @private
 * @type {number}
 */
mx.utils.NameUtil.counter = 0;


/**
 *  Creates a unique name for any Object instance, such as "Button12", by
 *  combining the unqualified class name with an incrementing counter.
 *
 *  @asparam object Object requiring a name.
 *
 *  @asreturn String containing the unique name.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @nocollapse
 * @param {Object} object
 * @return {string}
 */
mx.utils.NameUtil.createUniqueName = function(object) {
  if (!object)
    return null;
  var /** @type {string} */ name = org.apache.royale.reflection.getQualifiedClassName(object);
  var /** @type {number} */ index = (name.lastIndexOf(".")) >> 0;
  if (index != -1)
    name = name.substr(index + 1);
  var /** @type {number} */ charCode = (name.charCodeAt(name.length - 1)) >> 0;
  if (charCode >= 48 && charCode <= 57)
    name += "_";
  return name + mx.utils.NameUtil.counter++;
};


/**
 *  Returns the name of the specified object's class,
 *  such as <code>"Button"</code>
 *
 *  <p>This string does not include the package name.
 *  If you need the package name as well, call the
 *  <code>getQualifiedClassName()</code> method in the flash.utils package.
 *  It will return a string such as <code>"mx.controls::Button"</code>.</p>
 *
 *  @asparam object The object.
 *
 *  @asreturn The name of the specified object's class.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @nocollapse
 * @param {Object} object
 * @return {string}
 */
mx.utils.NameUtil.getUnqualifiedClassName = function(object) {
  var /** @type {string} */ name;
  if (org.apache.royale.utils.Language.is(object, String))
    name = org.apache.royale.utils.Language.as(object, String);
  else
    name = org.apache.royale.reflection.getQualifiedClassName(object);
  var /** @type {number} */ index = (name.lastIndexOf(".")) >> 0;
  if (index != -1)
    name = name.substr(index + 1);
  return name;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.utils.NameUtil.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'NameUtil', qName: 'mx.utils.NameUtil', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.utils.NameUtil.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    methods: function () {
      return {
        '|createUniqueName': { type: 'String', declaredBy: 'mx.utils.NameUtil', parameters: function () { return [ 'Object', false ]; }},
        '|getUnqualifiedClassName': { type: 'String', declaredBy: 'mx.utils.NameUtil', parameters: function () { return [ 'Object', false ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.utils.NameUtil.prototype.ROYALE_COMPILE_FLAGS = 10;