/**
 * Generated by Apache Royale Compiler from mx/validators/IValidator.as
 * mx.validators.IValidator
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.validators.IValidator');

goog.require('mx.events.ValidationResultEvent');
goog.require('XML');



/**
 * @interface
 */
mx.validators.IValidator = function() {
};
/**  * @type {boolean}
 */mx.validators.IValidator.prototype.enabled;
/**
 *  Performs validation and optionally notifies
 *  the listeners of the result. 
 *
 *  @asparam value Optional value to validate.
 *  If null, then the validator uses the <code>source</code> and
 *  <code>property</code> properties to determine the value.
 *  If you specify this argument, you should also set the
 *  <code>listener</code> property to specify the target component
 *  for any validation error messages.
 *
 *  @asparam suppressEvents If <code>false</code>, then after validation,
 *  the validator will notify the listener of the result.
 *
 *  @asreturn A ValidationResultEvent object
 *  containing the results of the validation. 
 *  For a successful validation, the
 *  <code>ValidationResultEvent.results</code> Array property is empty. 
 *  For a validation failure, the
 *  <code>ValidationResultEvent.results</code> Array property contains
 *  one ValidationResult object for each field checked by the validator, 
 *  both for fields that failed the validation and for fields that passed. 
 *  Examine the <code>ValidationResult.isError</code>
 *  property to determine if the field passed or failed the validation. 
 *
 *  @see mx.events.ValidationResultEvent
 *  @see mx.validators.ValidationResult
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.1
 *  @playerversion AIR 2.5
 *  @productversion Flex 4.5
 * @param {Object=} value
 * @param {boolean=} suppressEvents
 * @return {mx.events.ValidationResultEvent}
 */
mx.validators.IValidator.prototype.validate = function(value, suppressEvents) {
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.validators.IValidator.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'IValidator', qName: 'mx.validators.IValidator', kind: 'interface' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.validators.IValidator.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'enabled': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.validators.IValidator'}
      };
    },
    methods: function () {
      return {
        'validate': { type: 'mx.events.ValidationResultEvent', declaredBy: 'mx.validators.IValidator', parameters: function () { return [ 'Object', true ,'Boolean', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.validators.IValidator.prototype.ROYALE_COMPILE_FLAGS = 10;