/**
 * Generated by Apache Royale Compiler from mx/validators/NumberValidator.as
 * mx.validators.NumberValidator
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.validators.NumberValidator');

goog.require('mx.validators.NumberValidatorDomainType');
goog.require('mx.validators.ValidationResult');
goog.require('mx.validators.Validator');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @constructor
 * @extends {mx.validators.Validator}
 */
mx.validators.NumberValidator = function() {
  mx.validators.NumberValidator.base(this, 'constructor');
};
goog.inherits(mx.validators.NumberValidator, mx.validators.Validator);


/**
 *  Convenience method for calling a validator
 *  from within a custom validation function.
 *  Each of the standard Flex validators has a similar convenience method.
 *
 *  @asparam validator The NumberValidator instance.
 *
 *  @asparam value A field to validate.
 *
 *  @asparam baseField Text representation of the subfield
 *  specified in the <code>value</code> parameter.
 *  For example, if the <code>value</code> parameter specifies value.number,
 *  the <code>baseField</code> value is "number".
 *
 *  @asreturn An Array of ValidationResult objects, with one ValidationResult 
 *  object for each field examined by the validator. 
 *
 *  @see mx.validators.ValidationResult
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @nocollapse
 * @param {mx.validators.NumberValidator} validator
 * @param {Object} value
 * @param {string} baseField
 * @return {Array}
 */
mx.validators.NumberValidator.validateNumber = function(validator, value, baseField) {
  var /** @type {number} */ i = 0;
  var /** @type {Array} */ results = [];
  var /** @type {boolean} */ allowNegative = !!(validator.allowNegative);
  var /** @type {string} */ decimalSeparator = validator.decimalSeparator;
  var /** @type {string} */ domain = validator.domain;
  var /** @type {number} */ maxValue = Number(validator.maxValue);
  var /** @type {number} */ minValue = Number(validator.minValue);
  var /** @type {number} */ precision = org.apache.royale.utils.Language._int(validator.precision);
  var /** @type {string} */ thousandsSeparator = validator.thousandsSeparator;
  var /** @type {string} */ input = String(value);
  var /** @type {number} */ len = (input.length) >> 0;
  var /** @type {boolean} */ isNegative = false;
  //var /** @type {number} */ i = 0;
  var /** @type {string} */ c;
  var /** @type {boolean} */ isNumber = org.apache.royale.utils.Language.is(value, Number);
  var /** @type {string} */ invalidFormChars = mx.validators.Validator.DECIMAL_DIGITS + "-";
  if (decimalSeparator == thousandsSeparator || invalidFormChars.indexOf(decimalSeparator) != -1 || invalidFormChars.indexOf(thousandsSeparator) != -1 || decimalSeparator.length != 1 || thousandsSeparator.length != 1) {
    results.push(new mx.validators.ValidationResult(true, baseField, "invalidFormatChar", validator.invalidFormatCharsError));
    return results;
  }
  var /** @type {string} */ validChars = mx.validators.Validator.DECIMAL_DIGITS + "-" + decimalSeparator + thousandsSeparator;
  for (i = 0; i < len; i++) {
    c = input.charAt(i);
    if (validChars.indexOf(c) == -1) {
      results.push(new mx.validators.ValidationResult(true, baseField, "invalidChar", validator.invalidCharError));
      return results;
    }
  }
  if (input.charAt(0) == "-") {
    if (len == 1) {
      results.push(new mx.validators.ValidationResult(true, baseField, "invalidChar", validator.invalidCharError));
      return results;
    } else if (len == 2 && input.charAt(1) == '.') {
      results.push(new mx.validators.ValidationResult(true, baseField, "invalidChar", validator.invalidCharError));
      return results;
    }
    if (!allowNegative) {
      results.push(new mx.validators.ValidationResult(true, baseField, "negative", validator.negativeError));
      return results;
    }
    input = input.substring(1);
    len--;
    isNegative = true;
  }
  if (input.indexOf(decimalSeparator) != input.lastIndexOf(decimalSeparator)) {
    results.push(new mx.validators.ValidationResult(true, baseField, "decimalPointCount", validator.decimalPointCountError));
    return results;
  }
  var /** @type {number} */ decimalSeparatorIndex = input.indexOf(decimalSeparator);
  if (decimalSeparatorIndex != -1) {
    var /** @type {number} */ numDigitsAfterDecimal = 0;
    if (i == 1 && i == len) {
      results.push(new mx.validators.ValidationResult(true, baseField, "invalidChar", validator.invalidCharError));
      return results;
    }
    for (i = (decimalSeparatorIndex + 1) >> 0; i < len; i++) {
      if (mx.validators.Validator.DECIMAL_DIGITS.indexOf(input.charAt(i)) == -1) {
        results.push(new mx.validators.ValidationResult(true, baseField, "invalidChar", validator.invalidCharError));
        return results;
      }
      ++numDigitsAfterDecimal;
      if (domain == mx.validators.NumberValidatorDomainType.INT && input.charAt(i) != "0") {
        results.push(new mx.validators.ValidationResult(true, baseField, "integer", validator.integerError));
        return results;
      }
      if (precision != -1 && numDigitsAfterDecimal > precision) {
        results.push(new mx.validators.ValidationResult(true, baseField, "precision", validator.precisionError));
        return results;
      }
    }
  }
  if (mx.validators.Validator.DECIMAL_DIGITS.indexOf(input.charAt(0)) == -1 && input.charAt(0) != decimalSeparator) {
    results.push(new mx.validators.ValidationResult(true, baseField, "invalidChar", validator.invalidCharError));
    return results;
  }
  var /** @type {number} */ end = (decimalSeparatorIndex == -1 ? len : decimalSeparatorIndex) >> 0;
  if (!isNumber) {
    for (i = 1; i < end; i++) {
      c = input.charAt(i);
      if (c == thousandsSeparator) {
        if (c == thousandsSeparator) {
          if ((end - i != 4 && input.charAt(i + 4) != thousandsSeparator) || mx.validators.Validator.DECIMAL_DIGITS.indexOf(input.charAt(i + 1)) == -1 || mx.validators.Validator.DECIMAL_DIGITS.indexOf(input.charAt(i + 2)) == -1 || mx.validators.Validator.DECIMAL_DIGITS.indexOf(input.charAt(i + 3)) == -1) {
            results.push(new mx.validators.ValidationResult(true, baseField, "separation", validator.separationError));
            return results;
          }
        }
      } else if (mx.validators.Validator.DECIMAL_DIGITS.indexOf(c) == -1) {
        results.push(new mx.validators.ValidationResult(true, baseField, "invalidChar", validator.invalidCharError));
        return results;
      }
    }
  }
  if (!isNaN(minValue) || !isNaN(maxValue)) {
    for (i = 0; i < end; i++) {
      if (input.charAt(i) == thousandsSeparator) {
        var /** @type {string} */ left = input.substring(0, i);
        var /** @type {string} */ right = input.substring(i + 1);
        input = left + right;
      }
    }
    if (validator.decimalSeparator != '.') {
      var /** @type {number} */ dIndex = (input.indexOf(validator.decimalSeparator)) >> 0;
      if (dIndex != -1) {
        var /** @type {string} */ dLeft = input.substring(0, dIndex);
        var /** @type {string} */ dRight = input.substring(dIndex + 1);
        input = dLeft + '.' + dRight;
      }
    }
    var /** @type {number} */ x = Number(input);
    if (isNegative)
      x = -x;
    if (!isNaN(minValue) && x < minValue) {
      results.push(new mx.validators.ValidationResult(true, baseField, "lowerThanMin", validator.lowerThanMinError));
      return results;
    }
    if (!isNaN(maxValue) && x > maxValue) {
      results.push(new mx.validators.ValidationResult(true, baseField, "exceedsMax", validator.exceedsMaxError));
      return results;
    }
  }
  return results;
};


/**
 * @private
 * @type {Object}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__allowNegative = true;


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__decimalSeparator = ".";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__domain = "real";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__integerError = "The number must be an integer.";


/**
 * @private
 * @type {Object}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__maxValue;


/**
 * @private
 * @type {Object}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__minValue;


/**
 * @private
 * @type {Object}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__precision = -1;


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__thousandsSeparator = ",";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__decimalPointCountError = "The decimal separator can occur only once.";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__exceedsMaxError = "The number entered is too large.";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__invalidCharError = "The input contains invalid characters.";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__invalidFormatCharsError = "One of the formatting parameters is invalid.";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator_invalidFormatCharsErrorOverride;


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__lowerThanMinError = "The amount entered is too small.";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__negativeError = "The amount may not be negative.";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__precisionError = "The amount entered has too many digits beyond the decimal point.";


/**
 * @private
 * @type {string}
 */
mx.validators.NumberValidator.prototype.mx_validators_NumberValidator__separationError = "The thousands separator must be followed by three digits.";


/**
 *  Override of the base class <code>doValidation()</code> method 
 *  to validate a number.
 *
 *  <p>You do not call this method directly;
 *  Flex calls it as part of performing a validation.
 *  If you create a custom Validator class, you must implement this method. </p>
 *
 *  @asparam value Object to validate.
 *
 *  @asreturn An Array of ValidationResult objects, with one ValidationResult 
 *  object for each field examined by the validator. 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Flex 3
 * @protected
 * @override
 */
mx.validators.NumberValidator.prototype.doValidation = function(value) {
  var /** @type {Array} */ results = mx.validators.NumberValidator.superClass_.doValidation.apply(this, [value]);
  var /** @type {string} */ val = value ? String(value) : "";
  if (results.length > 0 || ((val.length == 0) && !this.required))
    return results;
  else
    return mx.validators.NumberValidator.validateNumber(this, value, null);
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.validators.NumberValidator.prototype.allowNegative;


mx.validators.NumberValidator.prototype.get__allowNegative = function() {
  return this.mx_validators_NumberValidator__allowNegative;
};


mx.validators.NumberValidator.prototype.set__allowNegative = function(value) {
  this.mx_validators_NumberValidator__allowNegative = value != null ? Boolean(value) : true;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.decimalSeparator;


mx.validators.NumberValidator.prototype.get__decimalSeparator = function() {
  return this.mx_validators_NumberValidator__decimalSeparator;
};


mx.validators.NumberValidator.prototype.set__decimalSeparator = function(value) {
  this.mx_validators_NumberValidator__decimalSeparator = value != null ? value : ".";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.domain;


mx.validators.NumberValidator.prototype.get__domain = function() {
  return this.mx_validators_NumberValidator__domain;
};


mx.validators.NumberValidator.prototype.set__domain = function(value) {
  this.mx_validators_NumberValidator__domain = value != null ? value : "real";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.integerError;


mx.validators.NumberValidator.prototype.get__integerError = function() {
  return this.mx_validators_NumberValidator__integerError;
};


mx.validators.NumberValidator.prototype.set__integerError = function(value) {
  this.mx_validators_NumberValidator__integerError = value != null ? value : "";
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.validators.NumberValidator.prototype.maxValue;


mx.validators.NumberValidator.prototype.get__maxValue = function() {
  return this.mx_validators_NumberValidator__maxValue;
};


mx.validators.NumberValidator.prototype.set__maxValue = function(value) {
  this.mx_validators_NumberValidator__maxValue = value != null ? Number(value) : NaN;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.validators.NumberValidator.prototype.minValue;


mx.validators.NumberValidator.prototype.get__minValue = function() {
  return this.mx_validators_NumberValidator__minValue;
};


mx.validators.NumberValidator.prototype.set__minValue = function(value) {
  this.mx_validators_NumberValidator__minValue = value != null ? Number(value) : NaN;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.validators.NumberValidator.prototype.precision;


mx.validators.NumberValidator.prototype.get__precision = function() {
  return this.mx_validators_NumberValidator__precision;
};


mx.validators.NumberValidator.prototype.set__precision = function(value) {
  this.mx_validators_NumberValidator__precision = value != null ? org.apache.royale.utils.Language._int(value) : -1;
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.thousandsSeparator;


mx.validators.NumberValidator.prototype.get__thousandsSeparator = function() {
  return this.mx_validators_NumberValidator__thousandsSeparator;
};


mx.validators.NumberValidator.prototype.set__thousandsSeparator = function(value) {
  this.mx_validators_NumberValidator__thousandsSeparator = value != null ? value : ",";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.decimalPointCountError;


mx.validators.NumberValidator.prototype.get__decimalPointCountError = function() {
  return this.mx_validators_NumberValidator__decimalPointCountError;
};


mx.validators.NumberValidator.prototype.set__decimalPointCountError = function(value) {
  this.mx_validators_NumberValidator__decimalPointCountError = value != null ? value : "";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.exceedsMaxError;


mx.validators.NumberValidator.prototype.get__exceedsMaxError = function() {
  return this.mx_validators_NumberValidator__exceedsMaxError;
};


mx.validators.NumberValidator.prototype.set__exceedsMaxError = function(value) {
  this.mx_validators_NumberValidator__exceedsMaxError = value != null ? value : "";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.invalidCharError;


mx.validators.NumberValidator.prototype.get__invalidCharError = function() {
  return this.mx_validators_NumberValidator__invalidCharError;
};


mx.validators.NumberValidator.prototype.set__invalidCharError = function(value) {
  this.mx_validators_NumberValidator__invalidCharError = value != null ? value : "";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.invalidFormatCharsError;


mx.validators.NumberValidator.prototype.get__invalidFormatCharsError = function() {
  return this.mx_validators_NumberValidator__invalidFormatCharsError;
};


mx.validators.NumberValidator.prototype.set__invalidFormatCharsError = function(value) {
  this.mx_validators_NumberValidator_invalidFormatCharsErrorOverride = value;
  this.mx_validators_NumberValidator__invalidFormatCharsError = value != null ? value : "";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.lowerThanMinError;


mx.validators.NumberValidator.prototype.get__lowerThanMinError = function() {
  return this.mx_validators_NumberValidator__lowerThanMinError;
};


mx.validators.NumberValidator.prototype.set__lowerThanMinError = function(value) {
  this.mx_validators_NumberValidator__lowerThanMinError = value != null ? value : "";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.negativeError;


mx.validators.NumberValidator.prototype.get__negativeError = function() {
  return this.mx_validators_NumberValidator__negativeError;
};


mx.validators.NumberValidator.prototype.set__negativeError = function(value) {
  this.mx_validators_NumberValidator__negativeError = value != null ? value : "";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.precisionError;


mx.validators.NumberValidator.prototype.get__precisionError = function() {
  return this.mx_validators_NumberValidator__precisionError;
};


mx.validators.NumberValidator.prototype.set__precisionError = function(value) {
  this.mx_validators_NumberValidator__precisionError = value != null ? value : "";
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.NumberValidator.prototype.separationError;


mx.validators.NumberValidator.prototype.get__separationError = function() {
  return this.mx_validators_NumberValidator__separationError;
};


mx.validators.NumberValidator.prototype.set__separationError = function(value) {
  this.mx_validators_NumberValidator__separationError = value != null ? value : "";
};


Object.defineProperties(mx.validators.NumberValidator.prototype, /** @lends {mx.validators.NumberValidator.prototype} */ {
/**
 * @type {Object}
 */
allowNegative: {
get: mx.validators.NumberValidator.prototype.get__allowNegative,
set: mx.validators.NumberValidator.prototype.set__allowNegative},
/**
 * @type {string}
 */
decimalSeparator: {
get: mx.validators.NumberValidator.prototype.get__decimalSeparator,
set: mx.validators.NumberValidator.prototype.set__decimalSeparator},
/**
 * @type {string}
 */
domain: {
get: mx.validators.NumberValidator.prototype.get__domain,
set: mx.validators.NumberValidator.prototype.set__domain},
/**
 * @type {string}
 */
integerError: {
get: mx.validators.NumberValidator.prototype.get__integerError,
set: mx.validators.NumberValidator.prototype.set__integerError},
/**
 * @type {Object}
 */
maxValue: {
get: mx.validators.NumberValidator.prototype.get__maxValue,
set: mx.validators.NumberValidator.prototype.set__maxValue},
/**
 * @type {Object}
 */
minValue: {
get: mx.validators.NumberValidator.prototype.get__minValue,
set: mx.validators.NumberValidator.prototype.set__minValue},
/**
 * @type {Object}
 */
precision: {
get: mx.validators.NumberValidator.prototype.get__precision,
set: mx.validators.NumberValidator.prototype.set__precision},
/**
 * @type {string}
 */
thousandsSeparator: {
get: mx.validators.NumberValidator.prototype.get__thousandsSeparator,
set: mx.validators.NumberValidator.prototype.set__thousandsSeparator},
/**
 * @type {string}
 */
decimalPointCountError: {
get: mx.validators.NumberValidator.prototype.get__decimalPointCountError,
set: mx.validators.NumberValidator.prototype.set__decimalPointCountError},
/**
 * @type {string}
 */
exceedsMaxError: {
get: mx.validators.NumberValidator.prototype.get__exceedsMaxError,
set: mx.validators.NumberValidator.prototype.set__exceedsMaxError},
/**
 * @type {string}
 */
invalidCharError: {
get: mx.validators.NumberValidator.prototype.get__invalidCharError,
set: mx.validators.NumberValidator.prototype.set__invalidCharError},
/**
 * @type {string}
 */
invalidFormatCharsError: {
get: mx.validators.NumberValidator.prototype.get__invalidFormatCharsError,
set: mx.validators.NumberValidator.prototype.set__invalidFormatCharsError},
/**
 * @type {string}
 */
lowerThanMinError: {
get: mx.validators.NumberValidator.prototype.get__lowerThanMinError,
set: mx.validators.NumberValidator.prototype.set__lowerThanMinError},
/**
 * @type {string}
 */
negativeError: {
get: mx.validators.NumberValidator.prototype.get__negativeError,
set: mx.validators.NumberValidator.prototype.set__negativeError},
/**
 * @type {string}
 */
precisionError: {
get: mx.validators.NumberValidator.prototype.get__precisionError,
set: mx.validators.NumberValidator.prototype.set__precisionError},
/**
 * @type {string}
 */
separationError: {
get: mx.validators.NumberValidator.prototype.get__separationError,
set: mx.validators.NumberValidator.prototype.set__separationError}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.validators.NumberValidator.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'NumberValidator', qName: 'mx.validators.NumberValidator', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.validators.NumberValidator.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'allowNegative': { type: 'Object', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'decimalSeparator': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'domain': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'integerError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'maxValue': { type: 'Object', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'minValue': { type: 'Object', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'precision': { type: 'Object', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'thousandsSeparator': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'decimalPointCountError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'exceedsMaxError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'invalidCharError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'invalidFormatCharsError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'lowerThanMinError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'negativeError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'precisionError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'},
        'separationError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.NumberValidator'}
      };
    },
    methods: function () {
      return {
        '|validateNumber': { type: 'Array', declaredBy: 'mx.validators.NumberValidator', parameters: function () { return [ 'mx.validators.NumberValidator', false ,'Object', false ,'String', false ]; }},
        'NumberValidator': { type: '', declaredBy: 'mx.validators.NumberValidator'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.validators.NumberValidator.prototype.ROYALE_COMPILE_FLAGS = 10;