/**
 * Generated by Apache Royale Compiler from mx/validators/Validator.as
 * mx.validators.Validator
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('mx.validators.Validator');

goog.require('mx.events.FlexEvent');
goog.require('mx.events.ValidationResultEvent');
goog.require('mx.utils.ObjectUtil');
goog.require('mx.validators.IValidator');
goog.require('mx.validators.IValidatorListener');
goog.require('mx.validators.ValidationResult');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.EventDispatcher');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.utils.Language');
goog.require('XML');



/**
 *  Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @constructor
 * @extends {org.apache.royale.events.EventDispatcher}
 */
mx.validators.Validator = function() {
  
  this.subFields = [];
  this.mx_validators_Validator__triggerEvent = mx.events.FlexEvent.VALUE_COMMIT;
  mx.validators.Validator.base(this, 'constructor');
};
goog.inherits(mx.validators.Validator, org.apache.royale.events.EventDispatcher);


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
mx.validators.Validator.ROMAN_LETTERS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";


/**
 * @protected
 * @nocollapse
 * @const
 * @type {string}
 */
mx.validators.Validator.DECIMAL_DIGITS = "0123456789";


/**
 *  Invokes all the validators in the <code>validators</code> Array.
 *  Returns an Array containing one ValidationResultEvent object 
 *  for each validator that failed.
 *  Returns an empty Array if all validators succeed. 
 *
 *  @asparam validators An Array containing the Validator objects to execute. 
 *
 *  @asreturn Array of ValidationResultEvent objects, where the Array
 *  contains one ValidationResultEvent object for each validator
 *  that failed. 
 *  The Array is empty if all validators succeed.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @nocollapse
 * @param {Array} validators
 * @return {Array}
 */
mx.validators.Validator.validateAll = function(validators) {
  var /** @type {Array} */ result = [];
  var /** @type {number} */ n = (validators.length) >> 0;
  for (var /** @type {number} */ i = 0; i < n; i++) {
    var /** @type {mx.validators.IValidator} */ v = org.apache.royale.utils.Language.as(validators[i], mx.validators.IValidator);
    if (v && v.enabled) {
      var /** @type {mx.events.ValidationResultEvent} */ resultEvent = v.validate();
      if (resultEvent.type != mx.events.ValidationResultEvent.VALID)
        result.push(resultEvent);
    }
  }
  return result;
};


/**
 *  @asprivate
 * @private
 * @param {string} str
 * @return {string}
 */
mx.validators.Validator.trimString = function(str) {
  var /** @type {number} */ startIndex = 0;
  while (str.indexOf(' ', startIndex) == startIndex) {
    ++startIndex;
  }
  var /** @type {number} */ endIndex = (str.length - 1) >> 0;
  while (str.lastIndexOf(' ', endIndex) == endIndex) {
    --endIndex;
  }
  return endIndex >= startIndex ? str.slice(startIndex, endIndex + 1) : "";
};


/**
 * @private
 * @type {boolean}
 */
mx.validators.Validator.prototype.mx_validators_Validator__enabled = true;


/**
 * @private
 * @type {Object}
 */
mx.validators.Validator.prototype.mx_validators_Validator__listener;


/**
 * @private
 * @type {string}
 */
mx.validators.Validator.prototype.mx_validators_Validator__property;


/**
 * @private
 * @type {boolean}
 */
mx.validators.Validator.prototype.mx_validators_Validator__required = true;


/**
 * @private
 * @type {Object}
 */
mx.validators.Validator.prototype.mx_validators_Validator__source;


/**
 * @protected
 * @type {Array}
 */
mx.validators.Validator.prototype.subFields;


/**
 * @private
 * @type {org.apache.royale.events.IEventDispatcher}
 */
mx.validators.Validator.prototype.mx_validators_Validator__trigger;


/**
 * @private
 * @type {string}
 */
mx.validators.Validator.prototype.mx_validators_Validator__triggerEvent;


/**
 * @private
 * @type {string}
 */
mx.validators.Validator.prototype.mx_validators_Validator__requiredFieldError = "This field is required";


/**
 * @private
 * @type {string}
 */
mx.validators.Validator.prototype.mx_validators_Validator_requiredFieldErrorOverride;


/**
 *  This method is called when a Validator is constructed,
 *  and again whenever the ResourceManager dispatches
 *  a <code>"change"</code> Event to indicate
 *  that the localized resources have changed in some way.
 * 
 *  <p>This event will be dispatched when you set the ResourceManager's
 *  <code>localeChain</code> property, when a resource module
 *  has finished loading, and when you call the ResourceManager's
 *  <code>update()</code> method.</p>
 *
 *  <p>Subclasses should override this method and, after calling
 *  <code>super.resourcesChanged()</code>, do whatever is appropriate
 *  in response to having new resource values.</p>
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @protected
 */
mx.validators.Validator.prototype.resourcesChanged = function() {
  this.requiredFieldError = this.mx_validators_Validator_requiredFieldErrorOverride;
};


/**
 *  @asprivate
 * @private
 */
mx.validators.Validator.prototype.mx_validators_Validator_addTriggerHandler = function() {
  if (this.actualTrigger)
    this.actualTrigger.addEventListener(this.mx_validators_Validator__triggerEvent, org.apache.royale.utils.Language.closure(this.triggerHandler, this, 'triggerHandler'));
};


/**
 *  @asprivate
 * @private
 */
mx.validators.Validator.prototype.mx_validators_Validator_removeTriggerHandler = function() {
  if (this.actualTrigger)
    this.actualTrigger.removeEventListener(this.mx_validators_Validator__triggerEvent, org.apache.royale.utils.Language.closure(this.triggerHandler, this, 'triggerHandler'));
};


/**
 *  Sets up all of the listeners for the 
 *  <code>valid</code> and <code>invalid</code>
 *  events dispatched from the validator. Subclasses of the Validator class 
 *  should first call the <code>removeListenerHandler()</code> method, 
 *  and then the <code>addListenerHandler()</code> method if 
 *  the value of one of their listeners or sources changes. 
 *  The CreditCardValidator and DateValidator classes use this function internally. 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @protected
 */
mx.validators.Validator.prototype.addListenerHandler = function() {
  var /** @type {Object} */ actualListener;
  var /** @type {Array} */ listeners = this.actualListeners;
  var /** @type {number} */ n = (listeners.length) >> 0;
  for (var /** @type {number} */ i = 0; i < n; i++) {
    actualListener = listeners[i];
    if (org.apache.royale.utils.Language.is(actualListener, mx.validators.IValidatorListener)) {
      this.addEventListener(mx.events.ValidationResultEvent.VALID, org.apache.royale.utils.Language.closure(org.apache.royale.utils.Language.as(actualListener, mx.validators.IValidatorListener, true).validationResultHandler, org.apache.royale.utils.Language.as(actualListener, mx.validators.IValidatorListener, true), 'validationResultHandler'));
      this.addEventListener(mx.events.ValidationResultEvent.INVALID, org.apache.royale.utils.Language.closure(org.apache.royale.utils.Language.as(actualListener, mx.validators.IValidatorListener, true).validationResultHandler, org.apache.royale.utils.Language.as(actualListener, mx.validators.IValidatorListener, true), 'validationResultHandler'));
    }
  }
};


/**
 *  Disconnects all of the listeners for the 
 *  <code>valid</code> and <code>invalid</code>
 *  events dispatched from the validator. Subclasses should first call the
 *  <code>removeListenerHandler()</code> method and then the 
 *  <code>addListenerHandler</code> method if 
 *  the value of one of their listeners or sources changes. 
 *  The CreditCardValidator and DateValidator classes use this function internally. 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @protected
 */
mx.validators.Validator.prototype.removeListenerHandler = function() {
  var /** @type {Object} */ actualListener;
  var /** @type {Array} */ listeners = this.actualListeners;
  var /** @type {number} */ n = (listeners.length) >> 0;
  for (var /** @type {number} */ i = 0; i < n; i++) {
    actualListener = listeners[i];
    if (org.apache.royale.utils.Language.is(actualListener, mx.validators.IValidatorListener)) {
      this.removeEventListener(mx.events.ValidationResultEvent.VALID, org.apache.royale.utils.Language.closure(org.apache.royale.utils.Language.as(actualListener, mx.validators.IValidatorListener, true).validationResultHandler, org.apache.royale.utils.Language.as(actualListener, mx.validators.IValidatorListener, true), 'validationResultHandler'));
      this.removeEventListener(mx.events.ValidationResultEvent.INVALID, org.apache.royale.utils.Language.closure(org.apache.royale.utils.Language.as(actualListener, mx.validators.IValidatorListener, true).validationResultHandler, org.apache.royale.utils.Language.as(actualListener, mx.validators.IValidatorListener, true), 'validationResultHandler'));
    }
  }
};


/**
 *  Returns <code>true</code> if <code>value</code> is not null. 
 * 
 *  @asparam value The value to test.
 *
 *  @asreturn <code>true</code> if <code>value</code> is not null.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @protected
 * @param {Object} value
 * @return {boolean}
 */
mx.validators.Validator.prototype.isRealValue = function(value) {
  return (value != null);
};


/**
 *  Performs validation and optionally notifies
 *  the listeners of the result. 
 *
 *  @asparam value Optional value to validate.
 *  If null, then the validator uses the <code>source</code> and
 *  <code>property</code> properties to determine the value.
 *  If you specify this argument, you should also set the
 *  <code>listener</code> property to specify the target component
 *  for any validation error messages.
 *
 *  @asparam suppressEvents If <code>false</code>, then after validation,
 *  the validator will notify the listener of the result.
 *
 *  @asreturn A ValidationResultEvent object
 *  containing the results of the validation. 
 *  For a successful validation, the
 *  <code>ValidationResultEvent.results</code> Array property is empty. 
 *  For a validation failure, the
 *  <code>ValidationResultEvent.results</code> Array property contains
 *  one ValidationResult object for each field checked by the validator, 
 *  both for fields that failed the validation and for fields that passed. 
 *  Examine the <code>ValidationResult.isError</code>
 *  property to determine if the field passed or failed the validation. 
 *
 *  @see mx.events.ValidationResultEvent
 *  @see mx.validators.ValidationResult
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @param {Object=} value
 * @param {boolean=} suppressEvents
 * @return {mx.events.ValidationResultEvent}
 */
mx.validators.Validator.prototype.validate = function(value, suppressEvents) {
  value = typeof value !== 'undefined' ? value : null;
  suppressEvents = typeof suppressEvents !== 'undefined' ? suppressEvents : false;
  if (value == null)
    value = this.getValueFromSource();
  if (this.isRealValue(value) || this.required) {
    return this.mx_validators_Validator_processValidation(value, suppressEvents);
  } else {
    var /** @type {mx.events.ValidationResultEvent} */ resultEvent = this.handleResults(null);
    if (!suppressEvents && this.mx_validators_Validator__enabled) {
      this.dispatchEvent(resultEvent);
    }
    return resultEvent;
  }
};


/**
 *  Returns the Object to validate. Subclasses, such as the 
 *  CreditCardValidator and DateValidator classes, 
 *  override this method because they need
 *  to access the values from multiple subfields. 
 *
 *  @asreturn The Object to validate.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @protected
 * @return {Object}
 */
mx.validators.Validator.prototype.getValueFromSource = function() {
  var /** @type {string} */ message;
  if (this.mx_validators_Validator__source && this.mx_validators_Validator__property) {
    return this.mx_validators_Validator__property.indexOf(".") == -1 ? this.mx_validators_Validator__source[this.mx_validators_Validator__property] : mx.utils.ObjectUtil.getValue(this.mx_validators_Validator__source, this.mx_validators_Validator__property.split("."));
  } else if (!this.mx_validators_Validator__source && this.mx_validators_Validator__property) {
    message = "SAttributeMissing";
    throw new Error(message);
  } else if (this.mx_validators_Validator__source && !this.mx_validators_Validator__property) {
    message = "PAttributeMissing";
    throw new Error(message);
  }
  return null;
};


/** 
 *  @asprivate 
 *  Main internally used function to handle validation process.
 * @private
 * @param {Object} value
 * @param {boolean} suppressEvents
 * @return {mx.events.ValidationResultEvent}
 */
mx.validators.Validator.prototype.mx_validators_Validator_processValidation = function(value, suppressEvents) {
  var /** @type {mx.events.ValidationResultEvent} */ resultEvent;
  if (this.mx_validators_Validator__enabled) {
    var /** @type {Array} */ errorResults = this.doValidation(value);
    resultEvent = this.handleResults(errorResults);
  } else {
    suppressEvents = true;
  }
  if (!suppressEvents) {
    this.dispatchEvent(resultEvent);
  }
  return resultEvent;
};


/**
 *  Executes the validation logic of this validator, 
 *  including validating that a missing or empty value
 *  causes a validation error as defined by
 *  the value of the <code>required</code> property.
 *
 *  <p>If you create a subclass of a validator class,
 *  you must override this method. </p>
 *
 *  @asparam value Value to validate.
 *
 *  @asreturn For an invalid result, an Array of ValidationResult objects,
 *  with one ValidationResult object for each field examined
 *  by the validator that failed validation.
 *
 *  @see mx.validators.ValidationResult
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @protected
 * @param {Object} value
 * @return {Array}
 */
mx.validators.Validator.prototype.doValidation = function(value) {
  var /** @type {Array} */ results = [];
  var /** @type {mx.validators.ValidationResult} */ result = this.mx_validators_Validator_validateRequired(value);
  if (result)
    results.push(result);
  return results;
};


/**
 *  @asprivate 
 *  Determines if an object is valid based on its
 *  <code>required</code> property.
 *  This is a convenience method for calling a validator from within a 
 *  custom validation function. 
 * @private
 * @param {Object} value
 * @return {mx.validators.ValidationResult}
 */
mx.validators.Validator.prototype.mx_validators_Validator_validateRequired = function(value) {
  if (this.required) {
    var /** @type {string} */ val = (value != null) ? String(value) : "";
    val = mx.validators.Validator.trimString(val);
    if (val.length == 0) {
      return new mx.validators.ValidationResult(true, "", "requiredField", this.requiredFieldError);
    }
  }
  return null;
};


/**
 *  Returns a ValidationResultEvent from the Array of error results. 
 *  Internally, this function takes the results from the 
 *  <code>doValidation()</code> method and puts it into a ValidationResultEvent object. 
 *  Subclasses, such as the RegExpValidator class, 
 *  should override this function if they output a subclass
 *  of ValidationResultEvent objects, such as the RegExpValidationResult objects, and 
 *  needs to populate the object with additional information. You never
 *  call this function directly, and you should rarely override it. 
 *
 *  @asparam errorResults Array of ValidationResult objects.
 * 
 *  @asreturn The ValidationResultEvent returned by the <code>validate()</code> method. 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 0.9.3
 * @protected
 * @param {Array} errorResults
 * @return {mx.events.ValidationResultEvent}
 */
mx.validators.Validator.prototype.handleResults = function(errorResults) {
  var /** @type {number} */ n = 0;
  var /** @type {number} */ i = 0;
  var /** @type {mx.events.ValidationResultEvent} */ resultEvent;
  if (errorResults != null && errorResults.length > 0) {
    resultEvent = new mx.events.ValidationResultEvent(mx.events.ValidationResultEvent.INVALID);
    resultEvent.results = errorResults;
    if (this.subFields.length > 0) {
      var /** @type {Object} */ errorFields = {};
      var /** @type {string} */ subField;
      //var /** @type {number} */ n = 0;
      //var /** @type {number} */ i = 0;
      n = (errorResults.length) >> 0;
      for (i = 0; i < n; i++) {
        subField = org.apache.royale.utils.Language.string(errorResults[i].subField);
        if (subField) {
          errorFields[subField] = true;
        }
      }
      n = (this.subFields.length) >> 0;
      for (i = 0; i < n; i++) {
        if (!errorFields[this.subFields[i]]) {
          errorResults.push(new mx.validators.ValidationResult(false, this.subFields[i]));
        }
      }
    }
  } else {
    resultEvent = new mx.events.ValidationResultEvent(mx.events.ValidationResultEvent.VALID);
  }
  return resultEvent;
};


/**
 *  @asprivate
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
mx.validators.Validator.prototype.triggerHandler = function(event) {
  this.validate();
};


/**
 * @nocollapse
 * @type {org.apache.royale.events.IEventDispatcher}
 */
mx.validators.Validator.prototype.actualTrigger;


mx.validators.Validator.prototype.get__actualTrigger = function() {
  if (this.mx_validators_Validator__trigger)
    return this.mx_validators_Validator__trigger;
  else if (this.mx_validators_Validator__source)
    return org.apache.royale.utils.Language.as(this.mx_validators_Validator__source, org.apache.royale.events.IEventDispatcher);
  return null;
};


/**
 * @nocollapse
 * @type {Array}
 */
mx.validators.Validator.prototype.actualListeners;


mx.validators.Validator.prototype.get__actualListeners = function() {
  var /** @type {Array} */ result = [];
  if (this.mx_validators_Validator__listener)
    result.push(this.mx_validators_Validator__listener);
  else if (this.mx_validators_Validator__source)
    result.push(this.mx_validators_Validator__source);
  return result;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.validators.Validator.prototype.enabled;


mx.validators.Validator.prototype.get__enabled = function() {
  return this.mx_validators_Validator__enabled;
};


mx.validators.Validator.prototype.set__enabled = function(value) {
  this.mx_validators_Validator__enabled = value;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.validators.Validator.prototype.listener;


mx.validators.Validator.prototype.get__listener = function() {
  return this.mx_validators_Validator__listener;
};


mx.validators.Validator.prototype.set__listener = function(value) {
  this.removeListenerHandler();
  this.mx_validators_Validator__listener = value;
  this.addListenerHandler();
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.Validator.prototype.property;


mx.validators.Validator.prototype.get__property = function() {
  return this.mx_validators_Validator__property;
};


mx.validators.Validator.prototype.set__property = function(value) {
  this.mx_validators_Validator__property = value;
};


/**
 * @nocollapse
 * @export
 * @type {boolean}
 */
mx.validators.Validator.prototype.required;


mx.validators.Validator.prototype.get__required = function() {
  return this.mx_validators_Validator__required;
};


mx.validators.Validator.prototype.set__required = function(value) {
  this.mx_validators_Validator__required = value;
};


/**
 * @nocollapse
 * @export
 * @type {Object}
 */
mx.validators.Validator.prototype.source;


mx.validators.Validator.prototype.get__source = function() {
  return this.mx_validators_Validator__source;
};


mx.validators.Validator.prototype.set__source = function(value) {
  if (this.mx_validators_Validator__source == value)
    return;
  if (org.apache.royale.utils.Language.is(value, String)) {
    var /** @type {string} */ message = "";
    throw new Error(message);
  }
  this.mx_validators_Validator_removeTriggerHandler();
  this.removeListenerHandler();
  this.mx_validators_Validator__source = value;
  this.mx_validators_Validator_addTriggerHandler();
  this.addListenerHandler();
};


/**
 * @nocollapse
 * @export
 * @type {org.apache.royale.events.IEventDispatcher}
 */
mx.validators.Validator.prototype.trigger;


mx.validators.Validator.prototype.get__trigger = function() {
  return this.mx_validators_Validator__trigger;
};


mx.validators.Validator.prototype.set__trigger = function(value) {
  this.mx_validators_Validator_removeTriggerHandler();
  this.mx_validators_Validator__trigger = value;
  this.mx_validators_Validator_addTriggerHandler();
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.Validator.prototype.triggerEvent;


mx.validators.Validator.prototype.get__triggerEvent = function() {
  return this.mx_validators_Validator__triggerEvent;
};


mx.validators.Validator.prototype.set__triggerEvent = function(value) {
  if (this.mx_validators_Validator__triggerEvent == value)
    return;
  this.mx_validators_Validator_removeTriggerHandler();
  this.mx_validators_Validator__triggerEvent = value;
  this.mx_validators_Validator_addTriggerHandler();
};


/**
 * @nocollapse
 * @export
 * @type {string}
 */
mx.validators.Validator.prototype.requiredFieldError;


mx.validators.Validator.prototype.get__requiredFieldError = function() {
  return this.mx_validators_Validator__requiredFieldError;
};


mx.validators.Validator.prototype.set__requiredFieldError = function(value) {
  this.mx_validators_Validator_requiredFieldErrorOverride = value;
  this.mx_validators_Validator__requiredFieldError = value != null ? value : "";
};


Object.defineProperties(mx.validators.Validator.prototype, /** @lends {mx.validators.Validator.prototype} */ {
/**
 * @type {org.apache.royale.events.IEventDispatcher}
 */
actualTrigger: {
get: mx.validators.Validator.prototype.get__actualTrigger},
/**
 * @type {Array}
 */
actualListeners: {
get: mx.validators.Validator.prototype.get__actualListeners},
/**
 * @type {boolean}
 */
enabled: {
get: mx.validators.Validator.prototype.get__enabled,
set: mx.validators.Validator.prototype.set__enabled},
/**
 * @type {Object}
 */
listener: {
get: mx.validators.Validator.prototype.get__listener,
set: mx.validators.Validator.prototype.set__listener},
/**
 * @type {string}
 */
property: {
get: mx.validators.Validator.prototype.get__property,
set: mx.validators.Validator.prototype.set__property},
/**
 * @type {boolean}
 */
required: {
get: mx.validators.Validator.prototype.get__required,
set: mx.validators.Validator.prototype.set__required},
/**
 * @type {Object}
 */
source: {
get: mx.validators.Validator.prototype.get__source,
set: mx.validators.Validator.prototype.set__source},
/**
 * @type {org.apache.royale.events.IEventDispatcher}
 */
trigger: {
get: mx.validators.Validator.prototype.get__trigger,
set: mx.validators.Validator.prototype.set__trigger},
/**
 * @type {string}
 */
triggerEvent: {
get: mx.validators.Validator.prototype.get__triggerEvent,
set: mx.validators.Validator.prototype.set__triggerEvent},
/**
 * @type {string}
 */
requiredFieldError: {
get: mx.validators.Validator.prototype.get__requiredFieldError,
set: mx.validators.Validator.prototype.set__requiredFieldError}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
mx.validators.Validator.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Validator', qName: 'mx.validators.Validator', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
mx.validators.Validator.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'enabled': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.validators.Validator'},
        'listener': { type: 'Object', access: 'readwrite', declaredBy: 'mx.validators.Validator'},
        'property': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.Validator'},
        'required': { type: 'Boolean', access: 'readwrite', declaredBy: 'mx.validators.Validator'},
        'source': { type: 'Object', access: 'readwrite', declaredBy: 'mx.validators.Validator', metadata: function () { return [ { name: 'Bindable', args: [ { key: '', value: 'sourceChanged' } ] } ]; }},
        'trigger': { type: 'org.apache.royale.events.IEventDispatcher', access: 'readwrite', declaredBy: 'mx.validators.Validator'},
        'triggerEvent': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.Validator'},
        'requiredFieldError': { type: 'String', access: 'readwrite', declaredBy: 'mx.validators.Validator'}
      };
    },
    methods: function () {
      return {
        '|validateAll': { type: 'Array', declaredBy: 'mx.validators.Validator', parameters: function () { return [ 'Array', false ]; }},
        'Validator': { type: '', declaredBy: 'mx.validators.Validator'},
        'validate': { type: 'mx.events.ValidationResultEvent', declaredBy: 'mx.validators.Validator', parameters: function () { return [ 'Object', true ,'Boolean', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
mx.validators.Validator.prototype.ROYALE_COMPILE_FLAGS = 10;